/*
 Copyright (C) 2010 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef __BIXFORMAT_H__
#define __BIXFORMAT_H__ 1

/* 
		11111 100000 00000
		54321 098765 43210
  2b_16bpp	rrrrr gggggg bbbbb

		33222222 22221111 11111100 00000000
		10987654 32109876 54321098 76543210
  4b_24bpp	00000000 rrrrrrrr gggggggg bbbbbbbb

		33222222 22221111 11111100 00000000
		10987654 32109876 54321098 76543210
  4b_24bpp8a	aaaaaaaa rrrrrrrr gggggggg bbbbbbbb

*/

  /* pxm_LD */
#define pxm_2b_16bpp	1
#define B16_RGB565	1
#define pxm_4b_24bpp	2
#define B32_RGB888	2
#define pxm_4b_24bpp8a	3
#define B32_ARGB8888	3

/* VIDEO */
#define pxm_YUV420	10
#define pxm_YUV422	11
#define pxm_YUV420b	12
#define pxm_YUV422b	13


#define pxmLD_bppMask	0xff

#define fps_23_976	0x01
#define fps_24		0x02
#define fps_25		0x03
#define fps_29_97	0x04
#define fps_30		0x05
#define fps_50		0x23
#define fps_59_94	0x24
#define fps_60		0x25
#define fps_2x		0x20
#define fps_Interlace	0x40
#define fps_DeIntl_L2	0x80

extern int get_bytes_per_line(int width, int bytes_per_line, dword format);

#endif /* __BIXFORMAT_H__ */
