#ifndef	__CPUID_H__
#define	__CPUID_H__    1

#if defined (__i386__) || defined(__x86_64__)

/* FeatureFlags1 */
#define FPU_FLAG 0x0001
#define VME_FLAG 0x0002
#define DE_FLAG 0x0004
#define PSE_FLAG 0x0008
#define TSC_FLAG 0x0010
#define MSR_FLAG 0x0020
#define PAE_FLAG 0x0040
#define MCE_FLAG 0x0080
#define CX8_FLAG 0x0100
#define APIC_FLAG 0x0200
#define SEP_FLAG 0x0800
#define MTRR_FLAG 0x1000
#define PGE_FLAG 0x2000
#define MCA_FLAG 0x4000
#define CMOV_FLAG 0x8000
#define PAT_FLAG 0x10000
#define PSE36_FLAG 0x20000
#define PSNUM_FLAG 0x40000
#define CLFLUSH_FLAG 0x80000
#define DTS_FLAG 0x200000
#define ACPI_FLAG 0x400000
#define MMX_FLAG 0x800000
#define FXSR_FLAG 0x1000000
#define SSE_FLAG 0x2000000
#define SSE2_FLAG 0x4000000
#define SS_FLAG 0x8000000
#define HTT_FLAG 0x10000000
#define TM_FLAG 0x20000000
#define IA64_FLAG 0x40000000
#define PBE_FLAG 0x80000000

/* FeatureFlags0 */
#define SSE3_FLAG 0x0001 
#define MONITOR_FLAG 0x0008 
#define DS_CPL_FLAG 0x0010 
#define EIST_FLAG 0x0080 
#define TM2_FLAG 0x0100 
#define SSSE3_FLAG 0x0200 
#define CID_FLAG 0x0400 
#define CX16_FLAG 0x2000 
#define XTPR_FLAG 0x4000 
#define DCA_FLAG 0x40000 
#define LAHF_FLAG 0x00000001 
#define SYSCALL_FLAG 0x00000800 
#define XD_FLAG 0x00100000 
#define EM64T_FLAG 0x20000000

typedef struct TCPUID {
  int stdFunkt;		//0
  char VendorID[16];

  dword ProcessorSig;	//1
  dword Misc;
  dword FeatureFlags0;
  dword FeatureFlags1;

  dword TLB_0;		//2
  dword TLB_1;
  dword TLB_2;
  dword TLB_3;
/* ****** Extended ****** */
  int ExtFunkt;		//0x80000000
  dword Ext0_Res1;
  dword Ext0_Res2;
  dword Ext0_Res3;
  dword Ext1_FeatureFlag;	//0x80000001

  char ProcessorName[48];//0x80000002..4

  dword Ext5_Res[4];

  dword Ext6_Res0;
  dword Ext6_Res1;
  dword Ext6_L2;
  dword Ext6_Res3;

  dword Ext7_Res[4];

  byte Physical_Bits;
  byte Virtual_Bits;
  word Ext8_Res0;
  dword Ext8_Res1;
  dword Ext8_Res2;
  dword Ext8_Res3;
} TCPUID;

#if defined (__i386__)
extern int __attribute__ ((regparm (3))) Get_CPUID(TCPUID *cpuid);
extern int __attribute__ ((regparm (3))) Get_TSC(uint64_t *tsc);
#else
extern int Get_CPUID(TCPUID *cpuid);
extern int Get_TSC(uint64_t *tsc);
#endif
#endif

#endif /* __CPUID_H__ */
