/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef	__FILEMSG_H__
#define	__FILEMSG_H__    1

#define fmTyp_none	0
#define fmTyp_int	1
#define fmTyp_char	2
#define fmTyp_void	3
#define fmTyp_gp	4
#define fmTyp_stat	5
#define fmTyp_lb	6
#define fmTyp_ioinfo	7

#define fmTyp_dfl	16
#define fmTyp_sh	17
#define fmTyp_shd	18
//#define fmTyp_shf	10
#define fmTyp_shst	19

// ****** TFileMsg.type ********
#define fmType_		1

// ****** TFileMsg.art ********
#define fmArt_AlgErr		1
#define fmArt_errLogin		2
#define fmArt_errConnect	3
//#define fmArt_errNoLogin	3
#define fmArt_NewLogin		4
#define fmArt_strg		5
#define fmArt_TdServ		6

#define fmArt_ftpappclient	7
#define fmArt_DirList		8
#define fmArt_DataIO		9

/* fmArt_AlgErr || fmArt_errLogin
  typD = fmTyp_char  
  D.s = ERROR String
*/

/* fmArt_strg    in net_io.h
  typD = fmTypD_int  
  D.m = hSHStM_Connect, hSHStM_user, ... hSHStM_xOk,hSHStM_Error
*/

/* fmArt_ftpappclient
  typD = fmTypD_int  
  D.m = facEndCode_OK, facEndCode_ERROR
*/

/* ----------------------- fmArt_DataIO --------------------------------- */
#define fmIOInfo_EOF 1
typedef struct TDataIO_Info {
  uint64_t DataSize;
  uint64_t DataNowSize;
  uint64_t Time_us;
  dword stat;
} TDataIO_Info;

#define fmFillSendBuf 1
#define fmReadRecvBuf 2
/* fmArt_DataIO
  typD = fmTypD_int
  D.m =  fmFillSendBuf
  typF = fmTyp_lb
  D.lb = TLineBuf
    ----------
  typD = fmTypD_int
  D.m =  fmReadRecvBuf
  typF = fmTyp_lb
  D.lb = TLineBuf
    ----------
  typD = fmTyp_stat
  D.st = Tstat64
*/

typedef struct TFileMsg {
  int wtyp;
  void *obj;
  void *owner;
  void *sender;
  int art;
  int tag;
  bool Ok;
  bool ev_Stop;  //(Ok && ev_Stop) nicht an Glob_OnFileMsg weiterleiten
  bool nc2, nc3;
  int res;	//return msgOK,msgCANCEL,... in dlg.h
  int typD;
  union {
    int m;
    char *s;
    void *v;
    struct Tstat64 *st;
    TDataIO_Info *ioinfo;
  } D;
  int typF;
  union {
    int m;
    char *s;
    void *v;
    struct TglobPath *gp;
    struct Tstat64 *st;
    struct TLineBuf *lb;
    struct TDirFileList *dfl;
    struct TdServHead *sh;
    struct TdData *shd;
    struct TdServFileStat *shst;
  } F;
/* return data */
  int ret_art;
  int ret_fu;
  int ret_tag;
  int typR;
  union {
    int m;
    char *s;
    void *v;
    struct TglobPath *gp;
    struct Tstat64 *st;
    struct TDirFileList *dfl;
    struct TAHdServHead *sh;
    struct TdServFileStat *shst;
  } R;
} TFileMsg;

typedef void (*TOnFileMsg)(TFileMsg *fmsg);

extern void (*Glob_OnFileMsg)(TFileMsg *fmsg);

/* in lib/io/file_msg.c */
extern void file_msg(TFileMsg *fmsg);
extern void file_msg_ev(TFileMsg *fmsg, TTC0 *ttc, TOnFileMsg ev);
extern void file_msg_ev_next(TFileMsg *fmsg, TTC0 *ttc, TOnFileMsg ev);
extern void REGP2 file_msg_init(TFileMsg *fmsg, int art);
extern void REGP3 file_msg_init_Dm(TFileMsg *fmsg, int art, int Dm);


extern bool file_msg_chk_wtyp(TFileMsg *fmsg, int wtyp, const char *fn, int line);
/* zB: if (!file_msg_chk_wtyp(fmsg, wtyp_TDirListObjNy, FL)) return; 
   fn=NULL no printf */

/* in lib/io/file_msg_debug.c */
extern void file_msg_debug(TFileMsg *fmsg, const char *name);

#endif /* __FILEMSG_H__ */
