/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef	__FONT_XFT_H__
#define	__FONT_XFT_H__    1

/* typedef struct {
  int left;
  int top;
  int width;
  int height;
//  int XOrigin, YOrigin;
} TClipRc; */

/* TFontS->flags */
#define FONTFG_UTF8		1
#define FONTFG_ImageString	(1<<1)
//#define FONTFG_UseOrigin_0	(1<<2)
#define FONTFG_OriginAdd	(1<<3)

#define FONT_WCBUF_MAX	200


#define AlgTFontPvBase dword Color, BackColor; \
  dword flags;

#define AlgTFontStuct  AlgTTC0 \
  FONT_HANDLE; \
  FONT_PV; \
  struct TCSelf * (*CreateDuplicate)(struct TCSelf *self); \
  bool (*SetColor)(struct TCSelf *self, dword Color); \
  bool (*SetBackColor)(struct TCSelf *self, dword Color); \
  bool (*SetFlag)(struct TCSelf *self, dword flag); \
  bool (*ClrFlag)(struct TCSelf *self, dword flag); \
  bool (*SetFlags)(struct TCSelf *self, dword flags); \
  int  (*GetWidth)(struct TCSelf *self, const char *s, int len); \
  bool (*GetVector)(struct TCSelf *self, int *x, int *y, const char *s, int len); \
  bool (*GetVectorFloat)(struct TCSelf *self, float *x, float *y, const char *s, int len); \
  bool (*GetMetrics)(struct TCSelf *self, int *height, int *ascent); \
  bool (*ClrOrigin)(struct TCSelf *self); \
  bool (*SetOrigin)(struct TCSelf *self, int x, int y); \
  bool (*GetOrigin)(struct TCSelf *self, int *x, int *y); \
  bool (*SetOriginFloat)(struct TCSelf *self, float x, float y); \
  bool (*GetOriginFloat)(struct TCSelf *self, float *x, float *y); \
  bool (*SetDefault)(struct TCSelf *self, bool Value); \
  bool (*SetClipRc)(struct TCSelf *self, TWRect *ClipRc); \
  int  (*GetGlyphs)(struct TCSelf *self);

//  bool (*ClrClipRc)(struct TCSelf *self);

#define AlgTFontBase  AlgTFontStuct \
  bool (*PaintTo)(struct TCSelf *self, long *toobj, int x, int y, const char *s, int slen); \
  bool (*NC_ToImage)(struct TCSelf *self, long *toobj, int x, int y, const char *s, int slen); \
  bool (*NC_ToWinID)(struct TCSelf *self, long *toobj, int x, int y, const char *s, int slen);

#define AlgTFontFTBase  AlgTFontStuct \
  bool (*PaintTo)(struct TCSelf *self, struct TImage *img, int x, int y, const char *s, int slen); \
  bool (*ToImage)(struct TCSelf *self, struct TImage *img, int x, int y, const char *s, int slen); \
  bool (*NC_ToWinID)(struct TCSelf *self, long *toobj, int x, int y, const char *s, int slen);

//  bool (*ToImage)(struct TCSelf *self, struct TImage *img, int x, int y, const char *s, int slen); 

//  bool (*PaintToWinID)(struct TCSelf *self, long WinID, const char *s, int len); 
//  bool (*PaintToImg)(struct TCSelf *self, struct TImage *img, const char *s, int len);

typedef struct TFont_pv {
  AlgTFontPvBase
} TFont_pv;

#define FONT_HANDLE	void *fh
#define FONT_PV		TFont_pv *fpv
#define TCSelf		TFont
typedef struct TFont {
  AlgTFontBase
} TFont;
#undef FONT_HANDLE
#undef FONT_PV
#undef TCSelf

extern TFont *Font_CreateDuplicate(TFont *self);
extern bool Font_SetFlag(TFont *self, dword flag);	//or v
extern bool Font_ClrFlag(TFont *self, dword flag);	//and ~v
extern bool Font_SetFlags(TFont *self, dword flags);
extern bool Font_SetColor(TFont *self, dword Color);
extern bool Font_SetBackColor(TFont *self, dword Color);
extern bool Font_SetUTF8(TFont *self, bool UTF8on);
extern int  Font_GetWidth(TFont *self, const char *s, int len);
extern bool Font_GetMetrics(TFont *self, int *height, int *ascent);
extern int  Font_GetGlyphs(TFont *self);

extern bool Font_ClrOrigin(TFont *self);
extern bool Font_SetOrigin(TFont *self, int x, int y);
extern bool Font_GetOrigin(TFont *self, int *x, int *y);
extern bool Font_SetOriginFloat(TFont *self, float x, float y);
extern bool Font_GetOriginFloat(TFont *self, float *x, float *y);
extern bool Font_SetDefault(TFont *self, bool Value);
extern bool Font_SetClipRc(TFont *self, TWRect *ClipRc);
extern bool Font_ClrClipRc(TFont *self);

extern bool Font_GetVector(TFont *self, int *x, int *y, const char *s, int len);
extern bool Font_StrGetVector(TFont *self, int *x, int *y, const char *s);
extern bool Font_GetVectorFloat(TFont *self, float *x, float *y, const char *s, int len);
extern bool Font_StrGetVectorFloat(TFont *self, float *x, float *y, const char *s);

extern bool Font_PaintTo(TFont *self, long *toobj, int x, int y, 
			const char *s, int len);
extern bool Font_StrPaintTo(TFont *self, long *toobj, int x, int y, 
			const char *s);

extern bool Font_ChkPaintToIsImage(long *toobj);

#define AlgTFontCharData  int char_idx; \
  int char_x; \
  int char_top; \
  int char_width; \
  int char_height; \
  int char_count; \
  const char *char_s; \
  bool isUTF8, bnc1, bnc2, bnc3;

typedef struct {
  AlgTFontCharData
} TFontCharData;

extern bool Font_PointX_GetCharData(TFont *self, TFontCharData *fcd,
				    int x, const char *s, int len);
extern bool Font_StrIdx_GetCharData(TFont *self, TFontCharData *fcd, 
				    const char *s, int idx);


#endif /* __FONT_XFT_H__ */
