/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef __FONT_X_FT_H__
#define __FONT_X_FT_H__    1

#include "font.h"

#define AlgTFontXBase  AlgTFontStuct \
  bool (*PaintTo)(struct TCSelf *self, Window *WinID, int x, int y, const char *s, int slen); \
  bool (*NC_ToImage)(struct TCSelf *self, long *toobj, int x, int y, const char *s, int slen); \
  bool (*NC_ToWinID)(struct TCSelf *self, long *toobj, int x, int y, const char *s, int slen);

#define AlgTFontXFTBase  AlgTFontStuct \
  bool (*PaintTo)(struct TCSelf *self, Window *WinID, int x, int y, const char *s, int slen); \
  bool (*ToImage)(struct TCSelf *self, struct TImage *img, int x, int y, const char *s, int slen); \
  bool (*NC_ToWinID)(struct TCSelf *self, long *toobj, int x, int y, const char *s, int slen);

#ifndef TFontX_handle
#define TFontX_handle void *fh
#endif
#ifndef TFontX_pv
#define TFontX_pv void *fpv
#endif

#define FONT_HANDLE	TFontX_handle
#define FONT_PV		TFontX_pv
#define TCSelf		TFontX
typedef struct TFontX {
  AlgTFontXBase
//  XFontStruct *xfont;
//  char* name;
//  int height;			//height of the font
//  TFontGC g;
//  TFontGC gtmp;
//  int xfu;
} TFontX;
#undef FONT_HANDLE
#undef FONT_PV
#undef TCSelf

//#ifdef	__APPXBASE_H__
extern TFontX *TFontX_Create(const char *FontFileName);

extern bool FontX_PaintTo(TFontX *self, Window *WinID,
			  int x, int y, const char *s, int len);

extern const char *FontX_GetFontName(TFontX *self);
extern XFontStruct *FontX_GetXFontStruct(TFontX *self);

/* ____________________________ Font X11 Freetype ______________________ */
#ifndef TFontX_FT_handle
#define TFontX_FT_handle void *fh
#endif
#ifndef TFontX_FT_pv
#define TFontX_FT_pv void *fpv
#endif

#define FONT_HANDLE	TFontX_FT_handle
#define FONT_PV		TFontX_FT_pv
#define TCSelf		TFontX_FT
typedef struct TFontX_FT {
  AlgTFontXFTBase
} TFontX_FT;
#undef FONT_HANDLE
#undef FONT_PV
#undef TCSelf

extern TFontX_FT *TFontX_FT_Create(const char *FontFileName, 
				int font_height, int font_dpi);

extern bool FontX_FT_ToImage(TFontX_FT *self, struct TImage *img, int x, int y, const char *s, int len);
extern bool FontX_FT_StrToImage(TFontX_FT *self, struct TImage *img, int x, int y, const char *s);
#define BiFlags_IsLineImage	1
extern bool FontX_FT_SetBackImage(TFontX_FT *self, struct TImage *BackImage, 
			dword BiFlags, int BiOriginX, int BiOriginY);

#endif /* __FONT_X_FT_H__ */
