/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef	__SYSBASE_H__
#define	__SYSBASE_H__    1

#ifndef	__USE_LARGEFILE64
#define __USE_LARGEFILE64	1
#endif

#ifndef	__USE_FILE_OFFSET64
#define __USE_FILE_OFFSET64	1
#endif

#define _GNU_SOURCE

#define FL	__FILE__, __LINE__
// printf("%s(%d): \n", FL);

#define PTR_FAILED	((void *) 1)

#ifdef _OS_WIN32
#define cHIDDEN extern
#else
#define cHIDDEN extern __attribute__ ((visibility ("hidden")))
#endif
//#define cEXPORT extern

#if defined (__arm__)
/* ------------- ARM ------------------ */
#define REGP1
#define REGP2
#define REGP3

#elif defined(__i386__)
/* ------------- i386 ------------------ */
#define REGP1 __attribute__ ((regparm (1), stdcall))
#define REGP2 __attribute__ ((regparm (2), stdcall))
#define REGP3 __attribute__ ((regparm (3), stdcall))

#define SWAP_INT(x, y)  __asm__ __volatile__("xchg %1, %0;" : "+r"(x), "+r" (y) )

#elif defined(__x86_64__)
/* ------------- x86_64 ------------------ */
#define REGP1
#define REGP2
#define REGP3

#ifndef __ILP32__
#define POINTER64BIT 1
#endif

#define SWAP_INT(x, y)  __asm__ __volatile__("xchg %1, %0;" : "+r"(x), "+r" (y) )

#else
# error "Unsupported architecture!"
#endif


#ifndef ALD_BUILD_V
#define ALD_BUILD_V 1
#endif

#ifndef SWAP
#define SWAP(x, y) ({typeof(x) _tmp = x; x = y; y = _tmp;})
#endif

#ifndef SWAP_INT
#define SWAP_INT(x, y) ({int _tmp = x; x = y; y = _tmp;})
#endif

#if 1
#include <stdbool.h>
#else
typedef char bool;
#endif
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>

#include "ALDconfig.h"


#ifdef _OS_WIN32
#include <windef.h>
#include <winbase.h>

#define C_SLASH '\\'
#define S_SLASH "\\"

#else /* ! _OS_WIN32 */

#define C_SLASH '/'
#define S_SLASH "/"

#endif /* ! _OS_WIN32 */

#ifndef USE_ASM
#define USE_ASM 0
#endif

/* ab 0xnn00nnnn - 0xnnFFnnnn no Wins Typen
 0xnn00nnnn  TWins
 0xnn01nnnn  Algemein
 0xnn02nnnn  ????
 0xnn03nnnn  Tnet
*/

//#define wtyp_BaseMask		0xf00ff

#define wtyp_SysAlg		0x10000
#define wtyp_TpcIni		0x10001
#define wtyp_TLines		0x10002
#define wtyp_TLinesUnRedo	0x10003
#define wtyp_TFileList		0x10004
#define wtyp_Ttty		0x10005
#define wtyp_TPattern		0x10007
#define wtyp_TSearch_Rec	0x10008
#define wtyp_TgTimer		0x10009
#define wtyp_Trs232		0x1000a
#define wtyp_Trs232ald		0x1000b
#define wtyp_TLineBuf		0x10010
#define wtyp_TEnvPath		0x10011
#define wtyp_TParPort		0x10012

#define wtyp_Tapph		0x10020
#define wtyp_Texec_pipe		0x10021
#define wtyp_Tpty		0x10023
#define wtyp_leterm		0x10024

#define wtyp_TNotify		0x10030
#define wtyp_TNotifyNode	0x10031
#define wtyp_TNotifyNodeHandle	0x10031

#define wtyp_TFIO		0x10040

#define wtyp_TstatMime		0x10051
#define wtyp_TExecMime		0x10052
#define wtyp_TDirList		0x10055
#define wtyp_TDirListPattern	0x10056
#define wtyp_TDirListLoader	0x10057
#define wtyp_TDirListLoaderPg	0x10058
#define wtyp_TDirListNotify	0x10059
#define wtyp_TDirListObjNy	0x10060
#define wtyp_TMountNy		0x10061

#define wtyp_TFtp		0x10080


#define wtyp_TXcopy		0x10090
#define wtyp_TXcopy_ld		0x10091

/* #define wtyp_Tpthd		0x10100
#define wtyp_Tpthd_MSG_Buf	0x10102
#define wtyp_Tpthd_MSG_Obj	0x10103
#define wtyp_Tpthd_msg		0x10110
#define wtyp_Tpthd_msg16B	0x10111
#define wtyp_Tpthd_msg32B	0x10112
#define wtyp_Tpthd_msg64B	0x10113
#define wtyp_Tpthd_msgStr	0x10114
#define wtyp_Tpthd_msgErr	0x10115
#define wtyp_Tpthd_msg16BStr	0x10116
#define wtyp_Tpthd_msgData	0x10117 */

#define wtyp_Thread		0x10120
//#define wtyp_Thread_MSG		0x10121

#define wtyp_TLzw		0x10130

#define wtyp_TItem		0x10160
#define wtyp_TNode		0x10180
/*	wtyp_TNode 0x10180-0x103ff
	wtyp_TTreeVNode		0x10200-0x102ff */

#define wtyp_TSound_IO		0x10401
#define wtyp_TSound_IOC		0x10402
#define wtyp_TSound_IOF		0x10403
#define wtyp_TSound_FIFO	0x10404
#define wtyp_TSound_MIXER	0x10405

#define wtyp_TVideo_IO		0x10500
#define wtyp_TVideo_IO_PV	0x10501
#define wtyp_TVideo_IOC		0x10502
#define wtyp_TVideo_IOC_PV	0x10503
#define wtyp_TVideo_FIFO	0x10504
#define wtyp_TVideo_FIFO_PV	0x10505
#define wtyp_TVideo_IO_seqBuf	0x10506
//#define wtyp_TVideo_IO_poolBuf	0x10507
//#define wtyp_TVideo_IO_DeInterlace	0x10508
#define wtyp_TVideo_FileRD	0x10520
#define wtyp_TVideo_FileWR	0x10540

#define wtyp_Tv4l_IO		0x10601

#define wtyp_Tv_hTunerDrv	0x10700
#define wtyp_Tv_TunerDrv	0x10701

#define wtyp_TMedia_TTC		0x10800
#define wtyp_TMedia_IO		0x10801

#define wtyp_TImage		0x12010
#define wtyp_TImage_MASK	0xffffc
//#define wtyp_TPixMap		0x12011 in stdwin.h

//#define wtyp_Timg_load_struct	0x12023
//#define wtyp_Tpxm_load_struct	wtyp_Timg_load_struct
#define wtyp_Timg_TPen		0x12024

#define wtyp_TColMap		0x12030

#define wtyp_TImageExGif	0x12040

//#define wtyp_Font_FT		0x12060
#define wtyp_FontHandle_FT	0x1207c
#define wtyp_FontHandle_X	0x1207d

#define wtyp_Font		0x12080
#define wtyp_Font_MASK		0xffff0
#define wtyp_FontX		wtyp_Font
#define wtyp_Font_FT		(wtyp_Font + 1)
#define wtyp_FontX_FT		(wtyp_Font + 2)
//#define wtyp_FontImg_FT		(wtyp_Font + 4)

#define wtyp_WrapLine		0x12090

//#define wtyp_TNet		0x30000
#define wtyp_TNetStat		0x30001
#define wtyp_TNetDirList	0x30002
#define wtyp_TNetLineBuf	0x30003
#define wtyp_TNetStream		0x30004
#define wtyp_TNetUnlink		0x30005
//#define wtyp_TNetChmode		0x30006
#define wtyp_TNetFtp		0x30200
#define wtyp_TFtpAppClient	0x30201
#define wtyp_TFtpClientCMD	0x30202




#define wtyp_USER		0xa0000

//typedef char bool;
//typedef _Bool bool;

#ifndef True
#define True 1
#endif

#ifndef False
#define False 0
#endif

typedef uint8_t byte;
typedef uint16_t word;
typedef uint32_t dword;


#ifdef _OS_WIN32
typedef word charOS;
typedef HANDLE FileHandle;
#define ChkFileHandleOK(a) (a != INVALID_HANDLE_VALUE)
#define ChkFileHandleAkt(a) ((a != INVALID_HANDLE_VALUE) && (a != NULL))
#define FileHandleNULL NULL

#else /* _OS_WIN32 */
typedef char charOS;
typedef int FileHandle;
#define ChkFileHandleOK(a) (a >= 0)
#define ChkFileHandleAkt(a) (a > 0)
#define FileHandleNULL 0

#ifdef DEBUG_STACK
/* in mem.c */
extern void abort_SIGSEGV(int n);
#endif /* DEBUG_STACK */

#endif /* ! _OS_WIN32 */

typedef union {
  int i;
  short s[2];
  char c[4];
  dword dw;
  word w[2];
  byte b[4];
#ifdef _OS_WIN32
  LONG l;
#endif
} ic32;

typedef union {
  int64_t lli;
  int i[2];
  short s[4];
  char c[8];
  uint64_t llu;
  dword dw[2];
  word w[4];
  byte b[8];
#ifdef _OS_WIN32
  LONG l[2];
#endif
} ic64;

typedef union {
  int64_t lli;
  int    i[2];
  short  s[4];
  char   c[8];
  uint64_t llu;
  dword  dw[2];
  word   w[4];
  byte   b[8];
  float  f[2];
  double df;
#ifdef _OS_WIN32
  LONG l[2];
#endif
} ic64f;

typedef union {
  char *s;
  const char *s_const;
  unsigned char *us;
  const unsigned char *us_const;
} xchar;


#define AlgTlgs    int lg; \
  union {char *s; const char *s_const;};

typedef struct {
  AlgTlgs
} Tlgs;

typedef struct {
  int lg;
  char s[];
} Tss;

typedef struct {
  int items;
  void *val[];
} Tptr_arr;

typedef struct {
    int x, y;
} TPoint;

#define TTC_MAGIC 0xfffda559
#define TTC_MAXDEFAULDSIZE 0xffff
#define TTC_MAXSIZE 0xffff
#define TTC_GoFree 1

#define AlgTTC0    dword magic; \
  dword	wtcsize; \
  bool	(*destroy)(void *tc); \
  int	wtyp; \
  word	FREE_LOCK, FREE_LOCK_Stat; 

#define AlgTTC1    dword magic; \
  dword	wtcsize; \
  bool	(*destroy)(void *tc); \
  int	wtyp; \
  word	FREE_LOCK, FREE_LOCK_Stat; \
  int	art;

#define AlgTTC    dword magic; \
  dword	wtcsize; \
  bool	(*destroy)(void *tc); \
  int	wtyp; \
  word	FREE_LOCK, FREE_LOCK_Stat; \
  int	art; \
  long	tag; \
  void	*tagp; \
  void	*private;

typedef struct {
  AlgTTC0
} TTC0;

typedef struct {
  AlgTTC1
} TTC1;

typedef struct {
  AlgTTC
} TTC;

/* in mem.c */
extern const char *app_name;

typedef void (*TAppProcAtExit)();
extern TAppProcAtExit *AppProcAtExit;
extern bool AppToAtExit;
extern bool AppToAtExit_Wait; //Wait 10ms on end

extern void *ttc_create(int tcsize, int wtyp);
extern bool ttc_chk_struct(void *tc);
extern void Tfree(void *tc);
extern void pp_Tfree(TTC0 **pptc);
#define ppTfree(a) pp_Tfree((void*)a)

extern void TfreeLock(void *tc);
extern bool TfreeUnLock(void *tc);	//True = Free or GoFree or !ttc_struct
#define TfreeChkGoFree(a) ((((TTC*)a)->FREE_LOCK_Stat & TTC_GoFree) != 0)

extern bool REGP2 ttc_chk_is_wtyp(void *tc, int wtyp);

typedef bool (*TDESTROY)(void *tc);

extern char *SysError_pc();

extern void *xmalloc(size_t size);  //result NULL ERROR + EXIT 
extern void *xcalloc(size_t size);
extern void *xrealloc(void *ptr, size_t size);
extern void *xrecalloc(void *ptr, size_t size, size_t old_size);
extern void xfree(void *ptr);
extern void pp_free(void **ptr); //mem Free and *ptr = NULL
#define ppfree(a) pp_free((void*)a)
#define ppcfree(a) pp_free((void*)a)

#ifdef MEM_CHK
extern void *zmalloc(size_t size);  //result NULL no ERROR
extern void MEM_CHK_AZ();
extern void MEM_CHK_AZ_pc(const char *pc);
extern void MEM_CHK_ADD(void *xm, size_t size);
extern bool MEM_CHK_CLR(void *xm);
extern void MEM_CHK_Count(int *count, size_t *size);
#else
#define zmalloc(a) malloc(a)
#define MEM_CHK_AZ()
#define MEM_CHK_AZ_pc(a)
#define MEM_CHK_ADD(a, b)
#define MEM_CHK_CLR(a)
#endif

extern void set_arr(void **parr, int headsize, int old_items, int items, int size);
extern void set_ptr_arr(Tptr_arr **parr, int items);

extern void pp_void_va_add(void ***ppp, int n, va_list args);
extern void pp_void_add(void ***ppp, int n, ...);

extern dword GetTime_us();
extern dword GetTime_ms();
extern bool cpTime(dword ref, dword now);
extern dword GetCurTimeDiv_us(dword StartTime);

extern uint64_t GetTime_us64();
extern uint64_t GetCurTimeDiv_us64(uint64_t StartTime);

#ifdef _OS_WIN32
extern void set_app_time(uint64_t *app_us, dword *app_ms, dword *Hz30, long *tv_sec);
#else
extern void set_timeval(struct timeval *tv, dword us);
#endif

// ******************* String ***********************
#define chkStrLen 	0x7fffffff

extern void Tlgs_Clr(Tlgs *lgs);
extern void Tlgs_Add(Tlgs *lgs, Tlgs *lgs_add);
extern void Tlgs_Add_s(Tlgs *lgs, const char *s, int lg);
extern void ppclg_ins_slg(char **ppc, int *pplg, const char *s, int slg, int ins_idx);

extern void ppcchange(char **ppc, const char *s);
extern void ppcnchange(char **ppc, const char *s, int lg);
extern bool ppcchange_cmp(char **ppc, const char *s);
extern int  ppcchange_add_n(char **ppc, int n, ...); //ppc = a + ...

extern char *pcdup(const char *s);
extern char *pcndup(const char *s, int lg);
extern long  pclen(const char *s);
extern long pwclen(const word *s);

extern void ppcadd(char **ppc, const char *s);
extern char *pcadd(const char *a, const char *b);

extern char *pcadd_n(int n, ...);
extern int  ppcadd_n(char **ppc, int n, ...);	//ppc = ppc + ...

extern char *pcnnadd(const char *a, int la, const char *b, int lb);
extern void ppcnadd(char **ppc, const char *s, int lg);
extern void ppcadd2(char **ppc, const char *a, const char *b);	//ppc = ppc + a + b

extern void ppclg_Add2_slg(char **ppc, int *pplg, const char *a, int alg, 
						  const char *b, int blg);

extern char *pctrim(const char *a);
extern void ppctrim(char **ppc);
//extern void ppcchange_trim(char **ppc, const char *a);
extern char *pctrimleft(const char *a);
extern void ppctrimleft(char **ppc);
//extern void ppcchange_trimleft(char **ppc, const char *a);
extern char *pctrimright(const char *a);
extern void ppctrimright(char **ppc);
//extern void ppcchange_trimright(char **ppc, const char *a);

extern bool pcfind(const char *s, const char *find, int *idx);

extern void ppcins(char **ppc, const char *s, int ins_idx);

extern void ppcdelsel(char **ppc, int sa, int se);
extern void ppclg_delsel(char **ppc, int *lg, int sa, int se);

extern char *strgetsel(char *s, int sa, int se);

extern long ppcmove(char **dest, const char *src);
extern long pcmove(char *dest, const char *src);
extern void ppcnmove(char **dest, const char *src, long len);
extern void pcnmove(char *dest, const char *src, long len);
extern int pcxmove(char *dest, const char *src, long max_len);

extern void nmove(void **dest, const void *src, long len);
#define ppnmove(a, b, c) nmove((void*)a, b, c)
extern void pnmove(void *dest, const void *src, long len);
extern void *pndup(const void *src, long len);


#define fcmp_ascii 1
#define fcmp_utf8  (1<<1)
#define fcmp_u16   (1<<2)
#define fcmp_u16BE (1<<3)
//#define fcmp_u32   (1<<4)
//#define fcmp_u32BE (1<<5)
#define fcmp_case (1<<8)


extern const char l_ascii[272];
extern const char l_iso8859_1[272];
extern const char u_ascii[272];
extern const char u_iso8859_1[272];

extern int pccmp_i(const char *a, const char *b);
extern int pcncmp_i(const char *a, const char *b, int n);
//extern int pwccmp_i(word *a, word *b);
//extern int pwcncmp_i(word *a, word *b, int n);

#define FU_CASE_NONE	0
#define FU_CASE_ASCII	1
#define FU_CASE_8859_1	2
#define FU_CASE_MASK	0xff
#define FU_CASE_SpaceOK (1<<16)
extern int pccasecmp_fi(const char *a, const char *b, int fu);
extern int pcncasecmp_fi(const char *a, const char *b, int n, int fu);
extern int pccasecmpASCII(const char *a, const char *b);
#define casecmpA(a, b) pccasecmpASCII(a, b)
extern int pcncasecmpASCII(const char *a, const char *b, int n);
#define ncasecmpA(a, b, c) pcncasecmpASCII(a, b, c)
extern int pccasecmpASpace(const char *a, const char *b);
extern int pcncasecmpASpace(const char *a, const char *b, int n);
extern bool str_match(const char *pattern, const char *string, int fu);

extern bool pccmp(const char *a, const char *b);
extern bool pcncmp(const char *a, const char *b, int n);
#define pccasecmp(a,b) (pccasecmp_fi(a, b, 0) == 0)
#define pcncasecmp(a,b,n) (pcncasecmp_fi(a, b, n, 0) == 0)

extern bool pwccmp(const word *a, const word *b);
extern bool pwcncmp(const word *a, const word *b, int n);
extern int pwccmp_i(const word *a, const word *b);
extern int pwcncmp_i(const word *a, const word *b, int n);
extern int pwccasecmp_fi(const word *a, const word *b, int fu);

//extern void pwctoUTF8lgs(const word *pwc, Tlgs *lgs);
extern char *pwctoUTF8(const word *pwc);
extern word *UTF8lgstopwc(Tlgs *lgs, int UCfu);
extern word *UTF8topwc_fu(const char *pc, int UCfu);
extern word *UTF8topwc(const char *pc);


extern void pctoLcase_fi(char *a, int fu);
extern void pctoLcaseASCII(char *a);


/*__________________________ token ______________________________________*/
/* sys/token.c */
#define TokenFu_PlusSep		1
/*
  char *token;
  const char *indata;
	indata = "T1 T2 T3";
	while (indata) {
	    indata = GetToken(indata, &token);
	    if (token) {
		// user code
		xfree(token);
	    }
	}
*/
extern const char *GetToken(const char *indata, char **token);
extern const char *pcGetToken(const char *indata, const char **token, int *lg);
extern const char *GetTokenFu(const char *indata, char **token, int fu);

extern const char *token_find(const char *data, const char *find);

extern void FillChar(char *pc, int lg, char c);
extern void FillChar0(char *pc, int lg);
#define Fill0(a, b) FillChar0((void*)a, b)
//extern void Fill0(void *p, int lg);

#define Char_ErrorUTF8 0x80000000
extern dword REGP1 Utf8CharToWChar(const char *pc);
extern dword REGP2 Utf8CharToWChar_rlg(const char *pc, int *rlg); //rlg = 1,2,3 (char)
extern int  REGP1 get_Utf8Chars(const char *pc);  //ret = 1,2,3 (char)
extern void REGP2 IncUtf8Idx_lgs(int *idx, Tlgs *lgs);
extern void REGP2 DecUtf8Idx(int *idx, const char *s);

extern dword Get_WChar(int idx, const char *pc, int lg, bool UTF8on);
extern dword GetNext_WChar(int *idx, const char *pc, int lg, bool UTF8on);
extern dword GetPrev_WChar(int *idx, const char *pc, bool UTF8on);

#define UC_WCharBE		0x01
#define UC_force_ASCII		0x04
#define UC_force_LastChar0	0x08
extern int Utf8ToWChars(word *dpc, int DWChars, const char *spc, int SChars, int UCfu);
extern int WCharsToUtf8(char *dpc, int DChars, const word *swc, int SWChars, int UCfu);
extern int AsciiToUtf8(char *dpc, int DChars, const char *spc, int SChars);

/* fuEOL in sysbaseio.h */
extern int Chk_fio_UTF8(const char *spc, int SChars, int *fuEOL); //ret WChars
extern int Chk_fio_UTF8_lgs(Tlgs *lgs, int *fuEOL);

/* utf8 escape */
extern int CharsToUtf8esc(char *dpc, int DChars, const char *spc, int SChars, int UCfu);
extern void pctoUTF8esclgs(const char *pc, Tlgs *lgs);
extern char *pctoUTF8esc(const char *pc);

extern int Utf8escToChars(char *dpc, int DChars, const char *spc, int SChars, int UCfu);
extern void UTF8esctopclgs(const char *pc, Tlgs *lgs);
extern char *UTF8esctopc(const char *pc);

/* LF -> escape sequence '\n' */
extern char *sc_lf_to_backslash(const char *s);
/* escape sequence '\n' -> LF */
extern char *sc_backslash_to_lf(const char *s);



typedef struct TLineBuf {
  AlgTTC0
  long lg;
  long memlg;
  char *pc;
  char *pc_rdidx;
  char *UTF8_buf;
  long UTF8_buf_size;
  long maxLineLen;
  int64_t datalg;		//used in ftp_stream.c
  bool eof;
  bool rd_ok;
  bool wr_memlook;
} TLineBuf;

extern TLineBuf * TLineBuf_Create();

extern void TLineBuf_Clr(TLineBuf *lb);
extern void TLineBuf_Add(TLineBuf *lb, const char *s, long lg);
extern long TLineBuf_Sub(TLineBuf *lb, long lg); //return Rest lg
extern long TLineBuf_fd_Add(TLineBuf *lb, FileHandle fd);
extern long TLineBuf_Get(TLineBuf *lb, long max, char **ppc);
extern bool TLineBuf_GetData_lgs(TLineBuf *lb, Tlgs *lgs, long max, int *fuEOL);
extern char *TLineBuf_Set_mem(TLineBuf *lb, long lg);
extern bool TLineBuf_GetLineEOL_lgs(TLineBuf *lb, Tlgs *lgs, int *fuEOL);
extern void TLineBuf_SetLineEOL_lgs(TLineBuf *lb, Tlgs *lgs, int *fuEOL);
extern void TLineBuf_Ins(TLineBuf *self, long idx, const char *s, long lg);
extern void TLineBuf_Del(TLineBuf *self, long idx, long lg);

extern long TLineBuf_sync0_mem(TLineBuf *lb);

// ******************** Mat str RD *******************************

extern int ppctoint_scan(const char **ppc, bool Scan);
extern int ppctoint(const char **ppc);
extern int pctoint_scan(const char *pc);
extern int pctoint(const char *pc);

extern int ppctohex_scan(const char **ppc, bool Scan);
extern int ppctohex(const char **ppc);
extern int pctohex(const char *pc);

extern float ppctofloat_scan(const char **ppc, bool Scan);
extern float ppctofloat(const char **ppc);
extern float pctofloat(const char *pc);

extern int64_t ppctoint64_scan(const char **ppc, bool Scan);
extern int64_t ppctoint64(const char **ppc);
extern int64_t pctoint64(const char *pc);

extern int64_t ppctohex64_scan(const char **ppc, bool Scan);
extern int64_t ppctohex64(const char **ppc);
extern int64_t pctohex64(const char *pc);

extern double ppctodouble_scan(const char **ppc, bool Scan);
extern double ppctodouble(const char **ppc);
extern double pctodouble(const char *pc);


// ******************** Mat str WR *******************************
#define kNULL_ADD    0x0000000
#define kSPACE_ADD   0x0100000
#define kCOMMA_ADD   0x0200000
#define kSEMICOL_ADD 0x0300000
#define kCOLON_ADD   0x0400000
#define kSLASH_ADD   0x0500000
#define kPERCENT_ADD 0x0600000
//0  1   2   3   4   5   6   7
//0 " " "," ";" ":" "/" "%" " "
#define kLF_ADD      0x0800000
#define kNO_NULL     0x1000000

extern void ppcmove_kchar(char **ppc, int kxxx_add);
extern void ppcmove_k(char **dest, const char *src, int kxxx_add);

#define kLEFT_ALIGN  0x80
#define kVALUE_Neg   0x010000
#define kVALUE_int   0x020000

//b0..4    l=min.lg	0..31
//b8..11   n=nachkomma	0..9 (int64 0..15)
//b12..15  i		0x010000 w=neg   0x020000 w=integer
//b16..19  char+	0x100000 add ' ' 0x200000 add ',' 0x30000 add ';' 
//                    i n l
//w= 1234 min_nums=0x010208 --> "  -12.34"
//w=-1234 min_nums=0x020208 --> "  -12.34"
extern void ppcmove_v32(char **ppc, dword w, int min_nums);    //Achtung *pc min 16 char's
extern int  pcmove_v32(char *pc, dword w, int min_nums);	//         nk max 9
extern void ppcmove_v64(char **ppc, uint64_t w, int min_nums);	//Achtung *pc min 24 char's
extern int  pcmove_v64(char *pc, uint64_t w, int min_nums);		//         nk max 15

extern void inttoppc(char **ppc, int w);	//Achtung *pc min 16 char's
extern int  inttopc(char *pc, int w);		//Achtung *pc min 16 char's
extern void int64toppc(char **ppc, int64_t w);	//Achtung *pc min 24 char's
extern int  int64topc(char *pc, int64_t w);	//Achtung *pc min 24 char's

//min_nums +char  0x100000 add ' ' 0x200000 add ',' 0x30000 add ';' ...
extern void hextoppc(char **ppc, dword val, int min_nums);
extern void hextopc(char *pc, dword val, int min_nums);
extern void hexto0xppc(char **ppc, dword val, int min_nums);
extern void hexto0xpc(char *pc, dword val, int min_nums);
extern void hex64toppc(char **ppc, uint64_t val, int min_nums);
extern void hex64topc(char *pc, uint64_t val, int min_nums);
extern void hex64to0xppc(char **ppc, uint64_t val, int min_nums);
extern void hex64to0xpc(char *pc, uint64_t val, int min_nums);

//decipoint +char  0x100000 add ' ' 0x200000 add ',' 0x30000 add ';' ...
extern void floattoppc(char **ppc, float w, int decipoint);
extern int  floattopc(char *pc, float w, int decipoint);
#define DECIPOINT_AUTO	0x10
#define DECIPOINT_EXP	0x20
extern void doubletoppc(char **ppc, double w, int decipoint); //Achtung *pc min 32 char's
extern int  doubletopc(char *pc, double w, int decipoint);

// ******************** Error *******************************
#define EMSG_TXT	0
#define EMSG_DEBUG	1
#define EMSG_INFO	2
#define EMSG_WARN	3
#define EMSG_ERR	4
#define EMSG_ERR1	5
#define EMSG_ERR2	6
#define EMSG_ERR_EXIT	7
#define EMSG_MASK_Bef	0x0000000f

#define EMSG_SYS		0x00000100
#ifdef _OS_WIN32
#define EMSG_ToLastBuf		0x00000400
#define EMSG_FromLastBuf	0x00000800
#endif
#define EMSG_NOH		0x00001000
#define EMSG_NOSYS		0x00002000
#define EMSG_NO_LF		0x00004000
#define EMSG_H_LF		0x00008000

#define EMSG_MASK_Type		0xff0000
#define EMSG_tALG		0x000000
#define EMSG_tSYS		0x010000
#define EMSG_tMEM		0x020000
#define EMSG_tIO		0x030000
#define EMSG_tSIG		0x080000
#define EMSG_tSIGSEGV		0x090000
#define EMSG_tLibSIGSEGV	0x0d0000

#define EMSG_IMAGE_RD		0x400000
//#define EMSG_IMAGE_WR		0x410000

#define EMSG_GetResult	0x10000000
#define EMSG_None	0x80000000

/* ************* appError ****************
 errno = 2;	//[No such file or directory]
 appError(EMSG_ERR1, "Test String");
 appError(EMSG_ERR1 | EMSG_SYS, "Test String");
 appError(EMSG_ERR1 | EMSG_SYS | EMSG_NOSYS, "Test String");
 appError(EMSG_ERR1 | EMSG_NOH, "Test String");
 appError(EMSG_ERR1 | EMSG_NOH | EMSG_SYS, "Test String");

ERROR exec_name: Test String
ERROR exec_name: Test String [No such file or directory]
ERROR exec_name: Test String
Test String
Test String [No such file or directory]

**************************************** */

extern void appError(int ErrType, const char *msg, ...);
#ifdef _OS_WIN32
//extern char *appError_LastBuf;
extern void appError_LastClr();
#endif
extern int (*appError_ev)(int ErrType, const char *err);
/* if appError_Str buf==NULL result is alloc */
extern char *appError_va_Str(char *buf, int size, int ErrType, const char *msg, va_list args);

extern int appError_Mk;

// ******************** File str *******************************

#define TestSlash(a) ((a == '/') || (a == '\\'))
#define TestNoSlash(a) ((a != '/') && (a != '\\'))

extern char *GetFilePath(const char *fn);
extern const char *GetFileName_pc(const char *fn);
extern char *GetFileName(const char *fn);
extern const char *GetFileExt_dot_pc(const char *fn);	//name.ext > .ext
extern const char *GetFileExt_pc(const char *fn);	//name.ext > ext
extern char *ChangeFileExt(const char *fn, const char *ext);
extern void ChangeFileExt_ppc(char **fn, const char *ext);
extern char *ChangeFileName(const char *fn, const char *name);
extern void ChangeFileName_ppc(char **fn, const char *name);

#ifdef _OS_WIN32
extern bool path_cmp(const char *a, const char *b);
#else
#define path_cmp(a, b) pccmp(a, b)
#endif

/* -----------------------------------------------
path_add() 
  NULL + NULL     result=NULL
  "/a/b/" + NULL  result="/a/b"
  "/a" + "b"      result="/a/b"
----------------------------------------------- */
extern char *path_add(const char *basepath, const char *s);
extern void path_add_ppc(char **basepath, const char *s);

/* -----------------------------------------------
path_add_Slash() 
  NULL + NULL     result="/"
  "/a/b" + NULL   result="/a/b/"
  "/a" + "b"      result="/a/b/"
----------------------------------------------- */
extern char *path_add_Slash(const char *basepath, const char *s);
extern void path_add_Slash_ppc(char **basepath, const char *s);

/* -----------------------------------------------
path_add_noChk() 
  NULL + NULL     result=NULL
  "/a/b/" + NULL  result="/a/b/"
  "/a" + "b"      result="/a/b"
----------------------------------------------- */
extern char REGP3 *path_add_noChk(const char *basepath, const char *s);

/* -----------------------------------------------
path_sub() 
  /a/b -> *ret = /a/  result=True
  / -> *ret == NULL   result=False
----------------------------------------------- */
extern bool path_sub(const char *path, char **ret);
extern bool path_sub_ppc(char **path);


extern bool path_end_isSlash(const char *path);

/* -----------------------------------------------
path_cut("ftp://127.0.0.1/tmp/testdir/test.txt", 16) 
	"ftp://.../test.txt" 		--> Achtung lg=18 !!!!!!!
path_cut("file:///tmp/testdir/test.txt", 16) 
	/.../test.txt
path_cut("file:///tmp/testdir/test.txt", 50) 
	/tmp/testdir/test.txt
----------------------------------------------- */
extern char *path_cut(const char *path, int max_char); //max_char not exact !!!

  /* ***** io/x.c ****** */
  /* not encode ./abc/def */
extern char *dotdot_korr(const char *s);	//result mem alloc
extern void ppc_dotdot_korr(char **s);

extern void dotdot_scan(char *pc0);

extern void slash_korr(char *s, bool backslash);

#define pathi_Local	1
#define pathi_rel	(1<<1)
#define pathi_RA_file	(1<<2)
#ifdef _OS_WIN32
#define pathi_SMB	(1<<3)
#define pathi_RA_SMB	(1<<4)
#endif
#define pathi_dest	(1<<8)

typedef struct {
  dword fu;
  int RA_lg;  //file: RA_lg=5
  int URL_lg; //ftp://0.0.0.0/ URL_lg=7
  union {
    const char *path;
    char *path_s;
  };
  union {
    const char *path_anf;
    char *path_anf_s;
  };
  union {
    const char *url_anf;
    char *url_anf_s;
  };
} TPathInfo;

extern bool get_PathInfo(const char *fn, TPathInfo *pathi);

/* -----------------------------------------------
path_to_local()      incl path_rel2abs() + dotdot_korr() + slash_korr()
  "/"           --> "/"
  "/tmp/a"      --> "/tmp/a"
  "/tmp/a/"     --> "/tmp/a"
  "/tmp/a/.."   --> "/tmp"
  "file:/tmp/a" --> "/tmp/a"
  "ftp:/tmp/a"  --> NULL
  "tmp/a"       --> PWD + "/tmp/a"
----------------------------------------------- */
extern char *path_to_local(const char *path);
#ifdef _OS_WIN32
extern charOS *path_to_local_OS(const char *path);
#else
#define path_to_local_OS(a) path_to_local(a)
#endif

/* -----------------------------------------------
path_korr_file()
  "file:/tmp/a" --> "/tmp/a"
  "/tmp/a"      --> "/tmp/a"
  "/tmp/a/.."   --> "/tmp/a/.."
  "ftp:/tmp/a"  --> "ftp:/tmp/a"
  "tmp/a"       --> "tmp/a"
----------------------------------------------- */
extern const char *path_korr_file(const char *path);

extern bool test_local_drive(const char *fn);

// *********************** app misc ***********************************
extern void cmdline_slash_korr(int argc, char **argv);
extern void cmdline_del_argv0(int *argc, char **argv);
extern void cmdline_passwd_korr(char *arg);

  /* ***** sys/xgetpwd.c ****** */
extern char *xgetcwd(bool add_slash);	//result malloc

/* ----------------------------------------------- */
typedef struct {
  AlgTTC0
  int count;
  char **ppath;
} TEnvPath;

extern TEnvPath *TEnvPath_Create(const char *path);
extern char *TEnvPath_GetExec(TEnvPath *self, const char *exec);

// *********************** TItem ***********************************

#define AlgTItem    AlgTTC0 \
  struct TAlgItem *prev; \
  struct TAlgItem *next; \
  struct TAlgItem **pproot;

typedef struct TItem {
  AlgTTC0
  struct TItem *prev;
  struct TItem *next;
  struct TItem **pproot;
} TItem;

extern void *TItem_Create(TItem **pproot, int size, int wtyp);
extern bool TItem__Destroy(TItem *self);
//extern void *TItemAdd(TItem **pproot, TItem *prev, int size, int wtyp);
extern void *TItemAdd(TItem **pproot, int size, int wtyp);
extern void *TItemAddTo(TItem **pproot, TItem *prev, int size, int wtyp);

extern void TItemIns(TItem *prev, TItem *self);

// *********************** TNode ***********************************
#define AlgTNode  AlgTTC \
  struct TAlgNode *prev; \
  struct TAlgNode *next; \
  struct TAlgNode *prev_child; \
  struct TAlgNode *next_child; \
  struct TAlgNode **pproot;

typedef struct TNode {
  AlgTTC
  struct TNode *prev;
  struct TNode *next;
  struct TNode *prev_child;
  struct TNode *next_child;
  struct TNode **pproot;
} TNode;

extern void *TNode_Create(TNode **pproot, int size, int wtyp);
extern bool TNode__Destroy(TNode *self);
extern void *TNodeAddTo(TNode **pproot, TNode *prev_child, TNode *prev, int size, int wtyp);

extern void TNodeIns(TNode *prev_child, TNode *prev, TNode *self);
extern void TNodeReMove(TNode *self);

// ******************* cpu *****************************
extern dword GetCPU_Flags();

#define CPU_has_MMX	1
#define CPU_has_SSE	(1<<1)
#define CPU_has_SSE2	(1<<2)
#define CPU_has_SSE3	(1<<3)
#define CPU_has_TSC	(1<<8)

// ******************* bits_io.c ***********************
typedef dword (*TFBitsIO_rd_byte)(void *io_struct);
typedef void (*TFBitsIO_wr_byte)(void *io_struct, int value);

typedef union {
  dword (*rd_byte)(void *io_struct);
  void (*wr_byte)(void *io_struct, int value);
} TFBitsIO;

typedef struct {
  union {
    byte *dat;
    const byte *dat_const;
    char *pc;
    const char *pc_const;
  };
  dword buf;
  int k;
  TFBitsIO io;
  void *io_struct;
} TBitsIO;

extern void SetBits8(TBitsIO *bits, int v, int n);
extern void SetBits8End(TBitsIO *bits);
extern int GetBits8(TBitsIO *bits, int n);
extern void REGP2 SetBits8Data(TBitsIO *bits, const byte *dat);

extern const byte *Clip255;

// ******************* RGB ***********************
extern word  REGP1 RGB24To16(dword Col);
extern dword REGP1 RGB16To24(word RGB16);


// ******************* Misc ***********************
typedef int (*TCompareFunction)(char*, char*, int fu);

extern void QuickSort_PL(char **PL, int L, int R, int fu, TCompareFunction);

extern void *load_lib(void *Module, const char *Proc);

/* TdServHead.HeadArt */
#define hServHead		0
#define hServFileStat		1
#define hServFile		hServFileStat
//#define hServFileCopyStat	3
//#define hServFilePlugin		4
#define hServData		5

#define AlgTdServHead    int lg; \
  byte HeadArt; \
  byte bef; \
  byte fu; \
  byte strg; \
  int pid; \
  int ID; \
  int UserID; \
  int UserTag; \
  word m;

typedef struct TdServHead {
  AlgTdServHead
  char dat[1];
} TdServHead;

// ******************* base32.c ***********

char *base32_dec(const char *data, int count);

// ******************* Crypt Mini -- lib/sys/CryptMini16c.c ***********
//min 1 Char ... max 16 Chars
char *CryptMini16c_dec(char *pw16);
char *CryptMini16c_enc(const char *crypt);
void  CryptMini16c_enc_reg(const char *crypt);

// ******************* Char Tab -- lib/sys/char/zC_*.c ***********
extern const char zC_DIGIT[256];

extern const char zC_HEX[256];
extern const char zC_HEX2ASCII[16];
extern const char zC_HEX2LASCII[16];

extern const char zC_ASCII2INT[256];

// ******************* appMutex (in mem.c) ***********************
extern void appMutex_init();
extern void appMutex_lock();
extern void appMutex_unlock();

extern void REGP2 atomic_and(dword *var, dword op);
extern void REGP2 atomic_or(dword *var, dword op);

extern void app_atexit();

// ******************* misc cmd ***********************************
/* result True == Error; */
extern bool cmd_get_double(int argc, char **argv, char *pc, int *idx, double *res);
extern bool cmd_get_float (int argc, char **argv, char *pc, int *idx, float *res);
extern bool cmd_get_int   (int argc, char **argv, char *pc, int *idx, int *res);
extern bool cmd_get_pc    (int argc, char **argv, char *pc, int *idx, char **res);
extern bool cmd_get_cpc   (int argc, char **argv, const char *pc, int *idx, const char **res);

extern bool cmd_get_int_pp(int argc, char **argv, char **ppc, int *idx, int *res);

// ******************* meminfo.c ***********************************
typedef struct {
  dword Total, Free, Cached, SwapTotal, SwapFree;  //kB
} TMemInfo;

extern int meminfo_get(TMemInfo *MemInfo);
extern int meminfo_scan(TMemInfo *MemInfo, const char *buf, int lg);

// ******************* lib/Xapp/W32_X11/xxx.c ***********************
#ifdef _OS_WIN32
#define del_path_end_slash 0x01
#define add_end_asterisk 0x02
extern word *get_pcw_filename(const char *fn, int fu);
#endif

typedef struct TWRect {
  int left;
  int top;
  int width;
  int height;
} TWRect;

struct TImage;

#endif /* __SYSBASE_H__ */
