/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef	__ALD_FILEWIN_H__
#define	__ALD_FILEWIN_H__    1

#include "tdirlist.h"

//******************* TFileWin ***************************************
#define ie_artItemSelect	0
#define ie_artFileEnter		1
#define ie_artPathEnter		2
//#define ie_artPathLoad	2
/* TItemEnter int stat 
 (*stat & 0xff) = 0	Start
 *stat |= 0x10		Halt 
 (*stat & 0xff) = 2	End
 (*stat & 0x100)	Path ret  (..)
*/
typedef struct {
  int art;
  char *fn;
  char *fn_passwd;
  const char *name_node;
  TglobPath *gp;
  TDirFileList *dfl;
  int stat;
} TItemEnter;

typedef struct {
  int art;
  int fu;
  int Width;
  char *name;
} TFDL_ColD;

typedef struct {
  bool Az0_ItemE_Dbl;
  bool Az0_PathE_Dbl;
  bool Az1_ItemE_Dbl;
  bool Az1_PathE_Dbl;
} TFDL_Def;

typedef struct {
  int fu;
  int size;		//default width, height
  int max_w;
  int max_h;
  int max_ico_size;		//max width or height to show icon
} TGetFilePic_rszPara;

#define fwgfp_bef_ClrAll	0
#define fwgfp_bef_GetPic	1
#define fwgfp_bef_Free		2
#define fwgfp_bef_ClrPic	3

#define AzFu_Col1_DirHeight32	1
#define AzFu_DriveList		(1<<16)

#define fwOn_stat_Start		0
#define fwOn_stat_End		2
#define fwOn_stat_Error		9
#define fwOn_stat_RetHalt	0x10
#define fwOn_stat_Mask		0xff

/* OnLoadDir int *stat 
 (*stat & 0xff) = 0	Start
 *stat |= 0x10		Halt 
 (*stat & 0xff) = 2	End
*/

/* OnPathEnter int *stat 
 (*stat & 0xff) = 0	Start
 *stat |= 0x10		Halt 
 (*stat & 0xff) = 2	End
 (*stat & 0x100)	Path ret  (..)
*/

#define TCSelf TFileWin

#define AlgFileWin  AlgGrid \
  int AzArt; \
  int sortFu; \
  int AzFu; \
  int OldSelIdx; \
  char *Akt_FileName; \
  TPattern *patt; \
  TFDL_ColD FDL_ColD_arr[9]; \
  void (*OnLoadDir)(struct TFileWin*, char **ppfn, int *stat); \
  void (*OnItemEnter)(struct TFileWin*, TItemEnter *ie); \
  TPic *(*GetFilePic)(struct TFileWin*, TDirFileList *dfl, int size, int bef); \
  void (*OnFileMsg)(struct TFileWin *self, TFileMsg *fmsg); \
  void *GetFilePic_struct; \
  TGetFilePic_rszPara *rszPara; \
  TGetFilePic_rszPara rszPA[4]; \
  TFDL_Def FDL_Def; \
  int Sort_Col; \
  int NyAzStat; \
  char *DriveList; \
  bool Strg_SelMod; \
  bool DblClick_ItemEnter; \
  bool DblClick_PathEnter; \
  bool fw_nc3; \
  byte LastSortUD[12];

typedef struct TFileWin {
  AlgFileWin
} TFileWin;
#undef TCSelf

extern TFileWin *TFileWin_Create(TWins *Parent);
extern TFileWin *TFileWin_CreateA(TWins *Parent, int left, int top, int width, int height, int Align);
extern bool TFileWin__Destroy (TFileWin *self);
extern void TFileWin_DoMouseDown(TFileWin *self, XButtonEvent *ev);
extern void TFileWin_DoClick(TFileWin *self, long KeyState, bool DblClick);
extern void TFileWin_PathEnter(TFileWin *self, TDirFileList *dfl, const char *fn, int art);
extern void TFileWin_DoItemEnter(TFileWin *self, int fu);
extern int TFileWin_DoKeyDown(TFileWin *self, TKeyEvent *KeyEv);
extern void TFileWin_DoFocusIn(TFileWin *self, int Change);
extern void TFileWin_DoFocusOut(TFileWin *self, int Change);

extern TDirFileList *TFileWin_Get_dfl(TFileWin *self, int idx);

extern void TFileWin_SetColsArt(TFileWin *self, int AzArt);
extern void TFileWin_SetSort(TFileWin *self, int sortFu); //in tdirlist.h dlsortFu_Case,..
extern void TFileWin_SetSelect(TFileWin *self, int idx, int fu);

extern void TFileWin_Resize(TFileWin *self);
extern bool TFileWin_DoPaintCell(TFileWin *self, int ACol, int ARow, TWRect *rc, int *fu);
extern void TFileWin_SetIdxToWin(TFileWin *fw, int idx);
extern void TFileWin_NewFocusIdx(TFileWin *self, int Idx, int fu);

extern bool TFileWin_LoadDir(TFileWin *fw, char *FileName);
extern void TFileWin_SetShowHidden(TFileWin *self, bool ShowHidden);
extern void TFileWin_Clr(TFileWin *self);

extern void TFileWin_ReLoadDir(TFileWin *self);
extern void TFileWin_ReScan(TFileWin *self);
extern void TFileWin_set_pattern(TFileWin *fw, const char *pattern, 
				unsigned short *FileType);
extern TPattern *TFileWin_get_pattern(TFileWin *fw);
#ifdef DRAG_AND_DROP
extern void TFileWin_dnd_master_init(TFileWin *fw);
#endif  /* DRAG_AND_DROP */


extern void TFileWin_InitAzPic(TFileWin *self);
extern TPic *TFileWin_GetFilePic(TFileWin *self, TDirFileList *dfl, int size, int bef);

extern TglobPath *TFileWin_Get_gp(TFileWin *self);
extern TDirFileList *TFileWin_Get_dfl0(TFileWin *self);
extern TDirFileList *TFileWin_Get_Select_dfl(TFileWin *self, TDirFileList *old_dfl);
extern char *TFileWin_GetAktDir(TFileWin *fw);

extern void TFileWin_ini_RD(TFileWin *self, TpcIni *pcIni, const char *Gruppe);
extern void TFileWin_ini_WR(TFileWin *self, TpcIni *pcIni, const char *Gruppe);

extern bool TFileWin_GetColsData(TFileWin *self, int idx, TFDL_ColD *ColD);
extern bool TFileWin_SetColsData(TFileWin *self, int idx, TFDL_ColD *ColD);

extern void TFileWin_ini_RD_ColD(TFileWin *self, TpcIni *pcIni, const char *Gruppe);
extern void TFileWin_ini_WR_ColD(TFileWin *self, TpcIni *pcIni, const char *Gruppe);

extern void TFileWin_SetMouseZ_Wheel(TFileWin *self, int Value);

/* --------------- tfilewin_get_dfl_by_name.c -------- */
extern bool TFileWin_Get_dfl_by_name(TFileWin *self, const char *fn, \
				int *ret_idx, TDirFileList **ret_dfl);


/* _____________________ TTreeVFile __________________________ */

#define tfvfart_ROOT	1
#define tfvfart_MASK	0xff

#define tfvfart_Dummy	(1<<8)


#define TCSelf TTreeVFile
typedef struct TTreeVFile {
  AlgTreeV
  TTreeVNode *Nodes;
  TglobPath sel_gp;
  void (*OnFileMsg)(struct TTreeVFile *self, TTreeVNode *tvfn, TFileMsg *fmsg);
  void (*OnChkOpenNode)(struct TTreeVFile *self, TTreeVNode **tvfn);
  bool AnyNodeChange;
  bool tv_ncb1, tv_ncb2, tv_ncb3;
} TTreeVFile;
#undef TCSelf

extern bool TTreeVFileNode__Destroy(TTreeVNode *self);

extern TTreeVFile *TTreeVFile_Create(TWins *Parent);
extern TTreeVFile *TTreeVFile_CreateA(TWins *Parent, int Left, int Top, int Width, 
			int Height, int Align);
extern TTreeVNode *TTreeVFile_AddNode(TTreeVFile *self, TTreeVNode *prev_child, 
			TTreeVNode *prev, const char* s);
extern TTreeVNode *TTreeVFile_AddRoodNode(TTreeVFile *self, TTreeVNode *prev_child, 
			TTreeVNode *prev, const char* s, const char *fn_root);
extern TTreeVNode *TTreeVFile_AddDummyRoodNode(TTreeVFile *self, TTreeVNode *prev_child, 
			TTreeVNode *prev, const char* s, const char *fn_root, TglobPath *gp);
extern TTreeVNode *TTreeVFile_AddDummyNode(TTreeVFile *self, TTreeVNode *prev_child, 
			TTreeVNode *prev, const char* s);

extern TTreeVNode   *TTreeVFile_GetSelectNode(TTreeVFile *self);
extern TglobPath    *TTreeVFile_GetSelect_gp (TTreeVFile *self, bool prev);
extern TDirFileList *TTreeVFile_GetSelect_dfl(TTreeVFile *self);

extern void TTreeVFile_OpenRoodNode(TTreeVFile *self, TTreeVNode *tvn);
extern char *TTreeVFile_GetNodeFileName(TTreeVFile *self, TTreeVNode *tvn);
extern char *TTreeVFile_GetNodeFileName_passwd(TTreeVFile *self, TTreeVNode *tvn);
extern bool TTreeVFile_SetSel_gp(TTreeVFile *tvf, TTreeVNode *tvfn);
extern void TTreeVFile_ChkOpenNode(TTreeVFile *tvf, TTreeVNode *tvn);

extern TDirFileList *TTreeVFileNode_Get_dfl(TTreeVNode *tvn);
extern TglobPath *TTreeVFileNode_Get_gp(TTreeVNode *tvn);
extern bool TTreeVFileNode_TestIsDummyNode(TTreeVNode *tvn);
extern TTreeVNode *TTreeVFileNode_GetDummyNode_name(TTreeVNode *tvn, const char *name);

extern bool TTreeVFileNode_ChkIsRootNode(TTreeVNode *tvn);
extern TTreeVNode *TTreeVFileNode_FindNode(TTreeVNode *root_tvn, const char *path);

extern void TTreeVFile_DoPaintNode(TTreeV *tv, TTreeVNode *tvn, int fu);

extern void TTreeVFile_SortNode(TDirListObjNy *ObjNy, int sortfu, TTreeVNode *child);

extern void TTreeVFile_SetMouseZ_Wheel(TTreeVFile *self, int Value);

#endif /* __ALD_FILEWIN_H__ */
