/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <dirent.h>

typedef struct TSearch_Rec {
  AlgTTC0
  char *path;
  TPattern *patt;
  int statfu;		//fsFollowLink,...
  int findAtr;		//findALL,findIsRootPath,....
  Tstat64 *st;
#ifdef _OS_WIN32
  HANDLE dh;
  WIN32_FIND_DATAA fid;
#else
  DIR *dh;
  struct dirent64 entry;
  struct dirent64 *ret_entry;
#endif
  bool isRoot;
  bool tsrec_nc1;
  bool tsrec_nc2;
  bool tsrec_nc3;
} TSearch_Rec;

extern TSearch_Rec *TSearch_Create(const char *fn, int findAtr, int statfu);
extern bool Find_First(TSearch_Rec *sr);
extern bool Find_Next(TSearch_Rec *sr);
extern void Find_Close(TSearch_Rec *sr);

extern bool Find_Match(TSearch_Rec *sr, const char *s);
