/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef __TWRAPLINE_H__
#define __TWRAPLINE_H__    1

typedef struct TWrapLineData {
  struct TWrapLineData *next;
  int len;
  const char *s;
  int x, y;
  dword Color, BackColor;
  TFont *font;
  const char *orig_s;
  int char_idx;
  int line_nr;
  int SelA, SelE;
  TWRect SelRc;
} TWrapLineData;

typedef struct {
  AlgTFontCharData
  TWrapLineData *wld;
//  int char_idx;
//  int char_x, char_top;
//  int char_width, char_height;
//  int char_count;
//  const char *char_s;
  int add_line_nr;
//  bool isUTF8;
} TWrapLineCharData;

/* TWrapLine.NewFlags */
#define TWLNF_USE_UPDATE_ALL	1

#define AlgTWrapLine  AlgTTC \
  int x, y; \
  int LineCount; \
  TWRect ClipRc; \
  int line_height; \
  char *line_tmp; \
  int  line_len; \
  TFont *font; \
  TWrapLineData *wld; \
  bool (*SetOrigin)(struct TCSelf *self, int x, int y); \
  bool (*SetClipRc)(struct TCSelf *self, TWRect *ClipRc); \
  bool (*SetFont)(struct TCSelf *self, TFont *font); \
  bool (*SetLine)(struct TCSelf *self, const char *s, int len); \
  bool (*SetFontLine)(struct TCSelf *self, TFont *font, const char *s, int len); \
  bool (*AddFontLine)(struct TCSelf *self, TFont *font, const char *s, int len); \
  bool (*ClrLine)(struct TCSelf *self); \
  bool (*UpdateLine)(struct TCSelf *self); \
  bool (*PaintTo)(struct TCSelf *self, long *toobj); \
  bool (*GetCharWlcd_XY)(struct TCSelf *self, int x, int y); \
  bool (*GetCharWlcd)(struct TCSelf *self, int char_idx); \
  void (*SetSelect)(struct TCSelf *self, int SelA, int SelE); \
  void (*ClrSelect)(struct TCSelf *self); \
  void (*DoXFillSelectRect)(struct TCSelf *self, long *toobj, TWRect *rc); \
  int SelA, SelE; \
  dword NewFlags; \
  int xo, yo, font_yo; \
  long *toobj; \
  TWrapLineCharData wlcd;
/* 
  char **lines; 
  int  lines_count; 
  int  lines_max_count; 
*/

#define TCSelf		TWrapLine
typedef struct TWrapLine {
  AlgTWrapLine

//  TFont *font;
//  int x, y;
//  int line_height;
//  TWRect rc;
//  long *toobj;
//  char *line;
} TWrapLine;
#undef TCSelf

extern TWrapLine *TWrapLine_Create();
extern TWrapLine *TWrapLine_AlgCreate(int tcsize, int wtyp);
extern bool TWrapLine__Destroy(TWrapLine *self);

//extern bool WrapLine_SetOrigin(TWrapLine *self, int x, int y);
extern bool WrapLine_SetClipRc(TWrapLine *self, TWRect *ClipRc);
extern bool WrapLine_SetFont(TWrapLine *self, TFont *font);

extern bool WrapLine_Set(TWrapLine *self, const char *s, int len);
extern bool WrapLine_SetStr(TWrapLine *self, const char *s);

extern bool WrapLine_UpdateLine(TWrapLine *self);
extern bool WrapLine_PaintTo(TWrapLine *self, long *toobj);

extern bool WrapLine_GetCharWlcd_XY(TWrapLine *self, int x, int y);
extern bool WrapLine_GetCharWlcd(TWrapLine *self, int char_idx);

extern void WrapLine_SetSelect(TWrapLine *self, int SelA, int SelE);
extern void WrapLine_ClrSelect(TWrapLine *self);

#endif /* __TWRAPLINE_H__ */
