/*
 Copyright (C) 2010 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef __VIDEO_IOC_H__
#define __VIDEO_IOC_H__    1

//#include <pthread.h>

#define HASF_ZOOM_plus		1
#define HASF_ZOOM_minus		(1<<1)
#define HASF_SRC_CLIP		(1<<2)
#define HASF_DEST_CLIP		(1<<3)
#define HASF_BRIGHTNESS		(1<<4)
#define HASF_CONTRAST		(1<<5)
#define HASF_COLORSAT		(1<<6)
#define HASF_RGB		(1<<7)
#define HASF_COPY_ALPHA		(1<<8)
#define HASF_ZOOM_ALPHA		(1<<9)
#define HASF_NEGATIV		(1<<10)
#define HASF_GRAY_NATURE	(1<<11)
#define HASF_RGB_REDUCE		(1<<12)

#define VIOCFU_NEGATIV		1
#define VIOCFU_GRAY_NATURE	(1<<1)
#define VIOCFU_COPY_ALPHA	(1<<2)
#define VIOCFU_ZOOM_ALPHA	(1<<3)

#define VIOCART_RGB_to_RGB		1
#define VIOCART_YUV422_to_RGB		2
#define VIOCART_ZOOM			3
#define VIOCART_Filter			4
#define VIOCART_YUYV_to_Jpeg		5
#define VIOCART_Jpeg_to_YUYV		6
#define VIOCART_Z1I_Filter		7
#define VIOCART_Z1O_Filter		8


#define iocf_stat_xo_Akt	0x01
#define iocf_stat_yo_Akt	0x02
#define iocf_stat_xyo_Akt	0x03

#define iocf_compress_jpeg	2
#define iocf_compress_zlib_jpeg	3

#define iocf_compress_f_diff	1
#define iocf_compress_f_diff7b	2
//#define iocf_compress_f_diff6b	1



extern TVideo_Stream *TVideo_Stream_alloc(dword width, dword height, dword bytes_per_line, dword format);

#if 1
#define TIOCF TIOCVideoF
#else
/* used in TVideo_Stream */
#define AlgTIOCF dword vdat_size; \
  byte typ; \
  byte stat; \
  byte compress; \
  byte compress_k; \
  byte format; \
  byte fps; \
  word width; \
  word height; \
  word bytes_per_line; \
  word xo, xl; \
  word yo, yl; \
  byte asp; \
  byte nc25; \
  word nc26; 

typedef struct {
  AlgTIOCF
} TIOCF;
#endif

extern TVideo_Stream *TVideo_Stream_iof_alloc(TIOCF *iof);

#define TIOCF_size 28
//#define TIOCF_wh_size 12

/*____________________________ VIDEO_TTC ________________________________*/
//#define friobef_Stream		0
//#define friobef_Open		1
//#define friobef_Close		1
//#define friobef_Start		1
//#define friobef_Stop		1
//#define friobef_EOF		2

#define friofu_GetLast		1
#define friofu_GetBufferIdx	2


#if 1
#define TFrame_IO TMediaFrame
#else
typedef struct {
  TIOCF *iof;
  union {
    TVideo_Stream *vs;
    TAudio_Stream *as;
    struct TImage *img;
    byte *raw;
  } t;
} TFrame_V;

typedef struct {
  int thdMSG;	//thdMSG (0==Stream)
  int fu;
  int tag;

  union {
    TAFrame a;
    TVFrame v;
  } org;


  union {
    TAFrame a;
    TVFrame v;
  } ret;

  union {
    TAFrame a;
    TVFrame v;
  } dest;

  int buf_frames;
} TFrame_IO;
#endif

#define tvpfst_Frame_in		1
#define tvpfst_Frame_out_ok	5
#define tvpfst_Bef_Mask		0xff



#define AlgTVideo_TTC AlgTTC \
  struct TVideo_TTC *next_link; \
  struct TVideo_TTC *next_set_link; \
  int stat; \
  int (*get_stat)(struct TVideo_TTC *tvttc); \
  int (*get_frame)(struct TVideo_TTC *tvttc, TFrame_IO *fio); \
  int (*On_frame)(struct TVideo_TTC *tvttc, TFrame_IO *fio, int *pfst); \
  int (*get_set_stat)(struct TVideo_TTC *tvttc); \
  int (*set_frame)(struct TVideo_TTC *tvttc, TFrame_IO *fio); \
  bool (*setup)(struct TVideo_TTC *tvttc, TThread_MSG *msg);


typedef struct TVideo_TTC {
  AlgTVideo_TTC
} TVideo_TTC;

extern int Video_TTC_get_stat(TVideo_TTC *tvttc);
extern int Video_TTC_get_frame(TVideo_TTC *tvttc, TFrame_IO *fio);
//void Video_TTC_SetUP(TVideo_TTC *tvttc, TThread_MSG *msg);

typedef int (*TVTTC_GET_STAT)(TVideo_TTC *tvttc);
typedef int (*TVTTC_GET_FRAME)(TVideo_TTC *tvttc, TFrame_IO *fio);
typedef int (*TVTTC_ON_FRAME)(TVideo_TTC *tvttc, TFrame_IO *fio, int *pfst);
typedef bool (*TVTTC_SETUP)(TVideo_TTC *tvttc, TThread_MSG *msg);

//  bool (*setup)(struct TVideo_IOC *ioc, TptVideo_IO_SetUP *msgData);

/*____________________________ VIDEO_Korr _______________________________*/
typedef struct {
  int	Brightness;	//-255..+255
  int	Contrast;	//-255..+255
  int	ColorSat;	//-255..+255
  int	Red;		//-255..+255
  int	Green;		//-255..+255
  int	Blue;		//-255..+255
  int	Alpha;		//-255..+255
  byte	R_reduce;	//2,3,4,5,8,9,16,17,32,33,64,65,128,129
  byte	G_reduce;	//0 and >129 not aktiv
  byte	B_reduce;
} TVideo_Color_Korr;

#define TIOCSetBef_size_s	1
#define TIOCSetBef_size_d	(1<<1)
#define TIOCSetBef_ZOOM		(TIOCSetBef_size_s|TIOCSetBef_size_d)
#define TIOCSetBef_Color	(1<<2)
#define TIOCSetBef_paintID	(1<<3)
#define TIOCSetBef_iocLink	(1<<4)
#define TIOCSetBef_DIMod	(1<<5)
#define TIOCSetBef_Filter	(1<<6)

#define TIOC_sfFilt_mod		1
#define TIOC_sfFilt_k1		(1<<1)
#define TIOC_sfFilt_k2		(1<<2)
#define TIOC_sfFilt_oForm	(1<<4)

#define TvSetUP_Video		1

typedef struct {
//  AlgTpthd_msgData
  int sf;
  TIOCF s;
  TIOCF d;
  TVideo_Color_Korr Color_Korr;
  int paintID;
  int DeInterlaceMod;
  int Filter_sf;
  int Filter_Mod;		//sf 0x01
  int Filter_k1;		//sf 0x02
  int Filter_k2;		//sf 0x04
  int Filter_out_format;	//sf 0x10
  int tvttc_count;
  struct TVideo_TTC *tvttc[8];

} TptVideo_IO_SetUP;

typedef struct TVideo_IOC {
  AlgTVideo_TTC
  TVideo_Color_Korr *tvckr;

  void	*src;
  void	*dest;
  int	iocfu;
  dword has_flag;
  dword extra_flag;
  bool (*init)(struct TVideo_IOC *ioc);
  bool (*setcolor)(struct TVideo_IOC *ioc, TVideo_Color_Korr *tvckr);
  struct TVideo_IOC *next;
  int	Fin_us;
  int	Fout_us;
  void	*Frsz;

} TVideo_IOC;

typedef void *(*TVideo_IOC_conv_vs)(TVideo_IOC *ioc, void *src, void *dest);
typedef void *(*TVideo_IOC_ConvVS)(TVideo_IOC *ioc, int styp, void *src, int dtyp, void *dest);

extern TVideo_IOC *TVideo_IOC_Create();
extern void TVideo_IOC_PV_Init(TVideo_IOC *ioc, int size, int art);

extern bool Video_IOC_ChkType(TVideo_IOC *ioc);
extern bool Video_IOC_ChkTypeArt(TVideo_IOC *self, int art);

extern bool Video_IOC_Init(TVideo_IOC *ioc);
extern bool Video_IOC_Conv(TVideo_IOC *ioc);
extern int Video_IOC_Get_Frame(TVideo_IOC *ioc, TFrame_IO *fio);
extern int Video_IOC_Set_Frame(TVideo_IOC *ioc, TFrame_IO *fio);
extern void *Video_IOC_Conv_VS(TVideo_IOC *ioc, void *src, void *dest);
extern void *Video_IOC_ConvVS(TVideo_IOC *ioc, int styp, void *src, int dtyp, void *dest);

extern bool Video_IOC_SetColor(TVideo_IOC *ioc, TVideo_Color_Korr *tvckr);
//void Video_IOC_Free(TVideo_IOC *ioc);

extern TVideo_IOC *TVideo_IOC_ColorRGB_Create();

/*____________________________ VIDEO_IO_DeInterlace _____________________*/
//Interlaced_1_2  direct Halbbild 1+2		25/50fps
//#define Interlaced_1_2		0
//Interlaced_2_3  direct Halbbild 2+3		25fps
//#define Interlaced_2_3		1
//DeInterlaced_4  DeInterlaced			25/50fps
#define DeInterlaced_4		4
//DeInterlaced_11  Halbbild 1 * 2		25fps
//#define DeInterlaced_11		5
//DeInterlaced_13  Halbbild 1 zeilen interpol	25fps
#define DeInterlaced_13		6
#define Bild_Frame_2x		(1<<5)
//#define Bild_50proz		(1<<8)
#define mod_fu_mask		0xffff
//#define DeIntFu_HBild2		(1<<16)


#endif /* __VIDEO_IOC_H__ */
