/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include "image.h"

bool DIB_chk_error(BITMAPINFOHEADER *p) {

	appError_LastClr();
	if (!p) {
	    appError(EMSG_ERR1|EMSG_ToLastBuf|EMSG_H_LF, " bmiHeader is NULL");
	    return True;
	} 
#if 0
	else {
 printf("%d %d %d %d %d %d %d %d %d %d %d\n",
	    (int)p->biSize,
	    (int)p->biWidth,
	    (int)p->biHeight,
	    (int)p->biPlanes,
	    (int)p->biBitCount,
	    (int)p->biCompression,
	    (int)p->biSizeImage,
	    (int)p->biXPelsPerMeter,
	    (int)p->biYPelsPerMeter,
	    (int)p->biClrUsed,
	    (int)p->biClrImportant);
	}
#endif
	if (p->biSize != 40) {
	    appError(EMSG_ERR1|EMSG_ToLastBuf|EMSG_H_LF, 
			" bmiHeader.biSize 40 is %d",  p->biSize);
	    return True;
	}
	if (p->biWidth > 8000) {
	    appError(EMSG_ERR1|EMSG_ToLastBuf|EMSG_H_LF, 
			" bmiHeader.biWidth %d > 8000",  p->biWidth);
	    return True;
	}
	if (p->biHeight > 6000) {
	    appError(EMSG_ERR1|EMSG_ToLastBuf|EMSG_H_LF, 
			" bmiHeader.biHeight %d > 6000",  p->biHeight);
	    return True;
	}
	if (p->biPlanes != 1) {
	    appError(EMSG_ERR1|EMSG_ToLastBuf|EMSG_H_LF, 
			" bmiHeader.biPlanes 1 is %d",  p->biPlanes);
	    return True;
	}
	if ((p->biBitCount != 16) &&
	    (p->biBitCount != 24) &&
	    (p->biBitCount != 32)) {
	    appError(EMSG_ERR1|EMSG_ToLastBuf|EMSG_H_LF, 
			" bmiHeader.biBitCount 16,24,32 is %d",  p->biBitCount);
	    return True;
	}
	if (p->biCompression != BI_RGB) {
	    appError(EMSG_ERR1|EMSG_ToLastBuf|EMSG_H_LF, 
			" bmiHeader.biCompression (BI_RGB)0 is %d",  p->biCompression);
	    return True;
	}

	return False;
}
