/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

static int dpyMonitorsStat;

TdpyMonitors dpyMonitors;
BOOL WINAPI (*dl_EnumDisplayMonitors)(HDC,LPCRECT,MONITORENUMPROC,LPARAM);


static BOOL CALLBACK EnumMonitorsCallBack(HMONITOR mon_id, HDC dc, LPRECT rc, LPARAM owner) {

	if (dpyMonitors.count < MAX_MONITORS) {
  TMonitor *mon = &dpyMonitors.mon[dpyMonitors.count];
	    dpyMonitors.count++;
	    mon->mon_id = mon_id;
	    mon->left = rc->left;
	    mon->top = rc->top;
	    mon->right = rc->right;
	    mon->bottom = rc->bottom;
	}
	return True;
}

void MonitorsInit() {
  TMonitor *mon;

	appXDat.Root_width = GetSystemMetrics(SM_CXSCREEN);
	appXDat.Root_height = GetSystemMetrics(SM_CYSCREEN);
	dpyMonitors.count = 0;
	dpyMonitors.PrimaryIdx = 0;

	if (dpyMonitorsStat == 2) goto noEnum;

	if (!dpyMonitorsStat) {
	    dpyMonitorsStat = 1;
	    HMODULE USER32dll = GetModuleHandle("USER32.dll");
	    if (USER32dll) {
		dl_EnumDisplayMonitors = GetProcAddress(USER32dll, "EnumDisplayMonitors");
	    }
	}

	if (!dl_EnumDisplayMonitors) {
noEnum:
	    dpyMonitors.count = 1;
	    mon = dpyMonitors.mon;
	    mon->mon_id = 0;
	    mon->left = 0;
	    mon->top = 0;
	    mon->right = appXDat.Root_width;
	    mon->bottom = appXDat.Root_height;
	    dpyMonitorsStat = 2;
	    return;
	}

	dl_EnumDisplayMonitors(0, NULL, EnumMonitorsCallBack, 0);
	if (dpyMonitors.count < 1) goto noEnum;

	for (int i=0;i<dpyMonitors.count;i++) {
	    mon = &dpyMonitors.mon[i];
	    if ((mon->left == 0) && (mon->top == 0) 
		&& (mon->right == appXDat.Root_width) 
		&& (mon->bottom == appXDat.Root_height)) {
		dpyMonitors.PrimaryIdx = i;
		break;
	    }
	}

	for (int i=0;i<dpyMonitors.count;i++) {
	    mon = &dpyMonitors.mon[i];
	    if (appXDat.Root_width < mon->right) appXDat.Root_width = mon->right;
	    if (appXDat.Root_height < mon->bottom) appXDat.Root_height = mon->bottom;
	}
}
