/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

int XCopyArea(Display *dpy, Drawable src_drawable, Drawable dst_drawable, GC gc,
	      int src_x, int src_y, unsigned int width, unsigned int height,
	      int dst_x, int dst_y) {

	if (!src_drawable || !dst_drawable || !gc) return 0;

  TBITMAP_Dat *srcbmDat = Get_BITMAP_Dat((HBITMAP)src_drawable);
  TBITMAP_Dat *dstbmDat = Get_BITMAP_Dat((HBITMAP)dst_drawable);
  HDC srcdc, dstdc;
  HBITMAP hbmMask = 0;
  int isTempDC;

	if (srcbmDat) {
		srcdc = CreateCompatibleDC(0);
		SelectObject(srcdc, src_drawable);
		hbmMask = gc->gcv.clip_mask;

	} else {
		srcdc = GetDC(src_drawable);
	}

	if (dstbmDat) {
		dstdc = CreateCompatibleDC(0);
		SelectObject(srcdc, dst_drawable);
	} else {
		dstdc = GetTmpPaintDC(dst_drawable, &isTempDC, gc, 0); //GetDC(dst_drawable);
	}

	if (hbmMask) {
		MaskBlt(dstdc, dst_x, dst_y, width, height,
			srcdc, src_x, src_y, 
			hbmMask, src_x, src_y, MAKEROP4(0x00AA0029, SRCCOPY));
	} else {
		BitBlt(dstdc, dst_x, dst_y, width, height,
			srcdc, src_x, src_y, SRCCOPY);
	}
 
	if (dstbmDat) DeleteDC(dstdc); else ReleaseTmpPaintDC(dst_drawable, dstdc, isTempDC); //ReleaseDC(dst_drawable, dstdc);
	if (srcbmDat) DeleteDC(srcdc); else ReleaseDC(src_drawable, srcdc);

	return 0;
}
