/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

/*____________________________________________________________________________*/
int XFreeGC (Display *dpy, GC gc) {
	if (gc->hpen) DeleteObject(gc->hpen);
	if (gc->hbrush) DeleteObject(gc->hbrush);
//	if (gc->hfont) DeleteObject(gc->hfont);
	if (gc->gcv.clip_mask) DeleteObject(gc->gcv.clip_mask);
	xfree(gc);
	return 0;
}

/*____________________________________________________________________________*/
GC XCreateGC (Display *dpy, Drawable d, unsigned long valuemask, XGCValues *values) {
  GC gc = xcalloc(sizeof(XGC));

	pnmove(&gc->gcv, values, sizeof(XGCValues));
	if (!(valuemask & GCLineWidth)) gc->gcv.line_width = 1;

// printf("%s(%d): XCreateGC: %x\n", FL, gc->gcv.background);
	gc->lopn.lopnStyle = PS_SOLID;
	gc->lopn.lopnWidth.x = gc->gcv.line_width;
	gc->lopn.lopnColor = gc->gcv.foreground;
	gc->hpen = CreatePenIndirect(&gc->lopn);

	if (valuemask & GCStipple) {
	    gc->hbrush = CreatePatternBrush(gc->gcv.stipple);
	} else {
	    gc->hbrush = CreateSolidBrush(gc->gcv.foreground);
	}
	if (valuemask & GCFont) gc->hfont = gc->gcv.font;
	return gc;
}

/*____________________________________________________________________________*/
int XChangeGC (Display *dpy, GC gc, unsigned long valuemask, XGCValues *values) {
// printf("%s(%d): XChangeGC: 0x%x\n", FL, (int)valuemask);

	if (valuemask & GCForeground) {
	    gc->gcv.foreground = values->foreground;
	    gc->lopn.lopnColor = gc->gcv.foreground;
	    if (gc->hpen) DeleteObject(gc->hpen);
	    gc->hpen = CreatePenIndirect(&gc->lopn);

	    if (gc->hbrush) DeleteObject(gc->hbrush);
	    if (valuemask & GCStipple) {
		gc->hbrush = CreatePatternBrush(gc->gcv.stipple);
	    } else {
		gc->hbrush = CreateSolidBrush(gc->gcv.foreground);
	    }
	}
	if (valuemask & GCBackground) gc->gcv.background = values->background;

	if (valuemask & GCFont) {
	    gc->gcv.font = values->font;
	    gc->hfont = values->font;
	}

	if (valuemask & GCTile) gc->gcv.tile = values->tile;
	if (valuemask & GCClipMask) gc->gcv.clip_mask = values->clip_mask;
	if (valuemask & GCClipXOrigin) gc->gcv.clip_x_origin = values->clip_x_origin;
	if (valuemask & GCClipYOrigin) gc->gcv.clip_y_origin = values->clip_y_origin;
	if (valuemask & GCTileStipXOrigin) gc->gcv.ts_x_origin = values->ts_x_origin;
	if (valuemask & GCTileStipYOrigin) gc->gcv.ts_y_origin = values->ts_y_origin;
	return 0;
}
