/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

int XSetWindowBackgroundPixmap(Display *dpy, Window w, Pixmap pixmap) {
  TWins *wins;
  HBRUSH background_pixmap;
// printf("%s(%d): XSetWindowBackgroundPixmap: \n", FL);

	wins = GetTWins(w);
	if (!wins) return 0;
	background_pixmap = wins->OS_var.background_pixmap;
	if ((background_pixmap != WinsDefault_GC->hbrush) &&
	    (background_pixmap)) DeleteObject(background_pixmap);
	if (pixmap) {
	    background_pixmap = CreatePatternBrush(pixmap);
	} else {
	    if (wins->Color != WinsDefault_GC->gcv.foreground) {
		background_pixmap = CreateSolidBrush(wins->Color);
	    } else {
		background_pixmap = WinsDefault_GC->hbrush;
	    }
	}
	wins->OS_var.background_pixmap = background_pixmap;
	return 0;
}
