/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include "tpixmap.h"

void SetSelection_TPixMap(TPixMap *pxm) {
  HGLOBAL hGlobMem;
  BITMAPINFO *p;
  int lg;

	SelRetClr();
	appXDat.SELECT_AtomsCount = 0;
	if (!pxm) return;

	lg = pxm->width * pxm->height * 4;
	if (Clipboard_Open()) {
	  hGlobMem = GlobalAlloc(GMEM_MOVEABLE+GMEM_DDESHARE, sizeof(BITMAPINFO) + lg);
	  if (hGlobMem) {
	    p = GlobalLock(hGlobMem);
	    if (p) {
		p->bmiHeader.biSize = 40; //sizeof(BITMAPINFO);
		p->bmiHeader.biWidth = pxm->width;
		p->bmiHeader.biHeight = pxm->height;
		p->bmiHeader.biPlanes = 1;
    //	    p->bmiHeader.biBitCount = 16;
		p->bmiHeader.biBitCount = 32;
		p->bmiHeader.biCompression = BI_RGB;
		p->bmiHeader.biSizeImage = lg;
		p->bmiHeader.biXPelsPerMeter = 0;
		p->bmiHeader.biYPelsPerMeter = 0;
		p->bmiHeader.biClrUsed = 0;
		p->bmiHeader.biClrImportant = 0;

		if (!image_to_DIB((TImage*)pxm, &p->bmiHeader, (byte*)p->bmiColors)) {
		    GlobalUnlock(hGlobMem);
		    GlobalFree(hGlobMem);
		} else {
		    Clipboard_Add();
		    SetClipboardData(CF_DIB, hGlobMem);
		    GlobalUnlock(hGlobMem);
		}
	    }
	  }
	  Clipboard_Close();
	}

	appError(EMSG_FromLastBuf, NULL);
}

TPixMap *GetSelection_TPixMap() {
  HGLOBAL hGlobMem;
  BITMAPINFO *p;
  TPixMap *pxm = NULL;

	if (Clipboard_Open()) {
	  hGlobMem = GetClipboardData(CF_DIB);
	  if (hGlobMem) {
	    p = GlobalLock(hGlobMem);
	    if (p) {
		pxm = TPixMap_Create_depth(p->bmiHeader.biWidth, p->bmiHeader.biHeight, 32);
		if (!DIB_to_image((TImage*)pxm, &p->bmiHeader, (byte*)p->bmiColors)) {
		    Tfree(pxm);
		    pxm = NULL;
		}
	    }
	    GlobalUnlock(hGlobMem);
	  }
	  Clipboard_Close();
	}

	appError(EMSG_FromLastBuf, NULL);
	return pxm;
}
