/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

static TForm *getappForm(Window win) {
  TWins *wins = appXDat.Wins;
	while (wins && (wins->WinID != win)) wins = wins->next;
	if (wins && (wins->wtyp & wtyp_Form)) return (TForm*)wins;
	return NULL;
}

/* ______________________________________________________________________*/
static void XKey2TKey(XKeyEvent *XKeyEv, int keyst) {
  Tobjmsg msg;
  TKeyEvent KeyEv;
  int m;

	Send_MSG_MotionEvent();
	if (appXDat.appCursorWait) return;

	appXDat.Tmp_XKeyEv = XKeyEv;
	appXDat.last_KeyState = XKeyEv->state;
	KeyEv.keyst = keyst;
	KeyEv.state = XKeyEv->state;
	KeyEv.keycode = XKeyEv->keycode;
	XLookupString(XKeyEv, (char*)&m, 4, &KeyEv.keysym, NULL);
	NumLook_korr(&KeyEv);
	msg.msg = msgKey;
	msg.f = msg.m = 0;
	msg.p = &KeyEv;
	if (appXDat.KeyInForm) Exec_Win_Ev(&msg, appXDat.KeyInForm->WinID);
	if (KeyEv.keysym && appXDat.KeyInWin) Exec_Win_Ev(&msg, appXDat.KeyInWin->WinID);
}

static Window REGP1 HandleKeyPress(TXev_msg *msg) {  //2 
	XKey2TKey((XKeyEvent*)msg->ev, keyst_Press);
	return 0;
}

static Window REGP1 HandleKeyRelease(TXev_msg *msg) {  //3
	XKey2TKey((XKeyEvent*)msg->ev, keyst_Release);
	return 0;
}

static Window REGP1 HandleButtonEvent(TXev_msg *msg) {  //4,5
  XButtonEvent *ev;

	Send_MSG_MotionEvent();
	if (appXDat.appCursorWait) return 0;
	MouseDown.UpDownCount++;

	ev = (XButtonEvent*)msg->ev;
	appXDat.last_KeyState = ev->state;

	if (appXDat.GrabWin && (!ttc_chk_struct(appXDat.GrabWin) ||
				!GetTWins(appXDat.GrabWin->WinID))) {
 printf("%s(%d): ERROR: GrabWin\n", FL);
	    Std_UngrabPointer();
	}

// printf("%s(%d): 0x%08x 0x%08x\n", FL, (int)appXDat.GrabWin, (int)ev->window);
	if (appXDat.GrabWin && (ev->window != appXDat.GrabWin->WinID)) {

 XID JunkChild;
	    XTranslateCoordinates (appXDat.dpy, appXDat.RootW, 
			appXDat.GrabWin->WinID, ev->x_root, ev->y_root,
			&ev->x, &ev->y, &JunkChild);
	    ev->window = appXDat.GrabWin->WinID;
	}
	return ev->window;
}


static Window REGP1 HandleMotionNotify(TXev_msg *msg) {  //6
  XMotionEvent *ev = (XMotionEvent*)msg->ev;
#if 1
	if (MotionEvent.window && (MotionEvent.window != ev->window)) {
	    Send_MSG_MotionEvent();
// printf("%s(%d): 0x%08x 0x%08x\n", FL, (int)MotionEvent.window, (int)ev->window);
	}
	MotionEvent = *ev;
	return 0;
#else
	while (XCheckTypedWindowEvent(appXDat.dpy, ev->window, 
				    MotionNotify, (XEvent*)ev)) {
// printf("%s(%d): \n", FL);
	}
	appXDat.last_KeyState = ev->state;
	return ev->window;
#endif
}

static Window REGP1 HandleFocusIn(TXev_msg *msg) {  //9
  XFocusInEvent *ev;
  TForm *Form;

	Send_MSG_MotionEvent();
	msg->msg = msgFocus;
	msg->m   = WinsFocusIN;
	ev = (XFocusInEvent*)msg->ev;
	Form = getappForm(ev->window);
	if (!Form) return 0;
	appXDat.KeyInForm = (TWins*)Form;
	if (!Form->FocusWin) return 0;
	return Form->FocusWin->WinID;
}

static Window REGP1 HandleFocusOut(TXev_msg *msg) {  //10
  XFocusOutEvent *ev;
  TForm *Form;

	Send_MSG_MotionEvent();
	msg->msg = msgFocus;
	msg->m   = 0; //WinsFocusOut;
	ev = (XFocusOutEvent*)msg->ev;
	Form = getappForm(ev->window);
	if (!Form || !Form->FocusWin) return 0;
	return Form->FocusWin->WinID;
}

static Window REGP1 HandlePropertyNotify(TXev_msg *msg) {  //28
  int i;
  XPropertyEvent *ev;

	Send_MSG_MotionEvent();
	ev = (XPropertyEvent*)msg->ev;
	for (i=0;i<evFilter_max;i++) {
	  if (appXDat.PropEvFilter[i].Filter_PropEv &&
	      appXDat.PropEvFilter[i].FilterAtom && 
	      (appXDat.PropEvFilter[i].FilterAtom == ev->atom)) {

	    appXDat.PropEvFilter[i].Filter_PropEv(ev);
	  }
	}
	return ev->window;
}

void appXeventDefaultInit() {
	set_XEventHandle(KeyPress,   HandleKeyPress);
	set_XEventHandle(KeyRelease, HandleKeyRelease);
	set_XEventHandle(ButtonPress,   HandleButtonEvent);
	set_XEventHandle(ButtonRelease, HandleButtonEvent);
	set_XEventHandle(MotionNotify, HandleMotionNotify);
	set_XEventHandle(FocusIn,  HandleFocusIn);
	set_XEventHandle(FocusOut, HandleFocusOut);
	set_XEventHandle(PropertyNotify, HandlePropertyNotify);
}
