/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/


#include "appXbase.h"
#include "cicons.h"
#include <X11/extensions/shape.h>

#ifdef DRAG_AND_DROP

static void Get_dnd_SysIconWin(TIconWin *icw, TPic *pic, int INr) {
  XSetWindowAttributes attr;

	if (pic) icw->Pic = pic; else icw->Pic = get_fileIcon(INr);

	attr.event_mask = PropertyChangeMask;
	attr.override_redirect = 1;
	icw->WinID = XCreateWindow(appXDat.dpy, appXDat.RootW,
                             -100, -100, icw->Pic->width, icw->Pic->height,
                             0, CopyFromParent, InputOutput,
                             CopyFromParent, 
                             CWOverrideRedirect | CWEventMask, &attr);
	if (icw->Pic->mask != 0)
		XShapeCombineMask(appXDat.dpy, icw->WinID, ShapeBounding, 0, 0,
				icw->Pic->mask, ShapeSet);
	icw->fu = 0;
} 

static void dnd_IconWinMap(int nr, int x, int y, bool Map) {
  int idx;
  Tdnd *dnd = appXDat.dnd;

	idx = nr & 0x0f;
	if (Map) {
	  if ((dnd->dndM_WinNr & 0x0f) != idx) dnd_IconWinMap(dnd->dndM_WinNr, 0, 0, False);
	  dnd->dndM_WinNr = idx;
	  dnd->dndM_WinX = x;
	  dnd->dndM_WinY = y;
	  XMoveWindow(appXDat.dpy, dnd->IconWin[idx].WinID, x, y);
	  if ((dnd->IconWin[idx].fu & 0x01) == 0) {
//      XMapRaised(appDat.dpy, appDat.IconWin[idx].WinID);
	    MapWinID(dnd->IconWin[idx].WinID, 2);
	    dnd->IconWin[idx].fu = dnd->IconWin[idx].fu | 0x01;
	    } 
	  DrawPic(dnd->IconWin[idx].WinID, dnd->IconWin[idx].Pic, 0, 0);
	} else {
	  if ((dnd->IconWin[idx].fu & 0x01) != 0) {
	    MapWinID(dnd->IconWin[idx].WinID, 0);
//      XUnmapWindow(appDat.dpy, appDat.IconWin[idx].WinID);
	    dnd->IconWin[idx].fu = 0;
	    } 
	} 
} 

void dndM_MoveSet(int sch, XID destWinID, int x, int y) {
  int IconMap;
  XClientMessageEvent xcmev;
  Tdnd *dnd = appXDat.dnd;
  bool IconMapMk, DropMk;

// printf("%s(%d): sch=%d dest=0x%x src=0x%x 0x%x \n", FL, sch, (int)destWinID, (int)dnd->dndM_SrcWin, (int)dnd->dndM_DestWin);
// fflush(stdout);
//	if (destWinID == 0) return;
	if ((destWinID == 0) && (dnd->dndM_SrcWin == 0) && (dnd->dndM_DestWin == 0)) return;

	IconMapMk = True;
	IconMap = dnd->dndM_WinNr;


	DropMk = (sch == dndM_Move_Drop);
	if (DropMk & (dnd->dndM_WinNr == 0)) sch = dndM_Move_Leave;

	if (sch == dndM_Move_Auto) {
	  if ((destWinID == 0) && (dnd->dndM_DestWin != 0)) {
	    sch = dndM_Move_Leave;
	  } else if (dnd->dndM_DestWin == 0) {
	    sch = dndM_Move_Enter;
	  } else if (dnd->dndM_DestWin != destWinID) {
	    sch = dndM_Move_Leave;
	  } else sch = dndM_Move_Position;
	} 
// printf("%s(%d): sch=%d\n", FL, sch);
// fflush(stdout);

	Fill0(&xcmev, sizeof(XClientMessageEvent));
	xcmev.type = ClientMessage;
	xcmev.format = 32;
	xcmev.data.l[0] = dnd->dndM_SrcWin;
//	xcmev.data.l[1] = 0; xcmev.data.l[2] = 0; 
//	xcmev.data.l[3] = 0; xcmev.data.l[4] = 0;

// printf('%d %d %d'#10, appDat.XA_XdndEnter, appDat.XA_XdndPosition, appDat.XA_XdndLeave);
	switch(sch) {
	case dndM_Move_Enter:
		xcmev.message_type = dnd->XA_XdndEnter;
		xcmev.window = destWinID;
		xcmev.data.l[1] = 0x03000001;   //(3 << 24) version
		dnd->dndM_DestWin = destWinID;
		IconMap = 0;
		break;

	case dndM_Move_Position:
		xcmev.message_type = dnd->XA_XdndPosition;
		xcmev.window = dnd->dndM_DestWin;
		xcmev.data.s[4] = y;
		xcmev.data.s[5] = x;
		xcmev.data.l[4] = dnd->dndM_Action;
		break;

	case dndM_Move_Leave: 
	case dndM_Move_Close:
		xcmev.message_type = dnd->XA_XdndLeave;
		xcmev.window = dnd->dndM_DestWin;
		dnd->dndM_DestWin = 0;
		IconMap = 0;
		if (sch == dndM_Move_Close) {
		  Tlgs_Clr(&dnd->SelTxt);
		  DropMk = True;
		} 
		break;

	case dndM_Move_Drop:
		xcmev.message_type = dnd->XA_XdndDrop;
		xcmev.window = dnd->dndM_DestWin;
		break;
	default:
		return;
	}
/*
 char *pc;
 pc = XGetAtomName(appXDat.dpy, xcmev.message_type);
 printf("%s dndM_MoveSet(%d): XSendEvent dest=0x%x Atom=%d(%s) src=0x%x\n", FL, 
	(int)xcmev.window, (int)xcmev.message_type, pc, (int)dnd->dndM_SrcWin);
 fflush(stdout);
 XFree(pc);
*/
	if (xcmev.window) {
//#ifdef USE_SEL_ROOT_PROXY
//	    XSendEvent(appXDat.dpy, xcmev.window, False, NoEventMask, (XEvent*)&xcmev);
//#else
 long mask;
	    mask = NoEventMask;
	    if (appXDat.RootW == xcmev.window) mask = SubstructureNotifyMask;
	    XSendEvent(appXDat.dpy, xcmev.window, False, mask, (XEvent*)&xcmev);
//#endif /* USE_SEL_ROOT_PROXY */
	}

	if (DropMk) {
		dnd_IconWinMap(dnd->dndM_WinNr, 0, 0, False);
		dnd->dndM_WinNr = 0;
		dnd->dndM_DestWin = 0;
		dnd->dndM_SrcWin = 0;
		IconMapMk = False;
	} 

	dnd_IconWinMap(IconMap, x+13, y, IconMapMk);
} 

typedef struct TXAH_QueryPointer {
  XID WinID;
  XID RootRet, ChildRet;
  int RootXRet, RootYRet;
  int WinXRet, WinYRet;
  unsigned int MaskRet;
} TXAH_QueryPointer;

static void Get_XAH_QueryPointer(TXAH_QueryPointer *qp){
	if (!qp->WinID ||  
            !XQueryPointer(appXDat.dpy, qp->WinID, &qp->RootRet, &qp->ChildRet,
                           &qp->RootXRet, &qp->RootYRet,
                           &qp->WinXRet, &qp->WinYRet, &qp->MaskRet)) {
		qp->ChildRet = 0;
	}
} 

XID dndM_GetMoveWin(){

  TXAH_QueryPointer qp;
  XID destWinID;
  XID destWinID_1 = 0;
  XID propWinID;
  Atom TypeRet;
  int FormatRet;
  unsigned long nItemsRet;
  unsigned long BytesAfterRet;
  unsigned char *PropRet;
  Tdnd *dnd = appXDat.dnd;

	destWinID = appXDat.RootW;
	while ((destWinID) && (XGetWindowProperty (appXDat.dpy, destWinID,
                          appXDat.XA_WM_STATE, 0, 0, False, AnyPropertyType,
                          &TypeRet, &FormatRet, &nItemsRet,
                          &BytesAfterRet, &PropRet)) == Success) {
		if (PropRet) XFree(PropRet);
// printf("%s(%d): dndM_GetMoveWin=0x%x %d %d\n", FL, (int)destWinID, (int)TypeRet, (int)nItemsRet);
// fflush(stdout);
		if (TypeRet) break; // return destWinID;

		qp.WinID = destWinID;
		Get_XAH_QueryPointer(&qp);
		destWinID = qp.ChildRet;
		if (!destWinID_1) destWinID_1 = destWinID;
	}
// printf("%s(%d): dndM_GetMoveWin=0x%x 0x%x\n", FL, (int)destWinID, (int)destWinID_1);

	if (!destWinID) destWinID = destWinID_1;
	propWinID = destWinID;
#ifdef USE_SEL_ROOT_PROXY
	if (!destWinID) {
		if (XGetWindowProperty (appXDat.dpy, appXDat.RootW,
                          dnd->XdndProxy, 0, 1, False, XA_WINDOW,
                          &TypeRet, &FormatRet, &nItemsRet,
                          &BytesAfterRet, &PropRet) == Success) {
		    if (TypeRet == XA_WINDOW && PropRet) {
			propWinID = *(XID*)PropRet;
			destWinID = appXDat.RootW;
			XFree(PropRet);
		    }
		}
	}
#else
	if (!destWinID) destWinID = appXDat.RootW;
#endif /* USE_SEL_ROOT_PROXY */

// printf("%s(%d): dndM_GetMoveWin=0x%x\n", FL, (int)destWinID);
// fflush(stdout);

	if (destWinID && propWinID && 
            (XGetWindowProperty (appXDat.dpy, propWinID,
                          dnd->XA_XdndAware, 0, 0, False, AnyPropertyType,
                          &TypeRet, &FormatRet, &nItemsRet,
                          &BytesAfterRet, &PropRet) == Success)) {
		if (PropRet) XFree(PropRet);
// printf("%s(%d): dndM_GetMoveWin=0x%x %d %d\n", FL, (int)destWinID, (int)TypeRet, (int)nItemsRet);
// fflush(stdout);
		if (TypeRet) return destWinID;
	}

	return 0;
} 


static void dnd_SetSelection(TWins *ws, Atom *nAtom, int nAtomCount) {
  int i;
  Tdnd *dnd = appXDat.dnd;

	dnd->SrcWins = ws;
	if (!ws) {
		dnd->dndM_SrcWin = 0;
//		dnd->dndM_SrcClientWin = 0;
		return;
	} 

/*
	dnd->dndM_SrcClientWin = ws->WinID;
  TForm *fws;
	fws = GetParentForm(ws);
	if (!fws) {
		dnd->dndM_SrcWin = 0;
		return;
	} 
	dnd->dndM_SrcWin = fws->WinID;
*/
	dnd->dndM_SrcWin = ws->WinID;

// printf("%s(%d): dndM_SrcWin=0x%x\n", FL, (int)dnd->dndM_SrcWin);

	dnd->dndM_SELECT_AtomsCount = 0;

	for (i=0;i<nAtomCount;i++) {
	    if (nAtom[i] > 0) {
		dnd->dndM_SELECT_Atoms[dnd->dndM_SELECT_AtomsCount] = nAtom[i];
		dnd->dndM_SELECT_AtomsCount++;
	    } 
//	  if dnd->dndM_SELECT_AtomsCount == Length(dnd->dndM_SELECT_Atoms) Break;
	} 

	XChangeProperty (appXDat.dpy, dnd->dndM_SrcWin, dnd->XA_XdndTypeList,
		XA_ATOM, 32, PropModeReplace,
		(unsigned char*)&dnd->dndM_SELECT_Atoms[0],
		dnd->dndM_SELECT_AtomsCount);


//  XChangeProperty ( appDat.dpy, appDat.dndM_SrcWin, appDat.XA_XdndSelection,
//                    appDat.XA_TEXT_PLAIN, 8, PropModeReplace, @rrrr[1], 4);

//  printf('XGetSelectionOwner XA_PRIMARY=%d'#10, i);
	XSetSelectionOwner( appXDat.dpy, dnd->XA_XdndSelection, 
		dnd->dndM_SrcWin, CurrentTime );
//  XGetSelectionOwner(appDat.dpy, appDat.XA_XdndSelection)

}

static bool dnd_SelectionReq(XSelectionRequestEvent *ev, char **ppc, int *lg, int *iss) {
  Tdnd *dnd = appXDat.dnd;
  TWins *SrcWins = dnd->SrcWins;
  int i;
  Atom a = 0;

	if (SrcWins && SrcWins->Hdnd && SrcWins->Hdnd->DodndSelectionReq) {
	    return SrcWins->Hdnd->DodndSelectionReq(ev, ppc, lg, iss);
	}

	for (i=0;i<dnd->dndM_SELECT_AtomsCount;i++) {
	    if (dnd->dndM_SELECT_Atoms[i] == ev->target) {
		a = ev->target;
		break;
	    } 
	}
// AzAtom(FL, "dnd_SelectionReq atom", a);
	if (!a) return False;

	if (a == appXDat.XA_TEXT_PLAIN) {
		*ppc = dnd->SelTxt.s;
		*lg = dnd->SelTxt.lg;
		*iss = 8;

	} else if (a == appXDat.XA_URL_STRING) {
 /* TODO Convert char > 0x7f to %hex */
		*ppc = dnd->SelTxt.s;
		*lg = dnd->SelTxt.lg;
		*iss = 8;

	} else return False;

	return True;
}

static bool Tdnd_MasterMessage(XClientMessageEvent *ev) {
  Tdnd *dnd = appXDat.dnd;
  int i;
  Tobjmsg msg;

	if (ev->message_type == dnd->XA_XdndStatus) {
// printf("XA_XdndStatus w=0x%x sw=0x%x 0x%x\n", (int)ev->xclient.window, (int)ev->xclient.data.l[0], (int)ev->xclient.data.l[1]);
		if (dnd->dndM_SrcWin > 0) {
		  msg.msg = msg_dnd;
		  msg.f = msgf_dndStatus;
		  msg.p = (int*)ev;
		  Exec_Win_Ev(&msg, dnd->dndM_SrcWin);
		  if (ev->data.l[1] == 0) i = 0; else i = dnd->dndM_WinOkNr;
		  dnd_IconWinMap(i, dnd->dndM_WinX, dnd->dndM_WinY, True);
		} 
	} else return False;
	return True;
}

void Tdnd_master_Create() {
  Tdnd *dnd = appXDat.dnd;

	if (!dnd) {
		dnd = Tdnd_Atoms_Create();
		appXDat.dnd = dnd;
	}
	if (!dnd->dndM_Message) {
	  dnd->MoveSet = dndM_MoveSet;
	  dnd->GetMoveWin = dndM_GetMoveWin;
	  dnd->SetSelection = dnd_SetSelection;
	  dnd->SelectionReq = dnd_SelectionReq;
	  dnd->dndM_Message = Tdnd_MasterMessage;
	  Get_dnd_SysIconWin(&dnd->IconWin[0], get_pic16_find_no(False), 0);  //0=dnd_No
	  Get_dnd_SysIconWin(&dnd->IconWin[1], NULL, fico_Txt);      //1=dnd_Txt
	  Get_dnd_SysIconWin(&dnd->IconWin[2], NULL, fico_Folder);   //2=dnd_Folder
	}
	dnd->dndM_WinOkNr = 1;

}

#endif  /* DRAG_AND_DROP */

