/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

void dotdesktop_new(const char *fn, const char *Name, const char *Icon, 
		const char *s1, const char *s2, const char *s3, int ddkt) {
  TpcIni *ini;
  const char *styp = NULL;
  const char *ss1 = NULL;
  const char *ss2 = NULL;
  const char *ss3 = NULL;

	ini = TpcIni_Create(fn);
	switch(ddkt) {
	case ddkt_Application:
		styp = "Application";
		ss1 = "Exec";
		break;
	case ddkt_FSDevice:
		styp = "FSDevice";
		ss1 = "Dev";
		ss2 = "MountPoint";
		ss3 = "ReadOnly";
		break;
	case ddkt_Directory:
		styp = "Directory";
		ss1 = "ALDsort";
		break;
	case ddkt_ALDeskBuildin:
		styp = "ALDeskBuildin";
		ss1 = "ALDeskBuildin";
		break;
	case ddkt_Mime:
		styp = "MimeType";
		ss1 = "MimeType";
		ss2 = "Patterns";
		break;
	}
	if (styp) TpcIni_WR(ini, Desktop_Entry, "Type", styp);
	if (Icon) TpcIni_WR(ini, Desktop_Entry, "Icon", Icon);
	if (s1 && ss1) TpcIni_WR(ini, Desktop_Entry, ss1, s1);
	if (s2 && ss2) TpcIni_WR(ini, Desktop_Entry, ss2, s2);
	if (s3 && ss3) TpcIni_WR(ini, Desktop_Entry, ss3, s3);
	if (Name) TpcIni_WR(ini, Desktop_Entry, "Name", Name);

	TpcIni_SaveAndFree(ini);
}
