/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/


#ifdef HAVE_FT
#include "image.h"
//#include "font_FT.h"
#include <ft2build.h>
#include FT_FREETYPE_H


#define TFCACHE_MAX 256

typedef struct {
  int advance;
  int bitmap_width, bitmap_rows, bitmap_left, bitmap_top;
  byte *data;
} TFCache;

#define TFGIDX_MAX 256

#define TCSelf TFontHandle_FT
typedef struct TFontHandle_FT {
  AlgTTC0
  FT_Library    library;
  FT_Face       face;

  int	metrics_height;
  int	metrics_ascent;
  int	font_dpi;
  int	font_height;
  long	glyphs;

  int  fcache_max;
  TFCache *fcache;
  TFCache *fcache_glyph;
//  TImage *paint_img;
  struct TPixMap *line_pxm;

  int  lnk_count;
  struct TFont_FT *create_TFont_FT;
  bool fixes_size;
  bool IsDefault;
  bool ft_ncb2, ft_ncb3;
#if TFGIDX_MAX > 0
  int  glyph_idx[TFGIDX_MAX];
#endif
} TFontHandle_FT;
#undef TCSelf

typedef struct TFT_idx {
  struct TFT_idx *next;
  TFontHandle_FT *fh;
  int font_height;
  int font_dpi;
  char FontFileName[];
} TFT_idx;

//extern bool REGP3 TFontHandle_FT_chk_cache(TFontHandle_FT *self, int *width, int *rows);
//extern void REGP3 TFontHandle_FT_Add_GlyphToCache(TFontHandle_FT *self, int glyph_index);
extern bool REGP3 TFontHandle_FT_Load_Glyph(TFontHandle_FT *self, dword c);

extern TFT_idx *TFontHandle_FT_Get_FT_idx(TFontHandle_FT *self);

#else /* HAVE_FT */

#define TFontHandle_FT void

#endif /* ! HAVE_FT */

extern TFontHandle_FT *TFontHandle_FT_Create(const char *FontFileName, 
				int font_height, int font_dpi);

//extern TFontHandle_FT *TFontHandle_FT_CreateDuplicate(TFontHandle_FT *orig);
