/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

static dword serial;

typedef struct {
  const char *s;
  int a;
} TAH_Atoms;


static TBITMAP_Dat *app_bmDat;

typedef struct {
  HWND hWnd;
  HDC hDC;
  HPEN hpen;
  HBRUSH hbrush;
  HFONT hfont;
  HRGN clip;
  int clip_x;
  int clip_y;
} TTGC_hDC;

static HWND Last_Mouse_hwnd;
static int Last_Mouse_tz;

static TTGC_hDC locAkt_hDC;
static TTGC_hDC locTmp_hDC[4];
static TWins *SIZEMOVE_ap;
static XConfigureEvent *tmp_ConfigureEvent;

/*____________________________________________________________________________*/
static int W32_WinsX_Ev(TWins *ap, XEvent *ev) {
  Tobjmsg msg;
	msg.msg = msgXEv;
	msg.f = 0;
	msg.m = 0;
	msg.p = (int*)ev;
	return Send_MSG(&msg, ap);
}

static void Set_XAnyEvent(XAnyEvent *ev, int type, HWND hwnd) {
	serial++;
	ev->type = type;
	ev->serial = serial;
	ev->send_event = False;
	ev->display = appXDat.dpy;
	ev->window = hwnd;
}

/*_5,70_______________________________________________________________________*/
static int X11_XConfigureEvent(TWins* wins, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
  XConfigureEvent xev;
  XConfigureEvent *ev = &xev;
  int tmp_mk = (SIZEMOVE_ap && (SIZEMOVE_ap == wins));

	if (tmp_mk) {
	    if (!tmp_ConfigureEvent) {
		tmp_ConfigureEvent = xcalloc(sizeof(XConfigureEvent));
		tmp_ConfigureEvent->x = wins->left;
		tmp_ConfigureEvent->y = wins->top;
		tmp_ConfigureEvent->width = wins->width;
		tmp_ConfigureEvent->height = wins->height;
	    }
	    ev = tmp_ConfigureEvent;
	}

	Set_XAnyEvent((XAnyEvent*)ev, ConfigureNotify, hwnd);

	if (Msg == WM_WINDOWPOSCHANGING) {
	    if (((PWINDOWPOS)Lpr)->flags & SWP_NOMOVE) return True;
	    if ((!wins->ResizeStartMk) &&
		((wins->left == CW_USEDEFAULT) || 
		 (wins->top == CW_USEDEFAULT))) {
		((PWINDOWPOS)Lpr)->flags |= SWP_NOMOVE;
		return True;
	    }
	    ev->x = ((PWINDOWPOS)Lpr)->x;
	    ev->y = ((PWINDOWPOS)Lpr)->y;
	    if (!tmp_mk) {
		ev->width = wins->width;
		ev->height = wins->height;
	    }
	} else {
	    if (!tmp_mk) {
		ev->x = wins->left;
		ev->y = wins->top;
	    }
	    ev->width = LOWORD(Lpr);
	    ev->height = HIWORD(Lpr);
	}

	ev->window = hwnd; //0;
	ev->border_width = 0;
	ev->above = 0;

	if (!tmp_mk) {
	    W32_WinsX_Ev(wins, (XEvent*)ev);
	}
	return True;
}

static int w32_ENTERSIZEMOVE(TWins* ap, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
	SIZEMOVE_ap = ap;
	return False;
}
static int w32_EXITSIZEMOVE(TWins* ap, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
	if (tmp_ConfigureEvent) {
	    W32_WinsX_Ev(SIZEMOVE_ap, (XEvent*)tmp_ConfigureEvent);
	    xfree(tmp_ConfigureEvent);
	    tmp_ConfigureEvent = NULL;
	}
	SIZEMOVE_ap = NULL;
	return False;
}

/*_7,8________________________________________________________________________*/
static int X11_XFocusChangeEvent(TWins* wins, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
  Tobjmsg msg;
  TWins* FocusWin;

	if (wins->wtyp & wtyp_Form) {
	    FocusWin = ((TForm*)wins)->FocusWin;
	    msg.wins = wins;
	    msg.f = 0;
	    msg.p = NULL;
	    if (Msg == WM_SETFOCUS) {
		appXDat.KeyInForm = wins;
		if (FocusWin) {
		    msg.msg = msgFocus;
		    msg.m   = WinsFocusIN;
		    Exec_Win_Ev(&msg, FocusWin->WinID);
		}
	    } else {
		if (FocusWin) {
		    msg.msg = msgFocus;
		    msg.m   = 0; //WinsFocusOut;
		    Exec_Win_Ev(&msg, FocusWin->WinID);
		}
	    }
	}
	return False;
}

/*_15_________________________________________________________________________*/
void SetTmp_hGC(HWND hWnd) {
// printf("%s(%d): SetTmp_hGC 0x%x 0x%x 0x%x  0x%x 0x%x\n", FL, 
//   (int)hWnd, (int)locAkt_hDC.hWnd, (int)locTmp_hDC.hWnd, 
//  (int)locAkt_hDC.hDC, (int)locTmp_hDC.hDC);
  int i;
  TTGC_hDC *gcdc = NULL;

	if (locAkt_hDC.hDC && (locAkt_hDC.hWnd == hWnd)) return;
	for (i=0;i<4;i++) {
	    if (locTmp_hDC[i].hDC && (locTmp_hDC[i].hWnd == hWnd)) return;
	    if (!locTmp_hDC[i].hDC && !gcdc) gcdc = &locTmp_hDC[i];
	}
	if (gcdc) {
	    gcdc->hDC = GetDC(hWnd);
	    gcdc->hWnd = hWnd;
	    gcdc->hpen = 0;
	    gcdc->hbrush = 0;
	    gcdc->hfont = 0;
	    gcdc->clip = 0;
	}
}

void ReleaseTmp_hGC(HWND hWnd) {
  int i;

	if (locAkt_hDC.hDC && (locAkt_hDC.hWnd == hWnd)) return;
	for (i=0;i<4;i++) {
	    if (locTmp_hDC[i].hDC && (locTmp_hDC[i].hWnd == hWnd)) {
		ReleaseDC(hWnd, locTmp_hDC[i].hDC);
		locTmp_hDC[i].hDC = 0;
		return;
	    }
	}
}

HDC GetTmpPaintDC(HWND hWnd, int *isTempDC, GC gc, int fu) {
// printf("%s(%d): \n", FL);
// printf("%s(%d): GetTmpPaintDC w=0x%x aw=0x%x atw=0x%x  ah=0x%x ath=0x%x\n", FL, 
//   (int)hwnd, (int)Akt_hwnd, (int)AktTmp_hwnd, (int)Akt_hDC, (int)AktTmp_hDC);
  TTGC_hDC *gcdc = NULL;
  HDC hDC;
  int i;

	if (!gc) fu = 0;
	if (locAkt_hDC.hDC && (locAkt_hDC.hWnd == hWnd)) gcdc = &locAkt_hDC;
	if (!gcdc) {
	    for (i=0;i<4;i++) {
		if (locTmp_hDC[i].hDC && (locTmp_hDC[i].hWnd == hWnd)) {
		    gcdc = &locTmp_hDC[i];
		    break;
		}
	    }
	}

	if (gcdc) {
	    hDC = gcdc->hDC;
	    if (gc && gc->gcv.clip_mask) {
		if (gcdc->clip) {
		    if (gcdc->clip == gc->gcv.clip_mask) {
			if ((gcdc->clip_x != gc->gcv.clip_x_origin) || 
			    (gcdc->clip_y != gc->gcv.clip_y_origin)) {
			    OffsetClipRgn(hDC, gc->gcv.clip_x_origin, 
					       gc->gcv.clip_y_origin);
			    gcdc->clip_x = gc->gcv.clip_x_origin;
			    gcdc->clip_y = gc->gcv.clip_y_origin;
			}
		    } else {
			SelectClipRgn(hDC, 0);
			gcdc->clip = 0;
		    }
		}
		if (!gcdc->clip) {
		    SelectClipRgn(hDC, gc->gcv.clip_mask);
		    gcdc->clip = gc->gcv.clip_mask;
		    OffsetClipRgn(hDC, gc->gcv.clip_x_origin, 
				       gc->gcv.clip_y_origin);
		    gcdc->clip_x = gc->gcv.clip_x_origin;
		    gcdc->clip_y = gc->gcv.clip_y_origin;
		}
	    } else {
		if (gcdc->clip) {
		    SelectClipRgn(hDC, 0);
		    gcdc->clip = 0;
		}
	    }
	    if ((fu & gcdc_hpen) && (gcdc->hpen != gc->hpen)) {
		SelectObject(hDC, gc->hpen);
		gcdc->hpen = gc->hpen;
	    }
	    if ((fu & gcdc_hbrush) && (gcdc->hbrush != gc->hbrush)) {
		SelectObject(hDC, gc->hbrush);
		gcdc->hbrush = gc->hbrush;
	    }
	    if ((fu & gcdc_hfont) && (gcdc->hfont != gc->hfont)) {
		SelectObject(hDC, gc->hfont);
		gcdc->hfont = gc->hfont;
	    }

	    *isTempDC = 16;
	    return hDC;
	}

	*isTempDC = 0;
	hDC = GetDC(hWnd);
	if (gc && gc->gcv.clip_mask) {
	    SelectClipRgn(hDC, gc->gcv.clip_mask);
	    OffsetClipRgn(hDC, gc->gcv.clip_x_origin, 
			       gc->gcv.clip_y_origin);    
	    *isTempDC = 1;
	}
	if (fu & gcdc_hpen) SelectObject(hDC, gc->hpen);
	if (fu & gcdc_hbrush) SelectObject(hDC, gc->hbrush);
	if (fu & gcdc_hfont) SelectObject(hDC, gc->hfont);

	return hDC;
}

void ReleaseTmpPaintDC(HWND hwnd, HDC hDC, int isTempDC) {
	if (isTempDC == 16) return;
	if (isTempDC == 1) SelectClipRgn(hDC, 0);
	ReleaseDC(hwnd, hDC);
}

static int X11_Expose(TWins* wins, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
  XExposeEvent ev;
  PAINTSTRUCT Ps;

	Set_XAnyEvent((void*)&ev, Expose, hwnd);
	ev.x = 0;
	ev.y = 0;
	ev.width = wins->width;
	ev.height = wins->height;
	ev.count = 1;
	if (!Wpr) {
		locAkt_hDC.hDC = BeginPaint(hwnd, &Ps);
		locAkt_hDC.hWnd = hwnd;
		locAkt_hDC.hpen = 0;
		locAkt_hDC.hbrush = 0;
		locAkt_hDC.hfont = 0;
		locAkt_hDC.clip = 0;
	}
	W32_WinsX_Ev(wins, (XEvent*)&ev);
	if (!Wpr) {
		locAkt_hDC.hDC = 0;
		locAkt_hDC.hWnd = 0;
		EndPaint(hwnd, &Ps);
	}
	*ret = 0;
	return True;
}

/*_16_________________________________________________________________________*/
static int X11_WM_DELETE_WINDOW(TWins* ap, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
  XClientMessageEvent ev;

	Set_XAnyEvent((void*)&ev, ClientMessage, hwnd);
	ev.format = 32;
	ev.data.l[0] = cXA_WM_DELETE_WINDOW;
	W32_WinsX_Ev(ap, (XEvent*)&ev);
	return True;
}

/*_20_________________________________________________________________________*/
static int WM_EraseBkgnd(TWins* wins, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
  RECT rc;

	GetClientRect(hwnd, &rc);
	FillRect((HDC)Wpr, &rc, wins->OS_var.background_pixmap);  //=HBRUSH
	*ret = 1;
	return True;
}

/*_256,257____________________________________________________________________*/
static word TransCharTab[] = {
 0,		0,		0,		0,		/* 0x00 */
 0,		0,		0,		0,
 XK_BackSpace,	XK_Tab,		0,		0,		/* 0x08 */
 XK_Clear,	XK_Return,	0,		0,
 XK_Shift_L,	XK_Control_L,	XK_Alt_L,	XK_Pause,	/* 0x10 */
 0,		0,		0,		0,
 0,		XK_Print,	0,		XK_Escape,	/* 0x18 */
 0,		0,		0,		0,
 0,		XK_Prior,	XK_Next,	XK_End,		/* 0x20 */
 XK_Home,	XK_Left,	XK_Up,		XK_Right,
 XK_Down,	0,		0,		0,		/* 0x28 */
 0,		XK_Insert,	XK_Delete,	0,
 0,		0,		0,		0,		/* 0x30 */
 0,		0,		0,		0,
 0,		0,		0,		0,		/* 0x38 */
 0,		0,		0,		0,
 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,		/* 0x40 */
 0,0,0,0, 0,0,0,0, 0,0,0,0,			/* 0x50 */
 0,		XK_Menu,	0,		0,		/* 0x5c */
 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,		/* 0x60 */
 XK_F1,		XK_F2,		XK_F3,		XK_F4,		/* 0x70 */
 XK_F5,		XK_F6,		XK_F7,		XK_F8,
 XK_F9,		XK_F10,		XK_F11,		XK_F12,		/* 0x78 */
 0,		0,		0,		0,
 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,		/* 0x80 */
 XK_Num_Lock,	XK_Scroll_Lock,	0,		0,		/* 0x90 */
 0,		0,		0,		0,
 0,		0,		0,		0,		/* 0x98 */
 0,		0,		0,		0,
 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,		/* 0xA0 */
 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,		/* 0xB0 */
 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,		/* 0xC0 */
 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,		/* 0xD0 */
 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,		/* 0xE0 */
 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0		/* 0xF0 */
};

static word TransKeyTab[] = {
   0,  9, 10, 11,  12, 13, 14, 15,  16, 17, 18, 19,  20, 21, 22, 23,	/* 0x00 */
  24, 25, 26, 27,  28, 29, 30, 31,  32, 33, 34, 35,  36, 37, 38, 39,	/* 0x10 */
  40, 41, 42, 43,  44, 45, 46, 47,  48, 49, 50, 51,  52, 53, 54, 55,	/* 0x20 */
  56, 57, 58,  0,   0,  0, 62,  0,   0, 65,  0, 67,  68, 69, 70, 71,	/* 0x30 */

  72, 73, 74, 75,   0,110,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,	/* 0x40 */
   0,  0,  0,  0,   0,  0,  0, 95,  96,  0,  0,  0,   0,  0,  0,  0,	/* 0x50 */
 113,115,  0,117,   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,	/* 0x60 */
   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,	/* 0x70 */

   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,	/* 0x80 */
   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,	/* 0x90 */
   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,	/* 0xA0 */
   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,	/* 0xB0 */

   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,	/* 0xC0 */
   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,	/* 0xD0 */
   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,	/* 0xE0 */
   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,   0,  0,  0,  0,	/* 0xF0 */
};

static int X11_XKeyEvent(TWins* ap, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
  byte st[256];
  dword m;
  dword keysym = 0;
  TKeyEvent KeyEv;

	GetKeyboardState(st);
	if ((Wpr >= 0) && (Wpr < 256) && TransCharTab[Wpr]) {
	    keysym =  TransCharTab[Wpr];
	    switch(keysym) {
	    case XK_Shift_L: 
		    if (((Lpr>>16) & 0xff) == 0x36) keysym = XK_Shift_R;
		    break;
	    case XK_Control_L: 
		    if (Lpr & (1<<24)) keysym = XK_Control_R;
		    break;
	    case XK_Alt_L: 
		    if (Lpr & (1<<24)) keysym = XK_Alt_R;
		    break;
	    }
	} else {
	    m = Lpr>>16;
	    m &= 0x3fff;
	    if (ToUnicode(Wpr, m, st, (void*)&keysym, 2, 0) != 1) keysym = 0;
	}

  int state = 0;
  Tobjmsg msg;

	msg.msg = msgKey; //msgXEv;
	msg.f = msg.m = 0;
	msg.p = &KeyEv;

	if ((st[VK_LSHIFT] & 0x80) || (st[VK_RSHIFT] & 0x80)) state |= ShiftMask;
	if (st[VK_CAPITAL] & 0x01) state |= LockMask;

	if (st[VK_RMENU] & 0x80) {
	  state |= Mod5Mask;
	} else {
	  if ((st[VK_LCONTROL] & 0x80) || (st[VK_RCONTROL] & 0x80)) state |= ControlMask;
	}
	if (st[VK_NUMLOCK] & 0x80) state |= Mod2Mask;

	if ((keysym == XK_Shift_L) || (keysym == XK_Shift_R)) state ^= ShiftMask;
	if ((keysym == XK_Control_L) || (keysym == XK_Control_R)) state ^= ControlMask;

	if ((keysym == XK_Tab) && (state & ShiftMask)) keysym = XK_ISO_Left_Tab;

#if 0
 if (Msg != WM_KEYUP) {
  printf("%s(%d): X11_XKeyDown: \n", FL);
 } else {
  printf("%s(%d): X11_XKeyUp: \n", FL);
 } 
 printf("0x%x 0x%x 0x%x 0x%x  0x%x 0x%x 0x%x 0x%x  0x%x 0x%x\n", 
  st[VK_NUMLOCK], st[VK_SCROLL], st[VK_LSHIFT], st[VK_RSHIFT], 
  st[VK_LCONTROL], st[VK_RCONTROL], st[VK_LMENU], st[VK_RMENU],
  st[VK_MENU], st[VK_CAPITAL]);
 printf("%d(0x%x) 0x%x c=0x%x st=0x%x\n", Wpr, Wpr, (int)Lpr, (int)keysym, state);
#endif

	KeyEv.state = state;
	KeyEv.keyst = keyst_Press;
	KeyEv.keysym = keysym & 0xffff;
	if (Msg == WM_KEYUP) {
	    KeyEv.keyst = keyst_Release;
	}
	KeyEv.keycode = TransKeyTab[(Lpr>>16) & 0xff]; //Wpr;

	if (appXDat.KeyInForm) {
	    Exec_Win_Ev(&msg, appXDat.KeyInForm->WinID);
	}
	if (KeyEv.keysym && appXDat.KeyInWin) {
	    Exec_Win_Ev(&msg, appXDat.KeyInWin->WinID);
	}
	*ret = 0;
	return True;
}

/*_512________________________________________________________________________*/
static void SetMouseEvDat(WPARAM Wpr, POINT *RootPoint, unsigned int *state) {
  int m;

	GetCursorPos(RootPoint);
	m = 0;
	if (Wpr & MK_SHIFT) m |= ShiftMask;
	if (Wpr & MK_CONTROL) m |= ControlMask;
	if (Wpr & MK_LBUTTON) m |= Button1Mask;
	if (Wpr & MK_MBUTTON) m |= Button2Mask;
	if (Wpr & MK_RBUTTON) m |= Button3Mask;
	appXDat.last_KeyState = m;
	*state = m;
}

static void X11_XLeaveWindowEvent(int x_root, int y_root) {
  XCrossingEvent ev;

	if (Last_Mouse_hwnd) {
  TWins* old_ap = GetTWins(Last_Mouse_hwnd);
	    if (old_ap) {
		Set_XAnyEvent((void*)&ev, LeaveNotify, Last_Mouse_hwnd);
		ev.root = 0;
		ev.subwindow = 0;
		ev.time = GetTime_ms();
		ev.x = 0;
		ev.y = 0;
		ev.x_root = x_root;
		ev.y_root = y_root;
		ev.mode = 0;
		ev.detail = 0;
		ev.same_screen = 0;
		ev.focus = 0;
		ev.state = 0;
		W32_WinsX_Ev(old_ap, (XEvent*)&ev);
	    }
	}
}

static int X11_XMotionEvent(TWins* ap, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
  XMotionEvent ev;
  XCrossingEvent eve;
  int x, y;
  POINT RootPoint;
  RECT rc;
  HWND child = hwnd;
  TWins* cap;

	x = (short int)(Lpr & 0xffff);
	y = (short int)(Lpr >> 16);

	SetMouseEvDat(Wpr, &RootPoint, &ev.state);
	ev.x_root = RootPoint.x;
	ev.y_root = RootPoint.y;

	if (appXDat.GrabWin) {		//Capture only Button
	    child = WindowFromPoint(RootPoint);
	    if (hwnd != child) {
		cap = GetTWins(child);
		if (!cap) return 0;
		ap = cap;
		GetWindowRect(child, &rc);
		x = RootPoint.x - rc.left;
		y = RootPoint.y - rc.top;
	    }
	}

// if (appXDat.GrabWin)
// printf("%s(%d): X11_XMotionEvent: w=0x%x Wpr=0x%x x=%d y=%d\n", FL, (int)hwnd, Wpr, x, y);

	Last_Mouse_tz = 2;	//Leave Time
	Set_XAnyEvent((void*)&ev, MotionNotify, child);
	ev.root = 0;
	ev.subwindow = 0;
	ev.time = GetTime_ms();
	ev.x = x;
	ev.y = y;
	ev.is_hint = 0;
	ev.same_screen = 0;


	if (Last_Mouse_hwnd != child) {
	    X11_XLeaveWindowEvent(ev.x_root, ev.y_root);
	    Set_XAnyEvent((void*)&eve, EnterNotify, child);
	    eve.root = 0;
	    eve.subwindow = 0;
	    eve.time = GetTime_ms();
	    eve.x = ev.x;
	    eve.y = ev.y;
	    eve.x_root = ev.x_root;
	    eve.x_root = ev.x_root;
	    eve.mode = 0;
	    eve.detail = 0;
	    eve.same_screen = 0;
	    eve.focus = 0;
	    eve.state = ev.state;
	    W32_WinsX_Ev(ap, (XEvent*)&eve);
	    Last_Mouse_hwnd = child;
	}

	W32_WinsX_Ev(ap, (XEvent*)&ev);
	return False;
}

/*_513,514,515,516,517,518,519,520,521________________________________________*/
static int X11_XButtonEvent(TWins* ap, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
  XButtonEvent ev;
  int type = ButtonPress;
  POINT RootPoint;

	if ((Msg == WM_LBUTTONUP) || 
	    (Msg == WM_MBUTTONUP) ||
	    (Msg == WM_RBUTTONUP)) type = ButtonRelease;

	if (Msg == WM_LBUTTONDOWN) SetCapture(hwnd);
	if ((Msg == WM_LBUTTONUP) && !appXDat.GrabWin) ReleaseCapture();

	Set_XAnyEvent((void*)&ev, type, hwnd);
	ev.root = 0;
	ev.subwindow = 0;
	ev.time = GetTime_ms();
	ev.x = LOWORD(Lpr);
	ev.y = HIWORD(Lpr);
	SetMouseEvDat(Wpr, &RootPoint, &ev.state);
	ev.x_root = RootPoint.x;
	ev.y_root = RootPoint.y;
	ev.button = 0;
	switch(Msg) {
	case WM_LBUTTONDOWN:
		ev.state &= ~Button1Mask;
		ev.button = 1;
		break;
	case WM_LBUTTONUP:
	case WM_LBUTTONDBLCLK:
		ev.state |= Button1Mask;
		ev.button = 1;
		break;
	case WM_MBUTTONDOWN:
		ev.state &= ~Button2Mask;
		ev.button = 2;
		break;
	case WM_MBUTTONUP:
	case WM_MBUTTONDBLCLK:
		ev.state |= Button2Mask;
		ev.button = 2;
		break;
	case WM_RBUTTONDOWN:
		ev.state &= ~Button3Mask;
		ev.button = 3;
		break;
	case WM_RBUTTONUP:
	case WM_RBUTTONDBLCLK:
		ev.state |= Button3Mask;
		ev.button = 3;
		break;
	}
	ev.same_screen = 0;
	W32_WinsX_Ev(ap, (XEvent*)&ev);
	return False;
}

/*_522_______________________________________________________________________*/
static int X11_XButtonEvent_WHEEL(TWins* ap, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
  XButtonEvent ev;
  POINT ClientPoint;
  int m;
  HWND child;
  TWins* nap;

	ClientPoint.x = LOWORD(Lpr);
	ClientPoint.y = HIWORD(Lpr);
	child = WindowFromPoint(ClientPoint);
	nap = GetTWins(child);
	if (nap) {
	    ap = nap;
	    hwnd = child;
	} else if (child) {
	    PostMessage(child, Msg, Wpr, Lpr);
	}

	Set_XAnyEvent((void*)&ev, ButtonPress, hwnd);
	ev.root = 0;
	ev.subwindow = 0;
	ev.time = GetTime_ms();
	ev.state = 0;
	m = LOWORD(Wpr);
	if (m & MK_SHIFT) ev.state |= ShiftMask;
	if (m & MK_CONTROL) ev.state |= ControlMask;
	if (m & MK_LBUTTON) ev.state |= Button1Mask;
	if (m & MK_MBUTTON) ev.state |= Button2Mask;
	if (m & MK_RBUTTON) ev.state |= Button3Mask;

	ScreenToClient(hwnd, &ClientPoint);
	ev.x = ClientPoint.x;
	ev.y = ClientPoint.y;
	ev.x_root = LOWORD(Lpr);
	ev.y_root = HIWORD(Lpr);
	ev.button = 4;
	if (HIWORD(Wpr) & 0x8000) ev.button = 5;
	ev.same_screen = 0;

// printf("%s(%d): X11_XButtonEvent: w=0x%x WL=0x%x WH=0x%x %d %d  %d %d\n", FL, (int)hwnd, 
//	LOWORD(Wpr), HIWORD(Wpr), LOWORD(Lpr), HIWORD(Lpr), (int)ClientPoint.x, (int)ClientPoint.y);

	W32_WinsX_Ev(ap, (XEvent*)&ev);

	ev.type = ButtonRelease;
	if (HIWORD(Wpr) & 0x8000) {
	    ev.button = 5;
	    ev.state |= Button5Mask;
	} else {
	    ev.button = 4;
	    ev.state |= Button4Mask;
	}
	W32_WinsX_Ev(ap, (XEvent*)&ev);

	return True;
}

/*_32_________________________________________________________________________*/
static int appWM_SETCURSOR(TWins* wins, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
	if ((hwnd == (HWND)Wpr) && (LOWORD(Lpr) == HTCLIENT) && 
	    wins->cursor_nr && 
	    (wins->cursor_nr != XC_top_left_arrow)) {
		SetCursor(appXDat.XCursors[wins->cursor_nr]);
		*ret = 1;
		return True;
	}
	return False;
}
/*_36_________________________________________________________________________*/
static int appWM_GETMINMAXINFO(TWins* wins, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
  MINMAXINFO *mmi = (MINMAXINFO*)Lpr;
//  printf("%s(%d): %d %d  %d %d  %d %d\n", FL, mmi->ptMaxSize.x, mmi->ptMaxSize.y,
//		mmi->ptMinTrackSize.x, mmi->ptMinTrackSize.y,
//		mmi->ptMaxTrackSize.x, mmi->ptMaxTrackSize.y);

	if (wins->min_width >= 112) mmi->ptMinTrackSize.x = wins->min_width;
	if (wins->max_width >= 112) mmi->ptMaxTrackSize.x = wins->max_width;
	if (wins->min_height >= 27) mmi->ptMinTrackSize.y = wins->min_height;
	if (wins->max_height >= 27) mmi->ptMaxTrackSize.y = wins->max_height;
	return False;
}
/*_260_________________________________________________________________________*/
static int appWM_SYSKEYDOWN(TWins* ap, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
	if (Wpr == 0x12) { //Alt_L
	    X11_XKeyEvent(ap, hwnd, WM_KEYDOWN, Wpr, Lpr, ret);
	    return True;
	}
	return False;
}
/*_261_________________________________________________________________________*/
static int appWM_SYSKEYUP(TWins* ap, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret) {
	if (Wpr == 0x12) { //Alt_L
	    X11_XKeyEvent(ap, hwnd, WM_KEYUP, Wpr, Lpr, ret);
	    return True;
	}
	return False;
}

/*____________________________________________________________________________*/
typedef int (*EvCBJP)(TWins* ap, HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr, int *ret);
static EvCBJP EvCALLBACKJumpTable[1024];

void InitEvCALLBACKJumpTable() {
  int i;
	serial = 0;
	for (i=0;i<1024;i++) EvCALLBACKJumpTable[i] = NULL;
	EvCALLBACKJumpTable[WM_SIZE] =		X11_XConfigureEvent;	//5
	EvCALLBACKJumpTable[WM_SETFOCUS] =	X11_XFocusChangeEvent;	//7
	EvCALLBACKJumpTable[WM_KILLFOCUS] =	X11_XFocusChangeEvent;	//8
	EvCALLBACKJumpTable[WM_PAINT] = 	X11_Expose;		//15
	EvCALLBACKJumpTable[WM_CLOSE] =		X11_WM_DELETE_WINDOW;	//16
	EvCALLBACKJumpTable[WM_ERASEBKGND] =	WM_EraseBkgnd;		//20
	EvCALLBACKJumpTable[WM_SETCURSOR] =	appWM_SETCURSOR;	//32
	EvCALLBACKJumpTable[WM_GETMINMAXINFO] =	appWM_GETMINMAXINFO;	//36
	EvCALLBACKJumpTable[WM_WINDOWPOSCHANGING] =	X11_XConfigureEvent;	//70
	EvCALLBACKJumpTable[WM_KEYDOWN] =	X11_XKeyEvent;		//256
	EvCALLBACKJumpTable[WM_KEYUP] =		X11_XKeyEvent;		//257
	EvCALLBACKJumpTable[WM_SYSKEYDOWN] =	appWM_SYSKEYDOWN;	//260
	EvCALLBACKJumpTable[WM_SYSKEYUP] =	appWM_SYSKEYUP;		//261
	EvCALLBACKJumpTable[WM_MOUSEMOVE] =	X11_XMotionEvent;	//512
	EvCALLBACKJumpTable[WM_LBUTTONDOWN] =	X11_XButtonEvent;	//513
	EvCALLBACKJumpTable[WM_LBUTTONUP] =	X11_XButtonEvent;	//514
	EvCALLBACKJumpTable[WM_LBUTTONDBLCLK] = X11_XButtonEvent;	//515
	EvCALLBACKJumpTable[WM_RBUTTONDOWN] =	X11_XButtonEvent;	//516
	EvCALLBACKJumpTable[WM_RBUTTONUP] =	X11_XButtonEvent;	//517
	EvCALLBACKJumpTable[WM_RBUTTONDBLCLK] = X11_XButtonEvent;	//518
	EvCALLBACKJumpTable[WM_MBUTTONDOWN] =	X11_XButtonEvent;	//519
	EvCALLBACKJumpTable[WM_MBUTTONUP] =	X11_XButtonEvent;	//520
	EvCALLBACKJumpTable[WM_MBUTTONDBLCLK] = X11_XButtonEvent;	//521
	EvCALLBACKJumpTable[WM_MOUSEWHEEL] =    X11_XButtonEvent_WHEEL;	//522
	EvCALLBACKJumpTable[WM_ENTERSIZEMOVE] = w32_ENTERSIZEMOVE;	//561
	EvCALLBACKJumpTable[WM_EXITSIZEMOVE] =  w32_EXITSIZEMOVE;	//562

	SIZEMOVE_ap = NULL;
	tmp_ConfigureEvent = NULL;
	locAkt_hDC.hDC = 0;
	locTmp_hDC[0].hDC = 0;
	locTmp_hDC[1].hDC = 0;
	locTmp_hDC[2].hDC = 0;
	locTmp_hDC[3].hDC = 0;

	app_bmDat = NULL;
}

int czzz = 0;

static LRESULT CALLBACK X11_WindowProc(HWND hwnd, UINT Msg, WPARAM Wpr, LPARAM Lpr) {
  TWins* ap;
  int handled = False;
  int res = 0;

    if ((Msg < 1024) && (EvCALLBACKJumpTable[Msg])) {
	ap = GetTWins(hwnd);
	if (ap) handled = (*EvCALLBACKJumpTable[Msg])(ap, hwnd, Msg, Wpr, Lpr, &res);
#if 0
    } else {
	ap = GetTWins(hwnd);
	switch (Msg) {
	case WM_CREATE:			//1
	case WM_DESTROY:		//2
	case WM_MOVE:			//3
//	case WM_SIZE:			//5
	case WM_ACTIVATE:		//6
//	case WM_SETFOCUS:		//7
//	case WM_KILLFOCUS:		//8
	case WM_SETTEXT:		//12
	case WM_GETTEXT:		//13
//	case WM_PAINT:			//15
//	case WM_CLOSE:			//16
	case WM_QUERYOPEN:		//19
//	case WM_ERASEBKGND:		//20
	case WM_SHOWWINDOW:		//24
	case WM_ACTIVATEAPP:		//28
	case WM_CANCELMODE:		//31
//	case WM_SETCURSOR:		//32
	case WM_CHILDACTIVATE:		//34
//	case WM_GETMINMAXINFO:		//36
//	case WM_WINDOWPOSCHANGING:	//70
	case WM_WINDOWPOSCHANGED:	//71
	case WM_CONTEXTMENU:		//123
	case WM_GETICON:		//127
	case WM_NCCREATE:		//129
	case WM_NCDESTROY:		//130
	case WM_NCCALCSIZE:		//131
	case WM_NCHITTEST:		//132
	case WM_NCPAINT:		//133
	case WM_NCACTIVATE:		//134
	case WM_SYNCPAINT:		//136
	case WM_NCMOUSEMOVE:		//160
	case WM_NCLBUTTONDOWN:		//161
	case WM_NCLBUTTONUP:		//162
	case WM_NCRBUTTONDOWN:		//164
	case 174:			//174  WM_???
//	case WM_KEYDOWN:		//256
//	case WM_KEYUP:			//257
//	case WM_CHAR:			//258
	case WM_SYSCOMMAND:		//274
	case WM_INITMENU:		//278
	case WM_INITMENUPOPUP:		//279
	case WM_MENUSELECT:		//287
	case WM_ENTERIDLE:		//289
//	case WM_MOUSEMOVE:		//512
	case WM_MOUSEACTIVATE:		//33
//	case WM_LBUTTONDOWN:		//513
//	case WM_LBUTTONUP:		//514
//	case WM_LBUTTONDBLCLK:		//515
//	case WM_RBUTTONDOWN:		//516
//	case WM_RBUTTONUP:		//517
//	case WM_MOUSEWHEEL:		//522
	case WM_PARENTNOTIFY:		//528
	case WM_ENTERMENULOOP:		//529
	case WM_EXITMENULOOP:		//530
	case WM_SIZING:			//532
	case WM_CAPTURECHANGED:		//533
	case WM_MOVING:			//534
	case WM_DEVICECHANGE:		//537
//	case WM_ENTERSIZEMOVE:		//561
//	case WM_EXITSIZEMOVE:		//562
	case 641:			//641  WM_IME_SETCONTEXT
	case 642:			//642  WM_IME_NOTIFY
	case 674:			//674  WM_NCMOUSELEAVE
	case WM_QUERYNEWPALETTE:	//783
		break;
	default:	
 printf("X11_WindowProc hwnd=%x Msg=%d ap=%x wp=0x%x lp=0x%x\n", (int)hwnd, Msg, (int)ap, (int)Wpr, (int)Lpr);

	} 
#endif
    }

    if (handled) return res; else return DefWindowProcW(hwnd, Msg, Wpr, Lpr);
}


/*____________________________________________________________________________*/
void W32_app_Timer_50ms(dword dwTime) {

	if (Last_Mouse_hwnd) {
	    Last_Mouse_tz -= 1;
	    if (!Last_Mouse_tz) {
		Last_Mouse_tz = 2;
  POINT mPoint;
  HWND child;
		GetCursorPos(&mPoint);
		child = WindowFromPoint(mPoint);
		if (Last_Mouse_hwnd != child) {
		    X11_XLeaveWindowEvent(mPoint.x, mPoint.y);
		    Last_Mouse_hwnd = 0;
// printf("%s(%d): %ld %ld 0x%x 0x%x\n", FL, mPoint.x, mPoint.y, (int)Last_Mouse_hwnd, (int)child);
		}
	    }
	}
}



/*____________________________________________________________________________*/
static const WCHAR strClassNameForm[] = { 'f','A','L','D','c','c','p',0 };
static const WCHAR strClassName[] = { 'p','A','L','D','c','c','p',0 };
static const WCHAR strClassNameMenu[] = { 'M','e','n','u','A','L','D',0 };

Window XCreateWindow(dpy, parent, x, y, width, height, 
                borderWidth, depth, class, visual, valuemask, attributes)
    register Display *dpy;
    Window parent;
    int x, y;
    unsigned int width, height, borderWidth;
    int depth;
    unsigned int class;
    Visual *visual;
    unsigned long valuemask;
    XSetWindowAttributes *attributes;
{
  BOOL ClassRegistered;
  WNDCLASSW TempClass;
  WNDCLASSW wclass;
  HWND hWnd;
  const WCHAR *class_name;
  bool OverrideRedirect;

	Fill0(&wclass, sizeof(WNDCLASSA));

	OverrideRedirect = ((valuemask & CWOverrideRedirect) && 
				attributes->override_redirect);

	wclass.style = CS_HREDRAW | CS_VREDRAW;
	if (OverrideRedirect) {
	    class_name = strClassNameMenu;
//	    wclass.style |= CS_SAVEBITS;
	} else if (parent) {
	    class_name = strClassName;
	} else {
	    class_name = strClassNameForm;
	    if (attributes->border_pixmap) {
		wclass.hIcon = (HICON)attributes->border_pixmap;
	    } else {
		wclass.hIcon = LoadIcon((HINSTANCE) NULL, IDI_APPLICATION); 
	    }
	}

// printf("%s(%d): XCreateWindow: parent=0x%x %d %d %dx%d\n", FL, (int)parent, x, y, width, height);
	ClassRegistered = GetClassInfoW(dpy->appInstance, class_name, &TempClass);
	if (!ClassRegistered) {
//	    wclass.style = CS_CLASSDC | CS_PARENTDC | CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
	    wclass.lpfnWndProc = X11_WindowProc;
	    wclass.hInstance = dpy->appInstance;
//	    wclass.hbrBackground = (HBRUSH) COLOR_BTNSHADOW;
	    wclass.lpszClassName = class_name;
	    wclass.hCursor = LoadCursor(NULL, IDC_ARROW);
	    RegisterClassW(&wclass);
	}

  dword dwStyle = WS_CLIPCHILDREN | WS_CLIPSIBLINGS;
  dword exStyle;

	if ((valuemask & CWBackPixel) &&
	    (attributes->background_pixel != WinsDefault_GC->gcv.foreground)) 
	{
	    attributes->background_pixmap = CreateSolidBrush(attributes->background_pixel);
	} else {
	    attributes->background_pixmap = WinsDefault_GC->hbrush;
	}

	if (OverrideRedirect) {
	    dwStyle = WS_POPUP;
	    exStyle = WS_EX_TOOLWINDOW | WS_EX_TOPMOST | WS_EX_NOPARENTNOTIFY; //WS_EX_APPWINDOW;
	} else if (parent) {
	    dwStyle |= WS_CHILD;
	    exStyle = WS_EX_CONTROLPARENT;
	} else {
	    dwStyle |= WS_CAPTION | WS_THICKFRAME | WS_MINIMIZEBOX |
			WS_MAXIMIZEBOX | WS_SYSMENU | WS_SIZEBOX;
//	    exStyle = WS_EX_APPWINDOW | WS_EX_TOOLWINDOW;
	    exStyle = 0;
	    parent = attributes->TransientWindow;
	}

  /* Create the window */
	hWnd = CreateWindowExW (exStyle,	/* Extended styles */
			  class_name,		/* Class name */
			  NULL,			/* Window name */
			  dwStyle,		/* window style */
			  x,			/* Horizontal position */
			  y,			/* Vertical position */
			  width,		/* Right edge */ 
			  height,		/* Bottom edge */
			  parent,		/* No parent or owner window */
			  0,			/* No menu */
			  dpy->appInstance, 	/* Instance handle */
			  0);			/* ScreenPrivates */


//	if ((valuemask & CWCursor) && attributes->cursor) {
//	
//	}

	return hWnd;
}

/*____________________________________________________________________________*/
int XDestroyWindow (Display *dpy, Window w) {
	DestroyWindow(w);
	return 0;
}

/*____________________________________________________________________________*/
int XFlush(Display *dpy) {
	return 0;
}

/*____________________________________________________________________________*/
int XQueryTree (dpy, w, root, parent, children, nchildren)
    register Display *dpy;
    Window w;
    Window *root;	/* RETURN */
    Window *parent;	/* RETURN */
    Window **children;	/* RETURN */
    unsigned int *nchildren;  /* RETURN */
{
	*root = appXDat.RootW;
	*parent = GetParent(w);
	*children = NULL;
	*nchildren = 0;
 printf("%s(%d): XQueryTree: w=0x%x root=0x%x parent=0x%x\n", FL, (int)w, (int)*root, (int)*parent);
	return (*parent > 0);
}

/*____________________________________________________________________________*/
int XGetGeometry (dpy, d, root, x, y, width, height, borderWidth, depth)
    register Display *dpy;
    Drawable d;
    Window *root; /* RETURN */
    int *x, *y;  /* RETURN */
    unsigned int *width, *height, *borderWidth, *depth;  /* RETURN */
{
  RECT rc;

	if (!GetWindowRect(d, &rc)) return 0;
	*x = rc.left;
	*y = rc.top;
	*width = rc.right - rc.left;
	*height = rc.bottom - rc.top;
	*root = appXDat.RootW;
	*borderWidth = 0;
	*depth = appXDat.RootW_depth;
	return 1;
}

/*____________________________________________________________________________*/
int XChangeWindowAttributes (Display *dpy, Window w, 
		unsigned long valuemask, XSetWindowAttributes *attributes) 
{
  TWins *wins = NULL;
  HBRUSH background_pixmap;

	if (valuemask & CWBackPixel) {
	  wins = GetTWins(w);
	  if (wins) {
	    background_pixmap = wins->OS_var.background_pixmap;
	    if (background_pixmap != WinsDefault_GC->hbrush) {
		if (background_pixmap)
			DeleteObject(background_pixmap);
	    }
	    if (attributes->background_pixel != WinsDefault_GC->gcv.foreground) {
		background_pixmap = CreateSolidBrush(attributes->background_pixel);
	    } else {
		background_pixmap = WinsDefault_GC->hbrush;
	    }
	    wins->OS_var.background_pixmap = background_pixmap;
	  }
	  valuemask &= ~CWBackPixel;
	}
	if (valuemask & CWCursor) valuemask &= ~CWCursor;

	if (valuemask) {
 printf("%s(%d): XChangeWindowAttributes: w=0x%x mask=0x%04x\n", FL, (int)w, (int)valuemask);
	}

	return 0;
}

/*____________________________________________________________________________*/
static void KorrWindowSize(Window w, int x, int y, dword width, dword height, int fu) {
  TWins* wins = GetTWins(w);

	if (!wins) return;
	if (fu & 1) {
	    x = wins->left;
	    y = wins->top;
	}
	if (fu & 2) {
	    width = wins->width;
	    height = wins->height;
	}
//	if (ap->wins->apph->aos & aosIsAppRoot) {
	if (wins->wtyp & wtyp_Form) {
  RECT wrc, crc;
	    GetWindowRect(w, &wrc);
	    GetClientRect(w, &crc);
	    width += (wrc.right - wrc.left) - (crc.right - crc.left);
	    height += (wrc.bottom - wrc.top) - (crc.bottom - crc.top);
	}
	MoveWindow(w, x, y, width, height, True);
}

/*____________________________________________________________________________*/
int XMoveResizeWindow(Display *dpy, Window w, int x, int y, dword width, dword height) {
	KorrWindowSize(w, x, y, width, height, 0);
	return 0;
}

/*____________________________________________________________________________*/
int XMoveWindow (Display *dpy, Window w, int x, int y) {
	KorrWindowSize(w, x, y, 0, 0, 2);
	return 0;
}

/*____________________________________________________________________________*/
int XResizeWindow(Display *dpy, Window w, unsigned int width, unsigned int height) {
	KorrWindowSize(w, 0, 0, width, height, 1);
	return 0;
}

/*____________________________________________________________________________*/
int XClearArea(Display * dpy, Window w, int x, int y, 
		unsigned int width, unsigned int height, Bool exposures) {
  int isTempDC;
  TWins* wins = GetTWins(w);
  RECT rc;
  HDC hDC = GetTmpPaintDC(w, &isTempDC, 0, 0);

	rc.left = x;
	rc.top = y;
	rc.right = x + width;
	rc.bottom = y + height;
	if (wins) FillRect(hDC, &rc, wins->OS_var.background_pixmap);
	ReleaseTmpPaintDC(w, hDC, isTempDC);
	return 0;
}

/*____________________________________________________________________________*/
int XClearWindow(Display *dpy, Window w) {
	InvalidateRect(w, NULL, True);
	UpdateWindow(w);
	return 0;
}

/*____________________________________________________________________________*/
Bool XTranslateCoordinates(Display *dpy, Window src_win, Window dest_win, 
		int src_x, int src_y, int *dst_x, int *dst_y, Window *child) {

// printf("%s(%d): XTranslateCoordinates: sw=0x%x dw=0x%x x=%d y=%d\n", FL, 
//	(int)src_win, (int)dest_win, src_x, src_y);

  RECT src_rc, dest_rc;
  POINT p;

	src_rc.left = 0;
	src_rc.top = 0;
	dest_rc.left = 0;
	dest_rc.top = 0;
	GetWindowRect(src_win, &src_rc);
	GetWindowRect(dest_win, &dest_rc);

	p.x = src_x + src_rc.left - dest_rc.left;
	p.y = src_y + src_rc.top - dest_rc.top;
	*dst_x = p.x;
	*dst_y = p.y;
	
	*child = WindowFromPoint(p);
	return 0;
}

/*____________________________________________________________________________*/
int XAllocColor(dpy, cmap, def)
register Display *dpy;
Colormap cmap;
XColor *def;
{
	return 0;
}

/*____________________________________________________________________________*/
int XTextWidth (XFontStruct *fs, const char *string, int count) {
  SIZE sz;
  HFONT hfold;
  HDC hdc;

	hdc = GetDC(0);
	hfold = SelectObject(hdc, fs->fid);
	GetTextExtentPoint32(hdc, string, count, &sz); 
	SelectObject(hdc, hfold);

	ReleaseDC(0, hdc);
	return sz.cx;
}

/*____________________________________________________________________________*/
int XTextWidth16 (XFontStruct *fs, const XChar2b *string, int count) {
  SIZE sz;
  HFONT hfold;
  HDC hdc;

	hdc = GetDC(0);
	hfold = SelectObject(hdc, fs->fid);
	GetTextExtentPoint32W(hdc, (LPCWSTR)string, count, &sz); 
	SelectObject(hdc, hfold);

	ReleaseDC(0, hdc);
	return sz.cx;
}

/*____________________________________________________________________________*/
int XDrawImageString(Display *dpy, Drawable d, GC gc, int x, int y, 
			const char *string, int length) {
  int isTempDC;
  HDC hDC;



	hDC = GetTmpPaintDC(d, &isTempDC, gc, gcdc_hfont);
	SetBkColor(hDC, gc->gcv.background);
	SetTextColor(hDC, gc->gcv.foreground);
	TextOutA(hDC, x, y, string, length);
	ReleaseTmpPaintDC(d, hDC, isTempDC);
	return 0;
}

/*____________________________________________________________________________*/
int
XDrawImageString16(Display *dpy, Drawable d, GC gc, int x, int y,
			const XChar2b *string, int length) {
  int isTempDC;
  HDC hDC = GetTmpPaintDC(d, &isTempDC, gc, gcdc_hfont);
	SetBkColor(hDC, gc->gcv.background);
	SetTextColor(hDC, gc->gcv.foreground);
	TextOutW(hDC, x, y, (LPCWSTR)string, length);
	ReleaseTmpPaintDC(d, hDC, isTempDC);
	return 0;
}

/*____________________________________________________________________________*/
int XDrawString(Display *dpy, Drawable d, GC gc, int x, int y, 
			const char *string, int length) {
  int isTempDC;
  HDC hDC = GetTmpPaintDC(d, &isTempDC, gc, gcdc_hfont);

	SetTextColor(hDC, gc->gcv.foreground);
	SetBkMode(hDC, TRANSPARENT);
	TextOutA(hDC, x, y, string, length);
	ReleaseTmpPaintDC(d, hDC, isTempDC);
	return 0;
}

/*____________________________________________________________________________*/
int
XDrawString16(Display *dpy, Drawable d, GC gc, int x, int y,
			const XChar2b *string, int length) {
  int isTempDC;
  HDC hDC;

	hDC = GetTmpPaintDC(d, &isTempDC, gc, gcdc_hfont);
	SetTextColor(hDC, gc->gcv.foreground);
	SetBkMode(hDC, TRANSPARENT);
	TextOutW(hDC, x, y, (LPCWSTR)string, length);
	ReleaseTmpPaintDC(d, hDC, isTempDC);
	return 0;
}

/*____________________________________________________________________________*/
int XSetWindowBackground(Display *dpy, Window w, unsigned long pixel) {
  XSetWindowAttributes XAttr;

 printf("%s(%d): XSetWindowBackground: w=0x%x \n", FL, (int)w);
	Fill0(&XAttr, sizeof(XAttr));
	XAttr.background_pixel = pixel; //GetColor_RGB(pixel);
	XChangeWindowAttributes(appXDat.dpy, w, CWBackPixel, &XAttr);
	return 0;
}

/*____________________________________________________________________________*/
int XUnmapWindow (Display *dpy, Window w) {
	ShowWindow(w, SW_HIDE);
	UpdateWindow(w);
	return 0;
}

/*____________________________________________________________________________*/
int XMapWindow (Display *dpy, Window w) {
  TWins* wins = GetTWins(w);
	if (wins && wins->OS_var.OverrideRedirect) {
	    SetWindowPos(w, HWND_TOPMOST, wins->left, wins->top, 
			wins->width, wins->height, 
			SWP_SHOWWINDOW | SWP_NOACTIVATE);
	} else {
	    ShowWindow(w, SW_SHOW);
	}
	UpdateWindow(w);
	return 0;
}

/*____________________________________________________________________________*/
int XMapRaised (Display *dpy, Window w) {
  TWins* wins = GetTWins(w);
	if (wins && wins->OS_var.OverrideRedirect) {
	    SetWindowPos(w, HWND_TOPMOST, wins->left, wins->top, 
			wins->width, wins->height, 
			SWP_SHOWWINDOW | SWP_NOACTIVATE);
	} else {
	    ShowWindow(w, SW_SHOW);
	    BringWindowToTop(w);
	}
	UpdateWindow(w);
	return 0;
}

int
XSetInputFocus(dpy, focus, revert_to, _time)
    register Display *dpy;
    Window focus;
    int revert_to;
    Time _time;
{       
 printf("%s(%d): XSetInputFocus: w=0x%x \n", FL, (int)focus);
	return 0;
}

/*____________________________________________________________________________*/
int XGrabPointer(Display *dpy, Window grab_window, Bool owner_events, 
		unsigned int event_mask, int pointer_mode, int keyboard_mode,
		Window confine_to, Cursor curs, Time _time) {
	SetCapture(grab_window);
	return 0;
}

/*____________________________________________________________________________*/
int XUngrabPointer(Display *dpy, Time _time) {
	ReleaseCapture();
	return 0;
}

/*****************************************************************
 *  IMAGING 
 *****************************************************************/
/*____________________________________________________________________________*/


void Add_BITMAP_Dat(TBITMAP_Dat *bmDat) {
	bmDat->next = app_bmDat;
	app_bmDat = bmDat;
}

void Del_BITMAP_Dat(TBITMAP_Dat *bmDat) {
  TBITMAP_Dat **ppbmDat = &app_bmDat;

	while (*ppbmDat && (*ppbmDat != bmDat)) {
		ppbmDat = &(*ppbmDat)->next;
	}
	if (*ppbmDat) {
		*ppbmDat = bmDat->next;
		xfree(bmDat);
	} else printf("%s(%d): Del_BITMAP_Dat bmDat 0x%x not found ?\n", FL, (int)bmDat);
}

TBITMAP_Dat *Get_BITMAP_Dat(HBITMAP hbitmap) {
  TBITMAP_Dat *bmDat = app_bmDat;

	while (bmDat && (bmDat->hbitmap != hbitmap)) {
		bmDat = bmDat->next;
	}
	return bmDat;
}

int Get_bytes_per_line(int depth, int width) {
	if (depth == 1) {
	    return ((width+15) >> 4) * 2;
	} else if (depth == 16) {
	    return ((width+1) >> 1) * 4;
	} else {
	    return width * 4;
	}
}

/*____________________________________________________________________________*/
XImage *XCreateImage (Display *dpy, Visual *visual, unsigned int depth, 
		int format, int offset, char *data, 
		unsigned int width, unsigned int height,
		int xpad, int image_bytes_per_line) {
  XImage *img;

	if (!image_bytes_per_line) 
		image_bytes_per_line = Get_bytes_per_line(depth, width);

// printf("%s(%d): XCreateImage: d=%u w=%u h=%u bl=%d\n", FL, depth, width, height, image_bytes_per_line);
	img = xcalloc(sizeof(XImage));
	img->width = width;
	img->height = height;
	img->xoffset = offset;
	img->format = format;
	img->data = data;
	img->height = height;
	img->bitmap_pad = xpad;
	img->bytes_per_line = image_bytes_per_line;
	img->depth = depth;

	return img;
}

/*____________________________________________________________________________*/
int XDestroyImage(XImage *ximage) {
	xfree(ximage->data);
	xfree(ximage);
	return 0;
}

/*____________________________________________________________________________*/
XImage *XGetImage (dpy, d, x, y, width, height, plane_mask, format)
     register Display *dpy;
     Drawable d;
     int x, y;
     unsigned int width, height;
     unsigned long plane_mask;
     int format;	/* either XYPixmap or ZPixmap */
{
 printf("%s(%d): XGetImage: d=0x%x \n", FL, (int)d);
	return NULL;
}

/*____________________________________________________________________________*/
int XPutImage (Display *dpy, Drawable d, GC gc, XImage *image, 
	int req_xoffset, int req_yoffset, int x, int y, 
	unsigned int req_width, unsigned int req_height) {

  TBITMAP_Dat *bmDat;
  int ix, iy, imW, imH, bmW, bmH;
  char *src0, *dest0;

	bmDat = Get_BITMAP_Dat((HBITMAP)d);
	if (!bmDat || !image) return 0;

	src0 = image->data;
	dest0 = bmDat->ui.DIBS.dsBm.bmBits;
	if (!src0 || !dest0) return 0;

	imW = image->width;
	imH = image->height;
	bmW = bmDat->ui.DIBS.dsBm.bmWidth;
	bmH = bmDat->ui.DIBS.dsBm.bmHeight;
	if ((imH != bmH) || (imW != bmW)) {
	        printf("%s(%d): (imgheight != bmHeight) or (imgwidth != bmWidth) %d=%d  %d=%d\n", FL, 
			imH, bmH, imW, bmH);
		return 0;
	}

// printf("%s(%d): %d %d 0x%x 0x%x\n", FL, bmDat->bytes_per_line, (int)bmDat->ui.DIBS.dsBm.bmHeight, (int)src0, (int)dest0);
// printf("%s(%d): %d %d \n", FL, image->depth, bmDat->depth);

	if ((image->depth == 16) && (bmDat->depth == 16)) {
  word *dest, *src;
	    dest0 += bmDat->bytes_per_line * (bmH - 1);
	    iy = imH;
	    while (iy) {
		src = (word*)src0;
		dest = (word*)dest0;
		ix = imW;
		while (ix) {
		    *dest = *src;
		    dest++; src++;
		    ix--;
		}
		src0 += image->bytes_per_line;
		dest0 -= bmDat->bytes_per_line;
		iy--;
	    }
	} else if ((image->depth == 24) && (bmDat->depth == 24)) {
  dword *dest, *src;
	    dest0 += bmDat->bytes_per_line * (bmH - 1);
	    iy = imH;
	    while (iy) {
		src = (dword*)src0;
		dest = (dword*)dest0;
		ix = imW;
		while (ix) {
		    *dest = *src;
		    dest++; src++;
		    ix--;
		}
		src0 += image->bytes_per_line;
		dest0 -= bmDat->bytes_per_line;
		iy--;
	    }
	}
	return 0;
}
