/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"

void bitmask2alpha(TImage *self) {
  byte *dbA0, *dbA, *sbm;
  int sboff, line_bytes, MaskZ;
  dword Mask;

	if (!self->mask_data) return;

	if ((self->pxm_LD & pxmLD_bppMask) == pxm_2b_16bpp) {
	    xfree(self->rgb565_alpha_data);
	    self->rgb565_alpha_data = xmalloc(self->width * self->height);
	    dbA0 = self->rgb565_alpha_data;
	    line_bytes = self->width;
	    sboff = 1;
	} else {
	    dbA0 = self->data + 3;
	    line_bytes = self->bytes_per_line;
	    sboff = 4;
	}

	sbm = self->mask_data;
	for (int y=self->height; y; y--) {
	    dbA = dbA0;
	    Mask = 0; MaskZ = 0;
	    for (int x=self->width; x; x--) {
		if (!MaskZ) {MaskZ = 8; Mask = *sbm; sbm++;}
		if (Mask & 0x01) {
		    *dbA = 255;
		} else {
		    *dbA = 0;
		}
		dbA += sboff;
		Mask >>= 1; MaskZ--;
	    }
	    dbA0 += line_bytes;
	}
	self->stat |= pmxStat_has_alpha;
	alpha_bm_stat(self);
}
