/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include "tpixmap.h"
#include "tdecor.h"

 

static dword TR3AddTab_Add_888(TRX_Dat *dat, int x, int y) {
  ic32 ic;
  int w;
  const byte *pc;

	w = dat->BordMaskDat[x + dat->xMoff + dat->Mw*y];
	pc = (Clip255 + w);
	ic.b[0] = pc[dat->bix.b[0]];
	ic.b[1] = pc[dat->bix.b[1]];
	ic.b[2] = pc[dat->bix.b[2]];
	return ic.dw;
}

static word TR3AddTab_Add_565(TRX_Dat *dat, int x, int y) {
  int w;
  const byte *pc;

	w = dat->BordMaskDat[x + dat->xMoff + dat->Mw*y];
	pc = (Clip255 + w);
	return  ((pc[dat->bix.b[0]] & 0xf8)>>3) |
		((pc[dat->bix.b[1]] & 0xfc)<<3) |
		((pc[dat->bix.b[2]] & 0xf8)<<8);
}

static void __attribute__ ((noinline)) x_md_565(TRX_Dat *dat, int y, word *dest) {
  int xo = 0;
  int dxo = dat->dxmod;
  int dxrep = dat->paint_pxm->width;

	y += dat->yMoff;
	for (int i=dat->lx;i;i--) {
	    if (xo >= dat->xrep) xo = 0;
	    if (dxo >= dxrep) dxo = 0;
	    dest[dxo] = TR3AddTab_Add_565(dat, xo, y);
	    xo++; dxo++;
	}
}

static void __attribute__ ((noinline)) x_sMd_565(TRX_Dat *dat, int y, word *dest, word *src) {
  int xo = 0;
  int sxo = dat->sxmod;
  int sxrep = dat->org_pxm->width;
  int dxo = dat->dxmod;
  int dxrep = dat->paint_pxm->width;

	y += dat->yMoff;
	for (int i=dat->lx;i;i--) {
	    if (xo >= dat->xrep) xo = 0;
	    if (dxo >= dxrep) dxo = 0;
	    if (sxo >= sxrep) sxo = 0;
	    dword sw = src[sxo];
	    dat->bix.i = ((sw & 0x1f)<<3)|((sw & 0x7e0)<<5)|((sw & 0xf800)<<8);
	    dest[dxo] = TR3AddTab_Add_565(dat, xo, y);
	    xo++; dxo++; sxo++;
	}
}

static void __attribute__ ((noinline)) x_md_888(TRX_Dat *dat, int y, dword *dest) {
  int xo = 0;
  int dxo = dat->dxmod;
  int dxrep = dat->paint_pxm->width;

	y += dat->yMoff;
	for (int i=dat->lx;i;i--) {
	    if (xo >= dat->xrep) xo = 0;
	    if (dxo >= dxrep) dxo = 0;
	    dest[dxo] = TR3AddTab_Add_888(dat, xo, y);
	    xo++; dxo++;
	}
}

static void __attribute__ ((noinline)) x_sMd_888(TRX_Dat *dat, int y, dword *dest, dword *src) {
  int xo = 0;
  int sxo = dat->sxmod;
  int sxrep = dat->org_pxm->width;
  int dxo = dat->dxmod;
  int dxrep = dat->paint_pxm->width;

	y += dat->yMoff;
	for (int i=dat->lx;i;i--) {
	    if (xo >= dat->xrep) xo = 0;
	    if (dxo >= dxrep) dxo = 0;
	    if (sxo >= sxrep) sxo = 0;
	    dat->bix.i = src[sxo];
	    dest[dxo] = TR3AddTab_Add_888(dat, xo, y);
	    xo++; dxo++; sxo++;
	}
}

static void TR3AddTab_Paint(TRX_Dat *dat) {
  int y, ym, dlg, dyo;
  TPixMap *paint_pxm;
  byte *db0;

	paint_pxm = dat->paint_pxm;
	dat->dxmod = dat->dx % paint_pxm->width;

	dyo = dat->dy % paint_pxm->height;
	dlg = paint_pxm->bytes_per_line;
	db0 = (byte*)paint_pxm->data;

	ym = 0;
	if (dat->org_pxm) {
	    dat->sxmod = dat->dx % dat->org_pxm->width;
	    int syo = dat->dy % dat->org_pxm->height;
	    int slg = dat->org_pxm->bytes_per_line;
	    byte *sb0 = (byte*)dat->org_pxm->data;

	    if ((paint_pxm->pxm_LD & pxmLD_bppMask) == pxm_2b_16bpp) {
		for (y=dat->ly;y;y--) {
		    if (dyo >= paint_pxm->height) dyo = 0;
		    if (syo >= dat->org_pxm->height) syo = 0;
		    if (ym >= dat->yrep) ym = 0;
		    byte *sb = sb0 + (syo * slg);
		    byte *db = db0 + (dyo * dlg);
		    x_sMd_565(dat, ym, (word*)db, (word*)sb);
		    dyo++; syo++; ym++;
		}
	    } else {		//24bpp
		for (y=dat->ly;y;y--) {
		    if (dyo >= paint_pxm->height) dyo = 0;
		    if (syo >= dat->org_pxm->height) syo = 0;
		    if (ym >= dat->yrep) ym = 0;
		    byte *sb = sb0 + (syo * slg);
		    byte *db = db0 + (dyo * dlg);
		    x_sMd_888(dat, ym, (dword*)db, (dword*)sb);
		    dyo++; syo++; ym++;
		}
	    }
	} else {		//no backimage

	    dat->bix.i = dat->Color;
	    if ((paint_pxm->pxm_LD & pxmLD_bppMask) == pxm_2b_16bpp) {
		for (y=dat->ly;y;y--) {
		    if (dyo >= paint_pxm->height) dyo = 0;
		    if (ym >= dat->yrep) ym = 0;
		    byte *db = db0 + (dyo * dlg);
		    x_md_565(dat, ym, (word*)db);
		    dyo++; ym++;
		}
	    } else {		//24bpp
		for (y=dat->ly;y;y--) {
		    if (dyo >= paint_pxm->height) dyo = 0;
		    if (ym >= dat->yrep) ym = 0;
		    byte *db = db0 + (dyo * dlg);
		    x_md_888(dat, ym, (dword*)db);
		    dyo++; ym++;
		}
	    }
	}

	dat->paint_pxm->stat &= ~pmxStat_XPixAkt;
	TPixMap_XPutImage(dat->paint_pxm);

	dat->gcv.tile = dat->paint_pxm->pmxID;
	ChangeGC(dat->tgc, GCTile , &dat->gcv);
}

void TR3AddTab_PaintH(TRX_Dat *dat) {
	TR3AddTab_Paint(dat);
	int y = dat->dy + (dat->paint_pxm->height >> 1);
	XDrawLine(appXDat.dpy, dat->WinID, dat->tgc, 
				dat->dx, y, dat->dx + dat->plg, y); 

}

void TR3AddTab_PaintVL(TRX_Dat *dat) {
	TR3AddTab_Paint(dat);
	int x = dat->dx + (dat->paint_pxm->width >> 1);
	XDrawLine(appXDat.dpy, dat->WinID, dat->tgc, 
				x, dat->dy, x, dat->dy + dat->plg); 
}

