/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appXbase.h"
#include "tpixmap.h"
#include "cicons.h"

typedef struct TPicCache {
  struct TPicCache *next;
  TPic pic;
  const char *zico;
} TPicCache;

static TPicCache *PicCache = NULL;

TPic *GetDisZIcon(const char *zico) {
  TPicCache *pch, **ppch;

	if (!zico || !*zico) return NULL;
	pch = PicCache;
	while (pch && (pch->zico != zico)) {
	    pch = pch->next;
	}
	if (pch) return &pch->pic;

	pch = xcalloc(sizeof(TPicCache));
	pch->zico = zico;
	if (!CreateAHicoDisPic(zico, &pch->pic)) {
	    xfree(pch);
	    return NULL;
	}

	ppch = &PicCache;
	while (*ppch) {
	    ppch = &(*ppch)->next;
	}
	*ppch = pch;
	return &pch->pic;
}
