/*
Attempted to execute a Streaming SIMD Extensions instruction when the OSFXSR bit is
not set (0) in CR4. Note this does not include the following Streaming SIMD Extensions:
PAVGB, PAVGW, PEXTRW, PINSRW, PMAXSW, PMAXUB, PMINSW, PMINUB,
PMOVMSKB, PMULHUW, PSADBW, PSHUFW, MASKMOVQ, MOVNTQ,
PREFETCH and SFENCE.
*/
/* ___________________ 16bpp X1Y1 _______________________ */
rszmmx16_X1Y1:
	test		%ecx, %ecx
       jz	rszmmx16_X1Y1_end
rszmmx16_X1Y1_loop:
	mov		pxTab_ox(%edx), %eax
	add		pxTab_dox(%edx), %edi

	movzwl		(%esi, %eax, 2), %eax
	movw		%ax, (%edi)

	add		CpxTab_inc, %edx
	dec		%ecx
       jnz	rszmmx16_X1Y1_loop
rszmmx16_X1Y1_end:
       ret
/* ___________________ 16bpp X2Y1 _______________________ */
rszmmx16_X2Y1:
	test		%ecx, %ecx
       jz	rszmmx16_X2Y1_end
rszmmx16_X2Y1_loop:
	mov		pxTab_ox(%edx), %eax
	add		pxTab_dox(%edx), %edi

	movd		(%esi, %eax, 2), %mm0	//rgb 565
	punpcklwd	%mm0, %mm0
	movq		%mm0, %mm1
	punpcklwd	%mm0, %mm0	
	pmullw		%mm6, %mm0
	pand		%mm7, %mm0	//r g b

	punpckhwd	%mm1, %mm1
	pmullw		%mm6, %mm1
	pand		%mm7, %mm1	//r g b

	pmulhuw		pxTab_cxa(%edx), %mm0
	pmulhuw		pxTab_cxe(%edx), %mm1
	paddusw		%mm1, %mm0

// -> rgb888
	pmulhuw		%mm3, %mm0	//rgb885 0xffff1f
	packuswb	%mm0, %mm0	//word -> byte
//rgb885 -> rgb565
	pand		%mm4, %mm0	//mask
	pmaddwd		%mm5, %mm0	//rb(0xf81f) + (g(0xfc) shl 3)
	movd		%mm0, %eax
	movw		%ax, (%edi)

	add		CpxTab_inc, %edx
	dec		%ecx
       jnz	rszmmx16_X2Y1_loop
rszmmx16_X2Y1_end:
       ret
/* ___________________ 16bpp XNY1 _______________________ */
rszmmx16_XNY1:
	test		%ecx, %ecx
       jz	rszmmx16_XNY1_end
	movd		kmulw, %mm2
	psllw		$4, %mm2
	punpcklwd	%mm2, %mm2
	punpcklwd	%mm2, %mm2

rszmmx16_XNY1_loop:
	mov		pxTab_ox(%edx), %ebx
	add		pxTab_dox(%edx), %edi

	movzwl		(%esi, %ebx, 2), %eax	//rgb 565
	movd		%eax, %mm0
	punpcklwd	%mm0, %mm0
	punpcklwd	%mm0, %mm0
	pmullw		%mm6, %mm0
	pand		%mm7, %mm0	//r g b
	pmulhuw		pxTab_cxa(%edx), %mm0

	mov		pxTab_lgx(%edx), %eax
	dec		%eax
	mov		%eax, xn
rszmmx16_XNY1_L:
	inc		%ebx
	movzwl		(%esi, %ebx, 2), %eax	//rgb 565
	movd		%eax, %mm1
	punpcklwd	%mm1, %mm1
	punpcklwd	%mm1, %mm1
	pmullw		%mm6, %mm1
	pand		%mm7, %mm1	//r g b
	pmulhuw		%mm2, %mm1
	paddusw		%mm1, %mm0
	decl		xn
       jnz	rszmmx16_XNY1_L

	inc		%ebx
	movzwl		(%esi, %ebx, 2), %eax	//rgb 565
	movd		%eax, %mm1
	punpcklwd	%mm1, %mm1
	punpcklwd	%mm1, %mm1
	pmullw		%mm6, %mm1
	pand		%mm7, %mm1	//r g b
	pmulhuw		pxTab_cxe(%edx), %mm1
	paddusw		%mm1, %mm0

// -> rgb888
	pmulhuw		%mm3, %mm0	//rgb885 0xffff1f
	packuswb	%mm0, %mm0	//word -> byte
//rgb885 -> rgb565
	pand		%mm4, %mm0	//mask
	pmaddwd		%mm5, %mm0	//rb(0xf81f) + (g(0xfc) shl 3)
	movd		%mm0, %eax
	movw		%ax, (%edi)

	add		CpxTab_inc, %edx
	dec		%ecx
       jnz	rszmmx16_XNY1_loop
rszmmx16_XNY1_end:
       ret

/* ___________________ 16bpp X1Y2 _______________________ */
rszmmx16_X1Y2:
	test		%ecx, %ecx
       jz	rszmmx16_X1Y2_end
rszmmx16_X1Y2_loop:
	mov		pxTab_ox(%edx), %ebx
	add		pxTab_dox(%edx), %edi

	movzwl		(%esi, %ebx, 2), %eax
	movd		%eax, %mm0	//line 1 rgb 565
	add		loff_x, %ebx
	movzwl		(%esi, %ebx, 2), %eax
	movd		%eax, %mm1	//line 2 rgb 565

	punpcklwd	%mm0, %mm0
	punpcklwd	%mm0, %mm0
	pmullw		%mm6, %mm0
	pand		%mm7, %mm0	//r g b -> [0][g][r][b]

	punpcklwd	%mm1, %mm1
	punpcklwd	%mm1, %mm1
	pmullw		%mm6, %mm1
	pand		%mm7, %mm1	//r g b -> [0][g][r][b]

	pmulhuw		%mm3, %mm0	//* cya
	pmulhuw		%mm4, %mm1	//* cye
	paddusw		%mm1, %mm0	//L1+L2

// -> rgb888
	pmulhuw		(a_mmx_mul1_565), %mm0	//rgb885 0xffff1f
	packuswb	%mm0, %mm0	//word -> byte
//rgb885 -> rgb565
	pand		(a_mmx_and_565), %mm0	//mask
	pmaddwd		%mm5, %mm0	//rb(0xf81f) + (g(0xfc) shl 3)
	movd		%mm0, %eax
	movw		%ax, (%edi)

	add		CpxTab_inc, %edx
	dec		%ecx
       jnz	rszmmx16_X1Y2_loop
rszmmx16_X1Y2_end:
       ret

/* ___________________ 16bpp X2Y2 _______________________ */
rszmmx16_X2Y2:
	test		%ecx, %ecx
       jz	rszmmx16_X2Y2_end
rszmmx16_X2Y2_loop:
	mov		pxTab_ox(%edx), %eax
	add		pxTab_dox(%edx), %edi

	movd		(%esi, %eax, 2), %mm0	//line 1 rgb 565
	add		loff_x, %eax
	movd		(%esi, %eax, 2), %mm2	//line 2 rgb 565
	punpcklwd	%mm0, %mm0
	movq		%mm0, %mm1
	punpcklwd	%mm0, %mm0
	pmullw		%mm6, %mm0
	pand		%mm7, %mm0	//L1_B1 r g b -> [0][g][r][b]
	punpckhwd	%mm1, %mm1
	pmullw		%mm6, %mm1
	pand		%mm7, %mm1	//L1_B2 r g b -> [0][g][r][b]
	pmulhuw		pxTab_cxa(%edx), %mm0
	pmulhuw		pxTab_cxe(%edx), %mm1
	paddusw		%mm1, %mm0
	pmulhuw		%mm3, %mm0	//* cya

	punpcklwd	%mm2, %mm2
	movq		%mm2, %mm1
	punpcklwd	%mm1, %mm1
	pmullw		%mm6, %mm1
	pand		%mm7, %mm1	//L2_B1 r g b -> [0][g][r][b]
	punpckhwd	%mm2, %mm2
	pmullw		%mm6, %mm2
	pand		%mm7, %mm2	//L2_B2 r g b -> [0][g][r][b]
	pmulhuw		pxTab_cxa(%edx), %mm1
	pmulhuw		pxTab_cxe(%edx), %mm2
	paddusw		%mm2, %mm1
	pmulhuw		%mm4, %mm1	//* cye

	paddusw		%mm1, %mm0	//(L1+L2)*2

// -> rgb888
	pmulhuw		(a_mmx_mul2_565), %mm0	//rgb885 0xffff1f
	packuswb	%mm0, %mm0	//word -> byte
//rgb885 -> rgb565
	pand		(a_mmx_and_565), %mm0	//mask
	pmaddwd		%mm5, %mm0	//rb(0xf81f) + (g(0xfc) shl 3)
	movd		%mm0, %eax
	movw		%ax, (%edi)

	add		CpxTab_inc, %edx
	dec		%ecx
       jnz	rszmmx16_X2Y2_loop
rszmmx16_X2Y2_end:
       ret
#if 1
/* ___________________ 16bpp XNYa _______________________ */
rszmmx16_XNYa:
	mov		pxTab_ox(%edx), %ebx
	add		pxTab_dox(%edx), %edi
	mov		pxTab_lgx(%edx), %ecx

	movzwl		(%esi, %ebx, 2), %eax
	movd		%eax, %mm0	//line 1 rgb 565
	punpcklwd	%mm0, %mm0
	punpcklwd	%mm0, %mm0
	pmullw		%mm6, %mm0
	pand		%mm7, %mm0	//r g b -> [0][g][r][b]
	pmulhuw		pxTab_cxa(%edx), %mm0
	dec		%ecx
rszmmx16_XNYa_LXa:
	inc		%ebx
	movzwl		(%esi, %ebx, 2), %eax
	movd		%eax, %mm1	//line 1 rgb 565
	punpcklwd	%mm1, %mm1
	punpcklwd	%mm1, %mm1
	pmullw		%mm6, %mm1
	pand		%mm7, %mm1	//r g b -> [0][g][r][b]
	pmulhuw		%mm2, %mm1	//*kmulw
	paddusw		%mm1, %mm0
	dec		%ecx
       jnz	rszmmx16_XNYa_LXa
	movzwl		2(%esi, %ebx, 2), %eax
	movd		%eax, %mm1	//line 1 rgb 565
	punpcklwd	%mm1, %mm1
	punpcklwd	%mm1, %mm1
	pmullw		%mm6, %mm1
	pand		%mm7, %mm1	//r g b -> [0][g][r][b]
	pmulhuw		pxTab_cxe(%edx), %mm1
	paddusw		%mm1, %mm0
	pmulhuw		%mm3, %mm0	//* cya
	paddusw		%mm0, %mm0
       ret

/* ___________________ 16bpp XNYe _______________________ */
rszmmx16_XNYe:
	movzwl		(%esi, %ebx, 2), %eax
	movd		%eax, %mm1	//line -> rgb 565
	punpcklwd	%mm1, %mm1
	punpcklwd	%mm1, %mm1
	pmullw		%mm6, %mm1
	pand		%mm7, %mm1	//r g b -> [0][g][r][b]
	pmulhuw		pxTab_cxa(%edx), %mm1
	paddusw		%mm1, %mm1
	pmulhuw		%mm4, %mm1	//* cye
	paddusw		%mm1, %mm0

	mov		pxTab_lgx(%edx), %ecx
	dec		%ecx
rszmmx16_XNYe_LXe:
	inc		%ebx
	movzwl		(%esi, %ebx, 2), %eax
	movd		%eax, %mm1	//line -> rgb 565
	punpcklwd	%mm1, %mm1
	punpcklwd	%mm1, %mm1
	pmullw		%mm6, %mm1
	pand		%mm7, %mm1	//r g b -> [0][g][r][b] 
	pmulhuw		%mm2, %mm1	//*kmulw
	paddusw		%mm1, %mm1
	pmulhuw		%mm4, %mm1	//* cye
	paddusw		%mm1, %mm0
	dec		%ecx
       jnz	rszmmx16_XNYe_LXe
	movzwl		2(%esi, %ebx, 2), %eax
	movd		%eax, %mm1	//line -> rgb 565
	punpcklwd	%mm1, %mm1
	punpcklwd	%mm1, %mm1
	pmullw		%mm6, %mm1
	pand		%mm7, %mm1	//r g b -> [0][g][r][b]
	pmulhuw		pxTab_cxe(%edx), %mm1
	paddusw		%mm1, %mm1
	pmulhuw		%mm4, %mm1	//* cye
	paddusw		%mm1, %mm0
// -> rgb888
	pmulhuw		(a_mmx_mul1_565), %mm0	//rgb885 0xffff1f
	packuswb	%mm0, %mm0	//word -> byte
//rgb885 -> rgb565
	pand		(a_mmx_and_565), %mm0	//mask
	pmaddwd		(mmx_mul_to_rgb565), %mm0	//rb(0xf81f) + (g(0xfc) shl 3)
	movd		%mm0, %eax
	movw		%ax, (%edi)
	add		CpxTab_inc, %edx
       ret
#endif
/* ___________________ 24bpp X1Y1 _______________________ */
rszmmx24_X1Y1:
	test		%ecx, %ecx
       jz	rszmmx16_X1Y1_end
rszmmx24_X1Y1_loop:
	mov		pxTab_ox(%edx), %eax
	add		pxTab_dox(%edx), %edi

	mov		(%esi, %eax, 4), %eax
	mov		%eax, (%edi)

	add		CpxTab_inc, %edx
	dec		%ecx
       jnz	rszmmx24_X1Y1_loop
rszmmx24_X1Y1_end:
       ret
/* ___________________ 24bpp X2Y1 _______________________ */
rszmmx24_X2Y1:
	test		%ecx, %ecx
       jz	rszmmx24_X2Y1_end
rszmmx24_X2Y1_loop:
	mov		pxTab_ox(%edx), %eax
	add		pxTab_dox(%edx), %edi

	movd		(%esi, %eax, 4), %mm0	//rgb 888
	movd		4(%esi, %eax, 4), %mm1	//rgb 888
	punpcklbw	%mm0, %mm0
	punpcklbw	%mm1, %mm1
	pmulhuw		pxTab_cxa(%edx), %mm0
	pmulhuw		pxTab_cxe(%edx), %mm1
	paddusw		%mm1, %mm0
// -> rgb888
	psrlw		$7, %mm0
	packuswb	%mm0, %mm0	//word -> byte
	add		CpxTab_inc, %edx
	movd		%mm0, (%edi)

	dec		%ecx
       jnz	rszmmx24_X2Y1_loop
rszmmx24_X2Y1_end:
       ret
/* ___________________ 24bpp X1Y2 _______________________ */
rszmmx24_X1Y2:
	test		%ecx, %ecx
       jz	rszmmx24_X1Y2_end
	mov		loff_x, %ebx
rszmmx24_X1Y2_loop:
	mov		pxTab_ox(%edx), %eax
	add		pxTab_dox(%edx), %edi

	movd		(%esi, %eax, 4), %mm0	//line 1 rgb 888
	add		%ebx, %eax
	movd		(%esi, %eax, 4), %mm1	//line 2 rgb 888
	punpcklbw	%mm0, %mm0
	punpcklbw	%mm1, %mm1
	pmulhuw		%mm4, %mm0	//* cya
	pmulhuw		%mm5, %mm1	//* cye
	paddusw		%mm1, %mm0	//L1+L2
// -> rgb888
	psrlw		$7, %mm0
	packuswb	%mm0, %mm0	//word -> byte
	add		CpxTab_inc, %edx
	movd		%mm0, (%edi)

	dec		%ecx
       jnz	rszmmx24_X1Y2_loop
rszmmx24_X1Y2_end:
       ret

/* ___________________ 24bpp X1Y2 _______________________ */
rszmmx24_X2Y2:
	test		%ecx, %ecx
       jz	rszmmx24_X2Y2_end
	mov		loff_x, %ebx
rszmmx24_X2Y2_loop:
	mov		pxTab_ox(%edx), %eax
	add		pxTab_dox(%edx), %edi

	movd		(%esi, %eax, 4), %mm0	//rgb 888
	movd		4(%esi, %eax, 4), %mm1	//rgb 888
	add		%ebx, %eax
	movd		(%esi, %eax, 4), %mm2	//rgb 888
	movd		4(%esi, %eax, 4), %mm3	//rgb 888

	punpcklbw	%mm0, %mm0
	punpcklbw	%mm1, %mm1
	punpcklbw	%mm2, %mm2
	punpcklbw	%mm3, %mm3
	pmulhuw		pxTab_cxa(%edx), %mm0
	pmulhuw		pxTab_cxe(%edx), %mm1
	pmulhuw		pxTab_cxa(%edx), %mm2
	pmulhuw		pxTab_cxe(%edx), %mm3
	paddusw		%mm1, %mm0
	pmulhuw		%mm4, %mm0	//* cya
	paddusw		%mm3, %mm2
	pmulhuw		%mm5, %mm2	//* cye
	paddusw		%mm2, %mm0	//(L1+L2)
// -> rgb888
	psrlw		$6, %mm0
	packuswb	%mm0, %mm0	//word -> byte
	add		CpxTab_inc, %edx
	movd		%mm0, (%edi)

	dec		%ecx
       jnz	rszmmx24_X2Y2_loop
rszmmx24_X2Y2_end:
       ret
