/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"

/*____________________________________________________________________________*/

void TImage_ColorToAlphaData(TImage *self, dword Color) {
  byte *dbA, *sb0, *sb;

	ppfree(&self->rgb565_alpha_data);
	sb0 = self->data;
	if (!sb0) return;
	dbA = xmalloc(self->width * self->height);
	self->rgb565_alpha_data = dbA;
  bool rgb565 = (self->pxm_LD & pxmLD_bppMask) == pxm_2b_16bpp;

	if (rgb565) {
	    Color = ((Color >> 8) & 0xf800) |
		    ((Color >> 5) & 0x07e0) |
		    ((Color >> 3) & 0x001f);
	} else Color &= 0x00ffffff;

	for (int y=self->height;y;y--) {
	    sb = sb0;
	    for (int x=self->width;x;x--) {
  dword cw;
		if (rgb565) {
		    cw = *((word*)sb);
		    sb += 2;
		} else {
		    cw = *((dword*)sb) & 0x00ffffff;
		    sb += 4;
		}
		if (Color == cw) *dbA++ = 0; else *dbA++ = 255;
	    }
	    sb0 += self->bytes_per_line;
	}
}
