/*
 Copyright (C) 2010-2015 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"

void TImage_ClsRGB(TImage *self, dword RGB) {
  int w, h, x;
  dword bpp, col;
  byte *pb;

	if (!self || !self->data || !self->bytes_per_line) return;

	w = self->width;
	h = self->height;
	if ((w <= 0) || (h <= 0)) return;

	pb = self->data;
	bpp = self->pxm_LD & pxmLD_bppMask;
	if (bpp == pxm_2b_16bpp) {
	    col = RGB24To16(RGB);
	    while (h > 0) {
		word *wx = (word*)pb;
		x = w;
		while (x > 0) {
		    *wx = col;
		    wx++; x--;
		}
		pb += self->bytes_per_line;
		h--;
	    }

	} else if ((bpp == pxm_4b_24bpp) || (bpp == pxm_4b_24bpp8a)) {
	    while (h > 0) {
		dword *wx = (dword*)pb;
		x = w;
		while (x > 0) {
		    *wx = RGB;
		    wx++; x--;
		}
		pb += self->bytes_per_line;
		h--;
	    }
	}
}

void TImage_FillRectRGB(TImage *self, dword RGB, int left, int top, 
						int width, int height) {
  int w, h, x;
  dword bpp, col;
  byte *pb;

	if (!self || !self->data || !self->bytes_per_line) return;

	w = self->width;
	h = self->height;
	if ((w <= 0) || (h <= 0)) return;
	if ((left >= w) || (top >= h)) return;
	if (left < 0) {width += left; left = 0;}
	if (top < 0)  {height += top; top = 0;}

	if ((left + width) > w) width  = w - left;
	if ((top + height) > h) height = h - top;

//	if (width > w) width = w;
//	if (height > h) height = h;

//	if (left > w) {width -= (left - w); left = w;}
//	if (top  > h) {height -= (top - h); top = h;}

	if ((width <= 0) || (height <= 0)) return;


	self->stat &= ~pmxStat_XPixAkt;

	pb = self->data + (self->bytes_per_line * top);
	bpp = self->pxm_LD & pxmLD_bppMask;
	if (bpp == pxm_2b_16bpp) {
	    pb += left * 2;
	    col = RGB24To16(RGB);
	    while (height > 0) {
		word *wx = (word*)pb;
		for (x=width;x>0;x--) {*wx = col; wx++;}
		pb += self->bytes_per_line;
		height--;
	    }

	} else if ((bpp == pxm_4b_24bpp) || (bpp == pxm_4b_24bpp8a)) {
	    pb += left * 4;
	    col = RGB;
	    while (height > 0) {
		dword *wx = (dword*)pb;
		for (x=width;x>0;x--) {*wx = col; wx++;}
		pb += self->bytes_per_line;
		height--;
	    }
	}
}

void TImage_FillRectRGB_rc(TImage *self, dword RGB, TWRect *rc) {
	TImage_FillRectRGB(self, RGB, rc->left, rc->top, rc->width, rc->height);
}
