/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"

bool TImage_GetColorMap(TImage *self) {
  dword ar, ag, ab, mr, mg, mb;
  int fu;
  bool MaskAkt;

	if (!self->cmap || (self->cmap->ColorCount <= 0)) return False;
	xfree(self->cmap->col_map);

	self->cmap->col_map = xmalloc(sizeof(ic32) * self->cmap->ColorCount);
	MaskAkt = ((self->cmap->pxgcc & pxgcc_ColorCount_AddMask) != 0) &&
		  alpha_akt(self);

	fu = self->cmap->pxgcc & pxgcc_RGB_Mask;
	if (((self->pxm_LD & pxmLD_bppMask) == pxm_2b_16bpp) || (fu == pxgcc_RGB_565)) {
	    ab = 8; ag = 32; ar = 256;
	    mb = 0xf8; mg = 0xfc00; mr = 0xf80000;
	} else {
	    if (fu == pxgcc_RGB_666) {
		ab = 4; ag = 16; ar = 64;
		mb = 0xfc; mg = 0xfc00; mr = 0xfc0000;
	    } else {

	  dword rgb = 0;
	  ic32 *col_map = self->cmap->col_map;
	  if (MaskAkt) {
	    col_map->i = -1;
	    col_map++;
	  }
#if 1 && defined(__i386__)
	  byte *bit_arr = self->cmap->bit_arr;
 __asm__ volatile(
	      "0: \n"
		"movzbl	(%2),%%ecx \n"
		"inc %2 \n"
		"test	%%ecx, %%ecx \n"
	      "je 90f \n"

		"shr	%%ecx \n"
	      "jnc 1f \n"
		"stos %0,(%1) \n"
	      "1: inc	%0 \n"

		"shr	%%ecx \n"
	      "jnc 2f \n"
		"stos %0,(%1) \n"
	      "2: inc	%0 \n"

		"shr	%%ecx \n"
	      "jnc 3f \n"
		"stos %0,(%1) \n"
	      "3: inc	%0 \n"

		"shr	%%ecx \n"
	      "jnc 4f \n"
		"stos %0,(%1) \n"
	      "4: inc	%0 \n"

		"shr	%%ecx \n"
	      "jnc 5f \n"
		"stos %0,(%1) \n"
	      "5: inc	%0 \n"

		"shr	%%ecx \n"
	      "jnc 6f \n"
		"stos %0,(%1) \n"
	      "6: inc	%0 \n"

		"shr	%%ecx \n"
	      "jnc 7f \n"
		"stos %0,(%1) \n"
	      "7: inc	%0 \n"

		"shr	%%ecx \n"
	      "jnc 8f \n"
		"stos %0,(%1) \n"
	      "8: inc	%0 \n"
		"dec	%3 \n"
	      "jne 0b \n"
	      "jmp 99f \n"

	      "90:\n"
		"add	$8,%%eax \n"
		"dec	%3 \n"
	      "jne 0b \n"
	      "99:\n"
		: "+%eax"(rgb), "+D"(col_map), "+S"(bit_arr)
		: "r"(self->cmap->arr_size)
		: "%ecx");
#else
	  byte *bit_arr = self->cmap->bit_arr;
	  dword k;
		for (int i=self->cmap->arr_size;i;i--) {
		    k = *bit_arr; bit_arr++;
		    if (k) {
			for (int x=8;x;x--) {
			    if (k & 1) {col_map->dw = rgb; col_map++;}
			    rgb++; k >>= 1;
			}
		    } else rgb += 8;
		}
#endif
		return True;
	    }
	}

  ic32 *col_map = self->cmap->col_map;
	if (MaskAkt) {
	  col_map->i = -1;
	  col_map++;
	}
  byte *bit_arr = self->cmap->bit_arr;
  dword r, g, b, k;
	r = g = b = 0;
	for (int i=self->cmap->arr_size;i;i--) {
	    k = *bit_arr; bit_arr++;
	    if (k) {
	      for (int x=8;x;x--) {
		if (k & 1) {
		    col_map->dw = (r & mr)|(g & mg)|(b & mb);
		    col_map++;
		}
		b += ab;
		g += ag;
		r += ar;
		k >>= 1;
	      }
	    } else {
		b += ab << 3;
		g += ag << 3;
		r += ar << 3;
	    }
	}
	return True;
}
