/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"
 
/*____________________________________________________________________________*/
void TImage_SetBase_rsz(TImage *self, Timg_rsz *rsz) {

	rsz->fu = 0;
	rsz->src_typ = 0;
	if ((self->pxm_LD & pxmLD_bppMask) == pxm_2b_16bpp) {
	  rsz->src_line_eoff = (self->bytes_per_line >> 1) - self->width;
	  rsz->src_typ = pxm_2b_16bpp;
	} else if (((self->pxm_LD & pxmLD_bppMask) == pxm_4b_24bpp) ||
		   ((self->pxm_LD & pxmLD_bppMask) == pxm_4b_24bpp8a)) {
	  rsz->src_typ = pxm_4b_24bpp;
	  if (self->stat & pmxStat_ckh_alpha) rsz->src_typ = pxm_4b_24bpp8a;
	  rsz->src_line_eoff = (self->bytes_per_line >> 2) - self->width;
	}
	rsz->src_dat = self->data;
	rsz->src_mask = self->mask_data;
	rsz->src_w = self->width;
	rsz->src_h = self->height;
	rsz->rsztemp0 = NULL;
	rsz->src_off_x = 0;
	rsz->src_off_y = 0;
	rsz->src_lg_x = self->width;
	rsz->src_lg_y = self->height;

  dword CPU_Flags = GetCPU_Flags();
	if ((CPU_Flags & CPU_has_MMX) &&
	    (CPU_Flags & CPU_has_SSE)) {
	  rsz->fu |= rsz_fu_HasMMX;
	}
	if (self->pxm_LD & pxmLD_FastZoom) {
	    rsz->fu |= rsz_fu_Fast_rsz;
	}
}

/*____________________________________________________________________________*/
void TImage_SetDestBase_rsz(TImage *self, Timg_rsz *rsz) {
	rsz->dest_typ = 0;
	if ((self->pxm_LD & pxmLD_bppMask) == pxm_2b_16bpp) {
	  rsz->dest_line_eoff = (self->bytes_per_line >> 1) - self->width;
	  rsz->dest_typ = pxm_2b_16bpp;
	} else if (((self->pxm_LD & pxmLD_bppMask) == pxm_4b_24bpp) ||
		   ((self->pxm_LD & pxmLD_bppMask) == pxm_4b_24bpp8a)) {
	  rsz->dest_typ = pxm_4b_24bpp;
	  rsz->dest_line_eoff = (self->bytes_per_line >> 2) - self->width;
	}
	rsz->dest_dat = self->data;
	rsz->dest_mask = self->mask_data;
	rsz->to_w = self->width;
	rsz->to_h = self->height;
	rsz->dest_off_x = 0;
	rsz->dest_off_y = 0;
	rsz->dest_lg_x = self->width;
	rsz->dest_lg_y = self->height;
}

