/*
 Copyright (C) 2010-2015 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"

void TImage_shift(TImage *self, int xo, int yo) {
  int x, y, incd, w, h;
  dword bpp;
 
	if (!self || !self->data) return;
	w = self->width;
	h = self->height;
	if ((w <= 0) || (h <= 0)) return;
	if (xo > w) xo = w;

	bpp = self->pxm_LD & pxmLD_bppMask;
	if (bpp == pxm_2b_16bpp) {
	    incd = self->bytes_per_line >> 1;
	    word *p = self->data16;
	    if (xo < 0) {
		word *spx, *dpx;
		for (y=h; y>0; y--) {
		    dpx = p;
		    spx = dpx - xo;
		    for (x=w+xo; x>0; x--) {
			*dpx = *spx; dpx++; spx++;
		    }
		    for (x=xo-1; x>0; x--) {
			*dpx = *spx; dpx++;
		    }
		    p += incd;
		}
	    } else if (xo > 0) {
		p += w - 1;
		word *spx, *dpx;
		for (y=h; y>0; y--) {
		    dpx = p;
		    spx = dpx - xo;
		    for (x=w-xo-1; x>0; x--) {
			*dpx = *spx; dpx--; spx--;
		    }
		    for (x=xo; x>0; x--) {
			*dpx = *spx; dpx--;
		    }
		    p += incd;
		}
	    }
	} else if ((bpp == pxm_4b_24bpp) || (bpp == pxm_4b_24bpp8a)) {
	    incd = self->bytes_per_line >> 2;
	    dword *p = self->data32;
	    if (xo < 0) {
		dword *spx, *dpx;
		for (y=h; y>0; y--) {
		    dpx = p;
		    spx = dpx - xo;
		    for (x=w+xo; x>0; x--) {
			*dpx = *spx; dpx++; spx++;
		    }
		    for (x=xo-1; x>0; x--) {
			*dpx = *spx; dpx++;
		    }
		    p += incd;
		}
	    } else if (xo > 0) {
		p += w - 1;
		dword *spx, *dpx;
		for (y=h; y>0; y--) {
		    dpx = p;
		    spx = dpx - xo;
		    for (x=w-xo-1; x>0; x--) {
			*dpx = *spx; dpx--; spx--;
		    }
		    for (x=xo; x>0; x--) {
			*dpx = *spx; dpx--;
		    }
		    p += incd;
		}
	    }
	}
}
