/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include "tpixmap.h"

/*____________________________________________________________________________*/
static TVDrawString *TPixMap_Get_vds(TPixMap *pxm) {
	if (!pxm->vds) {
	    pxm->vds = xcalloc(sizeof(TVDrawString));
	    pxm->vds->Font = appXDat.Default_Font;
	}
	return pxm->vds;
}
/*____________________________________________________________________________*/
void TPixMap_SetFont(TPixMap *pxm, TFontX *font) {
  TVDrawString *vds = TPixMap_Get_vds(pxm);
	vds->Font = font;
}

void TPixMap_SetFontName(TPixMap *pxm, const char *name) {
  TFontX *font;
  TVDrawString *vds;

	vds = TPixMap_Get_vds(pxm);
	font = vds->Font;
	vds->Font = MakeFont(name, FontX_GetFontName(appXDat.Default_Font));
	Tfree(font);
}

/*____________________________________________________________________________*/
void TPixMap_SetFontColor(TPixMap *pxm, dword ForeColor, dword BackColor) {
  TVDrawString *vds = TPixMap_Get_vds(pxm);
	Font_SetColor((TFont*)vds->Font, ForeColor);
	Font_SetBackColor((TFont*)vds->Font, BackColor);
}

/*____________________________________________________________________________*/
void TPixMap_DrawString(TPixMap *pxm, const char *s, int x, int y) {
  TVDrawString *vds = TPixMap_Get_vds(pxm);

	if (!(pxm->stat & pmxStat_NoBixImgSwitch)) TPixMap_XPutImage(pxm);
	vds->s_const = s;
	vds->lg = pclen(s);
	vds->scda = NULL;
	vds->WinID = pxm->pmxID;
	DrawColorString(x, y, vds);
	vds->s_const = NULL;
	vds->lg = 0;
	pxm->stat &= ~pmxStat_ImgAkt;
}
