/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
//#include "img.h"
#include "tpixmap.h"
#include "media_io.h"
#include "video_ioc.h"

/*_______________________________________________________________________*/
bool Video_IOC_ChkType(TVideo_IOC *ioc) {
	if (ioc && (ioc->wtyp == wtyp_TVideo_IOC)) return True;

	if (!ioc) {
	    appError(EMSG_ERR1, "%s(%d): TVideo_IOC = NULL", FL);
	} else if (ioc->wtyp != wtyp_TVideo_IOC) {
	    appError(EMSG_ERR1, "%s(%d): Type not TVideo_IOC (0x%x)", FL, ioc->wtyp);
	}
	return False;
}

bool Video_IOC_ChkTypeArt(TVideo_IOC *self, int art) {
	if (!self) return False;
	if (self->wtyp != wtyp_TVideo_IOC) {
	    appError(EMSG_ERR1, "%s(%d): type Video_IOC is not TVideo_IOC ???", FL);
	    return False;
	}
	if (self->art != art) {
	    appError(EMSG_ERR1, "%s(%d): Video_IOC.art(%d) is not TVideo_IOC.art(%d) ???", FL, self->art, art);
	    return False;
	}
	return True;
}

int Video_IOC_Get_Frame(TVideo_IOC *ioc, TFrame_IO *fio) {
	if (!Video_IOC_ChkType(ioc) || !ioc->get_frame) return 0;
	return ioc->get_frame((TVideo_TTC*)ioc, fio);
}

int Video_IOC_Set_Frame(TVideo_IOC *ioc, TFrame_IO *fio) {
	if (!Video_IOC_ChkType(ioc) || !ioc->set_frame) return 0;
	return ioc->set_frame((TVideo_TTC*)ioc, fio);
}

bool Video_IOC_SetColor(TVideo_IOC *ioc, TVideo_Color_Korr *tvckr) {
	if (!Video_IOC_ChkType(ioc) || !ioc->setcolor) return False;
	return ioc->setcolor(ioc, tvckr);
}

bool Video_IOC_Init(TVideo_IOC *ioc) {
	if (!Video_IOC_ChkType(ioc) || !ioc->init)return False;
	return ioc->init(ioc);
}

static bool Video_IOC__Destroy(TVideo_IOC *ioc) {
	if (!Video_IOC_ChkType(ioc)) return True;
	Tfree(ioc->private);
	return False;
}

static bool Video_IOC_PV__Destroy(void *ioc_pv) {
	if (((TTC*)ioc_pv)->wtyp != wtyp_TVideo_IOC_PV) {
	    appError(EMSG_ERR1, "%s(%d): Type not TVideo_IOC_PV (0x%x)", FL, ((TTC*)ioc_pv)->wtyp);
	    return True;	//ioc_pv not free
	}
	return False;
}

/*_____________________________ Create __________________________________*/

void TVideo_IOC_PV_Init(TVideo_IOC *ioc, int size, int art) {
  TTC1 *ioc_pv = ioc->private;

	if (ioc_pv && ((ioc_pv->art != art) || 
		       (ioc_pv->wtcsize != size))) {
	    Tfree(ioc_pv);
	    ioc_pv = NULL;
	}
	if (!ioc_pv) {
	    ioc_pv = ttc_create(size, wtyp_TVideo_IOC_PV);
	    ioc_pv->destroy = (TDESTROY)Video_IOC_PV__Destroy;
	    ioc_pv->art = art;
	    ioc->private = ioc_pv;
	}
}

TVideo_IOC *TVideo_IOC_Create() {
  TVideo_IOC *ioc;
	
	ioc = ttc_create(sizeof(TVideo_IOC), wtyp_TVideo_IOC);
	ioc->destroy = (TDESTROY)Video_IOC__Destroy;

/*	ioc = xcalloc(sizeof(TVideo_IOC));
	ioc->wtyp = wtyp_TVideo_IOC;
	ioc->free = TVideo_IOC_Free;
//	ioc->init = TVideo_IOC_Init;
//	ioc->tvco = xcalloc(sizeof(Ttv_conv)); */
	return ioc;
}
