/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include <errno.h>

int exec_pc_co_path(const char *args, TOn_pid_close On_pid_close, char *path) {
#ifdef _OS_WIN32
  word *lpCommandLine;
  word *lpCurrentDirectory;
  STARTUPINFOW StartupInfo;
  PROCESS_INFORMATION ProcessInformation;


	Fill0(&StartupInfo, sizeof(StartupInfo));
	StartupInfo.cb = sizeof(StartupInfo);
	Fill0(&ProcessInformation, sizeof(ProcessInformation));

	lpCommandLine = UTF8topwc(args);
	lpCurrentDirectory = UTF8topwc(path);
	CreateProcessW(NULL, lpCommandLine, NULL, NULL,
			False, NORMAL_PRIORITY_CLASS, NULL, lpCurrentDirectory, 
			&StartupInfo, &ProcessInformation);
	xfree(lpCommandLine);
	return ProcessInformation.dwProcessId;
#else
  int argc, pid, fu;
  char **argv = NULL;
  Texec_pipe *expip = NULL;

	if (!args || !*args) return 0;
	cmdtoargs(args, &argc, &argv);

	fu = expipfu_args_free;
	if (On_pid_close || path) {
	    if (On_pid_close) fu = expipfu_addPID_H | expipfu_args_free;
	    expip = Texec_pipe_Create();
	    expip->On_pid_close = On_pid_close;
	    expip->cd_path = path;
	}

	pid = exec_pipe_argv(argv, fu, expip);
	Tfree(expip);
	return pid;
#endif
}

int exec_pc_co(const char *args, TOn_pid_close On_pid_close) {
	return exec_pc_co_path(args, On_pid_close, NULL);
}
