/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include <unistd.h>

static void OnAppFD_close(FileHandle fd) {
  Tfd_list *fdl;

	if ((fd >= FD_SETSIZE) || (fd >= appDat.fd_set_count) || (fd < 0)) return;
	appDat.AktPipes[fd] = 0;
	fdl = &appDat.fd_list[fd];
	fdl->Proc = NULL;
	fdl->io = NULL;
	fdl->obj = NULL;
	fdl->m = 0;
}

Tfd_list *AddPipeProc_TmpRes(FileHandle fd, int fu, TOnPipe OnPipe, void *obj) {
  Tfd_list *fdl;

	if ((fd >= FD_SETSIZE) || (fd < 0)) {
	    appError(EMSG_ERR2, "%s(%d): fd=%d (Max=%d)", FL, fd, FD_SETSIZE);
	    return NULL;
	}

	if (!appFD_close) appFD_close = OnAppFD_close;
	fd_set_count(fd);

	fdl = &appDat.fd_list[fd];
	appDat.AktPipes[fd] = fu;
	fdl->Proc = OnPipe;
	fdl->io = NULL;
	fdl->obj = obj;
	fdl->m = 0;
	return fdl;
}

void AddPipeProc(FileHandle fd, int fu, TOnPipe OnPipe, void *obj) {
	AddPipeProc_TmpRes(fd, fu, OnPipe, obj);
}

void REGP2 ClosePipeProc(FileHandle fd, int fu) {
  Tfd_list *fdl;
  bool mk;

	if (fd < 0) return;
	fdl = &appDat.fd_list[fd];
	mk = appDat.AktPipes[fd] != 0;
	appDat.AktPipes[fd] = 0;
	if ((fu & clpp_io) && fdl->io) fclose(fdl->io);
	if (((fu & clpp_fd) && mk) || (fu & clpp_fdx)) close(fd);
	fdl->io = NULL;
	fdl->Proc = NULL;
}

void REGP1 pClosePipe(FileHandle *fd) {
	if (*fd >= 0) {
	    close(*fd);
	    *fd = -1;
	}
}

void REGP1 ClosePipe(FileHandle fd) {
	if (fd >= 0) close(fd);
}
