/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"

//************************** Timer ******************************************
extern dword w32_app_ms;  //in appbase_w32.c

dword gTimerEv_ms, gTimer_ms_old;
static TgTimer *gTimersX;
dword gTimerZ;

static void SetupApp_ms() {
  dword ms;
  TgTimer *self;

	ms = 50;
	self = gTimersX;
	while (self) {
	    if ((self->OrgInterval <= 50) && (ms > 25)) ms = 25;
	    if ((self->OrgInterval <  25) && (ms > 16)) ms = 16;
	    if ((self->OrgInterval <  16) && (ms > 10)) ms = 10;
	    self = self->next;
	}
	w32_app_ms = ms;
}

static void gTimer_DispatchX() {
  int m, d; 
  dword gTimer_ms;
  TgTimer *gTimer;
  TgTimer *gTFree = NULL;
  bool LoopAkt;

loop:
	gTimer_ms = GetTime_ms();
	d = gTimer_ms - gTimer_ms_old;
	if ((d >= 0) && (d < 10)) return;
	gTimerZ++;

	if (d > 30000) {
	    gTimer = gTimersX;
	    while (gTimer) {
		gTimer->Tmp_ms = gTimer->Tmp_ms + d;
		gTimer = gTimer->next;
	    }
	}
	LoopAkt = False;
	gTimer_ms_old = gTimer_ms;
	gTimer = gTimersX;
	while (gTimer) {

	    if (gTimer->func & Timer_Enabled) {
		m = gTimer_ms - (gTimer->Tmp_ms + gTimer->OrgInterval);
		if (m >= 0) {
		    if (gTimer->func & Timer_Single) gTimer->func &= ~Timer_Enabled;
		    if (gTimer->func & Timer_NoLostOnTimer) {
			gTimer->Tmp_ms += gTimer->OrgInterval;
			LoopAkt = True;
		    } else {
			gTimer->Tmp_ms = gTimer_ms;
		    }
		    if (gTimer->OnTimer && ((gTimer->intern_func & 0x01) == 0)) {
			gTimer->intern_func |= 0x01;
			gTimer->OnTimer(gTimer);
			gTimer->intern_func &= ~0x01;
		    }
		    if (gTimer->func & Timer_OnTimerAndFree) gTFree = gTimer;
		}
	    }
	    gTimer = gTimer->next;
	    if (gTFree) {
		Tfree(gTFree);
		gTFree = NULL;
	    }
	}
	if (LoopAkt) goto loop;
}

/*____________________________ Destroy __________________________________*/
static bool TgTimer__Destroy(TgTimer *self) {
  TgTimer **ppgt;

	ppgt = &gTimersX;
	while (*ppgt && (*ppgt != self)) ppgt = &(*ppgt)->next;
	if (*ppgt) {
	    *ppgt = self->next;
	    if (self->intern_func & 0x01) {
// Test timer del on AppHandleMessage()
		self->func |= Timer_OnTimerAndFree;
		return True;
	    }
	}
	SetupApp_ms();
	return False;
}

void TgTimer_NewInterval(TgTimer *self, dword Interval_ms) {
	if (!ttc_chk_is_wtyp(self, wtyp_TgTimer)) return;
	if (self->OrgInterval != Interval_ms) {
	    self->OrgInterval = Interval_ms;
	}
	SetupApp_ms();
}

/*____________________________ Create ___________________________________*/
TgTimer *gTimerX_Add(dword func, dword Interval_ms, void (*OnTimer)(struct TgTimer*)) {
  TgTimer *self;

	if (!appDat.TimerDispatch) gTimer_Init();
	self = ttc_create(sizeof(TgTimer), wtyp_TgTimer);
	self->destroy = (TDESTROY)TgTimer__Destroy;

	self->func = func;
	self->OrgInterval = Interval_ms;
	self->OnTimer = OnTimer;
	self->next = gTimersX;
	gTimersX = self;
	self->Tmp_ms = GetTime_ms();
	SetupApp_ms();
	return self;
}

void gTimer_Init() {
	appDat.TimerDispatch = gTimer_DispatchX;
	gTimerEv_ms = GetTime_ms();
	gTimer_ms_old = gTimerEv_ms;
}
