/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

char *ChangeFileExt(const char *fn, const char *ext) {
  int lg;
  const char *pce;
  char  *pc, *res;

	if (!fn) return NULL;
	pce = GetFileExt_dot_pc(fn);
	if (pce) {
	    lg = pce-fn; 
	} else {
	    lg = pclen(fn);
	}
	res = xmalloc(lg + pclen(ext) + 2);  //+1 for dot
	pc = res;
	ppcnmove(&pc, fn, lg);
	if (ext && *ext) {
	    if (*ext != '.') {*pc = '.'; pc++;}
	    ppcmove(&pc, ext);
	}
	return res;
}

void ChangeFileExt_ppc(char **fn, const char *ext) {
  char *s;
	if (!fn) return;
	s = ChangeFileExt(*fn, ext);
	xfree(*fn);
	*fn = s;
}
