/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <errno.h>

bool file_rename(const char *fn, TNetErrRet *ErrRet, const char *new_name) {
  bool result;
  char *pc, *pc2;

	path_sub(fn, &pc);
	pc2 = path_add(pc, new_name);
	xfree(pc);
#ifdef _OS_WIN32
	word *wcf = get_pcw_filename(fn, del_path_end_slash);
	word *wcn = get_pcw_filename(pc2, del_path_end_slash);
	result = _wrename(wcf, wcn) == 0;
	xfree(wcn);
	xfree(wcf);
#else
	result = rename(fn, pc2) >= 0;
#endif
	xfree(pc2);
	if (!result && ErrRet) ErrRet->sys_errno = errno;
	return result;
}

bool file_rename_gp(TglobPath *gp, TNetErrRet *ErrRet, const char *new_name) {
  char *fn;
  bool result;
	fn = gptopc(gp, gptfu_del_slash|gptfu_noRootArt);
	result = file_rename(fn, ErrRet, new_name);
	xfree(fn);
	return result;
}
