/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <sys/stat.h>

static bool Find_Chk_pattern(TPattern *patt, const char *s, Tstat64 *st) {
  char **ppc;
  word *pw;

	if (!patt) return True;

	ppc = patt->ppa;
	pw = patt->ft_arr;
	if (!ppc && !pw) return True;

	if (ppc && s && *s) {
	    while (*ppc) {
		if (str_match(*ppc, s, patt->fu_case)) return True;
		ppc++;
	    }
	}
	if (pw && st) {
	    while (*pw) {
		if (*pw == st->FileType) return True;
		pw++;
	    }
	}
	return False;
}

bool TPattern_Match(TPattern *patt, const char *s, Tstat64 *st) {
  bool res;
  
	if (!patt) return True;

	if ((patt->findAtr & findIsRootPath) && s && 
	    (s[0] == '.') && (s[1] == '.') && !s[2]) return False;

	res = True;
	if (st) {
	    if (patt->findAtr & findNoHidden) res = ((st->st & st_Hidden) == 0);
	    if (res) res = file_stat_mode_match(patt->findAtr, st->mode);
	    if (res && (!(patt->findAtr & findDIR_NoPattern) || !(st->st & st_Dir))) {
		res = Find_Chk_pattern(patt, s, st);
	    }
	} else {
	    res = Find_Chk_pattern(patt, s, st);
	}
	return res;
}

bool File_stat_Match(int findAtr, TPattern *patt, const char *s, Tstat64 *st) {
  bool res;

	if (!st) return False;
	if ((findAtr & findIsRootPath) && s 
	    && (s[0] == '.') && (s[1] == '.') && !s[2]) return False;
	res = True;

	if (findAtr & findNoHidden) res = ((st->st & st_Hidden) == 0);

	if (res) res = file_stat_mode_match(findAtr, st->mode);

	if (res && (!(findAtr & findDIR_NoPattern) || !(st->st & st_Dir))) {
	    res = Find_Chk_pattern(patt, s, st);
	}
	return res;
}
