/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"

static const char *DefaultFileArtName_tab[] = {
	NULL,		"Directory",	NULL, 		"Char ",
	"Block ",	"Fifo",		"Socket",	NULL,
	NULL,		NULL,		NULL, 		NULL,
	NULL,		NULL,		NULL, 		NULL,
	"none",		"Text",		"Executable",	"Library",
	NULL,		NULL,		"Shell",	"Pascal sources",
	"C sources",	"C++ sources",	"HTML",		"Binary",
	"Makefile",	"Font A",	"Font Fix",	NULL,
	"ASM File",	"Image",	NULL,		"Shell perl",
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL
};

const char *GetArtExt_pc(Tstat64 *st) {
  int idx = st->FileType;
  const char *pc;

	pc = Get_ExFileDat_pc(st, exfdt_type);
	if (pc && *pc) return pc;

	if (idx < 0) idx = stft_None;
	if (idx >= stft_ListEnde) idx = stft_None;
	if (!DefaultFileArtName_tab[idx]) idx = stft_None;
	if ((idx == stft_None) || (idx == stft_Txt)) {
	    pc = Get_ExFileDat_pc(st, exfdt_FileName);
	    if (pc && *pc && (*pc != '.')) {
		pc = GetFileExt_pc(pc);
		if (pc && *pc) return pc;
	    }
	}
	return DefaultFileArtName_tab[idx];
}
