/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

void (*Glob_OnFileMsg)(TFileMsg *fmsg);

void file_msg(TFileMsg *fmsg) {
	if (fmsg->ev_Stop) return;
	if (Glob_OnFileMsg) Glob_OnFileMsg(fmsg);
	if (fmsg->Ok) return;

	if ((fmsg->art == fmArt_AlgErr) || (fmsg->art == fmArt_errLogin)) {
	    appError(EMSG_ERR1 | EMSG_tIO, fmsg->D.s);
	    fmsg->Ok = True;
	    fmsg->ev_Stop = True;
	}
}

void file_msg_ev(TFileMsg *fmsg, TTC0 *ttc, TOnFileMsg ev) {
  int wtyp;
  void *obj;

	if (fmsg->ev_Stop) return;
	wtyp = fmsg->wtyp;
	obj = fmsg->obj;
	if (ttc) {
	    fmsg->wtyp = ttc->wtyp;
	    fmsg->obj = ttc;
	}
	if (ev) ev(fmsg);
	file_msg(fmsg);
	fmsg->wtyp = wtyp;
	fmsg->obj = obj;
}

void file_msg_ev_next(TFileMsg *fmsg, TTC0 *ttc, TOnFileMsg ev) {
  int wtyp;
  void *obj;

	if (!ev || fmsg->ev_Stop) return;
	wtyp = fmsg->wtyp;
	obj = fmsg->obj;
	if (ttc) {
	    fmsg->wtyp = ttc->wtyp;
	    fmsg->obj = ttc;
	}
	ev(fmsg);
	fmsg->wtyp = wtyp;
	fmsg->obj = obj;
}

void REGP2 file_msg_init(TFileMsg *fmsg, int art) {
	Fill0(fmsg, sizeof(TFileMsg));
	fmsg->art = art;
}

void REGP3 file_msg_init_Dm(TFileMsg *fmsg, int art, int Dm) {
	file_msg_init(fmsg, art);
	fmsg->typD = fmTyp_int;
	fmsg->D.m = Dm;
}

bool file_msg_chk_wtyp(TFileMsg *fmsg, int wtyp, const char *fn, int line) {
	if (fmsg->wtyp == wtyp) return True;
	if (fn) printf("%s(%d): Error: fmsg->wtyp=0x%06x is not 0x%06x\n", fn, line, fmsg->wtyp, wtyp);
	return False;
}
