/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include "net_io.h"
#include "ftp_io.h"

void AddToReplyBuf(TFtp *ftp, int code, char *msg, bool last) {
  TEvReplyBuf *rb;
  TEvReplyBuf **prb;

	prb = &ftp->ReplyBuf;
	while (*prb) prb = &((TEvReplyBuf*)*prb)->next;
	rb = xmalloc(sizeof(TEvReplyBuf));
	*prb = rb;
	rb->next = NULL;
	rb->code = code;
	rb->msg = pcdup(msg);
	rb->last = last;
}

void DelFirstReplyBuf(TFtp *ftp) {
  TEvReplyBuf *rb = ftp->ReplyBuf;
	if (rb) {
	    ftp->ReplyBuf = rb->next;
	    xfree(rb->msg);
	    xfree(rb);
	}
}

void ClrReplyBuf(TFtp *ftp) {
	while (ftp->ReplyBuf) DelFirstReplyBuf(ftp);
}

bool ReplyBuf_Line(TFtp *ftp) {
  TEvReplyBuf *rb = ftp->ReplyBuf;
  bool res = False;
	if (rb) {
	    if (ftp->OnLineRecv) ftp->OnLineRecv(ftp, rb->code, rb->msg, rb->last);
	    DelFirstReplyBuf(ftp);
	    res = True;
	}
	return res;
}
