/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

//fio_EOLdefault=0 fio_EOLunix=1 fio_EOLwindos=2 fio_EOL_0=3 fio_EOLnone=4
int REGP2 GetDefaultEOL_fu(int DefaultEOL, int OrgEOL) {
  int fuEOL = OrgEOL & fio_EOL_Mask;
  int defEOL = DefaultEOL & fio_EOL_Mask;

	if ((DefaultEOL & fio_Strg_C) || (OrgEOL & fio_Strg_C)) {
	    if (fuEOL == fio_EOLnone) return fio_EOLnone;
#ifdef _OS_WIN32
	    return fio_EOLwindos;
#else
	    return fio_EOLunix;
#endif
	}

	if (defEOL == fio_EOLunix) {
	    if ((fuEOL == fio_EOLdefault) || (fuEOL == fio_EOLunix) || (fuEOL == fio_EOLwindos)) {
		fuEOL = fio_EOLunix;
	    }
	} else if (defEOL == fio_EOLwindos) {
	    if ((fuEOL == fio_EOLdefault) || (fuEOL == fio_EOLunix) || (fuEOL == fio_EOLwindos)) {
		fuEOL = fio_EOLwindos;
	    }
	} else {
	    if (fuEOL == fio_EOLdefault) {
#ifdef _OS_WIN32
		fuEOL = fio_EOLwindos;
#else
		fuEOL = fio_EOLunix;
#endif
	    }
	}
	return fuEOL;
}

static const char *s_EOLwindos = "\r\n";
static const char *s_EOLunix = "\n";
static const char *s_EOL_0 = "\0";

const char *GetDefaultEOL_s(int DefaultEOL, int OrgEOL) {
  int fuEOL = GetDefaultEOL_fu(DefaultEOL, OrgEOL);

	if (fuEOL == fio_EOLunix) return s_EOLunix;
	if (fuEOL == fio_EOLwindos) return s_EOLwindos;
	if (fuEOL == fio_EOL_0) return s_EOL_0;
	return NULL;
}

int GetDefaultEOL_lg(int DefaultEOL, int OrgEOL) {
  int fuEOL = GetDefaultEOL_fu(DefaultEOL, OrgEOL);

	if (fuEOL == fio_EOLunix) return 1;
	if (fuEOL == fio_EOLwindos) return 2;
	if (fuEOL == fio_EOL_0) return 1;
	return 0;
}
