/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include "net_io.h"

bool GetSyncPipeServHead(TLineBuf *tpb, TdServHead **sh, int *tsf) {
  int lg;
  char *pcs;

	
	if (*tsf == 1) {
	    TLineBuf_Clr(tpb);
	    return False;
	}

	if (tpb && tpb->pc && (tpb->lg >= 8)) {
	    pcs = tpb->pc;
	    if (tpb->pc_rdidx) pcs = tpb->pc_rdidx;

	    lg = ((TdServHead*)pcs)->lg;
	    if ((lg < 8) || (lg > MAX_AHSERV_BUF)) {
 fprintf(stderr, "Error %s: GetSyncPipeServHead lg=%d\n", app_name, lg);
 for (int i=0;i<16;i++) fprintf(stderr, " %02x", (byte)pcs[i]);
 fprintf(stderr, "\n");
 fflush(stderr);
		TLineBuf_Clr(tpb);
		*tsf = 1;

	    } else if (tpb->lg >= lg) {
		*sh = (TdServHead*)pcs;
		tpb->lg -= lg;
// fprintf(stderr, "I: GetSyncPipeServHead lg=%d m=%d\n", lg, m);
		if (tpb->lg > 0) {
		    tpb->pc_rdidx = &pcs[lg];
		} else {
		    tpb->lg = 0;
		    tpb->pc_rdidx = NULL;
		}
		return True;
	    }
	}
	return False;
} 
