/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include "net_io.h"
#include <unistd.h>
#include <sys/socket.h>
#include <sys/un.h>

int make_named_socket(char *filename) {
  int lg, sock;
  struct sockaddr_un name;
  char *pc;

  // Remove the filename first, it's ok if the call fails
	unlink (filename);
	sock = 0;
  // Create the socket.
	sock = socket(PF_LOCAL, SOCK_DGRAM, 0);
	if (sock < 0) {
//	    error_msg("socket %s (%s)", filename, SysError_pc());
	    appError(EMSG_ERR1 | EMSG_SYS, "%s(%d): socket %s", FL, filename);
	    return 0;
	} 
  // Bind a name to the socket.
	name.sun_family = AF_LOCAL;
	pc = name.sun_path;
	lg = ppcmove(&pc, filename) + sizeof(name.sun_family) + 1;
	if (bind (sock, &name, lg) < 0) {
//	    error_msg("bind %s (%s)", filename, SysError_pc());
	    appError(EMSG_ERR1 | EMSG_SYS, "%s(%d): bind %s", FL, filename);
	    return 0;
	} 
	return sock;
} 
