/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include "tdirlist.h"

#include "tmime_pv.h"

static bool Chk_Pattern(char *patt, const char *fn) {
  int lg;
  char *pce;
  char buf[64];

	if (!fn || !patt) return False;
	pce = patt;
	while (*pce) {
	    if (*pce == ';') {
		lg = pce-patt;
		if (lg > 0) {
		    if (lg > 63) lg = 63;
		    pcnmove(buf, patt, lg);
		    if (str_match(buf, fn, FU_CASE_ASCII)) return True;
		}
		patt = pce+1;
	    }
	    pce++;
	}
	lg = pce-patt;
	if (lg > 0) {
	    if (lg > 63) lg = 63;
	    pcnmove(buf, patt, lg);
	    if (str_match(buf, fn, FU_CASE_ASCII)) return True;
	}
	return False;
}

char *TMime_stat_get_mimetype(TMime *self, Tstat64 *st, const char *fn) {
  char *res = NULL;
  TMime_private *pv;
  TMimeObj *mo, **ppmo;
  TMimeDat_type *mdt;

	if (st) res = stat_get_bi_mimetype(st);
	if (res) return res;

	if (!st) return NULL;
	if (!fn) fn = Get_ExFileDat_pc(st, exfdt_FileName);
	if (!fn || !self) return NULL;

	pv = self->private;
	ppmo = pv->mos;
	while (*ppmo) {
	    mo = *ppmo;
	    while (mo) {
		mdt = mo->mdt;
		while (mdt) {
		    if (Chk_Pattern(mdt->pattern, fn)) {
			return pcdup(mdt->mimetype);
		    }
		    mdt = mdt->next;
		}
		mo = mo->next;
	    }
	    ppmo++;
	}
	return NULL;
}

char *stat_get_mimetype(Tstat64 *st, const char *fn) {
	return TMime_stat_get_mimetype(app_mime, st, fn);
}
