/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include "tdirlist.h"

#include "tmime_pv.h"

void TMime_stat_set_mime_id(TMime *self, Tstat64 *st, const char *fn) {
  TMime_private *pv = self->private;
  char *mimetype, *pc, *pcd;
  const char *icon;
  TMimeDat md;
  char buf[256];

	if (!self) return;
	st->mime_id = NULL;
	if (st->FileType == stft_desktop) return;
	mimetype = stat_get_mimetype(st, fn);
	if (!mimetype) return;
// printf("%s(%d): %s %s\n", FL, fn, mimetype);
	icon = NULL;
	if (pv->overwrite_ini && (pclen(mimetype) < 252)) {

	    icon = TpcIni_RD(pv->overwrite_ini, "icon", mimetype);
	    if (!icon) {
		pc = mimetype;
		pcd = buf;
		while (*pc && (*pc != '/')) {*pcd = *pc; pcd++; pc++;}
		ppcmove(&pcd, "/all");
		*pcd = 0;
		icon = TpcIni_RD_pc(pv->overwrite_ini, "icon", buf, NULL);
	    }

// printf("%s(%d): %d %s -> %s -> %s\n", FL, st->FileType, fn, mimetype, icon);
	    if (!pccasecmpASCII(icon, "USE_APP_ICON")) {
		if (mimetype2app_getdat(mimetype, &md)) {
		    st->mime_id = md.id;
		}
	    } else if (!pccasecmpASCII(icon, "USE_SYS_ICON")) {
		st->mime_id = NULL;
		goto end;
//	    } else if (pccasecmpASCII(icon, "USE_MIME_ICON")) {
	    }
	}


	if (!st->mime_id && mimetype2lnk_getdat(mimetype, &md)) {
	    st->mime_id = md.id;
	}
end:
	xfree(mimetype);
}
