/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "tdirlist.h"

#include "tmime_pv.h"

TPic *TMime_stat_mime_getpic16(TMime *self, Tstat64 *st) {
  TMimeDat_x *md;
// printf("%s(%d): mime_getpic16 0x%x\n", FL, (int)st->mime_id);
	if (!self || !st->mime_id) return NULL;
	md = TMime_get_md(self, st->mime_id);
// printf("%s(%d): mime_getpic16 0x%x 0x%x\n", FL, (int)st->mime_id, (int)md->pic16);
	if (!md || (md->stat & ME_Pic16_NoFound)) return NULL;
// printf("%s(%d): mime_getpic16 0x%x 0x%x\n", FL, (int)st->mime_id, (int)md->pic16);
// printf("%s(%d): mime_getpic16 %s 0x%x 0x%x\n", FL, md->icon, (int)st->mime_id, (int)md->pic16);

	if (!md->pic16) {
	    md->pic16 = GetDeskIcon(ddkt_Mime, 16, md->icon, 0, NULL);
	    if (!md->pic16) md->stat |= ME_Pic16_NoFound;
	}
	return md->pic16;
}


TPic *TMime_stat_mime_getpic32(TMime *self, Tstat64 *st) {
  TMimeDat_x *md;
	if (!self || !st->mime_id) return NULL;
	md = TMime_get_md(self, st->mime_id);
	if (!md || (md->stat & ME_Pic32_NoFound)) return NULL;

	if (!md->pic32) {
	    md->pic32 = GetDeskIcon(ddkt_Mime, 32, md->icon, 0, NULL);
	    if (!md->pic32) md->stat |= ME_Pic32_NoFound;
	}
	return md->pic32;
}
