/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

#ifdef _OS_WIN32
TMountPoint *TMountPoint_Get(const char *path) {
	return NULL;
}
#else /* _OS_WIN32 */
#include <mntent.h>

TMountPoint *TMountPoint_Get(const char *path) {
  int lg, llg;
  char *ap, *pc;
  FILE *f;
  struct mntent *me;
  TMountPoint *result;
  TPathInfo pathi;

	if (path && *path) {
	    if (!get_PathInfo(path, &pathi)) return NULL;
	    if (!(pathi.fu & pathi_rel) &&
		!(pathi.fu & pathi_Local)) return NULL;
	    path = pathi.path_anf;
	}

	llg = 0;
	result = NULL;
	ap = path_absolut(path);
// printf("%s(%d): %s\n", FL, ap);
	f = setmntent("/proc/mounts", "r");
	if (f) {
loop:
	    me = getmntent(f);
	    if (me) {
		if (!pccmp(me->mnt_fsname, "rootfs")) {
// printf("%s(%d): %s %s %s %s\n", FL, me->mnt_fsname, me->mnt_dir, me->mnt_type, me->mnt_opts);
		    lg = pclen(me->mnt_dir);
		    if ((lg > llg) && pcncmp(ap, me->mnt_dir, lg) && 
			((lg == 1) || !ap[lg] || (ap[lg] == '/')))
		    {
			llg = lg;
			xfree(result);
			result = xmalloc(sizeof(TMountPoint) + 4 +
					lg +
					pclen(me->mnt_fsname) + 
					pclen(me->mnt_type) +
					pclen(me->mnt_opts));
			pc = result->data;
			result->fsname = pc;
			ppcmove(&pc, me->mnt_fsname); pc++;
			result->dir = pc;
			ppcmove(&pc, me->mnt_dir); pc++;
			result->type = pc;
			ppcmove(&pc, me->mnt_type); pc++;
			result->opts = pc;
			pcmove(pc, me->mnt_opts);
		    }
		}
		goto loop;
	    }
	    endmntent(f);
	}
	xfree(ap);
	return result;
}
#endif /* _OS_WIN32 */
