/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <errno.h>

void net_err_app_4(TNetErrRet *ErrRet, const char *fn, const char *bef, int err_level) {
  int i;
  const char *tmp = NULL;
  const char *ppbuf[3];
  char *pc;
  char buf[20];

	if (ErrRet) {
	    if (ErrRet->sys_errno) {
		errno = ErrRet->sys_errno;
		err_level |= EMSG_SYS;
	    } else if (ErrRet->err) {
		tmp = ErrRet->err;
	    } else if (ErrRet->const_err) {
		tmp = ErrRet->const_err;
	    }
	    if (ErrRet->fn) fn = ErrRet->fn;
	    if (ErrRet->bef) bef = ErrRet->bef;
	}

	i = 0;
	pc = buf;
	if (bef) {ppbuf[i] = bef; ppcmove(&pc, " %s");     i++;}
	if (fn)  {ppbuf[i] = fn;  ppcmove(&pc, " \"%s\""); i++;}
	if (tmp) {ppbuf[i] = tmp; ppcmove(&pc, " %s");     i++;}

	if (i == 1) {
	    appError(err_level, buf, ppbuf[0]);
	} else if (i == 2) {
	    appError(err_level, buf, ppbuf[0], ppbuf[1]);
	} else if (i == 3) {
	    appError(err_level, buf, ppbuf[0], ppbuf[1], ppbuf[2]);
	}
}

void net_err_app(TNetErrRet *ErrRet, int err_level) {
	net_err_app_4(ErrRet, NULL, NULL, err_level);
}
