/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "net_xxx.h"

bool net_file_new_va_gp(TglobPath *gp, TNetErrRet *ErrRet, const char *msg, ...) {
  va_list args;

	if (net_stream_gp_test(gp)) {
	    FILE *dout = net_stream_open_gp(gp, "w");
	    if (!dout) return False;
	    va_start(args, msg);
	    vfprintf(dout, msg, args);
	    va_end(args);
	    fclose(dout);
	    return True;
	} else if (net_LineBuf_gp_test(gp)) {

	    TLineBuf lb;
	    Fill0(&lb, sizeof(TLineBuf));
	    lb.pc = xmalloc(65000);
	    va_start(args, msg);
	    vsnprintf(lb.pc, 65000, msg, args);
	    va_end(args);
	    lb.lg = pclen(lb.pc);
	    lb.eof = True;
	    TNetLineBuf *nlb = TNetLineBuf_Create(NULL, gp);
	    nlb->lb = &lb;
	    nlb->open(nlb, NetOpenMod_Write);
	    bool res = nlb->wait(nlb);
	    Tfree(nlb);
	    xfree(lb.pc);
	    return res;
	}
	return False;
}

bool net_file_new_va_gp_test(TglobPath *gp) {
	return net_stream_gp_test(gp) || net_LineBuf_gp_test(gp);
}
