/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "net_xxx.h"

static ThNetLineBufLoader **hNetLineBufLd = NULL;

/*_____________________________ misc ____________________________________*/
static void TNetLineBuf_linebuf_sync(TNetLineBuf *self, int Dm) {
	if (self->OnFileMsg) {
	    self->fmsg.art = fmArt_DataIO;
	    self->fmsg.typD = fmTyp_int;
	    self->fmsg.D.m = Dm; //fmFillSendBuf, fmReadRecvBuf
	    self->fmsg.typF = fmTyp_lb;
	    self->fmsg.F.lb = self->lb;
	    TNet_msg((TNet*)self);
	}
}

void TNetLineBuf_sync_wr(TNetLineBuf *self) {
	if (self->pv_flag0 || self->lb->eof || 
	    (self->lb->lg > BUFSIZ)) return;

	TNetLineBuf_linebuf_sync(self, fmFillSendBuf);
	self->pv_flag0 = !self->fmsg.Ok;
}

void TNetLineBuf_sync_rd(TNetLineBuf *self) {
	if (!self->pv_flag0 && (self->lb->lg > RD_BUFSIZE)) {
	    TNetLineBuf_linebuf_sync(self, fmReadRecvBuf);
	    self->pv_flag0 = !self->fmsg.Ok;
	}
	if (self->lb->eof) {
	    self->ende = True;
	    self->ioinfo.stat |= fmIOInfo_EOF;
	}
}

/*_____________________________ Destroy _________________________________*/

/*_____________________________ Create __________________________________*/
TNetLineBuf *TNetLineBuf_Create(void *owner, TglobPath *gp) {
  ThNetLineBufLoader *hLD;
	if (gp_test_local_drive(gp)) {
	    return TNetFileLineBuf_Create(owner, gp);
	} else {
	    hLD = GetNet4_hLD((void*)hNetLineBufLd, gp, 1, hNet_appERR);
	    if (!hLD) return False;
	    return hLD->Create.lb(owner, gp);
	}
}

bool net_LineBuf_gp_test(TglobPath *gp) {
  ThNetStreamLoader *hLD;
	if (!gp_test_local_drive(gp)) {
	    hLD = GetNet4_hLD((void*)hNetLineBufLd, gp, 1, 0);
	    if (!hLD) return False;
	}
	return True;
}

void ThNetLineBufLoader_Reg(int n, ...) {
  va_list args;
	va_start(args, n);
	pp_void_va_add((void*)&hNetLineBufLd, n, args);
	va_end(args);
}
