/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "net_xxx.h"

bool TNet__Destroy(TNet *self) {
	gp_pc_free(&self->gp);
	return False;
}

void *TNet_Create(int TNet_size, int wtyp, TglobPath *gp) {
  TNet *self;
	self = ttc_create(TNet_size, wtyp);
	self->destroy = (TDESTROY)TNet__Destroy;

	self->fmsg.wtyp = wtyp;
	self->fmsg.obj = self;
	if (gp) {
	    gp_dup_gpdata(&self->gp, gp);
	    self->fmsg.typR = fmTyp_gp;
	    self->fmsg.R.gp = &self->gp;
	}
	self->ref_us = GetTime_us64();
	self->next_us = 0;
	self->next_us_add = 40000;
	return self;
}

void TNet_Reset(TNet *self) {
	self->ende = False;
	self->error = False;
	self->run = False;
	self->pv_flag0 = False;
	self->next_us = 0;
	self->ioinfo.DataNowSize = 0;
	self->ioinfo.stat = 0;
	self->ref_us = GetTime_us64();
}

void TTC_netError(TTC0 *ttc, TOnFileMsg ev, int ErrType, const char *msg, ...) {
  va_list args;
  TFileMsg fmsg;
  char line[2048];

	file_msg_init(&fmsg, fmArt_AlgErr);
	fmsg.typD = fmTyp_char;
	va_start(args, msg);
	vsnprintf(line, sizeof(line), msg, args);
	va_end(args);
	fmsg.D.s = line;
	file_msg_ev(&fmsg, ttc, ev);
}

/* void TNet_Error(TNet *self, int ErrType, char *msg, ...) {
  va_list args;
  char line[2048];

	self->fmsg.art = fmArt_AlgErr;
	self->fmsg.typD = fmTyp_char;
	va_start(args, msg);
	vsnprintf(line, sizeof(line), msg, args);
	va_end(args);
	self->fmsg.D.s = line;
	TNet_msg(self);
} */

void TNet_msg(TNet *self) {
	self->fmsg.Ok = False;
	self->fmsg.ev_Stop = False;
	self->fmsg.wtyp = self->wtyp;
	self->fmsg.obj = self;
	self->fmsg.sender = self;
	self->fmsg.owner = self->owner;
	if (self->OnFileMsg) self->OnFileMsg(&self->fmsg);
	file_msg(&self->fmsg);
}

void TNet_msg_next(TNet *self, TFileMsg *fmsg) {
  void *owner = fmsg->owner;
	fmsg->owner = self->owner;
	file_msg_ev(fmsg, (TTC0*)self, self->OnFileMsg);
	fmsg->owner = owner;
}


void *GetNet4_hLD(ThNetLoader4 **hLD, TglobPath *gp, int y, int fu) {

	if (hLD) {
	    if (y > 0) {
		while (*hLD && (!(*hLD)->x.ChkType(gp) || 
				!(*hLD)->x.proc[y])) hLD++;
	    } else {
		while (*hLD && !(*hLD)->x.ChkType(gp)) hLD++;
	    }
	    if (*hLD) return *hLD;
	}
	if (fu & hNet_appERR) appError(EMSG_ERR1, "no \"%s\" net_loader found !!!", gp->RootArt);
	return NULL;
}
