/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

typedef struct TNetPasswd {
  struct TNetPasswd *next;
  TglobPath gp;
} TNetPasswd;

static TNetPasswd *NetPasswd;

static TNetPasswd *find_NetPasswd(TglobPath *gp) {
  TNetPasswd *np = NetPasswd;
	while (np && (pccasecmpASCII(np->gp.RootArt, gp->RootArt) ||
		      !pccmp(np->gp.URL, gp->URL) ||
		      !pccmp(np->gp.user, gp->user))) {
	    np = np->next;
	}
	return np;
}


void NetPasswdSave(TglobPath *gp) {
  TNetPasswd *np;

	if (!gp || !gp->URL || !*gp->URL) return;
	np = find_NetPasswd(gp);
	if (np) {
	    ppcchange_cmp(&np->gp.passwd, gp->passwd);
	} else {
	    np = xcalloc(sizeof(TNetPasswd));
	    np->gp.RootArt = pcdup(gp->RootArt);
	    np->gp.URL = pcdup(gp->URL);
	    np->gp.user = pcdup(gp->user);
	    np->gp.passwd = pcdup(gp->passwd);

	    appMutex_lock();
	    np->next = NetPasswd;
	    NetPasswd = np;
	    appMutex_unlock();
	}
}

void NetPasswdSetup_gp(TglobPath *gp) {
  TNetPasswd *np;

	if (!gp || !gp->URL || !*gp->URL) return;
	np = find_NetPasswd(gp);
	if (np) {
	    ppcchange_cmp(&gp->passwd, np->gp.passwd);
	} else if (gp->passwd) {
	    NetPasswdSave(gp);
	}
}

