/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

char *path_abs2rel(const char *path, const char *basepath) {
  char *cwd = NULL;
  const char *ss, *ds, *pp;
  TPathInfo pathi;
  TPathInfo basei;
  char *pc, *cwd_path, *cwd_base;
  char ts[800];

	cwd_path = cwd_base = NULL;
	if (!get_PathInfo(path, &pathi)) return NULL;

	if (pathi.fu & pathi_rel) goto end_dup_path;

	if (!get_PathInfo(basepath, &basei)) {
	    cwd_base = xgetcwd(False);
	    get_PathInfo(cwd_base, &basei);
	}

	if (basei.fu & pathi_rel) goto end_dup_path;
	if ((pathi.fu & pathi_Local) != (pathi.fu & pathi_Local)) goto end_dup_path;

#ifdef _OS_WIN32
	if ((pathi.RA_lg == 2) && (basei.RA_lg == 2)) {
	    if (pcncasecmpASCII(pathi.path, basei.path, 2)) goto end_dup_path;
	}
#endif

	if (!(pathi.fu & pathi_Local)) {
	    if ((pathi.RA_lg != basei.RA_lg) || 
		pcncasecmpASCII(pathi.path, basei.path, pathi.RA_lg)) goto end_dup_path;

	    if ((pathi.URL_lg != basei.URL_lg) || 
		!pcncmp(pathi.url_anf, basei.url_anf, pathi.URL_lg)) {

end_dup_path:
	        cwd = pcdup(path);
		goto ende;
	    }
	}

	ss = pathi.path_anf;
	ds = basei.path_anf;
	if (!*ss) {
	    while (TestSlash(*ds)) ds++;
	}

	pp = NULL;
	while (*ss && (*ss == *ds)) {
	    if (TestSlash(*ss)) pp = ss;
	    ss++; ds++;
	}

	if (!*ds && (TestSlash(*ss) || (pp+1 == ss))) {
	    if (TestSlash(*ss)) ss++;
	    cwd = pcdup(ss);

	} else {
	    if (pp) ss = pp;
	    while (TestSlash(*ss)) ss++;
	    pc = ts;
	    *pc++ = '.'; *pc++ = '.'; *pc++ = '/';
	    while (*ds) {
		if (TestSlash(*ds) && ds[1]) {
		    *pc++ = '.'; *pc++ = '.'; *pc++ = '/';
		}
		ds++;
	    }
	    *pc = 0;
	    cwd = pcadd(ts, ss);
	}
ende:
	xfree(cwd_path);
	xfree(cwd_base);
	return cwd;
}
