/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

#ifndef _OS_WIN32
static bool chklink(char **ppc) {
  Tstat64 *st;
  const char *cpc;
  bool result;

	st = file_stat_fn(*ppc, 0);
	if (!st) return false;

	result = (st->st & st_Link) != 0;
	if (result) {
	    cpc = Get_ExFileDat_pc(st, exfdt_LinkName);
	    if (TestSlash(*cpc)) {
		ppcchange(ppc, cpc);
	    } else {
		ChangeFileName_ppc(ppc, cpc);
	    }
	    ppc_dotdot_korr(ppc);
	}
	xfree(st);
	return result;
}
#endif /* ! _OS_WIN32 */

char *path_absolut(const char *path) {
  char *xpath;
#ifndef _OS_WIN32
  char *pc, *pcx;
  int anf, lg, i;
  TPathInfo pathi;
#endif /* _OS_WIN32 */

	xpath = path_rel2abs(path, NULL);
	path_add_ppc(&xpath, NULL);

#ifndef _OS_WIN32
	anf = 0;
	if (get_PathInfo(xpath, &pathi)) {
	    anf = pathi.path_anf - pathi.path;
	}

//	if (chklink(&xpath)) chklink(&xpath);
	i = 8;
	while (i && chklink(&xpath)) i--;

	pcx = NULL;
loop:
	lg = pclen(xpath + anf) - 1;
	if (lg > 0) {
	     pc = xpath + anf + lg;
	     while (lg && TestNoSlash(*pc)) {pc--; lg--;}
	     if (lg > 1) {
		ppcchange_add_n(&pcx, 2, pc, pcx);
		*pc = 0;
		i = 8;
		while (i && chklink(&xpath)) i--;
		goto loop;
	     }
	}
	ppcadd(&xpath, pcx);
	xfree(pcx);

#endif /* ! _OS_WIN32 */
	return xpath;
}
