/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

bool get_PathInfo(const char *fn, TPathInfo *pathi) {
  const char *pc;
  int RAlg;

	if (pathi) {
	    Fill0(pathi, sizeof(TPathInfo));
	    pathi->path = pathi->path_anf = fn;
	}
	if (!fn || !*fn) return False;
	if (!pathi) return True;

#ifdef _OS_WIN32
	if (TestSlash(*fn) && TestSlash(fn[1])) {
	    pathi->fu = pathi_SMB;
	    pc = fn;
	    goto smb_url;
	}
#endif

	if (TestSlash(*fn)) {
	    pathi->fu = pathi_Local;
	    return True;
	}

	pc = fn;
	while (*pc) {
	    if (TestSlash(*pc)) goto path_rel_ret;
	    if ((*pc == ':') && (!pc[1] || TestSlash(pc[1]))) {
	        pc++;
		goto path_url;
	    }
	    pc++;
	}

path_rel_ret:
	pathi->fu = pathi_rel;
	pathi->path_anf = fn;
	return True;

path_url:
	RAlg = (pc - fn);
	pathi->RA_lg = RAlg;
#ifdef _OS_WIN32
	if ((RAlg == 2) && (((*fn >= 'a') && (*fn <= 'z')) ||
	                    ((*fn >= 'A') && (*fn <= 'Z'))))
	    goto path_url_local;

	if ((RAlg == 4) && !pcncasecmpASCII(fn, "smb:", 4)) {
	    pathi->fu |= pathi_RA_SMB;
	    goto smb_url;
	}
#endif

	if ((RAlg == 5) && !pcncasecmpASCII(fn, "file:", 5)) {
	    pathi->fu = pathi_RA_file;
#ifdef _OS_WIN32
path_url_local:
#endif
	    while (TestSlash(pc[1])) pc++;
	    pathi->fu |= pathi_Local;
	    pathi->path_anf = pc;
	    return True;
	}

#ifdef _OS_WIN32
smb_url:
#endif
	while (TestSlash(*pc)) pc++;
	pathi->url_anf = pc;
	while (*pc && TestNoSlash(*pc)) pc++;
	pathi->URL_lg = pc - pathi->url_anf;
	while (TestSlash(pc[1])) pc++;
	pathi->path_anf = pc;

	return True;
}
