/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

bool path_sub(const char *path, char **ret) {
  char *retpc, *pc, *pcp;
  TPathInfo pathi;
  bool result;

	if (!path) return False;
	retpc = pcdup(path);
	result = get_PathInfo(retpc, &pathi);
	if (result) {
	    pcp = NULL;
	    pc = pathi.path_anf_s;
	    while (*pc) {
		if (TestSlash(*pc) && pc[1]) pcp = pc;
		pc++;
	    }
	    result = (pcp != NULL);
	    if (result) {
		if (pcp[1]) {
		    pcp[1] = 0;
		} else *pcp = 0;
	    }
	}

	if (!result || !ret) ppcfree(&retpc);
	if (ret) *ret = retpc;
	return result;
}

bool path_sub_ppc(char **path) {
  char *tmp;
	if (!path || !path_sub(*path, &tmp)) return False;
	xfree(*path);
	*path = tmp;
	return True;
}
