/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

char *path_to_local(const char *path) {
  TPathInfo pathi;
  char *tmp, *pc;

	pc = NULL;
	tmp = path_rel2abs(path, NULL);

	if (get_PathInfo(tmp, &pathi)) {
#ifdef _OS_WIN32
	    if ((pathi.fu & pathi_RA_file) || 
		(pathi.fu & pathi_RA_SMB)) {
		pc = tmp + pathi.RA_lg;
	    } else if ((pathi.fu & pathi_SMB) || (pathi.fu & pathi_Local)) {
		pc = tmp;
	    }
#else
	    if (pathi.fu & pathi_Local) pc = pathi.path_anf_s;
#endif
	    if (pc) {
		int lg = pclen(pathi.path_anf);
		if ((lg > 1) && TestSlash(pathi.path_anf[lg-1])) 
			    pathi.path_anf_s[lg-1] = 0;
		if (pc > tmp) pcmove(tmp, pc);
		return tmp;
	    }
	}
	xfree(tmp);
	return NULL;
}

#ifdef _OS_WIN32
charOS *path_to_local_OS(const char *path) {
  charOS *result;
  char *fn = path_to_local(path);
	result = UTF8topwc(fn);
	xfree(fn);
	return result;
}
#endif

charOS *path_to_local_OS_err(const char *path, TNetErrRet *ErrRet) {
  charOS *result = path_to_local_OS(path);
	if (!result && ErrRet) ErrRet->err = pcdup("not a local filename");
	return result;
}
