/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include "tdirlist.h"
#include "tdirlist_pv.h"

//#define APP_SYNC_TIME 20000

typedef struct TDirList_private {
  Alg_dirlist_nypv
  TEv_Array *appEv;
} TDirList_private;


/*_____________________________ appEv ___________________________________*/
static void TDirList_ny_On_appEv(TEv_Array *appEv) {
  TDirListNotify *self = appEv->obj;
  TDirList_private *pv = self->private;

#ifdef TEST_NOTIFY_TIME
  dword t = GetTime_us();
#endif

	if (!pv->schr) {
	    if (cpTime(pv->open_us, appDat.app_us)) {
		if (!nypv_OpenDir(self)) return;
// printf("%s(%d): \n", FL);
	    }
	} else {
	    if (!nypv_ScanDir(self)) return;
	    TDirListNotify_ScanEnd(self);
	    pv->schr = 0;
	    pv->open_us = GetTime_us() + 500000;
	    if (!pv->change_akt) pv->open_us += 2000000;
	}
#ifdef TEST_NOTIFY_TIME
//  if (self->en_test_notify_us) 
	test_notify_us += GetCurTimeDiv_us(t);
#endif
}

/*_____________________________ ReScan __________________________________*/
static void TDirListNotify_File_ReScan(TDirListNotify *self) {
  TDirList_private *pv = self->private;
	if (!pv->schr) pv->open_us = GetTime_us();
}

/*_____________________________ Start ___________________________________*/
static void TDirListNotify_File_Start(TDirListNotify *self) {
  TDirList_private *pv = self->private;

	if (pv->appEv) return;
	pv->open_us = GetTime_us() + 3000000;
	pv->appEv = Add_appEv(TDirList_ny_On_appEv);
	pv->appEv->obj = self;
}

/*_____________________________ Destroy _________________________________*/
static bool TDirListNotify_File__Destroy(TDirListNotify *self) {
  TDirList_private *pv = self->private;

	if (pv->appEv) Free_appEv(pv->appEv);
	gp_pc_free(&pv->gp);
	xfree(self->private);
	return False;
}

/*_____________________________ Create __________________________________*/
static TDirListNotify *TDirListNotify_File_Create(TDirList *dl, TOnFileMsg OnFileMsg) {
  TDirListNotify *self;
  TDirList_private *pv;

	if (!gp_test_local_drive(&dl->gp)) return NULL;

	self = ttc_create(sizeof(TDirListNotify), wtyp_TDirListNotify);
	self->destroy = (TDESTROY)TDirListNotify_File__Destroy;
	self->OnFileMsg = OnFileMsg;
	self->dl = dl;
	pv = xcalloc(sizeof(TDirList_private));
	self->private = pv;
	gp_dup_gpdata_path(&pv->gp, &dl->gp);

	self->start = TDirListNotify_File_Start;
	self->ReScan = TDirListNotify_File_ReScan;
	self->UseRescan = True;
	return self;
}

const ThDirListNotify hdirlist_ny_File = {
  gp_test_local_drive,
  TDirListNotify_File_Create,
  0
};
