/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

static void TPattern_clr_pattern(TPattern *self) {
  char **ppc = self->ppa;
	if (ppc) {
	    while (*ppc) {
		xfree(*ppc);
		ppc++;
	    }
	    ppfree(&self->ppa);
	}
}

static void TPattern_clr_FileType(TPattern *self) {
	if (self->ft_arr != self->ft_buf) xfree(self->ft_arr);
	self->ft_arr = NULL;
}


static void TPattern_set_pattern(TPattern *self, const char *pattern) {
  int z;
  char **ppc, *pc, *pa;
  const char *indata;

	TPattern_clr_pattern(self);

	if (!pattern || !*pattern) return;
	pa = pcdup(pattern);
	pc = pa;
	while (*pc) {
	    if (*pc == ',') *pc = 0x20;
	    pc++;
	}
	z = 0;
	indata = pa;
	while (indata) {
	    z++;
	    indata = GetToken(indata, NULL);
	}
// printf("%s(%d): %d\n", FL, z);
	if (z) {
	    ppc = xmalloc(sizeof(char*) * (z+1));
	    self->ppa = ppc;
	    indata = pa;
	    while (indata) {
		indata = GetToken(indata, ppc);
		ppc++;
	    }
	    *ppc = NULL;
	}
	xfree(pa);
}

static void TPattern_set_FileType(TPattern *self, word *FileType_arr) {
  int z;
  word *pw;

	TPattern_clr_FileType(self);

	if (!FileType_arr) return;

	pw = FileType_arr;
	z = 0;
	while (*pw) {z++; pw++;}
	if (z) {
	    if (z > 7) {
		pw = xmalloc(sizeof(word) * (z+1));
	    } else {
		pw = self->ft_buf;
	    }
	    self->ft_arr = pw;
	    while (*FileType_arr) {*pw = *FileType_arr; pw++; FileType_arr++;}
	    *pw = 0;
	}
}

void TPattern_set(TPattern **ppatt, const char *pattern, word *FileType_arr) {
 
	if (!ppatt) return;
	if (!*ppatt) {
	    *ppatt = TPattern_Create(0, pattern, FileType_arr);
	    return;
	}

	TPattern_set_pattern(*ppatt, pattern);
	TPattern_set_FileType(*ppatt, FileType_arr);
}

static bool TPattern__Destroy(TPattern *self) {
	TPattern_clr_pattern(self);
	TPattern_clr_FileType(self);
	return False;
}

TPattern *TPattern_Create(int findAtr, const char *pattern, word *FileType_arr) {
  TPattern *self = ttc_create(sizeof(TPattern), wtyp_TPattern);

	self->findAtr = findAtr;
	self->fu_case = FU_CASE_8859_1;
	self->destroy = (TDESTROY)TPattern__Destroy;
	self->match_pattern = TPattern_Match;
	TPattern_set_pattern(self, pattern);
	TPattern_set_FileType(self, FileType_arr);
	return self;
}
