/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include "xtty.h"
#include <unistd.h>

static const char ColC_Arr[10] = {'0','1','2','3','4','5','6','7',0,'9'};

static char TTermStr_ColC(byte c) {
	if (c < 10) return ColC_Arr[c];
	return 0;
}

void TTermStr_ColOut(TTermStr *termstr, const char *str, int fcol, int bcol) {
  char *wrs = NULL;
  char tmpCol[8] = {0x1b,'[',0,0,'m',0,0,0};

	if ((fcol != mCOLOR_NONE) && (fcol != termstr->forecolor)) {
	    if (fcol == mCOLOR_REFRESH) fcol = termstr->forecolor;
	    termstr->forecolor = fcol;
	    tmpCol[3] = TTermStr_ColC(fcol);
	    if (tmpCol[3]) {
		tmpCol[2] = '3';
		ppcadd(&wrs, tmpCol);
	    }
	}
	if ((bcol != mCOLOR_NONE) && (bcol != termstr->backcolor)) {
	    if (bcol == mCOLOR_REFRESH) bcol = termstr->backcolor;
	    termstr->backcolor = bcol;
	    tmpCol[3] = TTermStr_ColC(bcol);
	    if (tmpCol[3]) {
		tmpCol[2] = '4';
		ppcadd(&wrs, tmpCol);
	    }
	}

	ppcadd(&wrs, str);
	if (wrs) {
	    write(termstr->fdout, wrs, pclen(wrs));
	    xfree(wrs);
	}
}

void TTermStr_lf(TTermStr *termstr) {
  char c_lf[2] = {0x0a,0};
	write(termstr->fdout, c_lf, 1);
}

void TTermStr_DelChars(TTermStr *termstr, int z) {
  char Sendbuf[32];
  char *pc = Sendbuf;

	*pc = 0x1B; pc++;
	*pc = '['; pc++;
	inttoppc(&pc, z);
	*pc = 'P'; pc++;
	write(termstr->fdout, Sendbuf, pc - Sendbuf);
}

/* void TTermStr_EraseLine(TTermStr *termstr) {
	write(termstr->fdout, "\x1b""[2K\0", 4);
} */

void TTermStr_Destroy(TTermStr *termstr) {
	if (!termstr) return;
	xfree(termstr);
}

TTermStr *TTermStr_Create(int fdout, int termart) {
  TTermStr *termstr;
	termstr = xcalloc(sizeof(TTermStr));
	termstr->fdout = fdout;
	termstr->termart = termart;
	termstr->forecolor = mCOLOR_DEFAULT;
	termstr->backcolor = mCOLOR_DEFAULT;

	return termstr;
}
