/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#define USE_THD 1

#include "xcopy.h"
#include "tthread.h"
#include <sys/stat.h>
#include <unistd.h>

#define USE_MMAP 0

#define ldart_file	1
#define ldart_ftp	2


#define xcywdstat_rd_run	1
#define xcywdstat_wr_run	(1<<1)
#define xcywdstat_run		(xcywdstat_rd_run|xcywdstat_wr_run)

#define xcywdstat_rd_err	(1<<4)
#define xcywdstat_wr_err	(1<<5)

#define xcywdstat_SameFileMk	(1<<16)

//#define xcywdstat_bit		(1<<30)
//#define xcywdstat_not		(1<<31)


#define mk_buf_mmap	1

#define srt_0		0
#define srt_init	1
#define srt_ChkStart	2
#define srt_Start	3
#define srt_open	4
#define srt_move	5
#define srt_preserv	6
#define srt_del_wait	7
#define srt_del		8
#define srt_ok		9
#define srt_skip	10

#define srt_Wait	31

#define srt_msg_wait	(1<<5)
#define srt_bef_mask	0xff


#define MsgSt_init		1
#define MsgSt_FileStatGet	2
#define MsgSt_FileStatRet	3
//#define MsgSt_open		4
#define MsgSt_close		5
#define MsgSt_skip		6
#define MsgSt_err		7

#define MsgSt_Preserv		8
#define MsgSt_Del		9

//#define MsgSt_Mask		xcySFU_befmask
#define ChkDat_DataOk	0x01
#define ChkDat_EOF	0x02
#define ChkDat_WAIT	0x04

typedef struct TXCopy_ld {
  AlgTTC;
  struct TXCopy_wd *wd;
  bool (*connect)(struct TXCopy_wd *wd);
  bool (*init)(struct TXCopy_wd *wd, int funkt);
//  bool (*open)(struct TXCopy_wd *wd);
  bool (*close)(struct TXCopy_wd *wd, int funkt);
  void (*clear)(struct TXCopy_wd *wd);
  bool (*get_dat)(struct TXCopy_wd *wd, int *lg, int *fuEOL, struct TXCopy_ld *dest);
  int  (*chk_dat)(struct TXCopy_wd *wd);
  bool (*set_gp)(struct TXCopy_ld *xcy, TglobPath *gp);
  int  (*send_Mt)(void *obj, int RunStat, int MsgSt);
  bool (*dev_open)(struct TXCopy_wd *wd);
  bool (*dev_close)(struct TXCopy_wd *wd, struct TXCopy_ld *ld);
  bool (*dev_wr)(struct TXCopy_wd *wd, byte *data, int lg, int fuEOL);
  Tstat64 *(*stat_gp)(TglobPath *gp, TNetErrRet *ErrRet, int fu);
  bool (*chmod_gp)(TglobPath *gp, TNetErrRet *ErrRet, int mode);
  bool (*utime_gp)(TglobPath *gp, TNetErrRet *ErrRet, time_t mtime);
  bool (*rmdir_gp)(TglobPath *gp, TNetErrRet *ErrRet);
  bool (*unlink_gp)(TglobPath *gp, TNetErrRet *ErrRet);

  TThread *thd;
  TglobPath gp;
  Tstat64 *st;
  bool init_send;
  bool _bnc1, _bnc2, bnc3;
  dword skip;
  int msgOk_skip;
  char *fname;
  charOS *fnameOS;
  char *msg_s;
  int srt;
  int msg_nr;
  FileHandle fd;
  int uid, gid;
  time_t atime, mtime;
  int stmode;
  int buf_size;
  char *buf;
  TLineBuf *lb;
  uint64_t open_data_us;
  uint64_t ToDevDataSize;
} TXCopy_ld;

cHIDDEN void xcyld_FreeFileName(TXCopy_ld *ld);
cHIDDEN void xcyld_SetFileName(TXCopy_ld *ld);

// ----------------------------------------------------------------
typedef struct TXCopy_wd {
  AlgTTC0;
  void *owner;
  TXCopy_ld *xcy_src, *xcy_dest;
  int stat;
  int xcyChk;
  dword skip;
  dword mode;		//cpwdMode_cut
  int uid, gid;
  int mode_dir, mode_file, mode_blk;
  ThCopyEv hcyEv;
  dword us;
  int MaxBufSize;
  struct TXCopy_dirlist *xcydl;
  uint64_t ges_us;

  TXCopyStats xcs;
} TXCopy_wd;

#ifdef _OS_WIN32
#define Mode07777 (S_IRWXU)
#else
#define Mode07777 (S_ISUID|S_ISGID|S_ISVTX|S_IRWXU|S_IRWXG|S_IRWXO)
#endif
/* ------ xcy_dir.c ------ */
cHIDDEN void clr_dest_dir(TXCopy_wd *wd);
cHIDDEN bool add_dest_dir(TXCopy_wd *wd, char *dir);
cHIDDEN bool chk_dest_ok(TXCopy_wd *wd, char *dir);

/* ------ xcy_chk_dest.c ------ */
#define xcyChkDest_DelDest	1
#define xcyChkDest_MsgSkip	2
#define xcyChkDest_Skip		3
#define xcyChkDest_Preserv	4
#define xcyChkDest_BefMask	0xff

#define xcyChkDest_bSkipDir	(1<<8)
#define xcyChkDest_NoDirCreate	(1<<9)

cHIDDEN int xcyChkDest(TXCopy_ld *src, TXCopy_ld *dest, int skip, 
		int *msgOk_skip, int *msg_nr);

cHIDDEN bool MSG_Init_RD(TXCopy_wd *wd, int MsgSt, bool isOpen);
//extern bool MSG_Close_RD(TXCopy_wd *wd, TXCopy_ld *src);
cHIDDEN bool chk_stat_Ok_RD(TXCopy_ld *ld, int fsfu);
cHIDDEN void step_Init_RD(void *obj, TXCopy_wd *wd);
cHIDDEN void step_ChkStart_RD(void *obj, TXCopy_wd *wd);
cHIDDEN void step_Start_RD(void *obj, TXCopy_wd *wd);
cHIDDEN int handle_Mt_RD(TXCopy_wd *wd, int MsgSt);



cHIDDEN bool MSG_Init_WR(void *obj, TXCopy_wd *wd, int MsgSt, bool isOpen);

cHIDDEN bool step_Init_WR(void *obj, TXCopy_wd *wd, int *xcyChk, int *src_ifmt);
cHIDDEN bool step_Open_WR(void *obj, TXCopy_wd *wd);
cHIDDEN bool step_Move_WR(void *obj, TXCopy_wd *wd);
cHIDDEN void step_Preserv_WR(void *obj, TXCopy_wd *wd, dword akt_fkt);
cHIDDEN void step_Del_RD(TXCopy_wd *wd);

cHIDDEN int handle_Mt_WR(TXCopy_wd *wd, int MsgSt);
