/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include "xcopy_pv.h"

typedef struct TXCopy_dirlist {
  struct TXCopy_dirlist *next;
  int lg;
  char d[];
} TXCopy_dirlist;

void clr_dest_dir(TXCopy_wd *wd) {
  TXCopy_dirlist *dl;
	while (wd->xcydl) {
	    dl = wd->xcydl;
	    wd->xcydl = dl->next;
	    xfree(dl);
	}
}

bool add_dest_dir(TXCopy_wd *wd, char *dir) {
  int lg;
  TXCopy_dirlist *dl, **ppdl;

// printf("%s(%d): add %s\n", FL, dir);
	lg = pclen(dir);
	dl = xmalloc(sizeof(TXCopy_dirlist) + lg + 1);
	dl->next = NULL;
	dl->lg = lg;
	pcnmove(dl->d, dir, lg);

	ppdl = &wd->xcydl;
	while (*ppdl) ppdl = &(*ppdl)->next;
	*ppdl = dl;
	return True;
}

bool chk_dest_ok(TXCopy_wd *wd, char *dir) {
  int lg;
  TXCopy_dirlist *dl;

// printf("%s(%d): chk %s\n", FL, dir);
	lg = pclen(dir);
	dl = wd->xcydl;
	while (dl && ((dl->lg != lg) || !pcncmp(dl->d, dir, lg))) dl = dl->next;
	return dl == NULL;
}
