/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

#ifdef _OS_WIN32

#define MAX_WC		256
#define MAX_PC		(MAX_WC * 3)

static word wcerrbuf[MAX_WC];
static char pcerrbuf[MAX_PC];

char *SysError_pc() {
  int l;
	wcerrbuf[0] = 0;
	FormatMessageW(FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, 
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		wcerrbuf, 256, NULL);
	wcerrbuf[MAX_WC-1] = 0;

	pcerrbuf[0] = 0;
	WCharsToUtf8(pcerrbuf, MAX_PC, wcerrbuf, pwclen(wcerrbuf), 0);
	pcerrbuf[MAX_PC-1] = 0;
	l = pclen(pcerrbuf);
	if (l > 2) {
	    l -= 2;
	    if ((pcerrbuf[l] = 0x0d) && (pcerrbuf[l+1] = 0x0a)) pcerrbuf[l] = 0;
	}
	return pcerrbuf;
}

#else /* _OS_WIN32 */

#include <errno.h>

char *SysError_pc() {
	return strerror(errno);
}
#endif /* _OS_WIN32 */
