/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
//Achtung *ret min 16 char's

void doubletoppc(char **ppc, double w, int decipoint) {
  double d10; 
  int lg, m, i;
  int nk, e;
  char *pc;
  bool neg;

	if (!ppc) return;
	pc = *ppc;
	if (!pc) return;

	e = 0;
	nk = decipoint & 0x000f;
	if (nk > 14) nk = 14;
	lg = 0;
	if ((w == 0) || (w == (w/2))) {  //test zero or inf
	    *pc++ = '0'; lg++;
	    if (nk > 0) {
		*pc++ = '.'; lg++;
		while (nk) {*pc++ = '0'; lg++; nk--;}
	    }
	} else {
// TODO use ieee754.h
	    neg = w < 0;
	    if (neg) {*pc = '-'; pc++; lg++; w = -w;}

	    if (decipoint & DECIPOINT_EXP) {
		if (!nk) nk = 14;
		if (w >= 10) {
		    while (w >= 1E+10) {w *= 1E-10; e += 10;}
		    while (w >= 10) {w *= 0.1; e += 1;}
		} else if (w < 1) {
		    while (w < 1E-10) {w *= 1E+10; e -= 10;}
		    while (w < 1) {w *= 10; e -= 1;}
		}
	    }

	    if (decipoint & DECIPOINT_AUTO) {
		nk = 14;    // 53bit -> 0x1fffffffffffff -> 9007199254740991
		if (w > 9007199254740991) {
		    while (w >= 1E+15) {w *= 1E-15; e += 15;}
		    while (w >= 1000) {w *= 0.001; e += 3;}
		}
		if (w > 9.007199254740991) {
		    nk--;
		    if (w > 90.07199254740991) nk--;
		    if (w > 900.7199254740991) nk--;
		    if (w > 9007.199254740991) nk--;
		    if (w > 90071.99254740991) nk--;
		    if (w > 900719.9254740991) nk--;
		    if (w > 9007199.254740991) nk--;
		    if (w > 90071992.54740991) nk--;
		    if (w > 900719925.4740991) nk--;
		    if (w > 9007199254.740991) nk--;
		    if (w > 90071992547.40991) nk--;
		    if (w > 900719925474.0991) nk--;
		    if (w > 9007199254740.991) nk--;
		    if (w > 90071992547409.91) nk = 0;
		} else if (w < 0.000001) {
		    while (w < 0.01) {w *= 1000; e -= 3;}
		} else if (w < 0.9) {
		    nk++;
		}
	    }


	    d10 = 0.5;
	    m = nk;
	    while (m--) d10 /= 10;
	    w += d10;
	    if (w >= 1) {
		while (w > 1E+16) {e++; w /= 10;}
		d10 = 100;
		while (d10 < w) d10 *= 100;
		while ((d10 >= 1) && (d10 > w)) d10 /= 10;
		while (d10 >= 1) {
		    m = w / d10;
		    *pc++ = (m + 0x30); lg++;
		    w = w - (d10 * m);
		    d10 /= 10;
		}
	    } else {
		*pc++ = '0'; lg++;
	    }
	    if (nk > 0) {
		*pc++ = '.'; lg++;
		for (i=nk;i>0;i--) {
		    w *= 10;
		    m = w;
		    *pc++ = (m + 0x30); lg++;
		    w = w - m;
		}
	    }
	    if (nk && (decipoint & (DECIPOINT_AUTO|DECIPOINT_EXP))) {
		while (pc[-1] == '0') pc--;
		while (pc[-1] == '.') pc--;
		*pc = 0;
	    }
	    if (e) {
		*pc++ = 'E'; lg++;
		if (e > 0) *pc++ = '+'; lg++;
		inttoppc(&pc, e);
	    }

	}

	*ppc = pc;
	ppcmove_kchar(ppc, decipoint);
}

int doubletopc(char *pc, double w, int decipoint) {
  char *pcn = pc;
	doubletoppc(&pcn, w, decipoint);
	return pcn-pc;
}
