/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

static void gpFree_pv(TglobPath *gp) {
	xfree(gp->RootArt);
	xfree(gp->URL);
	xfree(gp->path);
	xfree(gp->name);
	xfree(gp->user);
	xfree(gp->passwd);
}

void gp_free(TglobPath *gp) {
	if (!gp) return;
	gpFree_pv(gp);
	xfree(gp);
};

void gp_pc_free(TglobPath *gp) {
	if (!gp) return;
	gpFree_pv(gp);
	Fill0(gp, sizeof(*gp));
}

void gp_NULL(TglobPath *gp) {
	if (gp) Fill0(gp, sizeof(*gp));
}
