/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

char *gptopc(TglobPath *gp, int fu) {
  int lg;
  const char *RootArt, *URL, *path, *name, *user, *passwd;
  char *result, *pc, *tmp_path, *pathanf;

	if (!gp) return NULL;
	name = NULL;
	tmp_path = NULL;
	passwd = NULL;

	RootArt = gp->RootArt;
	if (gp->fu & gpi_Local) {
#ifndef _OS_WIN32
	    if (!(fu & gptfu_noRootArt) && !RootArt) RootArt = "file:";
#else
	} else if (gp->fu & gpi_RA_SMB) {
	    if (fu & gptfu_noRootArt) RootArt = "";
#endif
	} else if (!RootArt) {
	    RootArt = "Unknown:";
	}
	lg = pclen(RootArt);

	user = gp->user;
	lg += pclen(user);

	if (gp->passwd && !(fu & gptfu_noPasswd)) {
	    passwd = "*****";
	    if (fu & gptfu_PasswdTxt) passwd = gp->passwd;
	    lg += pclen(passwd) + 1;
	}

	URL = gp->URL;
	lg += pclen(URL);


	if (fu & gptfu_RootPath) {
	    path = "/";
	} else {
	    if (!(fu & gptfu_noName)) name = gp->name;
	    lg += pclen(name);

	    path = gp->path;
	    if (fu & gptfu_PathBack) {
		name = NULL;
		if (path_sub(path, &tmp_path)) path = tmp_path;
	    }
	}
	lg += pclen(path);
	lg += 6;

	result = xmalloc(lg);
	pc = result;

	if (RootArt) {
	    ppcmove(&pc, RootArt);
#ifdef _OS_WIN32
	    if (!(gp->fu & gpi_Local)) {
		*pc++ = '/'; *pc++ = '/'; *pc = 0;
	    }
#else
	    *pc++ = '/'; *pc++ = '/'; *pc = 0;
#endif
	}

	if (user) {
	    ppcmove(&pc, user);
	    if (passwd) {
		*pc++ = ':';
	    } else if (URL) {
		*pc++ = '@';
	    }
	}
	if (passwd) {
	    ppcmove(&pc, passwd);
	    if (URL) *pc++ = '@';
	}
	if (URL) ppcmove(&pc, URL);

	pathanf = pc;
	ppcmove(&pc, path);
	ppcmove(&pc, name);

	if (fu & gptfu_add_slash) {
	    if (TestNoSlash(pc[-1])) {*pc++ = '/'; *pc = 0;}
	} else if (fu & gptfu_del_slash) {
	    if ((pc > (pathanf + 1)) && (TestSlash(pc[-1]))) pc[-1] = 0;
	}

	xfree(tmp_path);

#ifdef _OS_WIN32
	slash_korr(result, ((gp->fu & gpi_Local) != 0) || (gp->fu & gpi_RA_SMB));
#endif /* ! _OS_WIN32 */

	return result;
}
