/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

bool pccmp(const char *a, const char *b) {
	if (!a && !b) return True;
	if (!a || !b) return False;
	while (1) {
  int c1, c2;
	    c1 = (byte)*a;
	    c2 = (byte)*b;
	    c1 -= c2;
	    if (c1) return False;
	    if (!c2) return True;
	    a++; b++;
	}
}

bool pcncmp(const char *a, const char *b, int n) {
	if ((!a && !b) || (n <= 0)) return True;
	if (!a || !b) return False;
	for (; n; n--) {
	    if (*a != *b) return False;
	    a++; b++;
	}
	return True;
}

int pccmp_i(const char *a, const char *b) {
	if (!a && !b) return 0;
	if (!a) return -1;
	if (!b) return 1;
	while (1) {
  int c1, c2;
	    c1 = (byte)*a;
	    c2 = (byte)*b;
	    c1 -= c2;
	    if (c1 || !c2) return c1;
	    a++; b++;
	}
}

int pcncmp_i(const char *a, const char *b, int n) {
	if ((!a && !b) || (n <= 0)) return 0;
	if (!a) return -1;
	if (!b) return 1;
	for (; n; n--) {
  dword c1, c2;
	    c1 = (byte)*a; c2 = (byte)*b;
	    c1 -= c2;
	    if (c1) return (int)c1;
	    a++; b++;
	}
	return 0;
}
