/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

int pcncasecmp_fi(const char *a, const char *b, int n, int fu) {
	if ((!a && !b) || (n <= 0)) return 0;
	if (!a) return -1;
	if (!b) return 1;
#ifdef USE_CHAR_NOTAB
	for (; n; n--) {
  dword c1, c2;
	    c1 = (const byte)*a; c2 = (const byte)*b;
	    if ((c1 >= 'a') && (c1 <= 'z')) c1 -= 0x20;
	    if ((c2 >= 'a') && (c2 <= 'z')) c2 -= 0x20;
	    c1 -= c2;
	    if (c1) return (int)c1;
	    a++; b++;
	}
	return 0;
#else /* USE_CHAR_NOTAB */
  const byte *ct;

	switch (fu & 0xff) {
#ifdef USE_CHAR_ASCII
	case FU_CASE_ASCII: ct = (const byte*)l_ascii; break;
#endif
#ifdef USE_CHAR_iso8859_1
	case FU_CASE_8859_1: ct = (const byte*)l_iso8859_1; break;
#endif
	default:
	    ct = (const byte*)USE_CHAR_DEFAULT;
	}

	for (; n; n--) {
  dword c1, c2;
	    c1 = ct[(const byte)*a]; c2 = ct[(const byte)*b];
	    c1 -= c2;
	    if (c1) return (int)c1;
	    a++; b++;
	}
	return 0;
#endif /* !USE_CHAR_NOTAB */
}
