/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

char *pctrim(const char *a) {
  const char *b;
	if (!a) return NULL;
	while (*a && ((byte)*a <= 0x20)) a++;
	if (!*a) return NULL;
	b = a;
	while (*b) b++;
	while ((byte)*b <= 0x20) b--;
	return pcndup(a, b - a + 1);
}
void ppctrim(char **ppc) {
  char *pc = pctrim(*ppc);
	xfree(*ppc);
	*ppc = pc;
}
/* void ppcchange_trim(char **ppc, const char *a) {
	xfree(*ppc);
	*ppc = pctrim(a);
} */

char *pctrimleft(const char *a) {
	if (!a) return NULL;
	while (*a && ((byte)*a <= 0x20)) a++;
	return pcdup(a);
}
void ppctrimleft(char **ppc) {
  char *pc = pctrimleft(*ppc);
	xfree(*ppc);
	*ppc = pc;
}
/* void ppcchange_trimleft(char **ppc, const char *a) {
	xfree(*ppc);
	*ppc = pctrimleft(a);
} */

char *pctrimright(const char *a) {
  const char *b;
	if (!a) return NULL;
	b = a;
	while (*b) b++;
	while ((a <= b) && ((byte)*b <= 0x20)) b--;
	return pcndup(a, b - a + 1);
}
void ppctrimright(char **ppc) {
  char *pc = pctrimright(*ppc);
	xfree(*ppc);
	*ppc = pc;
}
/* void ppcchange_trimright(char **ppc, const char *a) {
	xfree(*ppc);
	*ppc = pctrimright(a);
} */
