/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

void pp_void_va_add(void ***ppp, int n, va_list args) {
  int i, m;
#if ! defined(__x86_64__)
  int k;
  va_list org_args = args;
  void **ptn;
#endif
  void *tmp, **pt, **pp;

	pp = *ppp;
	if (n <= 0) {
	    xfree(pp);
	    pp = NULL;
	} else {
	    if (pp) {
#if defined(__x86_64__)
		m = 0;
		pt = pp;
		while (*pt) {pt++; m++;}

		for (i=0;i<n;i++) {
		    tmp = va_arg(args, void*);
		    pt = pp;
		    while (*pt && (*pt != tmp)) pt++;
		    if (!*pt) {
			pp = xrecalloc(pp, sizeof(void*) * (m+2), sizeof(void*) * m);
			pp[m] = tmp;
			m++;
		    }
		}
#else
		k = n;
		for (i=0;i<n;i++) {
		    tmp = va_arg(args, void*);
		    pt = pp;
		    while (*pt && (*pt != tmp)) pt++;
		    if (*pt) k--;
		}
		args = org_args;
		if (k <= 0) return;
		m = 0;
		pt = pp;
		while (*pt) {pt++; m++;}
// printf("%s(%d): n=%d k=%d m=%d\n", FL, n, k, m);
		pp = xrecalloc(pp, sizeof(void*) * (m+k+1), sizeof(void*) * m);
		ptn = &pp[m];
		for (i=0;i<n;i++) {
		    tmp = va_arg(args, void*);
		    pt = pp;
		    while (*pt && (*pt != tmp)) pt++;
		    if (!*pt) {
			*ptn = tmp;
			ptn++;
		    }
		}
#endif
	    } else {

		pp = xcalloc(sizeof(void*) * (n+1));
		for (i=0;i<n;i++) {
		    pp[i] = va_arg(args, void*);
		}
	    }
	}
// printf("%s(%d): 0x%x\n", FL, (int)pp);
	*ppp = pp;
}

void pp_void_add(void ***ppp, int n, ...) {
  va_list args;
	va_start(args, n);
	pp_void_va_add(ppp, n, args);
	va_end(args);
}
