/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

void ppclg_Add2_slg(char **ppc, int *pplg, const char *a, int alg, 
					   const char *b, int blg) {
  char *pc, *spc;
  int lg = 0;
	if (a) lg += alg;
	if (b) lg += blg;
	if (ppc && (lg > 0)) {
	    if (*ppc) {
		lg += *pplg;
		spc = xrealloc(*ppc, lg + 1);
		pc = spc + *pplg;
	    } else {
		spc = xmalloc(lg + 1);
		pc = spc;
	    }
	    *pplg = lg;
	    *ppc = spc;
	    if (a) ppcnmove(&pc, a, alg);
	    if (b) ppcnmove(&pc, b, blg);
	}
}

void ppcadd2(char **ppc, const char *a, const char *b) {
  int slg = pclen(*ppc);
	ppclg_Add2_slg(ppc, &slg, a, pclen(a), b, pclen(b));
}
void ppcadd(char **ppc, const char *a) {
	ppcadd2(ppc, a, NULL);
}
void ppcnadd(char **ppc, const char *s, int lg) {
  int slg = pclen(*ppc);
	ppclg_Add2_slg(ppc, &slg, s, lg, NULL, 0);
}

char *pcadd(const char *a, const char *b) {
  char *res = NULL;
	ppcadd2(&res, a, b);
	return res;
}

char *pcnnadd(const char *a, int la, const char *b, int lb) {
  char *res = NULL;
  int slg;
	ppclg_Add2_slg(&res, &slg, a, la, b, lb);
	return res;
}
