/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

static const dword ktab[11] = {
  0,
  1,
  10,
  100,
  1000,
  10000,
  100000,
  1000000,
  10000000,
  100000000,
  1000000000
};

//Achtung *ret min 16 char's

void ppcmove_v32(char **ppc, dword w, int min_nums) {
  int lg, nk, k, mlg;
  char *pc;
  bool neg = (min_nums & kVALUE_Neg) != 0;

	if ((min_nums & kVALUE_int) && ((int)w < 0)) {neg=True; w = -w;}

	if (!ppc || !*ppc) return;
	pc = *ppc;

	nk = (min_nums >> 8) & 0x000f;
	if (nk) nk++;

	k = 10;
	while (k && (ktab[k] > w)) {
	    if (k <= nk) {
		if (neg) {*pc = '-'; pc++; neg = False;}
		*pc = '0'; pc++;
		if (k == nk) {*pc = '.'; pc++;}
	    }
	    k--;
	}

	if (!nk && !k) {
	    *pc = '0'; pc++;
	} else {
	    if (neg) {*pc = '-'; pc++; neg = False;}
	    while (k > 0) {
		int m32 = w / ktab[k];
		w = w - (m32 * ktab[k]);
		*pc = (m32 + 0x30);
		pc++;
		if (k == nk) {*pc = '.'; pc++;}
		k--;
	    }
	}

	lg = pc - *ppc;
	mlg = (min_nums & 0x001f) - lg;
	if (mlg > 0) {
	    if (min_nums & kLEFT_ALIGN) {
		for (int i=mlg;i;i--) {*pc = ' '; pc++;}

	    } else {
		pcnmove(*ppc+mlg, *ppc, lg);
		FillChar(*ppc, mlg, ' ');
		pc += mlg;
	    }
	}
	*ppc = pc;
	ppcmove_kchar(ppc, min_nums);
}

int pcmove_v32(char *pc, dword w, int min_nums) {
  char *pcn = pc;
	ppcmove_v32(&pcn, w, min_nums);
	return pcn-pc;
}
