/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
//Achtung *ret min 24 char's
static const uint64_t ktab[21] = {
  0,
  1,
  10,
  100,
  1000,
  10000,
  100000,
  1000000,
  10000000,
  100000000,
  1000000000,
  10000000000,
  100000000000,
  1000000000000,
  10000000000000,
  100000000000000,
  1000000000000000,
  10000000000000000,
  100000000000000000,
  1000000000000000000,
#if 0   // warning on gcc  ???
  10000000000000000000
#else
  0x8ac7230489e80000
#endif
};

void ppcmove_v64(char **ppc, uint64_t w, int min_nums) {
  int lg, nk, k, mlg;
  char *pc;
  bool neg = (min_nums & kVALUE_Neg) != 0;

	if ((min_nums & kVALUE_int) && ((int64_t)w < 0)) {neg=True; w = -w;}

	if (!ppc || !*ppc) return;
	pc = *ppc;

	nk = (min_nums >> 8) & 0x000f;
	if (nk) nk++;

	k = 20;
	while (k && (ktab[k] > w)) {
	    if (k <= nk) {
		if (neg) {*pc = '-'; pc++; neg = False;}
		*pc = '0'; pc++;
		if (k == nk) {*pc = '.'; pc++;}
	    }
	    k--;
	}

	if (!nk && !k) {
	    *pc = '0'; pc++;
	} else {
	    if (neg) {*pc = '-'; pc++; neg = False;}
	    while (k > 0) {
		uint64_t d64 = ktab[k];
		uint64_t m64 = w / d64;
		w = w - (m64 * d64);
		*pc = (m64 + 0x30);
		pc++;
		if (k == nk) {*pc = '.'; pc++;}
		k--;
	    }
	}

	lg = pc - *ppc;
	mlg = (min_nums & 0x001f) - lg;
	if (mlg > 0) {
	    if (min_nums & kLEFT_ALIGN) {
		for (int i=mlg;i;i--) {*pc = ' '; pc++;}

	    } else {
		pcnmove(*ppc+mlg, *ppc, lg);
		FillChar(*ppc, mlg, ' ');
		pc += mlg;
	    }
	}

	*ppc = pc;
	ppcmove_kchar(ppc, min_nums);
}

int pcmove_v64(char *pc, uint64_t w, int min_nums) {
  char *pcn = pc;
	ppcmove_v64(&pcn, w, min_nums);
	return pcn-pc;
}
