/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

#define MK_COMMA	0x01
#define MK_NEG		0x02
#define MK_NUM		0x04
#define MK_EXP		0x08
#define MK_EXPPOS	0x10
#define MK_EXPNEG	0x20
#define MK_EXPNUM	0x40
#define MK_EXP_ALL	(MK_EXP|MK_EXPPOS|MK_EXPNEG|MK_EXPNUM)

float ppctofloat_scan(const char **ppc, bool Scan) {
  int Mk, exp;
  const char *pc, *pc_exp;
  float res, dez;

	if (!ppc) return 0;
	pc = *ppc;
	if (!pc) return 0;
	pc_exp = NULL;
	Mk = 0;
	dez = 0.1;
	res = 0;
	exp = 0;
	while (*pc) {
	    if ((*pc >= '0') && (*pc <= '9')) {
		if (Mk & MK_EXP) {
		    if (!(Mk & (MK_EXPPOS|MK_EXPNEG))) break;
		    Mk |= MK_EXPNUM;
		    exp = (exp * 10) + (*pc & 0x0f);

		} else {
		    Mk |= MK_NUM;
		    if (Mk & MK_COMMA) {
			res += (*pc & 0x0f) * dez;
			dez *= 0.1;
		    } else {
			res = (res * 10) + (*pc & 0x0f);
		    }
		}

	    } else if (*pc == '-') {
		if (Mk & MK_EXP) {
		    if ((Mk & MK_EXP_ALL) != MK_EXP) break;
		    Mk |= MK_EXPNEG;
		} else {
		    if ((Mk & (MK_NUM|MK_NEG)) == 0) Mk |= MK_NEG; else break;
		}

	    } else if (*pc == '+') {
		if ((Mk & MK_EXP_ALL) != MK_EXP) break;
		Mk |= MK_EXPPOS;

	    } else if ((*pc == '.') || (*pc == ',')) {
		if (Mk & (MK_COMMA|MK_EXP)) break;
		Mk |= MK_COMMA;

	    } else if (((*pc == 'E')||(*pc == 'e')) && 
			((Mk & (MK_NUM|MK_EXP)) == MK_NUM)) {
		pc_exp = pc;
		Mk |= MK_EXP;

	    } else if ((*pc == ' ') || (*pc == 0x09)) {
		if (Mk) break; //Leerzeichen am Anfang erlaubt

	    } else {
		if (!Scan || Mk) break;
	    }
	    pc++;
	}

	if (Mk & MK_EXP) {
	    if (Mk & MK_EXPNUM) {
		if (Mk & MK_EXPNEG) {
		    if (exp > 38+15) exp = 38+15;
		    while (exp >= 10)  {res *= 1E-10;  exp -= 10;};
		    while (exp >= 1)   {res *= 0.1;    exp -= 1;};
		} else {
		    if (exp > 37+15) exp = 37+15;
		    while (exp >= 10)  {res *= 1E+10;  exp -= 10;};
		    while (exp >= 1)   {res *= 10;     exp -= 1;};
		}
	    } else {
		pc = pc_exp;
	    }
	}
	if (Mk & MK_NEG) res = -res;
	*ppc = pc;
	return res;
}

float ppctofloat(const char **ppc) { return ppctofloat_scan(ppc, False);}

float pctofloat(const char *pc) { 
  const char *ppc = pc;
	return ppctofloat_scan(&ppc, False);
}
