/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

int64_t ppctohex64_scan(const char **ppc, bool Scan) {
  int64_t res;
  bool Mk;
  const byte *pc;

	if (!ppc) return 0;
	pc = (const byte*)*ppc;
	if (!pc) return 0;
	Mk = false;
	res = 0;
	while (*pc) {
	    if ((*pc >= '0') && (*pc <= '9')) {
		Mk = true;
		res = (res << 4) + (*pc & 0x0f);
	    } else if (((*pc >= 'A') && (*pc <= 'F')) || 
		      ((*pc >= 'a') && (*pc <= 'f'))) {
		Mk = true;
		res = (res << 4) + ((*pc - 7) & 0x0f);

	    } else if ((*pc == ' ') || (*pc == 0x09)) {
		if (Mk) break; //Leerzeichen am Anfang erlaubt
	    } else {
		if (!Scan || Mk) break;
	    }
	    pc++;
	}
	*ppc = (const char*)pc;
	return res;
}

int64_t ppctohex64(const char **ppc) { 
	return ppctohex64_scan(ppc, False);
}

int64_t pctohex64(const char *pc) { 
  const char *ppc = pc;
	return ppctohex64_scan(&ppc, False);
}
