/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

int ppctoint_scan(const char **ppc, bool Scan) {
  int res, Mk;
  const char *pc;
	if (!ppc || !*ppc) return 0;
	pc = *ppc;
	Mk = res = 0;

	while (*pc) {
	    if (!Mk && (*pc == '0')) {
		Mk |= 0x0001;   //0x mk
	    } else if ((*pc >= '0') && (*pc <= '9')) {
		Mk |= 0x8000;
		if ((Mk & 0x0002) == 0) {
		    res = (res * 10);
		} else {
		    res = (res << 4);
		}
		res += *pc & 0x0f;

	    } else if ((Mk & 0x0002) && (((*pc >= 'A') && (*pc <= 'F')) || 
					 ((*pc >= 'a') && (*pc <= 'f')))) {
		res = (res << 4) + ((*pc - 7) & 0x0f);

	    } else if (*pc == '-') {
		if ((Mk & 0x8000) == 0) Mk |= 0x8100; else break;
	    } else if ((*pc == ' ') || (*pc == 0x09)) {
		if (Mk) break; //Leerzeichen am Anfang erlaubt
	    } else if (((*pc == 'x') && (Mk == 0x0001)) || (!Mk && (*pc == '$'))) {
		Mk = 0x0002;   //Hex Val
	    } else {
		if (!Scan || Mk) break;
	    }
	    pc++;
	}
	if (Mk & 0x100) res = -res;
	*ppc = pc;
	return res;
}

int ppctoint(const char **ppc) {
	return ppctoint_scan(ppc, False);
}

int pctoint(const char *pc) {
  const char *cpc = pc;
	return ppctoint_scan(&cpc, False);
}

int pctoint_scan(const char *pc) {
  const char *cpc = pc;
	return ppctoint_scan(&cpc, True);
}
