/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

bool pwccmp(const word *a, const word *b) {
	if (!a && !b) return True;
	if (!a || !b) return False;
	while (1) {
  int c1, c2;
	    c1 = *a;
	    c2 = *b;
	    c1 -= c2;
	    if (c1) return False;
	    if (!c2) return True;
	    a++; b++;
	}
}

bool pwcncmp(const word *a, const word *b, int n) {
	if ((!a && !b) || (n <= 0)) return True;
	if (!a || !b) return False;
	for (; n; n--) {
	    if (*a != *b) return False;
	    a++; b++;
	}
	return True;
}

int pwccmp_i(const word *a, const word *b) {
	if (!a && !b) return 0;
	if (!a) return -1;
	if (!b) return 1;
	while (1) {
  int c1, c2;
	    c1 = *a;
	    c2 = *b;
	    c1 -= c2;
	    if (c1 || !c2) return c1;
	    a++; b++;
	}
}

int pwcncmp_i(const word *a, const word *b, int n) {
	if ((!a && !b) || (n <= 0)) return 0;
	if (!a) return -1;
	if (!b) return 1;
	for (; n; n--) {
  dword c1, c2;
	    c1 = *a; c2 = *b;
	    c1 -= c2;
	    if (c1) return (int)c1;
	    a++; b++;
	}
	return 0;
}
