/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

void TLines_ChkMax_xy(TLines *tls, int *xa, int *ya, int *xe, int *ye) {
  TColS *cs;
  int ixa = *xa;
  int iya = *ya;
  int ixe = *xe;
  int iye = *ye;

	if (!tls || (tls->Count <= 0)) {
	    ixa = 0;
	    ixe = 0;
	    iya = 0;
	    iye = 0;
	    goto ende;
	}

	if (iya < 0) iya = 0;
	if (iye < 0) iye = 0;
	if (iya > tls->Count) iya = tls->Count;
	if (iye > tls->Count) iye = tls->Count;

	if (iya > iye) {
	    SWAP_INT(ixa, ixe);
	    SWAP_INT(iya, iye);
	} else if ((iya == iye) && (ixa > ixe)) {
	    SWAP_INT(ixa, ixe);
	}

	cs = tls->lines->cs[iya];
	if (iya == iye) {
	    if (cs) {
		if (ixa > cs->lg) ixa = cs->lg;
		if (ixe > cs->lg) ixe = cs->lg;
	    } else {
		ixa = 0;
		ixe = 0;
	    }
	} else {
	    if (cs) {
		if (ixa > cs->lg) ixa = cs->lg;
		if (iye < tls->Count) {
		    cs = tls->lines->cs[iye];
		    if (ixe > cs->lg) ixe = cs->lg;
		} else ixe = 0;
	    } else {
		ixe = 0;
	    }
	}
ende:
	*xa = ixa; *ya = iya; *xe = ixe; *ye = iye;
}


dword TLines_GetSel_Size(TLines *tls, int xa, int ya, int xe, int ye, int fu) {
  TColS *cs;
  dword size = 0;

	if (tls->Count <= 0) return 0;
	TLines_ChkMax_xy(tls, &xa, &ya, &xe, &ye);

	 if (ya == ye) {
	    size =  xe - xa;
	} else  {
	    cs = tls->lines->cs[ya];
	    size =  cs->lg - xa;
	    size += GetDefaultEOL_lg(tls->DefaultEOL, fu | cs->fu);
	    ya++;
	    while (ya < ye) {
		cs = tls->lines->cs[ya];
		size += cs->lg;
		size += GetDefaultEOL_lg(tls->DefaultEOL, fu | cs->fu);
		ya++;
	    }
	    size += xe;
	}
	return size;
}

dword TLines_GetSize(TLines *tls, int fu) {
	return TLines_GetSel_Size(tls, 0, 0, chkStrLen, chkStrLen, fu);
}

void TLines_DelSel(TLines *tls, int *xa, int *ya, int xe, int ye) {
  int iya;
  TColS *cs, *cs0;

	TLines_ChkMax_xy(tls, xa, ya, &xe, &ye);
	iya = *ya;
	if (iya < tls->Count) {
	    cs0 = tls->lines->cs[*ya];
	    TLines_ResLinec(tls, cs0, *ya);
	    if (iya == ye) {
		ppclg_delsel(&cs0->s, &cs0->lg, *xa, xe);
		TLines_DoLineChange(tls, iya);
	    } else {
		if ((*xa > 0) || ((xe > 0) && (ye < tls->Count))) {
		    ppclg_delsel(&cs0->s, &cs0->lg, *xa, cs0->lg);
		    if (ye < tls->Count) {
			cs = tls->lines->cs[ye];
			ppclg_delsel(&cs->s, &cs->lg, 0, xe);
			Tlgs_Add((Tlgs*)cs0, (Tlgs*)cs);
		    }
		    TLines_DoLineChange(tls, iya);
		    iya++;
		}
		TLines_DelN(tls, iya, ye - *ya);
	    }
	}
}

static void TLines_C_nmove_AddEOL(TLines *tls, char **pcd, char *s, int lg, int fu) {
	ppcnmove(pcd, s, lg);
	ppcnmove(pcd, GetDefaultEOL_s(tls->DefaultEOL, fu), GetDefaultEOL_lg(tls->DefaultEOL, fu));
}

void TLines_GetSel_Tlgs(TLines *tls, Tlgs *lgs, int xa, int ya, int xe, int ye, int fu) {
  int mlg;
  TColS *cs;
  char *pcd;

	TLines_ChkMax_xy(tls, &xa, &ya, &xe, &ye);
	mlg = TLines_GetSel_Size(tls, xa, ya, xe, ye, fu);
	lgs->s = xmalloc(mlg + 1);
	lgs->lg = mlg;
	pcd = lgs->s;
	pcd[mlg] = 0;

	if (ya < tls->Count) {
	    if (ya == ye) {
		cs = tls->lines->cs[ya];
		ppcnmove(&pcd, &cs->s[xa], xe-xa);
	    } else  {
		cs = tls->lines->cs[ya];
		TLines_C_nmove_AddEOL(tls, &pcd, &cs->s[xa], cs->lg-xa, fu | cs->fu);
		ya++;
		while (ya < ye) {
		    cs = tls->lines->cs[ya];
		    TLines_C_nmove_AddEOL(tls, &pcd, cs->s, cs->lg, fu | cs->fu);
		    ya++;
		}
		if (xe > 0) {
		    cs = tls->lines->cs[ya];
		    ppcnmove(&pcd, cs->s, xe);
		}
	    }
	}
}
