/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include <errno.h>
#include <unistd.h>


char *xgetcwd(bool add_slash) {
  char *s, *res;
  int lg;
  int maxlg = 1024;

	res = xmalloc(maxlg);
	while (((s = getcwd(res, maxlg-1)) == NULL) && (errno == ERANGE)) {
	    maxlg += 1024;
	    res = xrealloc(res, maxlg);
	}
	if (!s) {
	    xfree(res);
	    appError(EMSG_ERR2|EMSG_SYS, "xgetcwd()");
	    return NULL;
	} else if (add_slash) {
	    lg = pclen(res);
	    if (!lg || (res[lg-1] != C_SLASH)) {res[lg] = C_SLASH; res[lg+1] = 0;}
	}
	return res;
}
