/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

//*********************** TClassGC ************************


void TClassGC_SetForeGround(TClassGC *self, int Color) {
	if (self->ForeColor == Color) return;
	self->ForeColor = Color;
	self->gcv.foreground = GetColor_RGB(Color);
	ChangeGC(self->gc, GCForeground, &self->gcv);
}

void TClassGC_SetBackGround(TClassGC *self, int Color) {
	if (self->BackColor == Color) return;
	self->BackColor = Color;
	self->gcv.background = GetColor_RGB(Color);
	ChangeGC(self->gc, GCBackground, &self->gcv);
	
}

static void SetClipRc(TClassGC *self, GC gc) {
	XSetClipRectangles(appXDat.dpy, gc, 
		self->XOrigin, self->YOrigin, &self->ClipRc, 1, 0);
}

void TClassGC_SetClipRc(TClassGC *self, TWRect *rc) {
 
	self->ClipRc.x = rc->left;
	self->ClipRc.y = rc->top;

	self->ClipRc.width = rc->width;
	self->ClipRc.height = rc->height;

	SetClipRc(self, self->gc);
#if 1
  TWRect ClipRc;

	ClipRc.left    = rc->left + self->XOrigin;
	ClipRc.top     = rc->top + self->YOrigin;
	ClipRc.width   = rc->width;
	ClipRc.height  = rc->height;
//	ClipRc.XOrigin = 0; //self->XOrigin;
//	ClipRc.YOrigin = 0; //self->YOrigin;
	Font_SetClipRc((TFont*)self->vds.Font, &ClipRc);
#else
#ifdef _OS_WIN32
 GC sgc = self->gc;
 GC gc = self->vds.Font->g.FontGC;
	if (gc) {
	    gc->gcv.clip_mask = sgc->gcv.clip_mask;
	    gc->gcv.clip_x_origin = sgc->gcv.clip_x_origin;
	    gc->gcv.clip_y_origin = sgc->gcv.clip_y_origin;
	}
	gc = self->vds.Font->gtmp.FontGC;
	if (gc) {
	    gc->gcv.clip_mask = sgc->gcv.clip_mask;
	    gc->gcv.clip_x_origin = sgc->gcv.clip_x_origin;
	    gc->gcv.clip_y_origin = sgc->gcv.clip_y_origin;
	}
#else /* _OS_WIN32 */
//  TFont *Font = self->vds.Font;
//	if (self->vds.Font->g.FontGC) SetClipRc(self, self->vds.Font->g.FontGC);
//	if (self->vds.Font->gtmp.FontGC) SetClipRc(self, self->vds.Font->gtmp.FontGC);
 printf("%s(%d): TODO Font SetClipRc\n", FL);
#endif /* ! _OS_WIN32 */
#endif
}


void TClassGC_DrawLine(TClassGC *self, int x1, int y1, int x2, int y2) {
	XDrawLine(appXDat.dpy, self->owner->WinID, self->gc, 
		x1 + self->XOrigin, y1 + self->YOrigin,
		x2 + self->XOrigin, y2 + self->YOrigin);
}

void TClassGC_DrawRect(TClassGC *self, int x, int y, int w, int h) {
	XDrawRectangle(appXDat.dpy, self->owner->WinID, self->gc, 
		x + self->XOrigin, y + self->YOrigin, w-1, h-1);
}
void TClassGC_DrawFocusRect_rc(TClassGC *self, TWRect *rc) {
	DrawRect(self->owner->WinID,appXDat.FocusLine_GC, 
		rc->left + self->XOrigin, rc->top + self->YOrigin, rc->width, rc->height);
}

void TClassGC_FillRect(TClassGC *self, int x, int y, int w, int h) {
	XFillRectangle(appXDat.dpy, self->owner->WinID, self->gc, 
		x + self->XOrigin, y + self->YOrigin, w, h);
}
void TClassGC_FillRect_rc(TClassGC *self, TWRect *rc) {
	XFillRectangle(appXDat.dpy, self->owner->WinID, self->gc, 
		rc->left + self->XOrigin, rc->top + self->YOrigin, rc->width, rc->height);
}
void TClassGC_FillSelectRect_rc(TClassGC *self, TWRect *rc) {
	XFillRectangle(appXDat.dpy, self->owner->WinID, appXDat.Select_GC, 
		rc->left + self->XOrigin, rc->top + self->YOrigin, rc->width, rc->height);
}

void TClassGC_BorderPaint(TClassGC *self, int BorderFu, int x, int y, int w, int h) {
	StdBorderPaint(self->owner->WinID, BorderFu,
		x + self->XOrigin, y + self->YOrigin, w, h);
}

void TClassGC_BorderPaint_rc(TClassGC *self, int BorderFu, TWRect *rc) {
	StdBorderPaint(self->owner->WinID, BorderFu,
		rc->left + self->XOrigin, rc->top + self->YOrigin, rc->width, rc->height);
}

int TClassGC_DrawColorString(TClassGC *self, int x, int y) {
  return DrawColorString(x + self->XOrigin, y + self->YOrigin, &self->vds);
}

int TClassGC_DrawColorStringFu(TClassGC *self, int x, int y, int fu) {
  int w, h, fonth;
//  bool mk;

	if ((fu & (mStrLeft | mStrRigth)) == mStrLeft) {
//		x = x + self->XOrigin;
	} else {
	    w = self->ClipRc.x + self->ClipRc.width - TextWidthColorString(&self->vds);
	    if ((fu & (mStrLeft | mStrRigth)) == 0) {
		x += w / 2;
	    } else {
		x += w;
	    }
	}

	if ((fu & (mStrTop | mStrBottom)) == mStrTop) {
//		y = y + self->YOrigin;
	} else {
	    Font_GetMetrics((TFont*)self->vds.Font, &fonth, NULL);
	    h = self->ClipRc.y + self->ClipRc.height - fonth;
	    if ((fu & (mStrTop | mStrBottom)) == 0) {
		y += h / 2;
	    } else {
		y += h;
	    }
	}
	return TClassGC_DrawColorString(self, x, y);
}

void TClassGC_DrawPic(TClassGC *self, TPic *pic, int x, int y) {
  int w, h, left, top, m, ho, wo;

	if (!pic) return;
	w = pic->width;
	h = pic->height;
	left = x + self->XOrigin;
	top = y + self->YOrigin;

	m = self->ClipRc.y + self->ClipRc.height;
	if ((y + h) > m) h -= y + h - m;
	ho = 0;
	if (self->ClipRc.y > y) ho = self->ClipRc.y - y;
	h -= ho;
	if (h <= 0) return;

	m = self->ClipRc.x + self->ClipRc.width;
	if ((x + w) > m) w -= x + w - m;
	wo = 0;
	if (self->ClipRc.x > x) wo = self->ClipRc.x - x;
	w -= wo;
	if (w <= 0) return;

	Set_Icon_gcv(pic, 0, left, top);
	XCopyArea (appXDat.dpy, (Drawable)pic->pic, self->owner->WinID, appXDat.IconGC, 
		wo, ho, w, h, left+wo, top+ho);
}

/*_____________________________ Free ____________________________________*/
static bool TClassGC__Destroy(TClassGC *self) {
	FreeGC(self->gc);
	Tfree(self->vds.Font);
	xfree(self->vds.s);
	return False;
}

/*_____________________________ Create __________________________________*/
static void TClassGC_Param(TClassGC *self, TWins *owner) {
  int gcm;

	self->Width = 0x7fffffff;
	self->Height = 0x7fffffff;
	self->owner = owner;
	self->vds.WinID = owner->WinID;
	self->vds.Wins = owner;
	self->vds.Font = (TFontX*)Font_CreateDuplicate((TFont*)owner->vds.Font);

	self->ForeColor = 0xffffff;
#ifdef USE_X11GC_plane_mask
	gcm = GCFunction | GCPlaneMask | GCGraphicsExposures | 
			GCLineWidth | GCForeground | GCFillStyle;
	self->gcv.plane_mask = AllPlanes;
#else
	gcm = GCFunction | GCGraphicsExposures | 
			GCLineWidth | GCForeground | GCFillStyle;
#endif
	self->gcv.line_width = 1;
	self->gcv.function = GXcopy;
	self->gcv.fill_style = FillSolid;
//	self->gcv.graphics_exposures = 0;
	self->gcv.foreground = GetColor_RGB(self->ForeColor);
	self->gc = CreateGC(gcm, &self->gcv);

	self->destroy = (TDESTROY)TClassGC__Destroy;
}

TClassGC *TClassGC_Create(TWins *owner) {
  TClassGC *self;
	self = ttc_create(sizeof(TClassGC), wtyp_TClassGC);
	TClassGC_Param(self, owner);
	return self;
}
