/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

int TGrid_DoKeyDown(TWins *self, TKeyEvent *KeyEv) {
  TGrid *gr = (TGrid*)self;
  int m;

	if (gr->SelectIdxRow < gr->FixedRows) return 0;

	if (TWins_DoKeyDown((TWins*)gr, KeyEv)) return 1;

	switch(KeyEv->keysym) {
	case XK_Up:
	    m = gr->SelectIdxRow;
	    while ((m > gr->FixedRows) && !gr->RowDat[m-1].Visible) m--;
	    if ((m > gr->FixedRows) && gr->RowDat[m-1].Visible) {
		gr->MouseCell.Row = m-1;
		if (gr->DoSelect) gr->DoSelect(gr, 0);
	    }
	    break;

	case XK_Down:
	    m = gr->SelectIdxRow;
	    while ((m < (gr->RowCount-1)) && !gr->RowDat[m+1].Visible) m++;
	    if ((m < (gr->RowCount-1)) && gr->RowDat[m+1].Visible) {
		gr->MouseCell.Row = m+1;
		if (gr->DoSelect) gr->DoSelect(gr, 0);
	    }
	    break;

	case XK_Left:
	    m = gr->SelectIdxCol;
	    while ((m > gr->FixedCols) && !gr->ColDat[m-1].Visible) m--;
	    if ((m > gr->FixedCols) && gr->ColDat[m-1].Visible) {
		gr->MouseCell.Col = m-1;
		if (gr->DoSelect) gr->DoSelect(gr, 0);
	    }
	    break;

	case XK_Right:
	    m = gr->SelectIdxCol;
	    while ((m < (gr->ColCount-1)) && !gr->ColDat[m+1].Visible) m++;
	    if ((m < (gr->ColCount-1)) && gr->ColDat[m+1].Visible) {
		gr->MouseCell.Col = m+1;
		if (gr->DoSelect) gr->DoSelect(gr, 0);
	    }
	    break;
	}

	return 1;
}

