/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

//*********************** ProgressBar ************************
void TProgressBar_DoPaint(TProgressBar *self) {
  TWRect rc;
  int w;

	Get_ClientRect((TWins*)self, &rc);
	w = rc.width * self->Proz / 1000;
	Fill_Rect(self->WinID, appXDat.GC_FFFFFF, rc.left, rc.top, rc.width, rc.height);
	TWins_DoPaint((TWins*)self);
	if (w > 0) {
	    Fill_Rect(self->WinID, appXDat.Select_GC, rc.left, rc.top, w, rc.height);
	}
}

void TProgressBar_SetProz(TProgressBar *pb, int Value) {
  int min_nums;
  char line[20];

	if (Value < 0) Value = 0;
	if (Value > 1000) Value = 1000;
	if (pb->Proz != Value) {
	    pb->Proz = Value;
	    if (pb->nk) {
		min_nums = kPERCENT_ADD|kVALUE_int|0x100;
	    } else {
		min_nums = kPERCENT_ADD|kVALUE_int;
		Value = (Value + 4) / 10;
	    }
	    pcmove_v32(line, Value, min_nums);
	    vds_SetStr(&pb->vds, line);
	    if ((GetCurTimeDiv_us(pb->LastPaintTime_us) > 20000) || (Value == 1000)) {
		Refresh((TWins*)pb);
	    }
	}
}

/*_____________________________ Create __________________________________*/
static void TProgressBar_CreateParams(TWins_Create_struct *wcs) {
  TProgressBar *self = wcs->wins;
	self->DoPaint = TProgressBar_DoPaint;
	self->nk = 1;
	self->CaptionFu = mCaptionPaint;
	self->BorderFu = mBorder | mBorderL;
}

TProgressBar *TProgressBar_Create(TWins *Parent) {
  TWins_Create_struct wcs;

	TWins_Create_struct_init(&wcs, sizeof(TProgressBar), wtyp_ProgressBar);
	wcs.Parent = Parent;
	wcs.CreateParams = TProgressBar_CreateParams;
	TWins_DefaultConf(&wcs);
	return wcs.wins;
}

TProgressBar *TProgressBar_CreateU(TWins *Parent, int Left, int Top, int Width, int Height) {
  TProgressBar *pb;
	pb = TProgressBar_Create(Parent);
	pb->top = Top;
	pb->left = Left;
	pb->width = Width;
	pb->height = Height;
	pb->CaptionFu |= mCaptionPaint;
	SetCaption((TWins*)pb, "0%");
	Set_Parent((TWins*)pb, Parent);
	return pb;
}
