/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

#ifdef USE_DECOR
TDecor *DefaultRepButtonDecor;
#endif

static void TRepButton_OnTimer(TgTimer *ti) {
  TRepButton *rb = (TRepButton*)ti->obj;

	if (rb->RepTimerStartCount > 0) {
	    rb->RepTimerStartCount--;
	    return;
	}
	if (rb->OnMouseDownRep) rb->OnMouseDownRep(rb);
}

static void TRepButton_DoMouseDown(TRepButton *self, XButtonEvent *ev) {
	if ((ev->button == 1) && TestWinIsEnabled((TWins*)self)) {
	    self->BorderFu |= mBorderL;
	    Refresh((TWins*)self);
	    if (!self->RepTimer && self->OnMouseDownRep) {
		self->RepTimerStartCount = 9;
		self->RepTimer = gTimerX_Add(Timer_Enabled, 33, TRepButton_OnTimer);
		self->RepTimer->obj = self;
		self->OnMouseDownRep(self);
	    }
	}
	TWins_DoMouseDown((TWins*)self, ev);
}

static void TRepButton_DoMouseUp(TRepButton *self, XButtonEvent *ev) {
	if ((ev->button == 1) && TestWinIsEnabled((TWins*)self)) {
	    self->BorderFu &= ~mBorderL;
	    Refresh((TWins*)self);
	    if (self->RepTimer) ppTfree(&self->RepTimer);
	}
	TWins_DoMouseUp((TWins*)self, ev);
}

/*____________________________ Create ___________________________________*/
void TRepButton_CreateParams(TWins_Create_struct *wcs) {
  TRepButton *self = wcs->wins;
#ifdef USE_DECOR
  TDecor *Decor;
#endif

	self->DoMouseDown = TRepButton_DoMouseDown;
	self->DoMouseUp = TRepButton_DoMouseUp;

	self->CaptionFu = mCaptionPaint;
	self->BorderFu = mBorder;
#ifdef USE_DECOR
	Decor = DefaultRepButtonDecor;
	if (Decor && Decor->CreateDup) {
	      self->Decor = Decor->CreateDup(&DefaultRepButtonDecor);
	}
#endif
}

TRepButton *TRepButton_Create(TWins *Parent) {
  TWins_Create_struct wcs;

	TWins_Create_struct_init(&wcs, sizeof(TRepButton), wtyp_RepButton);
	wcs.Parent = Parent;
	wcs.CreateParams = TRepButton_CreateParams;
	TWins_DefaultConf(&wcs);
	return wcs.wins;
}

TRepButton *TRepButton_CreateS(TWins *Parent, int Left, int Top, int Width, int Height, const char *s) {
  TRepButton *self;

	self = TRepButton_Create(Parent);
	SelfCreateS((TWins*)self, Left, Top, Width, Height, s);
	return self;
}
