/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

static void TSysTrayWin_Show(TSysTrayWin *self) {
	if (!self->IsParent) {
	    self->IsParent = True;
	    TWins_AdjustSize((TWins*)self);
	    self->Visible = True;
// printf("%s(%d): win=0x%x %d %d %d %d\n", FL, (int)self->SysTrayWin, self->SysTrayWin_rc.left, self->SysTrayWin_rc.top, self->SysTrayWin_rc.width, self->SysTrayWin_rc.height);
	    SendSysTrayWin(self->SysTrayWin, self->WinID);
	}
}

/*____________________________ Create ___________________________________*/
static void TSysTrayWin_CreateParams(TWins_Create_struct *wcs) {
  TSysTrayWin *self = wcs->wins;

	TForm_CreateParams(wcs);

	self->width = 20;
	self->height = 20;

	self->Show = TSysTrayWin_Show;
}


TSysTrayWin *TSysTrayWin_Create() {
  TWins_Create_struct wcs;
  Window SysTrayWin;
  TWRect rc;
  TSysTrayWin *self;

	if (!GetSysTrayWin(&SysTrayWin, &rc)) {
	    self = TForm_CreatParamAlg(NULL, sizeof(TSysTrayWin));
	    self->wtyp = wtyp_SysTrayWin;
	    SetRC((TWins*)self, -1000, -1000, 20, 20);
	    self->FormPosition = poDesigned;
	} else {
	    TWins_Create_struct_init(&wcs, sizeof(TSysTrayWin), wtyp_SysTrayWin);
	    wcs.CreateParams = TSysTrayWin_CreateParams;
	    wcs.CreateXWin = TForm_CreateXWin;
	    wcs.WCSfkt = WCSfkt_OverrideRedirect;
	    TWins_DefaultConf(&wcs);
	    self = wcs.wins;
	    self->SysTrayWin = SysTrayWin;
	    self->SysTrayWin_rc = rc;
	}
	return self;
}
