/*
 Copyright (C) 2010-2015 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

/* void TTreeV_Resize(TTreeV *self) {
  int m;
	TWins_Resize((TWins*)self);

	TScrollBar_SetButtonCountSize(self->VSB, self->height);
	m = ((self->height / self->DefaultHeight) - 1) * self->DefaultHeight;
	if (m < self->DefaultHeight) m = self->DefaultHeight;
	self->VSB->LargeChange = m;
	TScrollBar_SetButtonCountSize(self->HSB, self->width);
	self->HSB->LargeChange = self->width / 2;
} */

void TTreeV_DoResize(TTreeV *self) {
  int m;
	TWins_DoResize((TWins*)self);

	m = ((self->height / self->DefaultHeight) - 1) * self->DefaultHeight;
	if (m < self->DefaultHeight) m = self->DefaultHeight;
	self->VSB->LargeChange = m;
	self->HSB->LargeChange = self->width / 2;
}

void TTreeV_DoPaintNode(TTreeV *self, TTreeVNode *tvn, int fu) {
  int x, y, fonth;
  TFontX *orgFont;

#if TVN_CHK_EXPAND
	if ((fu & tvnfu_TestExpand) && 
	    !TTreeVNode_TestNodeIsExpand(tvn, tvnCF_ALLChild)) return;
#endif

	orgFont = self->vds.Font;
	if (tvn->Font) {
	    self->vds.Font = tvn->Font;
	}

	if (fu & tvnfu_CalcSizeOnly) {
	    if (tvn->st & tvnSt_SizeOk) goto end;
	    tvn->st |= tvnSt_SizeOk;
	    if (tvn->get_s_lg) {
		tvn->get_s_lg(tvn, &self->vds.s_const, &self->vds.lg);
	    } else {
		self->vds.s = tvn->s;
		self->vds.lg = tvn->lg;
	    }
	    tvn->width = 4 + TextWidthColorString(&self->vds);
	    if (tvn->pic) {
		tvn->width += tvn->pic->width;
	    }
	    self->vds.s = NULL;
	    self->vds.lg = 0;
	    goto end;
	}


	if (fu & tvnfu_PaintNew) {
	    FillRectRGB(self->WinID, self->Color, tvn->left, tvn->top, tvn->width, tvn->height);
	}

	if (tvn->get_s_lg) {
	    tvn->get_s_lg(tvn, &self->vds.s_const, &self->vds.lg);
	} else {
	    self->vds.s = tvn->s;
	    self->vds.lg = tvn->lg;
	}
	x = 2 + tvn->left;
	if (tvn->pic) x += tvn->pic->width;
	Font_GetMetrics((TFont*)self->vds.Font, &fonth, NULL);
	y = 1 + tvn->top + ((tvn->height - fonth) >> 1);
	self->vds.BackColor = self->Color;
	DrawColorString(x, y, &self->vds);
	self->vds.s = NULL;
	self->vds.lg = 0;

	if (self->SelectNode == tvn) {
	    Fill_Rect(self->WinID, appXDat.Select_GC, tvn->left, tvn->top, tvn->width, tvn->height);
	    if (self->KeyFu & mHasFocus) DrawRectFocus(self->WinID, tvn->left, tvn->top, tvn->width, tvn->height);
	}
	if (tvn->pic) {
	    DrawPic(self->WinID, tvn->pic, tvn->left+1, tvn->top+1);
	}
	if (self->OnPaintNode) self->OnPaintNode(self, tvn, fu);
end:
	self->vds.Font = orgFont;
}

static void TTreeV_GetMaxHeight(TTreeV *tv, TTreeVNode *tvn, int *height) {
	while (tvn) {
	    if (!(tvn->st & tvnSt_NotVisible)) {
		tvn->abs_top = *height;
		*height += tvn->height;
		if (tvn->next_child && (tvn->st & tvnSt_Expanded)) {
		    TTreeV_GetMaxHeight(tv, tvn->next_child, height);
		}
	    }
	    tvn = tvn->next;
	}
}

static void TTreeV_NodePaint(TTreeV *tv, TTreeVNode *tvn, int x, int y, int *ydyn) {
  int xm, yt, ym, xo;
  bool OnlyYLine;

	while (tvn) {
	  if (!(tvn->st & tvnSt_NotVisible)) {
	    yt = *ydyn; // + tvn->top;
	    xo = x - TScrollBar_GetCount(tv->HSB); //tv->HSB->Count;
	    tvn->left = xo;
	    tvn->top = yt;
	    *ydyn += tvn->height;
	    ym = yt + (tvn->height >> 1);
	    if (tv->DoPaintNode) tv->DoPaintNode(tv, tvn, tvnfu_CalcSizeOnly);

	    if (((yt + tvn->height) < 0) || 
		((yt - tvn->height) > 10000) ||
		(y > tv->height)) goto next_tvn;
	    OnlyYLine = (yt-tvn->height) > tv->height;

	    if (!OnlyYLine) FillRectRGB(tv->WinID, tv->Color, 0, yt, tv->width, tvn->height);

	    xm = xo-10;
	    if (tvn->next_child || (tvn->st & tvnSt_ForceCanExp)) {
		DrawLine(tv->WinID, appXDat.GC_000000_Dot, xm, y, xm, ym-4);
		if (!OnlyYLine) {
		    DrawRect(tv->WinID, appXDat.GC_000000, xm-4, ym-4, 9, 9);
		    DrawLine(tv->WinID, appXDat.GC_000000, xm-2, ym, xm+2, ym);
		    DrawLine(tv->WinID, appXDat.GC_000000_Dot, xm+4, ym, xo, ym);
		    if (!(tvn->st & tvnSt_Expanded)) {
			DrawLine(tv->WinID, appXDat.GC_000000, xm, ym-2, xm, ym+2);
		    }
		}
		y = ym + 4;
	    } else {
		DrawLine(tv->WinID, appXDat.GC_000000_Dot, xm, y, xm, ym);
		if (!OnlyYLine) DrawLine(tv->WinID, appXDat.GC_000000_Dot, xm, ym, xo, ym);
		y = ym;
	    }
	    if (!OnlyYLine && tv->DoPaintNode) tv->DoPaintNode(tv, tvn, 0);
next_tvn:

	    if (tvn->next_child && (tvn->st & tvnSt_Expanded)) {
		TTreeV_NodePaint(tv, tvn->next_child, x+16, yt + tvn->height, ydyn);
	    }

	    xm = x + tvn->width;
	    if (xm > tv->max_node_X) tv->max_node_X = xm;
	  }
	  tvn = tvn->next;
	}
	yt = *ydyn;
}

void TTreeV_DoPaint(TTreeV *self) {
  int VSBc = self->VSB->Count;
  int ydyn = -VSBc;

	self->max_node_X = 16;
	TTreeV_NodePaint(self, self->Nodes, 16, 0, &ydyn);

	if (ydyn < self->height) {
	    if (ydyn < 0) ydyn = 0;
	    FillRectRGB(self->WinID, self->Color, 0, ydyn, self->width, self->height - ydyn);
	}
	TScrollBar_SetMaxCount(self->VSB, ydyn+VSBc);
	TScrollBar_SetButtonCountSize(self->VSB, self->height);
	TScrollBar_SetMaxCount(self->HSB, self->max_node_X);
	TScrollBar_SetButtonCountSize(self->HSB, self->width);
}

static TTreeVNode *TTreeV_Find_Y_Node(int y, TTreeVNode *tvn) {
  TTreeVNode *res = NULL;

	if (!tvn) return NULL;
	while ((tvn != NULL) && !res) {
	    if (!(tvn->st & tvnSt_NotVisible)) {
		if ((y >= tvn->top) && (y < (tvn->top + tvn->height))) return tvn;
		if (tvn->next_child && (tvn->st & tvnSt_Expanded)) 
		    res = TTreeV_Find_Y_Node(y, tvn->next_child);
	    }
	    tvn = tvn->next;
	}
	return res;
}

void TTreeV_Update_ScrollBar(TTreeV *self, int *ppmxh) {
  int mxh = 0;
  int y;

	y = TScrollBar_GetCount(self->VSB);
	TTreeV_GetMaxHeight(self, self->Nodes, &mxh);
	TScrollBar_SetMaxCount(self->VSB, mxh);
	if (mxh < self->height) {
	    TScrollBar_SetCount(self->VSB, 0);
	} else {
	    if (y > (mxh - self->height)) {
		TScrollBar_SetCount(self->VSB, mxh - self->height);
	    }
	}
	Refresh((TWins*)self);
	if (ppmxh) *ppmxh = mxh;
}

void TTreeV_DoExpand(TTreeV *self, TTreeVNode *tvn) {
  TTreeVNode *tvnx;
  int h, ht, mxh;
	
	tvnx = tvn->next_child;
	h = tvn->height;
	while (tvnx) {
	    if (!(tvnx->st & tvnSt_NotVisible)) h += tvnx->height;
	    tvnx = tvnx->next;
	}
	if (h > self->height) h = self->height;
	ht = h + tvn->top - self->height;
	if (ht > 0) {
	    mxh = 0;
	    TTreeV_GetMaxHeight(self, self->Nodes, &mxh);
	    TScrollBar_SetMaxCount(self->VSB, mxh);
	    h = tvn->abs_top - (self->height - h);
	    TScrollBar_SetCount(self->VSB, h);
	}
	if (self->OnExpand) self->OnExpand(self, tvn);
}

void TTreeV_DoCollaps(TTreeV *self, TTreeVNode *tvn) {
  int h, mxh;
	TTreeV_Update_ScrollBar(self, &mxh);
	if (mxh > self->height) {
	    h = (mxh - tvn->abs_top) - (self->height - tvn->top);
	    if (h < 0) {
		TScrollBar_SetCount(self->VSB, mxh+h);
	    }
	}
	if (self->OnCollaps) self->OnCollaps(self, tvn);
}

void TTreeV_DoExpandChange(TTreeV *self, TTreeVNode *tvn, int ExpEv) {
	if (self->OnExpandChange && 
	    !self->OnExpandChange(self, tvn, ExpEv)) return;
	if (tvn->st & tvnSt_Expanded) {
	    tvn->st &= ~tvnSt_Expanded; 
	    if (self->DoCollaps) self->DoCollaps(self, tvn);
	} else {
	    tvn->st |= tvnSt_Expanded;
	    if (self->DoExpand) self->DoExpand(self, tvn);
	}
	Refresh((TWins*)self);
}

static void TTreeV_DoMouseDown(TTreeV *self, XButtonEvent *ev) {
  int xo, yo;
  TTreeVNode *tvn, *seltvn;

	if (TestWinIsEnabled((TWins*)self) && 
	    ((ev->button == 1) || (ev->button == 3))) {
	    seltvn = self->SelectNode;
	    tvn = TTreeV_Find_Y_Node(ev->y, self->Nodes);
	    if (tvn) {
		if (seltvn != tvn) {
		    self->SelectNode = tvn;
		    if (self->DoPaintNode) {
			if (seltvn) {
#if TVN_CHK_EXPAND
			    self->DoPaintNode(self, seltvn, tvnfu_PaintNew|tvnfu_TestExpand);
#else
			    self->DoPaintNode(self, seltvn, tvnfu_PaintNew);
#endif
			}
			self->DoPaintNode(self, tvn, 0);
		    }
		    if (self->OnNodeSelect) self->OnNodeSelect(self, tvn);
		}

		if (ev->button == 1) {
		    xo = tvn->left - 15;
		    yo = tvn->top + (tvn->height >> 1) - 5;
		    if ((ev->x >= xo) && (ev->x <= xo+11) && 
			(ev->y >= yo) && (ev->y <= yo+11)) {
			self->MouseClickStop = True;
			if (self->DoExpandChange) 
				self->DoExpandChange(self, tvn, tvExpEv_MouseDown);
			return;
		    }
		}
	    }
	}
	TWins_DoMouseDown((TWins*)self, ev);
}

static void TTreeV_DoMouseUp(TTreeV *self, XButtonEvent *ev) {
	TWins_DoMouseUp((TWins*)self, ev);
	TScrollBar_MouseZ_Wheel(self->VSB, ev);
}

void TTreeV_DoNodeClick(TTreeV *self, TTreeVNode *tvn, bool DblClick) {
	if (self->OnNodeClick) self->OnNodeClick(self, tvn, DblClick);
}

static void TTreeV_DoClick(TTreeV *self, long KeyState, bool DblClick) {
  TTreeVNode *tvn;

	tvn = self->SelectNode;
	if (tvn) {
	    bool mk = DblClick && (tvn == self->ClickNode);
	    self->ClickNode = tvn;
	    if (self->DoNodeClick) self->DoNodeClick(self, tvn, mk);
	}
	TWins_DoClick((TWins*)self, KeyState, DblClick);
}


static void TTreeV_VSB_OnCount(TScrollBar *sb, int Count) {
	Refresh(sb->owner);
}

static void TTreeV_HSB_OnCount(TScrollBar *sb, int Count) {
	Refresh(sb->owner);
}

TTreeVNode *TTreeV_Get_prev_child(TTreeV *tv, TTreeVNode *tvn) {

	while (tvn && (tv->Nodes != tvn)) {
	    if (tvn->prev_child) return tvn->prev_child;
	    tvn = tvn->prev;
	}
	return NULL;
}
/*_____________________________ Focus Ev ________________________________*/
static void TTreeV_DoFocus(TTreeV *self, int Change) {
	TWins_DoFocus((TWins*)self, Change);
	if (!self->DoPaintNode) return;

	if (Change & WinsFocusIN) {
	    if (!self->SelectNode && self->Nodes) 
		TTreeV_SetSelNode(self, self->Nodes);
	}

	if (self->SelectNode) 
#if TVN_CHK_EXPAND
		self->DoPaintNode(self, self->SelectNode, tvnfu_PaintNew|tvnfu_TestExpand);
#else
		self->DoPaintNode(self, self->SelectNode, tvnfu_PaintNew);
#endif
}
/*_____________________________ Key Ev __________________________________*/
void TTreeV_SetSelNode(TTreeV *self, TTreeVNode *tvn) {
TTreeVNode *seltvn;
  int h = 0;

	if (self->SelectNode == tvn) return;
	TTreeV_GetMaxHeight(self, self->Nodes, &h);
	seltvn = self->SelectNode;
	self->SelectNode = tvn;
	if (tvn) {
	    h = -1;
	    if (tvn->top < 0) {
		h = tvn->abs_top;
	    } else if ((tvn->top + tvn->height) > self->height) {
		h = tvn->abs_top + tvn->height - self->height;
	    }
	    if (h >= 0) {
		TScrollBar_SetCount(self->VSB, h);
		Refresh((TWins*)self);
		return;
	    }
	}

	if (self->DoPaintNode) {
#if TVN_CHK_EXPAND
	    if (seltvn) self->DoPaintNode(self, seltvn, tvnfu_PaintNew|tvnfu_TestExpand);
	    if (tvn) self->DoPaintNode(self, tvn, tvnfu_TestExpand);
#else
	    if (seltvn) self->DoPaintNode(self, seltvn, tvnfu_PaintNew);
	    if (tvn) self->DoPaintNode(self, tvn, 0);
#endif
	}
	if (self->OnNodeSelect) self->OnNodeSelect(self, tvn);
}

TTreeVNode *TTreeV_GetSelNode(TTreeV *self) {
	return self->SelectNode;
}

TTreeVNode* TTreeVNode_get_prev(TTreeVNode *tvn) {
	if (tvn) tvn = tvn->prev;
	while (tvn && (tvn->st & tvnSt_NotVisible)) {
	    tvn = tvn->prev;
	}
	return tvn;
}

TTreeVNode* TTreeVNode_get_next(TTreeVNode *tvn) {
	if (tvn) tvn = tvn->next;
	while (tvn && (tvn->st & tvnSt_NotVisible)) {
	    tvn = tvn->next;
	}
	return tvn;
}

TTreeVNode* TTreeVNode_get_prev_child(TTreeVNode *tvn) {
	while (tvn && tvn->prev) {
	    tvn = tvn->prev;
	}
	if (tvn) return tvn->prev_child;
	return NULL;
}

TTreeVNode* TTreeVNode_get_next_child(TTreeVNode *tvn) {
	if (tvn) tvn = tvn->next_child;
	while (tvn && (tvn->st & tvnSt_NotVisible)) {
	    tvn = tvn->next;
	}
	return tvn;
}

static int TTreeV_DoKeyDown(TTreeV *self, TKeyEvent *KeyEv) {
  TTreeVNode *seltvn, *tvn;

	if (TWins_DoKeyDown((TWins*)self, KeyEv)) return 1;

	seltvn = self->SelectNode;
	if (!seltvn) return 0;

	tvn = NULL;
	switch(KeyEv->keysym) {
	case XK_Up:
	    tvn = TTreeVNode_get_prev(seltvn);
	    if (!tvn) tvn = TTreeVNode_get_prev_child(seltvn);
	    break;

	case XK_Down:
	    tvn = TTreeVNode_get_next(seltvn);
	    if (!tvn && (seltvn->st & tvnSt_Expanded)) tvn = TTreeVNode_get_next_child(seltvn);
	    break;

	case XK_Left:
	    if (seltvn->st & tvnSt_Expanded) {
		if (self->DoExpandChange) self->DoExpandChange(self, seltvn, tvExpEv_KeyDown);
	    } else {
		tvn = TTreeVNode_get_prev_child(seltvn);
	    }
	    break;

	case XK_Right:
	    if (!(seltvn->st & tvnSt_Expanded)) {
		if (seltvn->next_child || (seltvn->st & tvnSt_ForceCanExp)) {
		    if (self->DoExpandChange) self->DoExpandChange(self, seltvn, tvExpEv_KeyDown);
		}
	    } else tvn = TTreeVNode_get_next_child(seltvn);
	    break;

	case XK_space:
	    if (self->DoNodeClick) self->DoNodeClick(self, seltvn, False);
	    break;

	case XK_Return:
	    if (self->DoNodeClick) self->DoNodeClick(self, seltvn, False);
	    break;

	default:
	    return 0;
	}
	if (tvn) TTreeV_SetSelNode(self, tvn);
	return 1;
}

bool TTreeVNode_TestNodeIsExpand(TTreeVNode *tvn, int CF) {
	if (!tvn) return False;

	if (CF == tvnCF_Child) {
	    tvn = TTreeVNode_get_prev_child(tvn);

	} else if (CF == tvnCF_ALLChild) {
	    while (tvn) {
		tvn = TTreeVNode_get_prev_child(tvn);
		if (tvn && !(tvn->st & tvnSt_Expanded)) break;
	    }
	}
	if (!tvn) return True;
	return (tvn->st & tvnSt_Expanded) != 0;
}


void TTreeV_NodeExpand(TTreeV *self, TTreeVNode *tvn) {
	if (!tvn || (tvn->st & tvnSt_Expanded)) return;
	TTreeV_DoExpandChange(self, tvn, tvExpEv_Software);
}

void TTreeV_NodeCollaps(TTreeV *self, TTreeVNode *tvn) {
	if (!tvn || !(tvn->st & tvnSt_Expanded)) return;
	TTreeV_DoExpandChange(self, tvn, tvExpEv_Software);
}

void TTreeV_SetNodeVisible(TTreeV *self, TTreeVNode *tvn, bool Value) {
  bool mk;
	if (!tvn) return;
	mk = !(tvn->st & tvnSt_NotVisible);
	if (mk == Value) return;
	tvn->st ^= tvnSt_NotVisible;
	Refresh((TWins*)self);
}

void TTreeV_Cls(TTreeV *self) {
	if (self->SelectNode) {
	    self->SelectNode = NULL;
	    if (self->OnNodeSelect) self->OnNodeSelect(self, NULL);
	}
	while (self->Nodes) Tfree(self->Nodes);
}

void TTreeVNode_Del(TTreeVNode *self) {
  TTreeV *tv = self->tv;
  TTreeVNode *tvn = NULL;
  
	if (!self) return;
	tv = self->tv;
	if (tv) tvn = tv->SelectNode;
	Tfree(self);
	if (!tv) return;
	Refresh((TWins*)tv);
	if (tv->OnNodeSelect && (tvn != tv->SelectNode)) {
	    tv->OnNodeSelect(tv, tv->SelectNode);
	}
}

void TTreeV_SetMouseZ_Wheel(TTreeV *self, int Value) {
	TScrollWin_SetMouseZ_Wheel((TScrollWin*)self, Value);
}

/*_____________________________ Destroy ____________________________________*/

static bool chk_seltvn(TTreeVNode *tvn, TTreeVNode *seltvn) {
  bool res = False;
	while (tvn) {
	    if (tvn == seltvn) return True;
	    if (tvn->next_child) res = chk_seltvn(tvn->next_child, seltvn);
	    if (res) return True;
	    tvn = tvn->next;
	}
	return False;
}

bool TTreeVNode__Destroy(TTreeVNode *self) {
  TTreeV *tv = self->tv;
  TTreeVNode *ntvn;

	Tfree(self->ttc);
	if (tv && tv->SelectNode) {
	    if ((self == tv->SelectNode) || chk_seltvn(self->next_child, tv->SelectNode)) {
		ntvn = TTreeVNode_get_prev(self);
		if (!ntvn) ntvn = TTreeVNode_get_next(self);
		if (!ntvn) ntvn = TTreeVNode_get_prev_child(self);
		tv->SelectNode = ntvn;
	    }
	}

	xfree(self->s);
	return TNode__Destroy((TNode*)self);
}

bool TTreeV__Destroy(TTreeV *self) {
	TTreeV_Cls(self);
	return TWins__Destroy((TWins*)self);
}

/*_____________________________ Create __________________________________*/
void TTreeVNode_Param(TTreeVNode *self, TTreeV *tv, const char *s) {
	self->destroy = (TDESTROY)TTreeVNode__Destroy;
	self->tv = tv;
	self->width = tv->DefaultWidth;
	self->height = tv->DefaultHeight;
	if (s) {
	    self->s = pcdup(s);
	    self->lg = pclen(s);
	}
	self->ForeColor = tv->DefaultForeColor;
	self->BackColor = tv->DefaultBackColor;
}

TTreeVNode *TTreeV_AddNode(TTreeV *tv, TTreeVNode *prev_child, TTreeVNode *prev, const char *s) {
  TTreeVNode *tvn;
	tvn = TNodeAddTo((void*)&tv->Nodes, (TNode*)prev_child, (TNode*)prev, sizeof(TTreeVNode), wtyp_TTreeVNode);
	TTreeVNode_Param(tvn, tv, s);
	return tvn;
}

TTreeVNode *TTreeV_AddNextNode(TTreeV *tv, TTreeVNode *prev_child, const char *s) {
  TTreeVNode *prev;
	prev = tv->Nodes;
	if (prev_child) prev = prev_child->next_child;
	while (prev && prev->next) prev = prev->next;
	return TTreeV_AddNode(tv, prev_child, prev, s);
}

void TTreeV_CreateParams(TWins_Create_struct *wcs) {
  TTreeV *self = wcs->wins;

	TScrollWin_CreateParams(wcs);

	self->destroy = (TDESTROY)TTreeV__Destroy;

//	self->Resize =  TTreeV_Resize;
	self->DoResize =  TTreeV_DoResize;
	self->DoPaint = TTreeV_DoPaint;
	self->DoPaintNode = TTreeV_DoPaintNode;
	self->DoKeyDown = TTreeV_DoKeyDown;
	self->DoMouseDown = TTreeV_DoMouseDown;
	self->DoMouseUp =   TTreeV_DoMouseUp;
	self->DoClick = TTreeV_DoClick;
	self->DoFocus = TTreeV_DoFocus;

	self->DoExpandChange = TTreeV_DoExpandChange;
	self->DoExpand = TTreeV_DoExpand;
	self->DoCollaps = TTreeV_DoCollaps;
	self->DoNodeClick = TTreeV_DoNodeClick;

	self->DefaultWidth = 60;
	self->DefaultHeight = 18;
	self->DefaultForeColor = 0x80000000;     // = no Color
	self->DefaultBackColor = 0x80000000;     // = no Color

	self->KeyFu = mCanFocus | mK_Tab;

	self->VSB->OnCount = TTreeV_VSB_OnCount;
	self->VSB->SmallChange = self->DefaultHeight;
	self->HSB->OnCount = TTreeV_HSB_OnCount;
	self->max_node_X = 16;
}

TTreeV *TTreeV_Create(TWins *Parent) {
  TWins_Create_struct wcs;
	TWins_Create_struct_init(&wcs, sizeof(TTreeV), wtyp_TreeV);
	wcs.Parent = Parent;
	wcs.CreateParams = TTreeV_CreateParams;
	TScrollWin_DefaultConf(&wcs);
	return wcs.wins;
}

TTreeV *TTreeV_CreateA(TWins *Parent, int Left, int Top, int Width, int Height, int Align) {
  TTreeV *self;
	self = TTreeV_Create(Parent);
	self->pw->top = Top;
	self->pw->left = Left;
	self->pw->width = Width;
	self->pw->height = Height;
	self->Align = alClient;
	if (Align) self->pw->Align = Align;
	Set_Parent((TWins*)self, Parent);
	return self;
}
