/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "dlg.h"

static void Find_Dlg_buOk_Click(TButton *self, long KeyState, bool DblClick) {
  TFind_Dlg *fw = (TFind_Dlg*)self->FormStruct;

//	if (DblClick) return;
	SetVisible((TWins*)self->FormStruct, False);
	if (pclen(fw->edFind->vds.s) > 0) {
		fw->RetCode = 1;
	}
}

static void Find_Dlg_buCancel_Click(TButton *self, long KeyState, bool DblClick) {
	SetVisible(self->FormStruct, False);
}

static void Find_Dlg_edFind_OnKeyDown(TComboBox *self, TKeyEvent *KeyEv) {
	if (KeyEv->keysym == XK_Return) Find_Dlg_buOk_Click((TButton*)self, 0, False);
}

void Find_Dlg_SetUTF8(TFind_Dlg *self, bool UTF8) {
	if (self) TWins_SetUTF8((TWins*)self->edFind, UTF8);
}

bool Find_Dlg_Execute(TFind_Dlg *fw, const char *s) {

	fw->RetCode = 0;
	if (s) SetCaption((TWins*)fw->edFind, s);
	fw->FocusWin = (TWins*)fw->edFind;
	SetVisible((TWins*)fw, True);
	while (fw->Visible && AppHandleMessage());
	if (fw->RetCode == 1) {
	    TComboBox_Push(fw->edFind, 10);
	}
	return (fw->RetCode == 1);
}

static void Find_Dlg_OnResize(TFind_Dlg *self) {
  int m;

	m = self->height - 2 - self->buOk->height;
	self->buOk->top = m;
	self->buCancel->top = m;

	m = self->width >> 1;
	self->buOk->left = m - 5 - self->buOk->width;
	self->buCancel->left = m + 5;

	self->edFind->width = self->width - 5 - self->edFind->left;
}

TFind_Dlg *Create_Find_Dlg(TWins *parent) {
  TFind_Dlg *self;

	self = TForm_CreatParamAlg(parent, sizeof(TFind_Dlg));
	self->Visible = False;
	self->FormZStyle = fszTransient;
	self->FormPosition = poCenter;
	self->OnResize = Find_Dlg_OnResize;

	SetCaption((TWins*)self, "Find Dlg");
	self->width = 300;
	self->height = 120;
	self->min_width = 300;
	self->min_height = 120;

	self->lbl1 = TWins_CreateLabel((TWins*)self, 4, 2, 70, 16, "Text to Find", 0, 0);
	self->edFind = TComboBox_CreateS((TWins*)self, 4, 18, 300, 20, NULL);
	self->edFind->AutoSel = True;
	self->edFind->OnKeyDown = Find_Dlg_edFind_OnKeyDown;
	self->cbCase = TChkBox_CreateS((TWins*)self, 4, 40, 140, 15, "Case Sensitive");
	self->cbBack = TChkBox_CreateS((TWins*)self, 4, 56, 140, 15, "Find Backwards");
	self->cbBack->Enabled = False;
	self->cbBegin = TChkBox_CreateS((TWins*)self, 4, 72, 140, 15, "From Beginning");
	self->cbBegin->Enabled = False;
	self->buOk = TButton_CreateS((TWins*)self, 100, 90, 64, 24, "OK");
	self->buOk->OnClick = Find_Dlg_buOk_Click;
	self->buCancel = TButton_CreateS((TWins*)self, 200, 90, 64, 24, "Cancel");
	self->buCancel->OnClick = Find_Dlg_buCancel_Click;

	return self;
}

