/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "dlg.h"
#include "commdlg.h"

#define HPIX13 1

bool font_dlg_W32(TWins *parent, LOGFONTW *lf, char **ret_fontname) {
  const char *s2, *s3;
  int i6, i7;
  const char *s12, *s13;
  HDC hdc;
  HFONT hf, hfo;

  char s1[256];
  char buf[256];

  CHOOSEFONTW cf;
  TEXTMETRICW tm;

	Fill0(&cf, sizeof(cf));
	cf.lStructSize = sizeof(cf);
	cf.hwndOwner = parent->WinID;
	cf.lpLogFont = lf;
	cf.Flags = CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT;

	if (!ChooseFontW(&cf)) return False;

	s12 = "iso10646";
	s13 = "1";
//#if 1
	Fill0(&tm, sizeof(TEXTMETRICW));
	hdc = GetDC(0);
	hf = CreateFontIndirectW(lf);
	hfo = SelectObject(hdc, hf);
	if (GetTextMetricsW(hdc, &tm)) {
	    if (tm.tmLastChar < 256) {
		s12 = "iso8859";
//		s13 = "1";
		switch (lf->lfCharSet) {
//		case ANSI_CHARSET: {s13 = "1"; break;}		//0
		case GREEK_CHARSET: {s13 = "7"; break;}		//161
		case TURKISH_CHARSET: {s13 = "9"; break;}	//162
		case HEBREW_CHARSET: {s13 = "8"; break;}		//177
		case BALTIC_CHARSET: {s13 = "4"; break;}		//186
		case RUSSIAN_CHARSET: {s13 = "5"; break;}	//204
		case THAI_CHARSET: {s13 = "11"; break;}		//222
		case EASTEUROPE_CHARSET: {s13 = "2"; break;}	//238
		}
	    }
	}
	SelectObject(hdc, hfo);
	DeleteObject(hf);
	ReleaseDC(0, hdc);
// printf("%s(%d): h=%d %d\n", FL, (int)lf->lfHeight, (int)tm.tmHeight);
//#endif

	WCharsToUtf8(s1, 256, lf->lfFaceName, pwclen(lf->lfFaceName), UC_force_ASCII);

	s2 = "medium";
	if (tm.tmWeight > FW_MEDIUM) s2 = "bold";
	s3 = "r";
	if (lf->lfItalic) s3 = "o";

#if HPIX13
	i6 = tm.tmHeight - tm.tmInternalLeading;
#else
	i6 = lf->lfHeight;
	if (i6 < 0) i6 = -i6;
	i6 = MulDiv(i6, 72, appXDat->LogPixel);
#endif
	i7 = i6 * 10;


	snprintf(buf, sizeof(buf), 
		"-*-%s-%s-%s-normal--%d-%d-*-*-*-*-%s-%s",
		s1,s2,s3,i6,i7,s12,s13);
 printf("%s(%d):    %s\n", FL, buf);

	if (ret_fontname) {
	    xfree(*ret_fontname);
	    *ret_fontname = GetFullFontName(buf);
 printf("%s(%d):    %s\n", FL, *ret_fontname);
	}
	return True;
}
