/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "dlg.h"
#include <errno.h>

int NetError_Dlg(TWins *owner, TglobPath *gp, int button, const char *bef, 
			TNetErrRet *ErrRet) {
  char *fn;
  int result;

	if (!(button & msgIcoERROR)) button |= msgIcoERROR;

	fn = get_DisplayFileStr(NULL, gp);
	if (ErrRet && ErrRet->sys_errno) {
	    errno = ErrRet->sys_errno;
	    result = MsgBox_Show_Error(owner, NULL, 
			button, msgCANCEL, EMSG_ERR1|EMSG_SYS, 
			"  %s \n %s\n", bef, fn);

	} else if (ErrRet && (ErrRet->err || ErrRet->const_err)) {
	    const char *tmp = ErrRet->const_err;
	    if (ErrRet->err) tmp = ErrRet->err;
	    result = MsgBox_Show_Error(owner, NULL, 
			button, msgCANCEL, EMSG_ERR1, 
			"  %s \n %s\n %s\n", bef, fn, tmp);

	} else {
	    result = MsgBox_Show_Error(owner, NULL, 
			button, msgCANCEL, EMSG_ERR1, 
			"  %s \n %s\n", bef, fn);
	}
	xfree(fn);
	return result;
}
