/*
 Copyright (C) 2010-2015 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "highl.h"

void highlight_ASMi386gcc(Thighlight *hl, TLines *tls, int edAnf, int edEnd, int fu);
void highlight_SetCaret_ASMi386gcc(Thighlight *hl, TLines *tls, int idx, int idy, int fu);

//*********************** highlight - C ******************************

const char *sDat_ASMi386gcc = 
"ret call jmp je jz jne jnz ja jnbe jae jnb jb jnae jbe jna jg jnle jge jnl jl jnge jle jng jc jnc jo jno js jns jpo jnp jpe jp jcxz jecxz loop loopz looppe loopnz loopne iret int into bound enter leave ";
const char *sDat_ASMi386gcc2 = 
"const int byte char word long dword quad short float single double static string string8 string16 string32 ascii asciz text";


const char C_zASMi386gcc[256] = {
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x22,0x23 ,0x00,0x00,0x00,0x27 ,0x00,0x00,0x10,0x00 ,0x00,0x00,0x00,0x10,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x00,0x3b ,0x00,0x00,0x00,0x00,

  0x00,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x00 ,0x5c,0x00,0x00,0x01,
  0x00,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x00 ,0x00,0x00,0x00,0x00,

  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,

  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00};

Thighlight *Thighlight_ASMi386gcc_Create(TWins *wins, TLines *tls) {
  Thighlight *hl;
	hl = Thighlight_Create(wins, tls);
	if (!hl) return NULL;

	hl_Set_keyword(hl, &hl->fc0_Dat, sDat_ASMi386gcc, FONT_Bold, 0x000000, wins->Color);
	hl_Set_keyword(hl, &hl->fc1_Dat, sDat_ASMi386gcc2, FONT_Medium, 0x800000, wins->Color);

	hl->ChangeLine = highlight_ASMi386gcc;
	hl->SetCaret = highlight_SetCaret_ASMi386gcc;
	hl->OldCaretX = -1;
	hl->OldCaretY = -1;
	return hl;
}

static bool Get_ASMi386gcc_STok(Thldat *hid, Tstoken *t) {
  unsigned char *s;
  int i;
  char m, c;

	s = t->s;
	if (!s || !*s) return False;
	t->mk &= ~smk_SCAN_MASK;
	if (hid->cs->s == (char*)s) {
	    t->mk |= smk_Char0;
	    while (*s && (*s != '.') && !C_zASMi386gcc[*s]) s++;
	    if ((*s == '.') && 
		(((s[1] >= 'a') && (s[1] <= 'z')) ||
		 ((s[1] >= 'A') && (s[1] <= 'Z')))) t->mk |= smk_Char0_mk1;
	}
	while (*s && !C_zASMi386gcc[*s]) s++;
	t->s = s;
	if (!*s) return False;
	i = 0;
	m = C_zASMi386gcc[*s];
	if (m == 0x10) {
	    while (*s && (m == C_zASMi386gcc[*s])) {
		c = *s;
		s++; i++;
		if ((c == '"') || (c == 0x27)) break;
		if (((c == '/') && (*s == '/')) ||
		    ((c == '/') && (*s == '*') && !(hid->mk & hl_comline)) ||
		    ((c == '*') && (*s == '/') && (hid->mk & hl_comline))) {
			if (i == 1){i++; s++; break;}
			if (i > 1) {i--; s--; break;}
		}
	    }
	} else {
	    if (*s) {s++; i++;}
	    if (m != '"')
		    while (*s && (m == C_zASMi386gcc[*s])) {s++; i++;}
	}
	t->next = s;
	t->lg = i;
	t->c = m;
	return True;
}

static bool findEnd_ASMi386gcc_comline(Thldat *hid) {
  Tstoken t;
	t.s = hid->t->next;
	t.next = hid->t->next;
	while (Get_ASMi386gcc_STok(hid, &t)) {
	    if ((t.c == 0x10) && (t.lg == 2)) {
		if ((t.s[0] == '*') && (t.s[1] == '/')) {
		    hid->t->lg = t.next - hid->t->s;
		    hid->t->next = t.next;
		    hid->mk &= ~hl_comline;
		    return True;
		}
	    }
	    t.s = t.next;
	}
	hid->t->lg = pclen((char*)hid->t->s);
	hid->t->next = t.next;
	return False;
}


static void hlSetLine_ASMi386gcc(Thldat *hid) {
  Tstoken t;
  int i, m;
  bool mk;

	t.mk = 0;
	xfree(hid->cs->c);
	hid->cs->c = NULL;
	hid->t = &t;
	t.s = (byte*)hid->cs->s;
	t.next = (byte*)hid->cs->s;
	if (hid->mk & hl_comline) {
	    mk = findEnd_ASMi386gcc_comline(hid);
	    add_scd_comment(hid, (char*)t.s, t.lg);
	    if (!mk) return;
	    t.s = t.next;
	} else if (hid->mk & hl_strline) {
	    add_scd_str(hid, &t);
	    t.s = t.next;
	} else if (hid->mk & hl_defline) {
	    add_scd_def(hid, &t);
	    t.s = t.next;
	}

	while (Get_ASMi386gcc_STok(hid, &t)) {
	    if (t.c == 0x10) {
		if (t.lg == 2) {
		    if ((t.s[0] == '/') && (t.s[1] == '/')) {
			t.lg = pclen((char*)t.s);
			add_scd_comment(hid, (char*)t.s, t.lg);
			break;
		    } else if ((t.s[0] == '/') && (t.s[1] == '*')) {
			hid->mk |= hl_comline;
			findEnd_ASMi386gcc_comline(hid);
			add_scd_comment(hid, (char*)t.s, t.lg);

		    } else if ((t.s[0] == '*') && (t.s[1] == '/')) {
			add_scd_comment(hid, (char*)t.s, t.lg);
			hid->mk &= ~hl_comline;
		    }
		} 
	    } else if (t.c == 0x01) {
		m = 0;
		if ((t.mk & smk_Char0_mk1) && !hl_keyword_scan(t.s, t.lg, hid->hl->fc1_Dat)) {
		    add_scd_def(hid, &t);

		} else if ((t.s[0] == '0') && (t.lg > 2) && (t.s[1] == 'x') && (zC_HEX[t.s[2]])) {
		    m = 1;
		    for (i=3; i<t.lg; i++) {
			if (!zC_HEX[t.s[i]]) {m = 0; break;}
		    }
		    if (m) add_scd_nr(hid, (char*)t.s, t.lg);
		} else if (zC_DIGIT[t.s[0]]) {
		    m = 1;
		    for (i=1; i<t.lg; i++) {
			if (!zC_DIGIT[t.s[i]]) {m = 0; break;}
		    }
		    if (m) add_scd_nr(hid, (char*)t.s, t.lg);
		}
		if (!m) {
		    if (t.lg > 1) {
			if ((t.mk & smk_Char0) && (t.s[t.lg] == ':')) {
			    t.lg++;
			    add_scd(hid->cs, (char*)t.s, t.lg, &hid->hl->fc0_Dat->fc, 0);
			} else if (!hl_keyword_c0(hid, hid->hl->fc0_Dat)) {
			    hl_keyword_c0(hid, hid->hl->fc1_Dat);
			}
		    }
		}

	    } else if (t.c == '"') {  //"
		add_scd_str(hid, &t);

	    } else if (t.c == ';') {
		if (t.mk & smk_Char0) {
		    t.lg = pclen((char*)t.s);
		    add_scd_comment(hid, (char*)t.s, t.lg);
		}

	    } else if (t.c == 0x23) {  //#
		if (t.mk & smk_Char0) add_scd_def(hid, &t);

	    } else if ((t.c == 0x27) && t.s[1]) {  //'
		if (t.s[2] == 0x27) {
		    t.lg = 3;
		    t.next += 2;
		    add_scd_char(hid, (char*)t.s, t.lg);
		} else if (t.s[1] == 0x5c && t.s[2] && t.s[3] == 0x27) {
		    t.lg = 4;
		    t.next += 3;
		    add_scd_char(hid, (char*)t.s, t.lg);
		}

//	    } else { //if (t.mk & smk_Char0) {
// printf("%s(%d): %d %s\n", FL, t.lg, (char*)t.s);
	    }
	    t.s = t.next;
	}
}

void highlight_ASMi386gcc(Thighlight *hl, TLines *tls, int edAnf, int edEnd, int fu) {
  int i;
  Thldat hld;

	hld.hl = hl;
	hld.mk = 0;

	if (fu & clfu_use_yaye) {
	    if (edAnf > 0) {
		hld.cs = tls->lines->cs[edAnf-1];
		hld.mk = hld.cs->hl_mk;
	    }
	    if (edEnd >= tls->Count) edEnd = tls->Count-1;
	    for (i=edAnf; i<=edEnd; i++) {
		hld.cs = tls->lines->cs[i];
		hlSetLine_ASMi386gcc(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }

	    for (; i<tls->Count; i++) {
		hld.cs = tls->lines->cs[i];
		if (hld.mk == hld.cs->hl_mk) break;
		hld.cs = tls->lines->cs[i];
		hlSetLine_ASMi386gcc(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }
	    if (i < tls->Count) {
		hld.cs = tls->lines->cs[i];
		hlSetLine_ASMi386gcc(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }
	} else {
	    for (i=0; i<tls->Count; i++) {
		hld.cs = tls->lines->cs[i];
		hlSetLine_ASMi386gcc(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }
	}
}

static bool hl_comCharAnf_ASMi386gcc(char *pc) {
	return ((*pc == '/') && ((pc[1] == '/') || (pc[1] == '*')));
}

void highlight_SetCaret_ASMi386gcc(Thighlight *hl, TLines *tls, int idx, int idy, int fu) {
  TLineEdit *le = (TLineEdit*)hl->wins;
  TColS *cs;
  int x, xe, y, h, count = 1, maxy=1000;
  int res_x = -1, res_y = -1;
  char c, cpc;
  char *pc;

	if (!fu) goto NoSelChar;
	if (!hl && !hl->wins) goto NoSelChar;
	if (hl->wins->wtyp != wtyp_LineEdit) goto NoSelChar;

	cs = TLines_Get_pcs(tls, idy);
	if (!cs || !cs->s) goto NoSelChar;
	if (idx >= cs->lg) goto NoSelChar;
	if (cs->hl_mk & hl_comline) goto NoSelChar;
	pc = &cs->s[idx];
	c = *pc;
	if ((c == '(') || (c == '{')) {
	    cpc = ')';
	    if (c == '{') cpc = '}';
	    pc++;
loop_v:
	    while (*pc && !hl_comCharAnf_ASMi386gcc(pc) && count) {
		if (*pc == cpc) count--; else if (*pc == c) count++;
		if (count) pc++;
	    }
loop_vs0:
	    maxy--;
	    if (!maxy) goto NoSelChar;
	    if (count) {
		idy++;
		cs = TLines_Get_pcs(tls, idy);
		if (!cs) goto NoSelChar;
		if (!cs->s) goto loop_vs0;
		if (cs->hl_mk & hl_comline) goto loop_vs0;
		pc = cs->s;
		goto loop_v;
	    }

	    if ((*pc == ')') || (*pc == '}')) {
		idx = pc - cs->s;
	    }
	}else if ((c == ')') || (c == '}')) {
	    cpc = '(';
	    if (c == '}') cpc = '{';
loop_r:
	    if (idx) {pc--; idx--;}
	    while (idx && count) {
		if (*pc == cpc) count--; else if (*pc == c) count++;
		if (count) {pc--; idx--;}
	    }
loop_rs0:
	    maxy--;
	    if (!maxy) goto NoSelChar;
	    if (count) {
		idy--;
		cs = TLines_Get_pcs(tls, idy);
		if (!cs) goto NoSelChar;
		if (!cs->s) goto loop_rs0;
		if (cs->hl_mk & hl_comline) goto loop_rs0;
		idx = 0;
		pc = cs->s;
		while (*pc && !hl_comCharAnf_ASMi386gcc(pc)) {pc++; idx++;}
		goto loop_r;
	    }
	}

	if (!count) {
	    TLineEdit_GetChar_xy(le, idx, idy, &x, &y, &h);
	    TLineEdit_GetChar_xy(le, idx+1, idy, &xe, &y, &h);
	    if ((x >= 0) && (xe >= 0) && (x < xe) && (y >= 0)){
		y += h - 2;
		DrawRectRGB(le->WinID, 0x000000, x, y, xe-x, 2);
	    }
	}

NoSelChar:
	hl->OldCaretX = res_x;
	hl->OldCaretY = res_y;
	return;
}

