/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "highl.h"

//*********************** highlight - C ******************************
static const char *sDat_C = 
"do if for case else goto true True TRUE break false False FALSE union while \
extern inline return sizeof struct switch default typedef continue ";
static const char *sDat_C2 = 
"int bool byte char long void word const dword float short xchar double \
signed static register unsigned size_t \
int8_t int16_t int32_t int64_t uint8_t uint16_t uint32_t uint64_t";

static const char *sDat_CXX = 
"do if for case else goto true True break false False union while \
extern inline return sizeof struct switch default typedef continue \
new private protected public ";
static const char *sDat_CXX2 = 
"int bool byte char long void word const dword float short double \
signed static register unsigned class size_t \
int8_t int16_t int32_t int64_t uint8_t uint16_t uint32_t uint64_t";

static const char C_zC[256] = {
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x22,0x23 ,0x00,0x00,0x00,0x27 ,0x00,0x00,0x10,0x00 ,0x00,0x00,0x00,0x10,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x00,0x00 ,0x00,0x00,0x00,0x00,

  0x00,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x00 ,0x5c,0x00,0x00,0x01,
  0x00,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x00 ,0x00,0x00,0x00,0x00,

  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,

  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00};

Thighlight *Thighlight_C_Create(TWins *wins, TLines *tls) {
  Thighlight *hl;
	hl = Thighlight_Create(wins, tls);
	if (!hl) return NULL;

	hl_Set_keyword(hl, &hl->fc0_Dat, sDat_C, FONT_Bold, 0x000000, wins->Color);
	hl_Set_keyword(hl, &hl->fc1_Dat, sDat_C2, FONT_Medium, 0x800000, wins->Color);

	hl->ChangeLine = highlight_C;
	hl->SetCaret = highlight_SetCaret_C;
	hl->OldCaretX = -1;
	hl->OldCaretY = -1;
	return hl;
}

Thighlight *Thighlight_CXX_Create(TWins *wins, TLines *tls) {
  Thighlight *hl;
	hl = Thighlight_Create(wins, tls);
	if (!hl) return NULL;

	hl_Set_keyword(hl, &hl->fc0_Dat, sDat_CXX, FONT_Bold, 0x000000, wins->Color);
	hl_Set_keyword(hl, &hl->fc1_Dat, sDat_CXX2, FONT_Medium, 0x800000, wins->Color);

	hl->ChangeLine = highlight_C;
	hl->SetCaret = highlight_SetCaret_C;
	hl->OldCaretX = -1;
	hl->OldCaretY = -1;
	return hl;
}

static bool Get_C_STok(Thldat *hid, Tstoken *t) {
  byte *s = t->s;
  int i;
  dword m;
	if (!s || !*s) return False;
	while (*s && !C_zC[*s]) s++;
	t->s = s;
	if (!*s) return False;
	i = 0;
	m = C_zC[*s];
	if (m == 0x10) {
	    while (*s && (m == C_zC[*s])) {
		dword c = *s;
		s++; i++;
		if ((c == '"') || (c == 0x27)) break;
		if (((c == '/') && (*s == '/')) ||
		    ((c == '/') && (*s == '*') && !(hid->mk & hl_comline)) ||
		    ((c == '*') && (*s == '/') &&  (hid->mk & hl_comline))) {
			if (i == 1){i++; s++; break;}
			if (i > 1) {i--; s--; break;}
		}
	    }
	} else {
	    if (*s) {s++; i++;}
	    if (m != '"') while (*s && (m == (C_zC[*s]))) {s++; i++;}
	}
	t->next = s;
	t->lg = i;
	t->c = m;
	return True;
}

static bool findEnd_C_comline(Thldat *hid) {
  Tstoken t;
	t.s = hid->t->next;
	t.next = hid->t->next;
	while (Get_C_STok(hid, &t)) {
	    if ((t.c == 0x10) && (t.lg == 2)) {
		if ((t.s[0] == '*') && (t.s[1] == '/')) {
		    hid->t->lg = t.next - hid->t->s;
		    hid->t->next = t.next;
		    hid->mk &= ~hl_comline;
		    return True;
		}
	    }
	    t.s = t.next;
	}
	hid->t->lg = pclen((char*)hid->t->s);
	hid->t->next = t.next;
	return False;
}


static void hlSetLine_C(Thldat *hid) {
  Tstoken t;
  int i, m;
  bool mk;

	xfree(hid->cs->c);
	hid->cs->c = NULL;
	hid->t = &t;
	t.s = (byte*)hid->cs->s;
	t.next = (byte*)hid->cs->s;
	if (hid->mk & hl_comline) {
	    mk = findEnd_C_comline(hid);
	    add_scd_comment(hid, (char*)t.s, t.lg);
	    if (!mk) return;
	    t.s = t.next;
	} else if (hid->mk & hl_strline) {
	    add_scd_str(hid, &t);
	    t.s = t.next;
	} else if (hid->mk & hl_defline) {
	    add_scd_def(hid, &t);
	    t.s = t.next;
	}

	while (Get_C_STok(hid, &t)) {
	    if (t.c == 0x10) {
		if (t.lg == 2) {
		    if ((t.s[0] == '/') && (t.s[1] == '/')) {
			t.lg = pclen((char*)t.s);
			add_scd_comment(hid, (char*)t.s, t.lg);
			break;
		    } else if ((t.s[0] == '/') && (t.s[1] == '*')) {
			hid->mk |= hl_comline;
			findEnd_C_comline(hid);
			add_scd_comment(hid, (char*)t.s, t.lg);

		    } else if ((t.s[0] == '*') && (t.s[1] == '/')) {
			add_scd_comment(hid, (char*)t.s, t.lg);
			hid->mk &= ~hl_comline;
		    }
		} 
	    } else if (t.c == 0x01) {
		m = 0;
		if ((t.s[0] == '0') && (t.lg > 2) && (t.s[1] == 'x') && (zC_HEX[t.s[2]])) {
		    m = 1;
		    for (i=3; i<t.lg; i++) {
			if (!zC_HEX[t.s[i]]) {m = 0; break;}
		    }
		    if (m) add_scd_nr(hid, (char*)t.s, t.lg);
		} else if (zC_DIGIT[t.s[0]]) {
		    m = 1;
		    for (i=1; i<t.lg; i++) {
			if (!zC_DIGIT[t.s[i]]) {m = 0; break;}
		    }
		    if (m) add_scd_nr(hid, (char*)t.s, t.lg);
		}
		if (!m) {
		    if (t.lg > 1) {
			if (!hl_keyword_c0(hid, hid->hl->fc0_Dat))
				hl_keyword_c0(hid, hid->hl->fc1_Dat);
		    }
		}

	    } else if (t.c == '"') {  //"
		add_scd_str(hid, &t);

	    } else if (t.c == 0x23) {  //#
		add_scd_def(hid, &t);

	    } else if ((t.c == 0x27) && t.s[1]) {  //'
		if (t.s[2] == 0x27) {
		    t.lg = 3;
		    t.next += 2;
		    add_scd_char(hid, (char*)t.s, t.lg);
		} else if (t.s[1] == 0x5c && t.s[2] && t.s[3] == 0x27) {
		    t.lg = 4;
		    t.next += 3;
		    add_scd_char(hid, (char*)t.s, t.lg);
		}
	    }
	    t.s = t.next;
	}
}

void highlight_C(Thighlight *hl, TLines *tls, int edAnf, int edEnd, int fu) {
  int i;
  Thldat hld;

	hld.hl = hl;
	hld.mk = 0;

	if (fu & clfu_use_yaye) {
	    if (edAnf > 0) {
		hld.cs = tls->lines->cs[edAnf-1];
		hld.mk = hld.cs->hl_mk;
	    }
	    if (edEnd >= tls->Count) edEnd = tls->Count-1;
	    for (i=edAnf; i<=edEnd; i++) {
		hld.cs = tls->lines->cs[i];
		hlSetLine_C(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }

	    for (; i<tls->Count; i++) {
		hld.cs = tls->lines->cs[i];
		if (hld.mk == hld.cs->hl_mk) break;
		hld.cs = tls->lines->cs[i];
		hlSetLine_C(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }
	    if (i < tls->Count) {
		hld.cs = tls->lines->cs[i];
		hlSetLine_C(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }
	} else {
	    for (i=0; i<tls->Count; i++) {
		hld.cs = tls->lines->cs[i];
		hlSetLine_C(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }
	}
}

static bool hl_comCharAnf_C(char *pc) {
	return ((*pc == '/') && ((pc[1] == '/') || (pc[1] == '*')));
}

void highlight_SetCaret_C(Thighlight *hl, TLines *tls, int idx, int idy, int fu) {
  TLineEdit *le = (TLineEdit*)hl->wins;
  TColS *cs;
  int x, xe, y, h, m, count = 1, maxy=1000;
  int txz = 0, res_x = -1, res_y = -1;
  char c, cpc, ct;
  char *pc;

	if (!fu) goto NoSelChar;
	if (!hl && !hl->wins) goto NoSelChar;
	if (hl->wins->wtyp != wtyp_LineEdit) goto NoSelChar;

	cs = TLines_Get_pcs(tls, idy);
	if (!cs || !cs->s) goto NoSelChar;
	if (idx > cs->lg) goto NoSelChar;
	if (cs->hl_mk & hl_comline) goto NoSelChar;
	pc = &cs->s[idx];

	x = 0;
	if ((*pc == '(') || (*pc == '{')) {
	    x = 1;
	} else if ((*pc == ')') || (*pc == '}')) {
	    x = 2;
	} else if (idx && ((pc[-1] == '(') || (pc[-1] == '{'))) {
	    pc--; idx--;
	    x = 1;
	} else if (idx && ((pc[-1] == ')') || (pc[-1] == '}'))) {
	    pc--; idx--;
	    x = 2;
	}

	c = *pc;
	ct = 0;
	if (x == 1) {
	    cpc = ')';
	    if (c == '{') cpc = '}';
	    pc++;
loop_v:
	    while (*pc && count) {
	        if (txz) {
		    if (ct == *pc) txz--;
		} else if ((*pc == 0x27) || (*pc == '\"')) {
		    ct = *pc;
		    txz++;
		} else if (hl_comCharAnf_C(pc)) goto loop_vs0;

	        if (!txz) {
		    if (*pc == cpc) count--; else if (*pc == c) count++;
		}
		if (count) pc++;
	    }
loop_vs0:
	    maxy--;
	    if (!maxy) goto NoSelChar;
	    if (count) {
		idy++;
		cs = TLines_Get_pcs(tls, idy);
		if (!cs) goto NoSelChar;
		if (!cs->s) goto loop_vs0;
		if (cs->hl_mk & hl_comline) goto loop_vs0;
		pc = cs->s;
		goto loop_v;
	    }
	    idx = pc - cs->s;

	} else if (x == 2) {
	    cpc = '(';
	    if (c == '}') cpc = '{';
loop_r:
	    if (idx) {pc--; idx--;}
	    while (idx && count) {
	        if (txz) {
		    if (ct == *pc) txz--;
		} else if ((*pc == 0x27) || (*pc == '\"')) {
		    ct = *pc;
		    txz++;
		}
	        if (!txz) {
		    if (*pc == cpc) count--; else if (*pc == c) count++;
		}

		if (count) {pc--; idx--;}
	    }
loop_rs0:
	    maxy--;
	    if (!maxy) goto NoSelChar;
	    if (count) {
		idy--;
		cs = TLines_Get_pcs(tls, idy);
		if (!cs) goto NoSelChar;
		if (!cs->s) goto loop_rs0;
		if (cs->hl_mk & hl_comline) goto loop_rs0;
		idx = 0;
		pc = cs->s;
		m = 0;
		while (*pc) {
	          if (m) {
		    if (ct == *pc) m--;
		  } else if ((*pc == 0x27) || (*pc == '\"')) {
		    ct = *pc;
		    m++;
		  }
		  if (!m && hl_comCharAnf_C(pc)) break;
		  pc++; idx++;
		}
		goto loop_r;
	    }
	}

	if (!count) {
	    TLineEdit_GetChar_xy(le, idx, idy, &x, &y, &h);
	    TLineEdit_GetChar_xy(le, idx+1, idy, &xe, &y, &h);
	    if ((x >= 0) && (x < xe)){
		y += h - 2;
		DrawRectRGB(le->WinID, 0x000000, x, y, xe-x, 2);
	    }
	}

NoSelChar:
	hl->OldCaretX = res_x;
	hl->OldCaretY = res_y;
	return;
}

