/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "tfilewin.h"

bool TFileWin_Get_dfl_by_name(TFileWin *self, const char *fn, \
			int *ret_idx, TDirFileList **ret_dfl) {
  const char *cpc;
  TDirFileList *dfl;
  int idx;

	if (!self || !fn || !*fn) return False;
	dfl = TFileWin_Get_dfl0(self);
	if (!dfl) return False;
	cpc = GetFileName_pc(fn);
	if (!cpc || !*cpc) return False;

	idx = 0;
	while (dfl) {
#ifdef _OS_WIN32
	    if (!pccasecmpASCII(dfl->fn, cpc)) break;
#else
	    if (pccmp(dfl->fn, cpc)) break;
#endif
	    dfl = dfl->next;
	    idx++;
	}

	if (!dfl) return False;
	if (ret_idx) *ret_idx = idx;
	if (ret_dfl) *ret_dfl = dfl;
	return True;
}
