/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "tfilewin.h"

void TFileWin_ini_RD(TFileWin *self, TpcIni *pcIni, const char *Gruppe) {
  bool mk;
	if (!self || !pcIni || !Gruppe) return;

	self->FDL_Def.Az0_ItemE_Dbl = TpcIni_RD_boolean(pcIni, Gruppe, "Az0_FileDblClick", False);
	self->FDL_Def.Az0_PathE_Dbl = TpcIni_RD_boolean(pcIni, Gruppe, "Az0_PathDblClick", False);
	self->FDL_Def.Az1_ItemE_Dbl = TpcIni_RD_boolean(pcIni, Gruppe, "Az1_FileDblClick", True);
	self->FDL_Def.Az1_PathE_Dbl = TpcIni_RD_boolean(pcIni, Gruppe, "Az1_PathDblClick", False);

#ifdef _OS_WIN32
	mk = TpcIni_RD_boolean(pcIni, Gruppe, "CaseSort", True);
#else
	mk = TpcIni_RD_boolean(pcIni, Gruppe, "CaseSort", False);
#endif
	if (mk) self->sortFu |= dlsortFu_Case;
}

void TFileWin_ini_WR(TFileWin *self, TpcIni *pcIni, const char *Gruppe) {
	if (!self || !pcIni || !Gruppe) return;

	if ((self->AzArt & 0xff) == 0) {
	    self->FDL_Def.Az0_ItemE_Dbl = self->DblClick_ItemEnter;
	    self->FDL_Def.Az0_PathE_Dbl = self->DblClick_PathEnter;
	} else {
	    self->FDL_Def.Az1_ItemE_Dbl = self->DblClick_ItemEnter;
	    self->FDL_Def.Az1_PathE_Dbl = self->DblClick_PathEnter;
	}

	TpcIni_WR_boolean(pcIni, Gruppe, "Az0_FileDblClick", self->FDL_Def.Az0_ItemE_Dbl);
	TpcIni_WR_boolean(pcIni, Gruppe, "Az0_PathDblClick", self->FDL_Def.Az0_PathE_Dbl);
	TpcIni_WR_boolean(pcIni, Gruppe, "Az1_FileDblClick", self->FDL_Def.Az1_ItemE_Dbl);
	TpcIni_WR_boolean(pcIni, Gruppe, "Az1_PathDblClick", self->FDL_Def.Az1_PathE_Dbl);

	TpcIni_WR_boolean(pcIni, Gruppe, "CaseSort", (self->sortFu & dlsortFu_Case) != 0);
}

void TFileWin_ini_RD_ColD(TFileWin *self, TpcIni *pcIni, const char *Gruppe) {
  int idx;
  TFDL_ColD ColD;
  char buf[40];

	if (!self || !pcIni || !Gruppe) return;
	idx = 0;
	while (TFileWin_GetColsData(self, idx, &ColD)) {
	    snprintf(buf, sizeof(buf), "fwcol%d_size", ColD.art);
	    ColD.Width = TpcIni_RD_int(pcIni, Gruppe, buf, ColD.Width);
	    snprintf(buf, sizeof(buf), "fwcol%d_fu", ColD.art);
	    ColD.fu = TpcIni_RD_int(pcIni, Gruppe, buf, ColD.fu);
	    TFileWin_SetColsData(self, idx, &ColD);
	    idx++;
	}
}

void TFileWin_ini_WR_ColD(TFileWin *self, TpcIni *pcIni, const char *Gruppe) {
  int idx;
  TFDL_ColD ColD;
  char buf[40];

	if (!self || !pcIni || !Gruppe) return;
	idx = 0;
	while (TFileWin_GetColsData(self, idx, &ColD)) {
	    snprintf(buf, sizeof(buf), "fwcol%d_size", ColD.art);
	    TpcIni_WR_int(pcIni, Gruppe, buf, ColD.Width);
	    snprintf(buf, sizeof(buf), "fwcol%d_fu", ColD.art);
	    TpcIni_WR_int(pcIni, Gruppe, buf, ColD.fu);
	    idx++;
	}
}
