/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldconsole.h"
#include "tsearch.h"

bool chk_sh_slave(TFormAHconsole *fmain, TPidStat **PidStat) {
  TSearch_Rec *sr;
  char *pc0, *pc;
  const char *fn;
  FILE *F;
  TPidStat *pidst;
  int pid, ppid, bits;
  bool run, Ok;
  char buf[32];
  char line[256];
  char name[256];

	if (PidStat) *PidStat = NULL;
	pc0 = buf;
	ppcmove(&pc0, "/proc/");

	Ok = False;
	sr = TSearch_Create(buf, findDIR | findIsRootPath, 0);
	run = Find_First(sr);
	while (run && !Ok) {
	    fn = Get_ExFileDat_pc(sr->st, exfdt_FileName);
	    if ((*fn >= '0') && (*fn <= '9')) {
		pc = pc0;
		ppcmove_k(&pc, fn, kSLASH_ADD);
		ppcmove(&pc, "status");
		F = fopen(buf, "r");
		if (F) {
		    pid = ppid = 0;
		    bits = 0x0019;
		    name[0] = 0;
loop:
		    pc = fgets(line, sizeof(line), F);
		    if (pcncmp(pc, "Name:", 5)) {
			pc += 5;
			while (*pc && ((byte)*pc <= 0x20)) pc++;
			char *pcn = name;
			while (*pc && ((byte)*pc >= 0x20)) {
			    *pcn = *pc;
			    pc++; pcn++;
			}
			*pcn = 0;
			bits &= ~0x0001;

		    } else if (pcncmp(pc, "Pid:", 4)) {
			pc += 4;
			pid = pctoint(pc);
			bits &= ~0x0008;

		    } else if (pcncmp(pc, "PPid:", 5)) {
			pc += 5;
			ppid = pctoint(pc);
			bits &= ~0x0010;
		    }
		    if (bits) goto loop;

		    Ok = fmain->pty->TermPid == ppid;
		    if (Ok && PidStat) {
			pidst = xcalloc(sizeof(TPidStat));
			pidst->name = pcdup(name);
			pidst->pid = pid;
			pidst->ppid = ppid;
			*PidStat = pidst;
		    }
		    fclose(F);
		}
	    }
	    run = Find_Next(sr);
	}

	Tfree(sr);
	return Ok;
}
