/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

// #define USE_PRINT_DLG 1

#include "appXbase.h"
#include "dlg.h"
#include "tpixmap.h"
#include "tlineedit.h"

#ifdef _OS_WIN32

#include "zsrc.h"

#ifdef DRAG_AND_DROP
#undef DRAG_AND_DROP
#endif

#ifdef Test_Root_WinId
#undef Test_Root_WinId
#endif

#endif /* _OS_WIN32 */

#define APPNAME "aldedit"

extern const int build_v;
extern const char *build_date;
extern const char *Help_Msg;

#define TCSelf TFormEdit
typedef struct TFormEdit {
  AlgTForm
  TWins *PanelTop;
  TWins *PanelBottom;

// ******* PanelTop *******
  TMenuButton *mbFile;
    TMenu *menuFile;
    TMenuItem *miClosePage;
    TMenuItem *miChangePage;

    TMenu *menuReopen;

    TMenuItem *miSave;
    TMenuItem *miSaveProj;
    TMenuItem *miSaveAsProj;
    TMenuItem *miSaveSize;

  TMenuButton *mbEdit;
    TMenu *menuEdit;

  TMenuButton *mbTools;
    TMenu *menuTools;

  TMenuButton *mbSetting;
    TMenu *menuSetting;
    TMenu *menuHighlight;
    TMenu *menuEOL;
      TMenuItem *miEOL_unix;
      TMenuItem *miEOL_windos;
      TMenuItem *miEOL_Strg_C_Korr;
#ifndef _OS_WIN32
    TMenu *menuClipbord;
#endif /* _OS_WIN32 */
    TMenu *menuFont;
    TMenuItem *miUTF8;
    TMenu *menuBOM;
    TMenu *menuLineOff;
    TMenu *menuConvert;
    TMenuItem *miChkReload;

  TMenuButton *mbHelp;
    TMenu *menuHelp;
  TMenuButton *mbSave;
  TMenuButton *mbRedo;
  TMenuButton *mbUndo;

// ******* Menu *******

  TMenu *menuLE;
    TMenuItem *miLESave;




// ******* PanelEdit *******

  TLineEdit *AktLE;

  TPageControl *PageControl;
  TButton *buNextPage;
  TButton *buPrevPage;

// ******* PanelBottom *******
  TWins *CursPosBox;
  TWins *SBVPosBox;
  TWins *CharAzBox;
  TProgressBar *ProgressBar;
  TWins *kpsBox;

  int argv_fileIdx;
  TgTimer *LdWrTimer;
  TFile_Dlg *File_Dlg;
  TFile_Dlg *FileSave_Dlg;
  TFind_Dlg *Find_Dlg;
  TReplace_Dlg *Replace_Dlg;

  int LineOffset;

  int LCount;
  int us_mk;
  long long mkDataNowSize;

  char *ProjFile;
  char *ProjPath;
  TpcIni *ProjFileIni;

  Tlgs Replace_lgs;
  char *Find_S;


  bool IO_Run;
  bool MsgBox_Reload_Run;
  bool File_Dlg_Run;
  bool Help_Info_Run;
  bool Help_cmd_Run;

  bool EditFind_run;
  bool mEdit_Find_run;
  bool EditReplace_run;
  bool mEdit_Replace_run;

} TFormEdit;
#undef TCSelf

typedef struct {
  int x, y;
  int vsb_count;
} TRestoreCaret;

extern bool ChkAllFileSaved(TFormEdit *fed);
extern void Chk_LE_Reload(TFormEdit *fed, TLineEdit *le);

extern void Add_Page(TFormEdit *fed, char *fn, const char *Caption);
extern int ChkFileIsSaved(TLineEdit *le);
extern void mFile_FileSave_Dlg_Init(TFormEdit *fed);
extern void File_Save(TFormEdit *fed);
extern void FileSaveAs(TLineEdit *le);
extern void LoadFile(TFormEdit *fed, TLineEdit *le, char *pfn, int fu, TRestoreCaret *rsc);
extern void File_SaveProj(TFormEdit *fed, int fu);

extern void StoreCaret(TLineEdit *le, TRestoreCaret *rsc);
extern void RestoreCaret(TLineEdit *le, TRestoreCaret *rsc);

/* ----------------- Menu File -------------------- */
#define REOPEN_ITEMS 10

extern void MenuFile_Create(TFormEdit *fed, bool use_pages);

extern void mFile_ClosePage(TMenu *self, long KeyState, TMenuItem *smi);
extern void mFile_ChangePage(TMenu *self, long KeyState, TMenuItem *smi);
extern void mFile_Open(TMenu *self, long KeyState, TMenuItem *smi);
extern void mFile_Save(TMenu *self, long KeyState, TMenuItem *smi);
extern void mFile_SaveAs(TMenu *self, long KeyState, TMenuItem *smi);

/* ----------------- Menu Tools ------------------- */
extern void MenuTools_Create(TFormEdit *fed);

/* ----------------- Menu Setting ----------------- */
extern void MenuSetting_Create(TFormEdit *fed);
extern void UpdateSettingMenu(TFormEdit *fed);
extern void Set_highlight(TFormEdit *fed, TLineEdit *le, int stft, int sub_mime);

/* ----------------- Menu Edit _------------------- */
extern void MenuEdit_Create(TFormEdit *fed);
extern void MenuEditLE_Create(TFormEdit *fed, bool use_pages);
extern void EditFind(TFormEdit *fed);
extern void TFormEdit_Find(TFormEdit *fed);

/* ----------------- Menu Help -------------------- */
extern void MenuHelp_Create(TFormEdit *fed);

/* ----------------- Menu Save -------------------- */
extern void MenuSave_Create(TFormEdit *fed);

/* ----------------- Menu UnRedo ------------------ */
extern void MenuUnRedo_Create(TFormEdit *fed);
extern void Chk_UnRedo(TFormEdit *fed);

#ifdef _OS_WIN32
extern const ThZsrc hZsrc_aldedit16_png;
extern const ThZsrc hZsrc_aldedit32_png;
extern const ThZsrc hZsrc_aldedit_desktop;
extern const ThZsrc hZsrc_aldeditpage_desktop;
#endif
