/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldedit.h"
#include "cicons.h"

void Chk_UnRedo(TFormEdit *fed) {
  bool mkundo, mkredo;
	TUnRedo_GetStat(fed->AktLE->UnRedo, &mkundo, &mkredo);
	SetEnabled((TWins*)fed->mbUndo, mkundo);
	SetEnabled((TWins*)fed->mbRedo, mkredo);
}

static void mbUndo_OnClick(TMenuButton *self, long KeyState, bool DblClick) {
  TFormEdit *fed = (TFormEdit*)self->FormStruct;
  TUnRedoLine *url = TUnRedo_GetUndo(fed->AktLE->UnRedo);
	if (url) {
	    if (!TLineEdit_Undo(fed->AktLE, url)) {
		TUnRedo_Undo_Old(fed->AktLE->UnRedo);
	    }
	}
	Chk_UnRedo(fed);
}

static void mbRedo_OnClick(TMenuButton *self, long KeyState, bool DblClick) {
  TFormEdit *fed = (TFormEdit*)self->FormStruct;
  TUnRedoLine *url = TUnRedo_GetRedo(fed->AktLE->UnRedo);
	if (url) {
	    if (!TLineEdit_Redo(fed->AktLE, url)) {
		TUnRedo_Redo_Old(fed->AktLE->UnRedo);
	    }
	}
	Chk_UnRedo(fed);
}

/* ______________________ Create _____________________________________ */
void MenuUnRedo_Create(TFormEdit *fed) {
// ******* Menu Undo *******
	fed->mbUndo = TMenuButton_Create(fed->PanelTop, fed->mbFile);
	fed->mbUndo->Enabled = False;
	fed->mbUndo->pic = get_pic16_undo(False);
	fed->mbUndo->dis_pic = get_pic16_undo(True);
	fed->mbUndo->OnClick = mbUndo_OnClick;
	Set_Parent((TWins*)fed->mbUndo, fed->PanelTop);

// ******* Menu Redo *******
	fed->mbRedo = TMenuButton_Create(fed->PanelTop, fed->mbFile);
	fed->mbRedo->Enabled = False;
	fed->mbRedo->pic = get_pic16_redo(False);
	fed->mbRedo->dis_pic = get_pic16_redo(True);
	fed->mbRedo->OnClick = mbRedo_OnClick;
	Set_Parent((TWins*)fed->mbRedo, fed->PanelTop);

}
