/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldesk.h"

static Tnymo_wd mount_wd;


static void RefreshDeskIcon() {
  TFSDevice_info *fs_info;
  TDesktopIcon *wmdi;
  const char *tpc;

	wmdi = (TDesktopIcon*)wmRoot->next_child;
	while (wmdi) {
	  if (wmdi->wtyp == wtyp_TwmDeskIcon) {
	    if (wmdi->ddkt == ddkt_FSDevice) {
		TPic *pic = wmdi->pic;
		tpc = wmdi->s2;
		if (!(wmdi->difs & (DIFS_NFS|DIFS_CIFS))) {
		    tpc = GetFileName_pc(tpc);
		}

		fs_info = get_fs_info(tpc);
		if (fs_info && (fs_info->stat & FSINFO_AZ_OK) && !(fs_info->stat & FSINFO_HIDE)) {
		    pic = wmdi->pic3;
		    if (fs_info->stat & FSINFO_MOUNT) pic = wmdi->pic2;
		} else {
		    pic = wmdi->pic4;
		}
		if (pic && (wmdi->pic != pic)) {
		    wmdi->pic = pic;
		    Refresh((TWins*)wmdi);
		}
	    }
	  }
	  wmdi = (TDesktopIcon*)wmdi->next;
	}
}

static void NotifyMountEv(Tnymo_wd wd, TNotifyMount_data *ny_data) {
  TFSDevice_info *fs_info = NULL;


	if (pcncmp(ny_data->mnt_fsname, "/dev/", 5)) {
	    fs_info = get_fs_info(&ny_data->mnt_fsname[5]);
	} else if (pccmp(ny_data->mnt_type, "nfs") ||
		   pccmp(ny_data->mnt_type, "nfs4") ||
		   pccmp(ny_data->mnt_type, "cifs")) {
	    fs_info = get_fs_info(ny_data->mnt_fsname);
	    if (fs_info) pcmove(((TNFSDevice_info*)fs_info)->dev, ny_data->mnt_fsname);
	}

	if (fs_info) {
	    if (ny_data->bef == nymobef_mount) fs_info->stat |= FSINFO_MOUNT; 
	    if (ny_data->bef == nymobef_umount) fs_info->stat &= ~FSINFO_MOUNT; 
	    RefreshDeskIcon();
	}
}

void TwmRoot_AzMount(TgTimer *gti) {

#if USE_PROC_PART
	Timer_AutoFsDev_proc_part();
#endif

	if (!mount_wd) {
	    mount_wd = TNotifyMount_Create(NULL, NotifyMountEv);
	    TNotifyMount_Replay(mount_wd);
	}

	RefreshDeskIcon();
}
