/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appXbase.h"
#include "buildin_app.h"
#include "tlineedit.h"
#include <unistd.h>

typedef struct TwmDebugWinForm {
  int wtyp;
  TForm *FormMain;
  TLineEdit *LineEdit;
} TwmDebugWinForm;

static void TwmDebugWin_PipeProc(int fd, Tfd_list *fdl) {
  int lg, lineNr, charPos;
  char line[BUFSIZ];
  TwmDebugWinForm *form;
  TLineEdit *le;

	lg = read(fd, line, BUFSIZ);
	if (lg > 0) {
	    line[lg] = 0;
	    form = fdl->obj;
	    if (!form) return;
	    le = form->LineEdit;
	    lineNr = le->tls->Count;
	    charPos = 0;
	    TLines_Paste(le->tls, &lineNr, &charPos, line);
	    TLineEdit_SetCaretXY(le, charPos, lineNr);
	    Refresh((TWins*)le);
	}
}

#ifdef STANDALONE_BUILDIN
int main (int argc, char **argv) {
#else
int bi_wmDebugWin_main (int argc, char **argv) {
#endif
  int i;
  char *pc;
  TwmDebugWinForm form;

	FillChar0((char*)&form, sizeof(TwmDebugWinForm));

#ifdef Test_Root_WinId
	for (i=1; i<argc; i++) {
	    pc = argv[i];
	    if (*pc == '-') {
		pc++;
		if (*pc == '-') {
		    pc++;
		    if (pcncmp(pc, "TestRootWinID", 13)) {
			i++;
			pc = argv[i];
			if (pc && *pc != '-') {
				TestRootWinId = pctoint(pc);
			}
		    }
		}
	    }
	}
#endif


	initXapp(0, argc, argv);

	AddPipeProc(0, InPipe, TwmDebugWin_PipeProc, &form);


	form.wtyp = wtyp_USER_Form;

	form.FormMain =  TForm_Create(NULL);
	form.FormMain->subClass = &form;
	SetCaption((TWins*)form.FormMain, "wmDebugWin");
	form.FormMain->min_width = 220;
	form.FormMain->min_height = 100;
	form.FormMain->max_width = 800;
	form.FormMain->max_height = 600;
	SetRC((TWins*)form.FormMain, 0, 0, 560, 300);
	form.FormMain->FormPosition = poDesigned;
//	((TForm*)form.FormMain)->FormPosition = poDefault;
	form.FormMain->Gravity = NorthEastGravity;

	TLineEdit_AddKeyDownPlugIn(NULL, TLineEdit_keyplugin_edit_Create());
	form.LineEdit = TLineEdit_CreateA((TWins*)form.FormMain, 0, 0, 200, 200, alClient);

	AppRun();
	return 0;
}
