/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldesk.h"
#include <X11/extensions/XTest.h>
#include <X11/XKBlib.h>

static dword getKeycode(KeySym xks) {
	return XKeysymToKeycode(appXDat.dpy, xks);
}

static bool get_modkey_stat(dword keycode, dword *ret_mod_mask) {
  Window nc_w;
  int nc_i;
  dword mod_mask, mask;
  XModifierKeymap *map;

	mask = mod_mask = 0;
        if (keycode) {
	    map = XGetModifierMapping(appXDat.dpy);
	    for (int i=0;i<8;i++) {
		if (map->modifiermap[map->max_keypermod * i] == keycode) {
		    mod_mask = 1 << i;
		    break;
		}
	    }
	    XFreeModifiermap(map);
	    XQueryPointer(appXDat.dpy, appXDat.RootW, &nc_w, &nc_w,
				    &nc_i, &nc_i, &nc_i, &nc_i, &mask);
	}
	if (ret_mod_mask) *ret_mod_mask = mod_mask;
	return (mod_mask & mask) != 0;
}

static void setLock(bool on, dword keycode) {
  dword mod_mask, mod;
	if ((get_modkey_stat(keycode, &mod_mask) == on) || !mod_mask) return;
	mod = mod_mask;
	if (!on) mod = 0;
	XkbLockModifiers(appXDat.dpy, XkbUseCoreKbd, mod_mask, mod);
}

void setNumlock(bool on) {
	setLock(on, getKeycode(XK_Num_Lock));
}

static void setCapslock(bool on) {
	setLock(on, getKeycode(XK_Caps_Lock));
}

/* void setShiftlock(bool on) {
	setLock(on, getKeycode(XK_Shift_Lock));
} */

void SetUpKey(TpcIni *Ini) {
	setNumlock(TpcIni_RD_boolean(Ini, "Key", "Numlock", False));
	setCapslock(TpcIni_RD_boolean(Ini, "Key", "Capslock", False));
}
