/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldesk.h"
#include "cicons.h"
//#include "dlg.h"

//menu_desktop_info_OnClick --> in aldesk.c


static void menu_desktop_OnInitDat(TMenuFile *self, bool iniEnd) {
  int i;
  TMenuFileItem *mi;

	if (!iniEnd) return;
	i = 0;
	mi = self->MenuItem;
	while (mi) {i++; mi = mi->next;}
	mi = (TMenuFileItem*)TMenu_InsItem((TMenu*)self, "Info", i-1);
	mi->pic = GetDeskIcon(ddkt_Actions, 16, "info", gdifu_noZoom, zico16info);
	mi->OnClick = (void*)menu_desktop_info_OnClick;
	mi = (TMenuFileItem*)TMenu_InsItem((TMenu*)self, "-", i);
}

/*_____________________________ Create __________________________________*/
void menu_desktop(TwmRoot *wmr) {
  TMenuFile *mf;
  char *pc0;
  char line[512];

	pc0 = line;
	ppcmove(&pc0, wmr->MenuPath);
	ppcmove(&pc0, "/DesktopMenu");
	if (file_mkdir_parents_ae(line, 0750, EMSG_ERR_EXIT) == True) {
	    pcmove_directory(pc0);
	    dotdesktop_new(line, "Default Menu", "desktop", "shutdown closeallwin -t", NULL, NULL, ddkt_Directory);

	    pcmove_desktop(pc0, "closeallwin");
	    dotdesktop_new(line, "Close all Win", NULL, "close_all_win", NULL, NULL, ddkt_ALDeskBuildin);

	    pcmove_desktop(pc0, "shutdown");
	    dotdesktop_new(line, "Shut Down", "shutdown", "Exit", NULL, NULL, ddkt_ALDeskBuildin);

	    pcmove_desktop(pc0, "xterm");
	    dotdesktop_new(line, "X Terminal", "console", "xterm", NULL, NULL, ddkt_Application);
	}
	wmr->PopupMenu = (TMenu*)TMenuFile_Create((TWins*)wmr);
	mf = (TMenuFile*)wmr->PopupMenu;
	pc0[0] = '/'; pc0[1] = 0;
	mf->path = pcdup(line);
	mf->OnMenuOpen = (void*)Menu_OnMenuOpen;
	mf->OnMenuClose = (void*)Menu_OnMenuClose;
	mf->OnClick = menuStart_OnClick;
	mf->OnInitDat = menu_desktop_OnInitDat;
	mf->mfk = mfk_sort_inv | mfk_AddDirHead | mfk_AutoFree;
}
