/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldesk.h"

static void menuStart_OnMenuClose(TMenuFile *self) {
	Menu_OnMenuClose((TMenu*)self);
	if (wmRoot->Taskbar) {
	    wmRoot->Taskbar->buStart->BorderFu &= ~mBorderL;
	    Refresh(wmRoot->Taskbar->buStart);
	}
}

void menuStart_OnClick(TMenuFile *self, long KeyState, bool DblClick) {
	menu_ExecDesktopFile(self, KeyState, NULL);
}

/*_____________________________ Create __________________________________*/
void menu_start(TwmRoot *wmr) {
  char *pc0, *pc1, *pc2;
  TMenuFile *mf;
  char line[512];

	pc0 = line;
	ppcmove(&pc0, wmr->MenuPath);
	ppcmove(&pc0, "/StartMenu");
	if (file_mkdir_parents_ae(line, 0750, EMSG_ERR_EXIT) == True) {
	    pcmove_directory(pc0);
	    dotdesktop_new(line, "Start", "startX", "Shut_Down Log_Off -t Help Documents Settings Network -t Programs -t KDE Microsoft -t", NULL, NULL, ddkt_Directory);
	    pc1 = pc0;
	    ppcmove(&pc1, "/Shut_Down");
	    if (file_mkdir_parents_ae(line, 0750, EMSG_ERR1)) {
		pcmove_directory(pc1);
		dotdesktop_new(line, "Shut Down ...", "shutdown", NULL, NULL, NULL, ddkt_Directory);
		pcmove_desktop(pc1, "closeallwin");
		dotdesktop_new(line, "Close all Win", NULL, "close_all_win", NULL, NULL, ddkt_ALDeskBuildin);
		pcmove_desktop(pc1, "shutdown");
		dotdesktop_new(line, "Shut Down", "shutdown", "Exit", NULL, NULL, ddkt_ALDeskBuildin);
	    }

	    pc1 = pc0;
	    ppcmove(&pc1, "/Network");
	    if (file_mkdir_parents_ae(line, 0750, EMSG_ERR1)) {
		pcmove_directory(pc1);
		dotdesktop_new(line, "Network", "network", NULL, NULL, NULL, ddkt_Directory);
	    }

	    pc1 = pc0;
	    ppcmove(&pc1, "/Programs");
	    if (file_mkdir_parents_ae(line, 0750, EMSG_ERR1)) {
		pcmove_directory(pc1);
		dotdesktop_new(line, "Programs", "exec", NULL, NULL, NULL, ddkt_Directory);
		pcmove_desktop(pc1, "aldedit");
		dotdesktop_new(line, "aldedit", "aldedit", "aldedit", NULL, NULL, ddkt_Application);
		pcmove_desktop(pc1, "aldconsole");
		dotdesktop_new(line, "console", "console", "aldconsole", NULL, NULL, ddkt_Application);
		pcmove_desktop(pc1, "aldfile");
		dotdesktop_new(line, "aldfile", "aldfile", "aldfile", NULL, NULL, ddkt_Application);

		pc2 = pc1;
		ppcmove(&pc2, "/Graphics");
		if (file_mkdir_parents_ae(line, 0750, EMSG_ERR1)) {
		    pcmove_directory(pc2);
		    dotdesktop_new(line, "Graphics", "graphics", NULL, NULL, NULL, ddkt_Directory);
		    pcmove_desktop(pc2, "aldpic");
		    dotdesktop_new(line, "aldpic", "aldpic", "aldpic", NULL, NULL, ddkt_Application);
		}

	    }
	}
	pc0[0] = '/'; pc0[1] = 0;

	mf = TMenuFile_Create((TWins*)wmr);
	wmr->menuStart = mf;
	mf->path = pcdup(line);
	mf->icon_size = 22;

	mf->OnMenuOpen = (void*)Menu_OnMenuOpen;
//	mf->OnMenuClose = Menu_OnMenuClose;
//	mf->OnUnmap = menuStart_OnUnmap;
	mf->OnMenuClose = menuStart_OnMenuClose;
	mf->OnClick = menuStart_OnClick;
	mf->mfk = mfk_sort_inv | mfk_AutoFree;
	mf->Gravity = SouthWestGravity;
}
