/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldfile.h"
#include "dlg.h"
#include "cicons.h"
#include "buildin_app/aldfind.h"

static void aldfile_SaveSetting() {
  TpcIni *ini = appDat.appIni;
  TMainForm *mf = appDat.obj;

	if (!ini) ini = TpcIni_Create(appDat.inifile_app);
	TpcIni_WR_boolean(ini, "Dlg_File", "Az0_ItemE_Dbl", mf->fw->FDL_Def.Az0_ItemE_Dbl);
	TpcIni_WR_boolean(ini, "Dlg_File", "Az0_PathE_Dbl", mf->fw->FDL_Def.Az0_PathE_Dbl);
	TpcIni_WR_boolean(ini, "Dlg_File", "Az1_ItemE_Dbl", mf->fw->FDL_Def.Az1_ItemE_Dbl);
	TpcIni_WR_boolean(ini, "Dlg_File", "Az1_PathE_Dbl", mf->fw->FDL_Def.Az1_PathE_Dbl);

	TpcIni_WR_boolean(ini, "Dlg_File", "CaseSort", ((mf->miCaseSort->fu & miChecked) != 0));

	TpcIni_WR_boolean(ini, APPNAME, "TermVisible", ((mf->miTermVis->fu & miChecked) != 0));
#ifdef USE_BULDIN_APP
	TpcIni_WR_boolean(ini, APPNAME, "FindVisible", ((mf->miFindVis->fu & miChecked) != 0));
#endif
	TpcIni_Save(ini);
	if (!appDat.appIni) Tfree(ini);
}

void aldfile_LoadSetting(TMainForm *self) {
  TpcIni *ini = appDat.appIni;
  bool mk;

	if (!ini) ini = TpcIni_Create(appDat.inifile_app);
	self->fw->FDL_Def.Az0_ItemE_Dbl = TpcIni_RD_boolean(ini, "Dlg_File", "Az0_ItemE_Dbl", False);
	self->fw->FDL_Def.Az0_PathE_Dbl = TpcIni_RD_boolean(ini, "Dlg_File", "Az0_PathE_Dbl", False);
	self->fw->FDL_Def.Az1_ItemE_Dbl = TpcIni_RD_boolean(ini, "Dlg_File", "Az1_ItemE_Dbl", True);
	self->fw->FDL_Def.Az1_PathE_Dbl = TpcIni_RD_boolean(ini, "Dlg_File", "Az1_PathE_Dbl", False);
	if ((self->fw->AzArt & 0xff) == 0) {
	    self->fw->DblClick_ItemEnter = self->fw->FDL_Def.Az0_ItemE_Dbl;
	    self->fw->DblClick_PathEnter = self->fw->FDL_Def.Az0_PathE_Dbl;
	} else {
	    self->fw->DblClick_ItemEnter = self->fw->FDL_Def.Az1_ItemE_Dbl;
	    self->fw->DblClick_PathEnter = self->fw->FDL_Def.Az1_PathE_Dbl;
	}
	self->miDblItem->fu &= ~miChecked;
	self->miDblPath->fu &= ~miChecked;
	if (self->fw->DblClick_ItemEnter) self->miDblItem->fu |= miChecked;
	if (self->fw->DblClick_PathEnter) self->miDblPath->fu |= miChecked;

	mk = TpcIni_RD_boolean(ini, "Dlg_File", "CaseSort", False);
	self->miCaseSort->fu &= ~miChecked;
	if (mk) self->miCaseSort->fu |= miChecked;
	self->fw->sortFu &= ~dlsortFu_Case;
	if (mk) self->fw->sortFu |= dlsortFu_Case;

	if (!appDat.appIni) Tfree(ini);
}

/* ______________________ File Ev ____________________________________ */
static void miTermVis_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TMainForm *mf = (TMainForm*)self->FormStruct;
	SetVisible((TWins*)mf->mbTerm, (mi->fu & miChecked) != 0);
	aldfile_PanelTop_OnResize(mf->pnlTop);
	aldfile_SaveSetting();
}

#ifdef USE_BULDIN_APP
static void miFindVis_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TMainForm *mf = (TMainForm*)self->FormStruct;
	SetVisible((TWins*)mf->mbFind, (mi->fu & miChecked) != 0);
	aldfile_PanelTop_OnResize(mf->pnlTop);
	aldfile_SaveSetting();
}
#endif

static void miDblItem_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TMainForm *mf = (TMainForm*)self->FormStruct;
	mf->fw->DblClick_ItemEnter = (mi->fu & miChecked) != 0;
	if ((mf->fw->AzArt & 0xff) == 0) {
	    mf->fw->FDL_Def.Az0_ItemE_Dbl = (mi->fu & miChecked) != 0;
	} else {
	    mf->fw->FDL_Def.Az1_ItemE_Dbl = (mi->fu & miChecked) != 0;
	}
	aldfile_SaveSetting();
}

static void miDblPath_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TMainForm *mf = (TMainForm*)self->FormStruct;
	mf->fw->DblClick_PathEnter = (mi->fu & miChecked) != 0;
	if ((mf->fw->AzArt & 0xff) == 0) {
	    mf->fw->FDL_Def.Az0_PathE_Dbl = (mi->fu & miChecked) != 0;
	} else {
	    mf->fw->FDL_Def.Az1_PathE_Dbl = (mi->fu & miChecked) != 0;
	}
	aldfile_SaveSetting();
}

static void miHidden_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TMainForm *mf = (TMainForm*)self->FormStruct;
	TFileWin_SetShowHidden(mf->fw, (mi->fu & miChecked) != 0);
}

static void miCaseSort_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TMainForm *mf = (TMainForm*)self->FormStruct;
  int m;
	m = mf->fw->sortFu & ~dlsortFu_Case;
	if (mi->fu & miChecked) m |= dlsortFu_Case;
	TFileWin_SetSort(mf->fw, m);
	aldfile_SaveSetting();
}

void SetFileSystemUTF8(TMainForm *self, bool UTF8) {
  TpcIni *ini;
	TWins_SetUTF8((TWins*)self->edPath, UTF8);
	TWins_SetUTF8((TWins*)self->tv, UTF8);
	TWins_SetUTF8((TWins*)self->fw, UTF8);

	ini = TpcIni_Create(appDat.inifile_global);
	TpcIni_WR_boolean(ini, "Global", "FileSystemUTF8", UTF8);
	TpcIni_SaveAndFree(ini);

#ifdef USE_BULDIN_APP
	TWins *wins = appXDat.Wins;
	while (wins) {
	    if (wins->wtyp == wtyp_TFormFind) {
		TFormFind_UpdataUTF8((TFormFind*)wins);
	    }
	    wins = wins->next;
	}
#endif
}
static void miUTF8_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
	appXDat.FileSystemUTF8on = mi->fu & miChecked;
	SetFileSystemUTF8((TMainForm*)self->FormStruct, appXDat.FileSystemUTF8on);
}

/* ______________________ Create _____________________________________ */
void MenuSetting_Create(TMainForm *self) {
  int m;
  TpcIni *ini;

	ini = get_appIni();
	self->mbSetting = TMenuButton_CreateS(self->pnlTop, self->mbFile, "Settings");
	self->menuSetting = TMenu_Create((TWins*)self);
	self->mbSetting->menu = self->menuSetting;
	self->miToolbar = TMenu_AddItem(self->menuSetting, "Toolbar", 0, NULL);
	  self->menuToolbar = TMenu_Create((TWins*)self);
	  self->miToolbar->next_menu = self->menuToolbar;
	  m = miCanCheck | miAutoToggle;
	  if (TpcIni_RD_boolean(ini, APPNAME, "TermVisible", True)) m = miCanCheck | miChecked | miAutoToggle;
	  self->miTermVis = TMenu_AddItem(self->menuToolbar, "Term visible",
					m, miTermVis_OnClick);
	  self->miTermVis->pic = GetZIcon(zico16console);
#ifdef USE_BULDIN_APP
	  m = miCanCheck | miAutoToggle;
	  if (TpcIni_RD_boolean(ini, APPNAME, "FindVisible", True)) m = miCanCheck | miChecked | miAutoToggle;
	  self->miFindVis = TMenu_AddItem(self->menuToolbar, "Find visible",
					m, miFindVis_OnClick);
	  self->miFindVis->pic = GetZIcon(zico16aldfind);
#endif
	TMenu_AddItem(self->menuSetting, "-", 0, NULL);
	self->miDblItem = TMenu_AddItem(self->menuSetting, "Dbl-Click Item",
				miCanCheck | miAutoToggle, miDblItem_OnClick);
	self->miDblPath = TMenu_AddItem(self->menuSetting, "Dbl-Click Path",
				miCanCheck | miAutoToggle, miDblPath_OnClick);
	TMenu_AddItem(self->menuSetting, "Show Hidden", 
				miCanCheck | miChecked | miAutoToggle, miHidden_OnClick);
	self->miCaseSort = TMenu_AddItem(self->menuSetting, "Case Sort",
				miCanCheck | miAutoToggle, miCaseSort_OnClick);

	m = miCanCheck | miAutoToggle;
	if (appXDat.FileSystemUTF8on) m = miCanCheck | miChecked | miAutoToggle;
	TMenu_AddItem(self->menuSetting, "-", 0, NULL);
	TMenu_AddItem(self->menuSetting, "File UTF-8", 
				m, miUTF8_OnClick);
	free_appIni(ini);
}
