/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appXbase.h"
#include "miCopy.h"
#ifdef _OS_WIN32
#include <shlobj.h>
#endif

void miCopy(char *pcsel, char *pcsel_passwd, bool utf8) {
#ifdef _OS_WIN32
  char *pc;
  int lg = pclen(pcsel);
  int wlg = lg;
  DROPFILES *DropFile;
  HGLOBAL hGlobMem;

	if (!pcsel) return;
	if (utf8) {
	    int fuEOL = 0;
	    wlg = Chk_fio_UTF8(pcsel, lg, &fuEOL);
	    if ((fuEOL & fio_has_0x80_char) && 
		!(fuEOL & fio_has_UTF8_char)) utf8 = False;
	    if (!utf8) wlg = lg;
	}
	pc = pcsel;
	while (*pc) {
	    if (*pc == '\n') *pc = 0;
	    pc++;
	}

	if (Clipboard_Open()) {
	    wlg++;
	    hGlobMem = GlobalAlloc(GMEM_MOVEABLE | GMEM_SHARE, 
				sizeof(DROPFILES) + (wlg * 2));
	    if (hGlobMem) {
		pc = GlobalLock(hGlobMem);
		DropFile = (DROPFILES*)pc;
		DropFile->pFiles = sizeof(DROPFILES);
		DropFile->pt.x = 0;
		DropFile->pt.y = 0;
		DropFile->fNC = 0;
		DropFile->fWide = 1;
		pc += sizeof(DROPFILES);
		int UCfu = 0;
		if (!utf8) UCfu = UC_force_ASCII;
		Utf8ToWChars((word*)pc, wlg, pcsel, lg, UCfu);
		Clipboard_Add();
		SetClipboardData(CF_HDROP, hGlobMem);
		GlobalUnlock(hGlobMem);
	    }

	    int CF_n = Get_Preferred_DropEffect();
	    if (CF_n) {
		hGlobMem = GlobalAlloc(GMEM_MOVEABLE | GMEM_SHARE, sizeof(int));
		if (hGlobMem) {
		    int *pint = GlobalLock(hGlobMem);

		    if (appXDat.SelCut) {
			*pint = DROPEFFECT_MOVE;
		    } else {
			*pint = DROPEFFECT_COPY;
		    }
		    Clipboard_Add();
		    SetClipboardData(CF_n, hGlobMem);
		    GlobalUnlock(hGlobMem);
		}
	    }
	    Clipboard_Close();
	}

#else /* _OS_WIN32 */
	if (!pcsel) return;
	bool mk_utf8 = utf8;
	if (utf8) {
	    int fuEOL = 0;
	    Chk_fio_UTF8(pcsel, pclen(pcsel), &fuEOL);
	    if ((fuEOL & fio_has_0x80_char) && 
		!(fuEOL & fio_has_UTF8_char)) utf8 = False;
	}
	pctoUTF8esclgs(pcsel, &appXDat.SelTxt);

	if (!pcsel_passwd) pcsel_passwd = pcsel;
	utf8 = mk_utf8;
	if (utf8) {
	    int fuEOL = 0;
	    Chk_fio_UTF8(pcsel_passwd, pclen(pcsel_passwd), &fuEOL);
	    if ((fuEOL & fio_has_0x80_char) && 
		!(fuEOL & fio_has_UTF8_char)) utf8 = False;
	}
	pctoUTF8esclgs(pcsel_passwd, &appXDat.SelTxt_URL);

	if (utf8) {
	    SetSelection(4, appXDat.XA_URL_STRING, appXDat.XA_UTF8_STRING, XA_STRING, appXDat.XA_KDE_CUT);
	} else {
	    SetSelection(3, appXDat.XA_URL_STRING, XA_STRING, appXDat.XA_KDE_CUT);
	}
#endif /* ! _OS_WIN32 */
}
