/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/


#ifndef	__TFIO_H__
#define	__TFIO_H__    1


#define FIOartLineBuf	1
#define FIOartFD	2


#define AlgTFIO    AlgTTC \
  char  *FileName; \
  void  *owner; \
  dword IOfkt; \
  TNetErrRet ErrRet; \
  void  (*OnReadEnd)(struct TCSelf *self); \
  void  (*OnWriteEnd)(struct TCSelf *self); \
  void  (*OnData)(struct TCSelf *self, bool mk_eof); \
  void  (*OnSetOffset)(struct TCSelf *self, int64_t Offset); \
  bool  (*Open)(struct TCSelf *self); \
  bool  (*Close)(struct TCSelf *self); \
  bool  (*Save)(struct TCSelf *self, const char *FileName); \
  int64_t (*GetSize)(struct TCSelf *self); \
  int64_t (*GetSizeAbs)(struct TCSelf *self); \
  bool  (*GetChanged)(struct TCSelf *self); \
  bool  (*SetOffset)(struct TCSelf *self, int64_t Offset); \
  int64_t (*GetOffset)(struct TCSelf *self); \
  char  *(*GetDataP)(struct TCSelf *self, int64_t Offset, int MaxChr); \
  bool  (*OverWrite)(struct TCSelf *self, int64_t Offset, const char *pc, int size); \
  bool  (*Insert)(struct TCSelf *self, int64_t Offset, const char *pc, int size); \
  bool  (*Delete)(struct TCSelf *self, int64_t Offset, int size);

//  bool (*SaveAs)(struct TCSelf *self, const char *FileName); 
//  bool (*ReOpen)(struct TCSelf *self, const char *FileName); 

#define TCSelf TFIO
typedef struct TFIO {
  AlgTFIO
} TFIO;
#undef TCSelf
 
extern TFIO  *TFIO_Create(const char *FileName, int tcsize, int wtyp);
extern bool  TFIO__Destroy(TFIO *self);

extern bool  FIO_Open(TFIO *self);
// extern bool FIO_ReOpen(TFIO *self, const char *FileName);
extern bool  FIO_Close(TFIO *self);

extern bool  FIO_Save(TFIO *self, const char *FileName);
//extern bool FIO_SaveAs(TFIO *self, const char *FileName);

extern int64_t FIO_GetSize(TFIO *self);
extern int64_t FIO_GetSizeAbs(TFIO *self);
extern bool  FIO_SetOffset(TFIO *self, int64_t Offset);
extern int64_t FIO_GetOffset(TFIO *self);
extern bool  FIO_GetChanged(TFIO *self);

extern char  *FIO_GetDataP(TFIO *self, int64_t Offset, int MaxChr);
extern bool  FIO_OverWrite(TFIO *self, int64_t Offset, const char *pc, dword size);
extern bool  FIO_Insert(TFIO *self, int64_t Offset, const char *pc, dword size);
extern bool  FIO_Delete(TFIO *self, int64_t Offset, dword size);

extern dword FIO_GetIOfkt(TFIO *self);
extern int   FIO_GetArt(TFIO *self);

extern TFIO  *TFIO_Create_LB(const char *FileName);
extern TFIO  *TFIO_Create_FD(const char *FileName);

#endif /* __TFIO_H__ */
