/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef	__THEXEDIT_H__
#define	__THEXEDIT_H__    1

#include "tlineedit.h"
#include "tfio.h"

#define MAX_CHARS	160
#define MAX_LINES	100
#define MAX_COLORS	4

#define csfu_HasData	1

#define Seg_Hex		0
#define Seg_Txt		1

//typedef void (*hp_init)(struct THexEdit *self);
//typedef struct THexEdit;

typedef struct {
  TColS *cs;
  byte *pb;
  int64_t idx;
  dword lg;
  bool Insert;
  bool ASCII_Korr;
} TPLine;

/* CaretCharIdxToOffX, CaretKorr fu */
#define cfu_Select	1

#define TCSelf THexEdit
typedef struct THexEdit {
  AlgLineEditBase
  bool Insert;
  bool EditMode;
  bool ncb2, ncb3;
  void (*OnChange)(struct TCSelf *self, int fu, TKeyS *KeyS, Tlgs *lgs, int xa,
			 int ya, int xe, int ye);
  int MaxLineByts;
//  char *FileName;
  TFIO *fio;

  TUnRedo *UnRedo;
  int VisibleAktLines;
  int CharWidth;
  int LineLength;
  int Seg;
  int ValChrOff;   //8hex 0=b7..4 1=b3..0
  int MaxValChrOff;  //8hex=1;

  int MaxSegData;


  void (*ReInit)(struct TCSelf *self);
  void (*PrintLine)(struct TCSelf *self, TPLine *pl);
  void (*Strg_C)(struct TCSelf *self, TLines *tls, int xa, int xe, int ya, int ye);
  void (*CaretKorr)(struct TCSelf *self, int *idx, int *idy, int cfu);
  int (*CaretCharIdxToOffX)(struct TCSelf *self, int idx, int idy, int cfu, bool Insert);
  int (*OffXToCaretCharIdx)(struct TCSelf *self, int x);
  int (*KeyDown)(struct TCSelf *self, TKeyEvent *KeyEv, int *fu);
  void (*DoChange)(struct TCSelf *self, int bef, TKeyS *KeyS, Tlgs *Ins_lgs);
  void (*OnReadEnd)(struct TCSelf *self);
  void (*OnWriteEnd)(struct TCSelf *self);
  void (*OnDataLoad)(struct TCSelf *self, bool eof);
  void  (*OnSetOffset)(struct TCSelf *self, int64_t Offset);
  int SelAx0;
} THexEdit;
#undef TCSelf

extern THexEdit *THexEdit_CreateA(TWins *Parent, int Left, int Top, int Width, 
					int Height, int Align);

extern bool THexEdit_LoadFile(THexEdit *self, const char *FileName);
extern bool THexEdit_SaveFile(THexEdit *self, const char *FileName);
extern void THexEdit_DoChange(THexEdit *self, int bef, TKeyS *KeyS, Tlgs *Ins_lgs);

extern const char *THexEdit_GetFileName(THexEdit *self);

extern bool THexEdit_Undo(THexEdit *self, TUnRedoLine *url);
extern bool THexEdit_Redo(THexEdit *self, TUnRedoLine *url);

extern dword GetCharOff(THexEdit *self, int idx, int idy);
extern void THexEdit_SetCaret(THexEdit *self);

//extern bool THexEdit_XK_Right(THexEdit *self, bool NoChk);
//extern bool THexEdit_XK_Left(THexEdit *self, bool NoChk);

extern void InitLines_8Hex(THexEdit *self);

extern void THexEdit_SetMaxSegData(THexEdit *self, int MaxSegData);
extern int THexEdit_GetMaxSegData(THexEdit *self);

extern int64_t THexEdit_GetSizeAbs(THexEdit *self);
extern bool  THexEdit_SetOffset(THexEdit *self, int64_t Offset);
extern int64_t THexEdit_GetOffset(THexEdit *self);

extern dword THexEdit_GetIOfkt(THexEdit *self);
extern int THexEdit_GetFIOArt(THexEdit *self);

extern void THexEdit_SetEditMode(THexEdit *self, bool Edit);
extern void THexEdit_SetInsertMode(THexEdit *self, bool Insert);
extern bool THexEdit_GetChanged(THexEdit *self);

#endif /* __THEXEDIT_H__ */

