/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldpic.h"

void CutOut_SetEvEn(bool en) {
  TMainForm *fmain = appDat.obj;
  TFormCutOut *fcut = fmain->fcutout;
  int en_fu = 0;

	if (en) en_fu = tdv_fu_LostFocusEnter | tdv_fu_MouseMove_add;

	fcut->dvX->dv_fu = en_fu;
	fcut->dvXz->dv_fu = en_fu;
	fcut->dvY->dv_fu = en_fu;
	fcut->dvYz->dv_fu = en_fu;
	fcut->dvW->dv_fu = en_fu;
	fcut->dvWz->dv_fu = en_fu;
	fcut->dvH->dv_fu = en_fu;
	fcut->dvHz->dv_fu = en_fu;
}

void CutOut_Clr() {
  TMainForm *fmain = appDat.obj;
  TFormCutOut *fcut = fmain->fcutout;
	TChkBox_SetChecked(fcut->cbCutOutOn, False);
	TDVal_Set_Max(fcut->dvX, 0);
	TDVal_Set_Max(fcut->dvXz, 0);
	TDVal_Set_Max(fcut->dvW, 0);
	TDVal_Set_Max(fcut->dvWz, 0);

	TDVal_Set_Max(fcut->dvY, 0);
	TDVal_Set_Max(fcut->dvYz, 0);
	TDVal_Set_Max(fcut->dvH, 0);
	TDVal_Set_Max(fcut->dvHz, 0);
}

bool CutOut_Chk_On() {
  TMainForm *fmain = appDat.obj;
  TFormCutOut *fcut = fmain->fcutout;
	return  fcut->cbCutOutOn->Checked &&
		(fcut->dvW->dval > 1) && 
		(fcut->dvH->dval > 1);
}

TPixMap *CutOut_PixMap(TPixMap *pxm, int new_w, int new_h) {
  TMainForm *fmain = appDat.obj;
  TFormCutOut *fcut = fmain->fcutout;
  Toff_rsz off;
  Toff_rsz *srcoff = NULL;

	if (CutOut_Chk_On()) {
	    off.x = fcut->dvX->dval;
	    off.y = fcut->dvY->dval;
	    off.width = fcut->dvW->dval;
	    off.height = fcut->dvH->dval;

	    new_w = fcut->dvWz->dval;
	    new_h = fcut->dvHz->dval;
	    srcoff = &off;
	}
	return (TPixMap*)TImage_dup_new_size_off((TImage*)pxm, new_w, new_h, srcoff);
}

static void clr_dv_max(TMainForm *fmain) {
  TFormCutOut *fcut = fmain->fcutout;
  TPixMap *pxm = ALDpic_pxm_get(fmain, ib_rszbase_pxm);
	TDVal_Set_Max(fcut->dvX, pxm->width);
	TDVal_Set_Max(fcut->dvXz, fmain->old_w);
	TDVal_Set_Max(fcut->dvW, pxm->width);
	TDVal_Set_Max(fcut->dvWz, fmain->old_w);

	TDVal_Set_Max(fcut->dvY, pxm->height);
	TDVal_Set_Max(fcut->dvYz, fmain->old_h);
	TDVal_Set_Max(fcut->dvH, pxm->height);
	TDVal_Set_Max(fcut->dvHz, fmain->old_h);
}

void AzCutOut(TMainForm *fmain) {
  TFormCutOut *fcut = fmain->fcutout;
  TPixMap *pxm;
  char buf[64];

	pxm = ALDpic_pxm_get(fmain, ib_rszbase_pxm);
	if (!pxm) {
	    SetCaption(fcut->lblOrgStat, "0 x 0  to  0 x 0");
	    return;
	}
	snprintf(buf, sizeof(buf), "%d x %d  to  %d x %d", 
		pxm->width, pxm->height,
		fmain->old_w, fmain->old_h);
	SetCaption(fcut->lblOrgStat, buf);

	clr_dv_max(fmain);

	TDVal_Set_Value(fcut->dvXz, fcut->dvX->dval * fmain->zoom_k);
	TDVal_Set_Value(fcut->dvWz, fcut->dvW->dval * fmain->zoom_k);
	TDVal_Set_Value(fcut->dvYz, fcut->dvY->dval * fmain->zoom_kh);
	TDVal_Set_Value(fcut->dvHz, fcut->dvH->dval * fmain->zoom_kh);
}

void AzCutOut_0(TMainForm *fmain) {
  TFormCutOut *fcut = fmain->fcutout;
  TPixMap *pxm = ALDpic_pxm_get(fmain, ib_rszbase_pxm);
	if (pxm) {
	    TDVal_Set_Value(fcut->dvX, 0);
	    TDVal_Set_Value(fcut->dvW, pxm->width);
	    TDVal_Set_Value(fcut->dvY, 0);
	    TDVal_Set_Value(fcut->dvH, pxm->height);
	}
	AzCutOut(fmain);
}

void AzGraf_CutOut_OnMouseMove(TWins *self, XMotionEvent *ev) {
  TMainForm *fmain = (TMainForm*)self->FormStruct;
  TFormCutOut *fcut = fmain->fcutout;
  int x, y, x0, y0, w, h;
  TPixMap *pxm = ALDpic_pxm_get(fmain, ib_rszbase_pxm);

	if ((ev->state & Button1Mask) && 
		   (MouseDown.apph == self)) {

	    if (fmain->selAkt) {
		fmain->selAkt = False;
		DrawRectFocus(fmain->AzGraf->WinID, 
			fmain->selx, fmain->sely,
			fmain->selw, fmain->selh);
	    }

	    x = ev->x_root - MouseDown.x_root;
	    y = ev->y_root - MouseDown.y_root;
	    x0 = MouseDown.x;
	    y0 = MouseDown.y;

	    if (self->cursor_nr == XC_top_left_arrow) {
		if (x < 0) {x0 += x; x = -x;}
		if (y < 0) {y0 += y; y = -y;}
		if ((x > 1) && (y > 1) && ((x > 4) || (y > 4))) {

		    fmain->selx = x0;
		    fmain->sely = y0;
		    fmain->selw = x;
		    fmain->selh = y;

		    DrawRectFocus(fmain->AzGraf->WinID, 
			    fmain->selx, fmain->sely,
			    fmain->selw, fmain->selh);
		    fmain->selAkt = True;

		    clr_dv_max(fmain);

      double wk, hk, xd, yd, x0d, y0d;
		    wk = 1 / fmain->zoom_k;
		    hk = 1 / fmain->zoom_kh;

		    x0 -= fmain->pxm_left;
		    if (x0 < 0) {x += x0; x0 = 0;}
		    x0d = x0 * wk;
		    y0 -= fmain->pxm_top;
		    if (y0 < 0) {y += y0; y0 = 0;}
		    y0d = y0 * hk;

		    xd = x * wk;
		    yd = y * hk;

		    if ((xd+x0d) > pxm->width ) xd = pxm->width - x0d;
		    if ((yd+y0d) > pxm->height) yd = pxm->height - y0d;
		    TDVal_Set_Value(fcut->dvX, x0d);
		    TDVal_Set_Value(fcut->dvY, y0d);
		    TDVal_Set_Value(fcut->dvW, xd);
		    TDVal_Set_Value(fcut->dvH, yd);
		    AzCutOut(fmain);
		} else {
		    TDVal_Set_Value(fcut->dvX, fcut->odvX);
		    TDVal_Set_Value(fcut->dvXz, fcut->odvXz);
		    TDVal_Set_Value(fcut->dvY, fcut->odvY);
		    TDVal_Set_Value(fcut->dvYz, fcut->odvYz);
		    TDVal_Set_Value(fcut->dvW, fcut->odvW);
		    TDVal_Set_Value(fcut->dvWz, fcut->odvWz);
		    TDVal_Set_Value(fcut->dvH, fcut->odvH);
		    TDVal_Set_Value(fcut->dvHz, fcut->odvHz);
		}


	    } else {

		if (fmain->rsz_run || fmain->paint_run) return;

  int mx, my, mw, mh;
		mx = MouseDown.obj_left;
		my = MouseDown.obj_top;
		mw = MouseDown.obj_width;
		mh = MouseDown.obj_height;
	    int cur = self->cursor_nr;

		if ((cur == XC_left_side) || 
		    (cur == XC_top_left_corner) ||
		    (cur == XC_bottom_left_corner)) {
		    if (mx + x < 0) x = 0 - mx;
		}
		if ((cur == XC_right_side) || 
		    (cur == XC_top_right_corner) ||
		    (cur == XC_bottom_right_corner)) {
		    if (mx + mw + x > fmain->old_w) x = fmain->old_w - mx - mw;
		}

		if ((cur == XC_top_side) || 
		    (cur == XC_top_left_corner) ||
		    (cur == XC_top_right_corner)) {
		    if (my + y < 0) y = 0 - my;
		}
		if ((cur == XC_bottom_side) || 
		    (cur == XC_bottom_left_corner) ||
		    (cur == XC_bottom_right_corner)) {
		    if (my + mh + y > fmain->old_h) y = fmain->old_h - my - mh;
		}

		if (cur == XC_left_side) {
		    mx += x; mw -= x;
		} else if (cur == XC_top_left_corner) {
		    mx += x; mw -= x;
		    my += y; mh -= y;
		} else if (cur == XC_top_side) {
		    my += y; mh -= y;
		} else if (cur == XC_top_right_corner) {
		    my += y; mh -= y;
		    mw += x;
		} else if (cur == XC_right_side) {
		    mw += x;
		} else if (cur == XC_bottom_right_corner) {
		    mw += x;
		    mh += y;
		} else if (cur == XC_bottom_side) {
		    mh += y;
		} else if (cur == XC_bottom_left_corner) {
		    mx += x; mw -= x;
		    mh += y;
		} else {
		    return;
		}
		if (mw < 2) mw = 2;
		if (mh < 2) mh = 2;

		if ((mx == fcut->omx) && (my == fcut->omy) && 
		    (mw == fcut->omw) && (mh == fcut->omh)) return;

		fcut->omx = mx;
		fcut->omy = my;
		fcut->omw = mw;
		fcut->omh = mh;

		TDVal_Set_Value(fcut->dvX, mx / fmain->zoom_k);
		TDVal_Set_Value(fcut->dvY, my / fmain->zoom_kh);
		TDVal_Set_Value(fcut->dvW, mw / fmain->zoom_k);
		TDVal_Set_Value(fcut->dvH, mh / fmain->zoom_kh);
		AzCutOut(fmain);
		fmain->paint_run = True;
		ALDpic_resize_pxm(fmain);
		Refresh((TWins*)fmain->AzGraf);
	    }

	} else if (CutOut_Chk_On()) {
	    x = ev->x - fmain->pxm_left - TDVal_GetInteger(fcut->dvXz);
	    y = ev->y - fmain->pxm_top - TDVal_GetInteger(fcut->dvYz);
	    w = TDVal_GetInteger(fcut->dvWz);
	    h = TDVal_GetInteger(fcut->dvHz);

#define lr 8
  int curs;

	    curs = XC_top_left_arrow;
	    if ((x >= -2) && (x <= 2)) {
	      curs = XC_left_side;
	      if (y < lr) curs = XC_top_left_corner;
	      if (y >= h - lr) curs = XC_bottom_left_corner;

	    } else if ((y >= -2) && (y <= 2)) {
	      curs = XC_top_side;
	      if (x < lr) curs = XC_top_left_corner;
	      if (x >= w - lr) curs = XC_top_right_corner;

	    } else if ((x >= (w - 2)) && (x <= (w + 2))) {
	      curs = XC_right_side;
	      if (y < lr) curs = XC_top_right_corner;
	      if (y >= (h - lr)) curs = XC_bottom_right_corner;

	    } else if ((y >= (h - 2)) && (y <= (h + 2))) {
	      curs = XC_bottom_side;
	      if (x < lr) curs = XC_bottom_left_corner;
	      if (x >= (w - lr)) curs = XC_bottom_right_corner;
	    }
	    Set_Cursor((TWins*)self, curs);
	}
}

void AzGraf_CutOut_OnMouseDown(TWins *self, XButtonEvent *ev) {
  TMainForm *fmain = appDat.obj;
  TFormCutOut *fcut = fmain->fcutout;

	fcut->odvX  = fcut->dvX->dval;
	fcut->odvXz = fcut->dvXz->dval;
	fcut->odvY  = fcut->dvY->dval;
	fcut->odvYz = fcut->dvYz->dval;
	fcut->odvW  = fcut->dvW->dval;
	fcut->odvWz = fcut->dvWz->dval;
	fcut->odvH  = fcut->dvH->dval;
	fcut->odvHz = fcut->dvHz->dval;

	if ((self->cursor_nr != XC_top_left_arrow) &&
	    CutOut_Chk_On()) {
		MouseDown.obj_left = TDVal_GetInteger(fcut->dvXz);
		MouseDown.obj_top = TDVal_GetInteger(fcut->dvYz);
		MouseDown.obj_width = TDVal_GetInteger(fcut->dvWz);
		MouseDown.obj_height = TDVal_GetInteger(fcut->dvHz);

	}
}

void AzGraf_CutOut_OnMouseUp(TWins *self, XButtonEvent *ev) {
  TMainForm *fmain = (TMainForm*)self->FormStruct;

	    if (fmain->selAkt) {
		fmain->selAkt = False;
		DrawRectFocus(fmain->AzGraf->WinID, 
			fmain->selx, fmain->sely,
			fmain->selw, fmain->selh);

		if (!TestWinIsVisible((TWins*)fmain->fcutout))
			TForm_Show((TForm*)fmain->fcutout);
		ALDpic_resize_pxm(fmain);
		Refresh((TWins*)fmain->AzGraf);
	    }
}

static void dvXz_OnValChange(TDVal *dv, double dval) {
  TMainForm *fmain = appDat.obj;
	TDVal_Set_Value_ev(fmain->fcutout->dvX, dval / fmain->zoom_k);
}
static void dvYz_OnValChange(TDVal *dv, double dval) {
  TMainForm *fmain = appDat.obj;
	TDVal_Set_Value_ev(fmain->fcutout->dvY, dval / fmain->zoom_kh);
}
static void dvWz_OnValChange(TDVal *dv, double dval) {
  TMainForm *fmain = appDat.obj;
	TDVal_Set_Value_ev(fmain->fcutout->dvW, dval / fmain->zoom_k);
}
static void dvHz_OnValChange(TDVal *dv, double dval) {
  TMainForm *fmain = appDat.obj;
	TDVal_Set_Value_ev(fmain->fcutout->dvH, dval / fmain->zoom_kh);
}

static void dvX_OnValChange(TDVal *dv, double dval) {
  TMainForm *fmain = appDat.obj;
	if (fmain->rsz_run) return;
	ALDpic_resize_pxm(fmain);
	Refresh((TWins*)fmain->AzGraf);
}

static void cbCutOutOn_OnClick(TChkBox *self, long KeyState, bool DblClick) {
  TMainForm *fmain = appDat.obj;
	ALDpic_resize_pxm(fmain);
	Set_Cursor((TWins*)fmain->AzGraf, XC_top_left_arrow);
	Refresh((TWins*)fmain->AzGraf);
}

/* ______________________ Focus Ev ___________________________________ */
static void dvX_OnFocus(TDVal *self, int Change) {
	if (!(Change & WinsFocusIN)) return;

  TMainForm *fmain = appDat.obj;
  TFormCutOut *fcut = fmain->fcutout;
  TPixMap *pxm = ALDpic_pxm_get(fmain, ib_rszbase_pxm);
  int w = pxm->width - TDVal_GetInteger(fcut->dvW);
	if (w < 0) w = 0;
	TDVal_Set_Max(fcut->dvX, w);
	w = fmain->old_w - TDVal_GetInteger(fcut->dvWz);
	if (w < 0) w = 0;
	TDVal_Set_Max(fcut->dvXz, w);
}

static void dvW_OnFocus(TDVal *self, int Change) {
	if (!(Change & WinsFocusIN)) return;
  TMainForm *fmain = appDat.obj;
  TFormCutOut *fcut = fmain->fcutout;
  TPixMap *pxm = ALDpic_pxm_get(fmain, ib_rszbase_pxm);
  int w = pxm->width - TDVal_GetInteger(fcut->dvX);
 	if (w < 0) w = 0;
	TDVal_Set_Max(fcut->dvW, w);
	w = fmain->old_w - TDVal_GetInteger(fcut->dvXz);
	if (w < 0) w = 0;
	TDVal_Set_Max(fcut->dvWz, w);
}

static void dvY_OnFocus(TDVal *self, int Change) {
	if (!(Change & WinsFocusIN)) return;
  TMainForm *fmain = appDat.obj;
  TFormCutOut *fcut = fmain->fcutout;
  TPixMap *pxm = ALDpic_pxm_get(fmain, ib_rszbase_pxm);
  int h = pxm->height - TDVal_GetInteger(fcut->dvH);
 	if (h < 0) h = 0;
	TDVal_Set_Max(fcut->dvY, h);
	h = fmain->old_h - TDVal_GetInteger(fcut->dvHz);
	if (h < 0) h = 0;
	TDVal_Set_Max(fcut->dvYz, h);
}

static void dvH_OnFocus(TDVal *self, int Change) {
	if (!(Change & WinsFocusIN)) return;
  TMainForm *fmain = appDat.obj;
  TFormCutOut *fcut = fmain->fcutout;
  TPixMap *pxm = ALDpic_pxm_get(fmain, ib_rszbase_pxm);
  int h = pxm->height - TDVal_GetInteger(fcut->dvY);
 	if (h < 0) h = 0;
	TDVal_Set_Max(fcut->dvH, h);
	h = fmain->old_h - TDVal_GetInteger(fcut->dvYz);
	if (h < 0) h = 0;
	TDVal_Set_Max(fcut->dvHz, h);
}

/* ______________________ Form Ev ____________________________________ */
static void TFormCutOut_OnKeyDown(TFormCutOut *self, TKeyEvent *KeyEv) {
  TMainForm *fmain = appDat.obj;
  TWins *dv = self->FocusWin;
  bool isdv = (dv && (dv->wtyp == wtyp_TDVal));

	if (((KeyEv->keycode == 54)) && (KeyEv->state & 0x4)) {      //Strg_C
	    if (isdv && (dv->vds.SelA != dv->vds.SelE)) return;
	    KeyEv->keycode = 0;
	    KeyEv->keysym = 0;
	    TMainForm_Copy(fmain);  //in mTools.c
	    return;

	} else if ((KeyEv->keycode == 53) && (KeyEv->state & 0x4)) { //Strg_X
	    if (isdv && (dv->vds.SelA != dv->vds.SelE)) return;
	    KeyEv->keycode = 0;
	    KeyEv->keysym = 0;
	    return;

	} else if ((KeyEv->keycode == 55) && (KeyEv->state & 0x4)) { //Strg_V

      bool en;
#ifdef _OS_WIN32
	    en = Chk_GetSelection(1, CF_DIB);
#else
	    en = Chk_GetSelection(2, XA_PIXMAP, appXDat.XA_IMAGE_PNG);
#endif
	    if (en) {
		TMainForm_Paste(fmain);  //in mTools.c
	    }
	    if (en || !isdv) {
		KeyEv->keycode = 0;
		KeyEv->keysym = 0;
	    }
	    return;
	}
}

static void TFormCutOut_OnMove(TFormCutOut *self) {
  TpcIni *ti = TpcIni_Create(appDat.inifile_app);
	TpcIni_WR_int(ti, "FormCutOut", "Top", self->top);
	TpcIni_WR_int(ti, "FormCutOut", "Left", self->left);
	TpcIni_SaveAndFree(ti);
}

/* ______________________ Create _____________________________________ */
static void CutOut_TDVal_Create(TWins *parent, TDVal **dv, int x, int addv) {
  TDVal *dvn;
	dvn = TDVal_CreateSV4(parent, x, 1, 42, 18, 0, 0, 9999, 0);
	dvn->MouseMove_add_dval = addv;
	dvn->BorderFu = mBorder|mBorderL;
	dvn->dv_fu = tdv_fu_LostFocusEnter | tdv_fu_MouseMove_add;
	*dv = dvn;
}


TFormCutOut *TFormCutOut_Create(TMainForm *fmain) {
  TFormCutOut *self;
  TpcIni *ti = appDat.appIni;

	if (!ti) ti = TpcIni_Create(appDat.inifile_app);
 
	self = TForm_CreatParamAlg((TWins*)fmain, sizeof(TFormCutOut));
	self->FormZStyle = fszTransient;
	self->FormPosition = poDesigned;
	SetCaption((TWins*)self, "ALDpic CutOut");
	self->Visible = False;
	self->top = TpcIni_RD_int(ti, "FormCutOut", "Top", 0);
	self->left = TpcIni_RD_int(ti, "FormCutOut", "Left", 0);
	self->max_width = self->min_width = self->width = 200;
	self->max_height = self->min_height = self->height = 102;
	self->OnKeyDown = TFormCutOut_OnKeyDown;
	self->OnMove = TFormCutOut_OnMove;

	self->lblOrgStat = TWins_CreateLabelA((TWins*)self, 0, 102, 230, 16, NULL, mCaptionLeft, mBorder|mBorderL, alTop);

	self->lblX = TWins_CreateLabelA((TWins*)self, 0, 19, 110, 20, "Xo", mCaptionLeft, mBorder|mBorderL, 0);
	CutOut_TDVal_Create(self->lblX, &self->dvX, 24, 1);
	self->dvX->OnValChange = dvX_OnValChange;
	self->dvX->OnFocus = dvX_OnFocus;

	CutOut_TDVal_Create(self->lblX, &self->dvXz, 67, 1);
	self->dvXz->OnValChange = dvXz_OnValChange;
	self->dvXz->OnFocus = dvX_OnFocus;


	self->lblW = TWins_CreateLabelA((TWins*)self, 0, 39, 110, 20, "W", mCaptionLeft, mBorder|mBorderL, 0);
	CutOut_TDVal_Create(self->lblW, &self->dvW, 24, 1);
	self->dvW->OnValChange = dvX_OnValChange;
	self->dvW->OnFocus = dvW_OnFocus;

	CutOut_TDVal_Create(self->lblW, &self->dvWz, 67, 1);
	self->dvWz->OnValChange = dvWz_OnValChange;
	self->dvWz->OnFocus = dvW_OnFocus;


	self->lblY = TWins_CreateLabelA((TWins*)self, 0, 61, 110, 20, "Yo", mCaptionLeft, mBorder|mBorderL, 0);
	CutOut_TDVal_Create(self->lblY, &self->dvY, 24, -1);
	self->dvY->OnValChange = dvX_OnValChange;
	self->dvY->OnFocus = dvY_OnFocus;

	CutOut_TDVal_Create(self->lblY, &self->dvYz, 67, -1);
	self->dvYz->OnValChange = dvYz_OnValChange;
	self->dvYz->OnFocus = dvY_OnFocus;


	self->lblH = TWins_CreateLabelA((TWins*)self, 0, 81, 110, 20, "H", mCaptionLeft, mBorder|mBorderL, 0);
	CutOut_TDVal_Create(self->lblH, &self->dvH, 24, -1);
	self->dvH->OnValChange = dvX_OnValChange;
	self->dvH->OnFocus = dvH_OnFocus;

	CutOut_TDVal_Create(self->lblH, &self->dvHz, 67, -1);
	self->dvHz->OnValChange = dvHz_OnValChange;
	self->dvHz->OnFocus = dvH_OnFocus;


	self->cbCutOutOn = TChkBox_CreateS((TWins*)self, 116, 20, 82, 16, "CutOut On");
	self->cbCutOutOn->OnClick = cbCutOutOn_OnClick;

	if (!appDat.appIni) Tfree(ti);

	return self;
}
