/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldpic.h"

static void miPngCompLev_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
  TMenuItem *mi = ((TMenu*)fpic->menu_pngCompLev)->MenuItem;
	while (mi) {
	    mi->fu &= ~miChecked;
	    mi = mi->next;
	}
	smi->fu |= miChecked;
	fpic->pngCompLev = smi->tag;
}

static void miJpgQuality_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
  TMenuItem *mi = ((TMenu*)fpic->menu_jpgQuality)->MenuItem;
	while (mi) {
	    mi->fu &= ~miChecked;
	    mi = mi->next;
	}
	smi->fu |= miChecked;
	fpic->jpgQuality = smi->tag;
}

static void miPnmPlain_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
	fpic->pnm_plain = (smi->fu & miChecked) != 0;
}

static void miBmpAutoMask_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
	fpic->bmp_AutoMask = (smi->fu & miChecked) != 0;
	ALDpic_Chk_AutoMask(fpic, 1);
	Refresh((TWins*)fpic->AzGraf);
}

static void miGRAY_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
	fpic->gray = (smi->fu & miChecked) != 0;
}

static void miGRAY_nature_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
	fpic->iocfu &= ~VIOCFU_GRAY_NATURE;
	if (smi->fu & miChecked) fpic->iocfu |= VIOCFU_GRAY_NATURE;
}

static void miNegative_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
	fpic->iocfu &= ~VIOCFU_NEGATIV;
	if (smi->fu & miChecked) fpic->iocfu |= VIOCFU_NEGATIV;
}

static void miColorOrder_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fmain;
  TMenuItem *mi;

	mi = self->MenuItem;
	while (mi) {
	    mi->fu &= ~miChecked;
	    mi = mi->next;
	}
	smi->fu |= miChecked;
	fmain = (TMainForm*)self->FormStruct;
	fmain->ColorOrder = smi->tag;
}

static void mibpp_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
  TMenuItem *mi = ((TMenu*)fpic->menuSetting)->MenuItem;
	while (mi) {
	    if (mi->tag & 0x10000) mi->fu &= ~miChecked;
	    mi = mi->next;
	}
	smi->fu |= miChecked;
	fpic->bpp = smi->tag & 0x0ffff;
}

void menuSetting_clr(TMainForm *fmain) {  //low mem
TMenuItem *mi;

	if (!fmain->menuSetting) return;
	mi = fmain->menuSetting->MenuItem;
	while (mi) {
	    if (mi->tag & 0x100000) {
		mi->fu &= ~miChecked;
		if (mi->tag & 0x200000) mi->fu |= miChecked;
	    }
	    mi = mi->next;
	}
	fmain->bpp = 0;
	fmain->gray = 0;
	fmain->iocfu &= ~VIOCFU_NEGATIV;
}

static void AddRGB_Menu(TMainForm *self, int tag, const char *s, int c1, int c2, int c3) {
  TPixMap *pxm;
  TMenuItem *mi;

	pxm = TPixMap_Create_whLD(15, 16, 0);
	TPixMap_img_malloc(pxm);
	TImage_FillRectRGB((TImage*)pxm, c1,  0, 0, 5, 16);
	TImage_FillRectRGB((TImage*)pxm, c2,  5, 0, 5, 16);
	TImage_FillRectRGB((TImage*)pxm, c3, 10, 0, 5, 16);
	TPixMap_XPutImage(pxm);

	mi = TMenu_AddItem(self->menuColorOrder, s, miCanCheck, miColorOrder_OnClick);
	mi->tag = tag;
	if (!tag) mi->fu |= miChecked;

	mi->pic = xcalloc(sizeof(TPic));
	mi->pic->width = pxm->width;
	mi->pic->height = pxm->height;
	mi->pic->pic = pxm->pmxID;
	pxm->pmxID = 0;
	Tfree(pxm);
}



/* ______________________ Create _____________________________________ */
void MenuSetting_Create(TMainForm *self) {
  TMenuItem *mi, *mi2;
	self->mbSetting = TMenuButton_Create(self->PanelTop, self->mbFile);
	SetCaption((TWins*)self->mbSetting, "Settings");
	Set_Parent((TWins*)self->mbSetting, self->PanelTop);
	self->menuSetting = TMenu_Create((TWins*)self);
	self->mbSetting->menu = self->menuSetting;

	if (TImageWR_AllFiletyp & filetyp_PNG) {
	  mi = TMenu_AddItem(self->menuSetting, "PNG", 0, NULL);
	    self->menu_png = (TMenu*)TMenu_Create((TWins*)self);
	    mi->next_menu = self->menu_png;
	    mi2 = TMenu_AddItem(self->menu_png, "Compress level", 0, NULL);
		self->menu_pngCompLev = TMenu_Create((TWins*)self);
		mi2->next_menu = self->menu_pngCompLev;
		TMenu_AddItem(self->menu_pngCompLev, "Speed", 
			miCanCheck, miPngCompLev_OnClick)->tag = 4; //4-1=3
		self->pngCompLev = 0;
		TMenu_AddItem(self->menu_pngCompLev, "Default", 
			miCanCheck | miChecked, miPngCompLev_OnClick); //0-1=-1
		TMenu_AddItem(self->menu_pngCompLev, "Max", 
			miCanCheck, miPngCompLev_OnClick)->tag = 10; //10-1=9
	    self->miPngPallette = TMenu_AddItem(self->menu_png, "use pallette <=256", 
			miChecked|miAutoToggle, NULL);
	}

	if (TImageWR_AllFiletyp & filetyp_JPEG) {
	  mi = TMenu_AddItem(self->menuSetting, "JPG", 0, NULL);
	    self->menu_jpg = TMenu_Create((TWins*)self);
	    mi->next_menu = self->menu_jpg;
	    mi2 = TMenu_AddItem(self->menu_jpg, "Quality", 0, NULL);
		self->menu_jpgQuality = (TMenu*)TMenu_Create((TWins*)self);
		mi2->next_menu = self->menu_jpgQuality;
		TMenu_AddItem(self->menu_jpgQuality, "100", 
			miCanCheck, miJpgQuality_OnClick)->tag = 100;
		TMenu_AddItem(self->menu_jpgQuality, "98", 
			miCanCheck, miJpgQuality_OnClick)->tag = 98;
		TMenu_AddItem(self->menu_jpgQuality, "95", 
			miCanCheck | miChecked, miJpgQuality_OnClick)->tag = 95;
		TMenu_AddItem(self->menu_jpgQuality, "90", 
			miCanCheck, miJpgQuality_OnClick)->tag = 90;
		TMenu_AddItem(self->menu_jpgQuality, "83", 
			miCanCheck, miJpgQuality_OnClick)->tag = 83;
		TMenu_AddItem(self->menu_jpgQuality, "75", 
			miCanCheck, miJpgQuality_OnClick)->tag = 75;
		TMenu_AddItem(self->menu_jpgQuality, "63", 
			miCanCheck, miJpgQuality_OnClick)->tag = 63;
		TMenu_AddItem(self->menu_jpgQuality, "50", 
			miCanCheck, miJpgQuality_OnClick)->tag = 50;
		TMenu_AddItem(self->menu_jpgQuality, "40", 
			miCanCheck, miJpgQuality_OnClick)->tag = 40;
		TMenu_AddItem(self->menu_jpgQuality, "25", 
			miCanCheck, miJpgQuality_OnClick)->tag = 25;
		self->jpgQuality = 95;
	}

	if (TImageWR_AllFiletyp & filetyp_PNM) {
	    TMenu_AddItem(self->menuSetting, "PPM,PNM  plain",
				miCanCheck|miAutoToggle, miPnmPlain_OnClick);
	}

	self->miAutoMask = TMenu_AddItem(self->menuSetting, "Auto Mask",
				miCanCheck|miAutoToggle, miBmpAutoMask_OnClick);


	TMenu_AddItem(self->menuSetting, "-", 0, NULL);
	TMenu_AddItem(self->menuSetting, "GRAY", 
			miCanCheck|miAutoToggle, miGRAY_OnClick)->tag = 0x100000;
	TMenu_AddItem(self->menuSetting, "GRAY nature", 
			miCanCheck|miAutoToggle, miGRAY_nature_OnClick);
	TMenu_AddItem(self->menuSetting, "Negative", 
			miCanCheck|miAutoToggle, miNegative_OnClick)->tag = 0x100000;

	TMenu_AddItem(self->menuSetting, "-", 0, NULL);
	self->miColorOrder = TMenu_AddItem(self->menuSetting, "Color Order", 0, NULL);
	  self->menuColorOrder = TMenu_Create((TWins*)self);
	  self->miColorOrder->next_menu = self->menuColorOrder;
	    AddRGB_Menu(self, IMGCOLORORDER_RGB_TO_RGB, " R G B", 0xff0000, 0x00ff00, 0x0000ff);
	    AddRGB_Menu(self, IMGCOLORORDER_RGB_TO_RBG, " R B G", 0xff0000, 0x0000ff, 0x00ff00);
	    AddRGB_Menu(self, IMGCOLORORDER_RGB_TO_GRB, " G R B", 0x00ff00, 0xff0000, 0x0000ff);
	    AddRGB_Menu(self, IMGCOLORORDER_RGB_TO_GBR, " G B R", 0x00ff00, 0x0000ff, 0xff0000);
	    AddRGB_Menu(self, IMGCOLORORDER_RGB_TO_BRG, " B R G", 0x0000ff, 0xff0000, 0x00ff00);
	    AddRGB_Menu(self, IMGCOLORORDER_RGB_TO_BGR, " B G R", 0x0000ff, 0x00ff00, 0xff0000);

	TMenu_AddItem(self->menuSetting, "-", 0, NULL);
	TMenu_AddItem(self->menuSetting, "bpp Default", 
		miCanCheck | miChecked, mibpp_OnClick)->tag = 0x310000;
	TMenu_AddItem(self->menuSetting, "bpp 6", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp6;
	TMenu_AddItem(self->menuSetting, "bpp 7", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp7;
	TMenu_AddItem(self->menuSetting, "bpp 8", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp8;
	TMenu_AddItem(self->menuSetting, "bpp 9", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp9;
	TMenu_AddItem(self->menuSetting, "bpp 10", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp10;
	TMenu_AddItem(self->menuSetting, "bpp 12", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp12;
	TMenu_AddItem(self->menuSetting, "bpp 15", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp15;
	TMenu_AddItem(self->menuSetting, "bpp 16", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp16;
	TMenu_AddItem(self->menuSetting, "bpp 18", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp18;
}
