/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldpic.h"
#include "cicons.h"

static bool chkPathOk(TMainForm *fpic) {
  TglobPath *gp1, *gp2;
  bool res;

	if (!fpic->pxmFile) return False;
	gp1 = pctogp(fpic->pxmFile);
	gp2 = TFileWin_Get_gp(fpic->FileWin);
	slash_korr(gp1->path, False);
	res = (gp2 && !pccasecmpASCII(gp1->RootArt, gp2->RootArt) &&
	       !pccasecmpASCII(gp1->path, gp2->path));
	gpFree(gp1);
	return res;
}

void ALDpic_mbPlay_Chk_en(TMainForm *fpic) {
  TDirFileList *dfl, *dflx;
  const char *fn;
  int st;

	dfl = TFileWin_Get_dfl0(fpic->FileWin);
	while (dfl && !(dfl->st->st & st_Reg)) dfl = dfl->next;

	st = 0x00;
	if (dfl) {
	    if (!chkPathOk(fpic)) {
		st = 0x0f;
	    } else {
		dflx = dfl;
		fn = GetFileName_pc(fpic->pxmFile);
		if (!pccmp(fn, Get_ExFileDat_pc(dfl->st, exfdt_FileName))) {
		    st = 0x03;
		}

		while (dfl) {
		    if (dfl->st->st & st_Reg) dflx = dfl;
		    dfl = dfl->next;
		}
		if (!pccmp(fn, Get_ExFileDat_pc(dflx->st, exfdt_FileName))) {
		    st |= 0x0c;
		}

	    }
	}
	ALDpic_mbXXXX_Set_en(fpic, st);
}

static void ALDpic_mbPlay_X(TMainForm *fpic, TDirFileList *dfl) {
  TDirFileList *dflx = TFileWin_Get_dfl0(fpic->FileWin);
  int idx = 0;
	if (!dfl) return;
	while (dflx && (dflx != dfl)) {dflx = dflx->next; idx++;}
	if (!dflx) return;
	TFileWin_SetSelect(fpic->FileWin, idx, 0x13);
}

void ALDpic_mbPlayrigth_OnClick(TMenuButton *self, long KeyState, bool DblClick) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
  TDirFileList *dfl = TFileWin_Get_dfl0(fpic->FileWin);
  const char *fn;

	while (dfl && !(dfl->st->st & st_Reg)) dfl = dfl->next;
	if (!dfl) return;

	if (chkPathOk(fpic)) {
	    fn = GetFileName_pc(fpic->pxmFile);
	    while (dfl) {
		if ((dfl->st->st & st_Reg) && 
		    pccmp(fn, Get_ExFileDat_pc(dfl->st, exfdt_FileName))) {
		    dfl = dfl->next;
		    break;
		}
		dfl = dfl->next;
	    }
	}
	ALDpic_mbPlay_X(fpic, dfl);
}


static void ALDpic_mbPlay2rigth_OnClick(TMenuButton *self, long KeyState, bool DblClick) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
  TDirFileList *dfl, *dflx;

	dflx = NULL;
	dfl = TFileWin_Get_dfl0(fpic->FileWin);
	while (dfl) {
	    if (dfl->st->st & st_Reg) dflx = dfl;
	    dfl = dfl->next;
	}
	ALDpic_mbPlay_X(fpic, dflx);
}

void ALDpic_mbPlayleft_OnClick(TMenuButton *self, long KeyState, bool DblClick) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
  TDirFileList *dfl, *dflx;
  const char *fn;

	dfl = TFileWin_Get_dfl0(fpic->FileWin);
	while (dfl && !(dfl->st->st & st_Reg)) dfl = dfl->next;
	if (!dfl) return;

	dflx = dfl;
	if (chkPathOk(fpic)) {
	    fn = GetFileName_pc(fpic->pxmFile);
	    while (dfl) {
		if (dfl->st->st & st_Reg) {
		    if (pccmp(fn, Get_ExFileDat_pc(dfl->st, exfdt_FileName))) break;
		    dflx = dfl;
		}
		dfl = dfl->next;
	    }
	}
	ALDpic_mbPlay_X(fpic, dflx);
}

static void ALDpic_mbPlay2left_OnClick(TMenuButton *self, long KeyState, bool DblClick) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
  TDirFileList *dfl = TFileWin_Get_dfl0(fpic->FileWin);
	while (dfl && !(dfl->st->st & st_Reg)) dfl = dfl->next;
	ALDpic_mbPlay_X(fpic, dfl);
}

/* ______________________ Create _____________________________________ */
void MenuButtonPlay_Create(TMainForm *self) {
	self->mbPlayleft = TMenuButton_Create(self->PanelTop, self->mbFile);
	self->mbPlayleft->Enabled = False;
	self->mbPlayleft->pic = get_pic16_playleft(False);
	self->mbPlayleft->dis_pic = get_pic16_playleft(True);
	self->mbPlayleft->OnClick = ALDpic_mbPlayleft_OnClick;
	Set_Parent((TWins*)self->mbPlayleft, self->PanelTop);

	self->mbPlay2left = TMenuButton_Create(self->PanelTop, self->mbFile);
	self->mbPlay2left->Enabled = False;
	self->mbPlay2left->pic = get_pic16_play2left(False);
	self->mbPlay2left->dis_pic = get_pic16_play2left(True);
	self->mbPlay2left->OnClick = ALDpic_mbPlay2left_OnClick;
	Set_Parent((TWins*)self->mbPlay2left, self->PanelTop);

	self->mbPlay2rigth = TMenuButton_Create(self->PanelTop, self->mbFile);
	self->mbPlay2rigth->Enabled = False;
	self->mbPlay2rigth->pic = get_pic16_play2rigth(False);
	self->mbPlay2rigth->dis_pic = get_pic16_play2rigth(True);
	self->mbPlay2rigth->OnClick = ALDpic_mbPlay2rigth_OnClick;
	Set_Parent((TWins*)self->mbPlay2rigth, self->PanelTop);

	self->mbPlayrigth = TMenuButton_Create(self->PanelTop, self->mbFile);
	self->mbPlayrigth->Enabled = False;
	self->mbPlayrigth->pic = get_pic16_playrigth(False);
	self->mbPlayrigth->dis_pic = get_pic16_playrigth(True);
	self->mbPlayrigth->OnClick = ALDpic_mbPlayrigth_OnClick;
	Set_Parent((TWins*)self->mbPlayrigth, self->PanelTop);

}
