/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldpic.h"
#include "cicons.h"

/* ca. sqrt(D*D*0.8) */
static const int ZoomTab [] = {
  200, 175, 150, 133, 125, 110, 100, 90, 80, 70, 62, 55, 50, 45, 40, 36, 32, 28, 25, 22, 19,
  16, 14, 12, 10, 8, 7, 6, 5, 4, 3, 2, 1, 0
};

static void mbZoom_plus_OnClick(TMenuButton* self, long KeyState, bool DblClick) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
  int i, x, k;
	if (!fpic->pxm) return;
	k = 200;
	i = 0;
	x = ZoomTab[i];
	while (x && (x > fpic->sbZoom->Count)) {
	    i++; k = x;
	    x = ZoomTab[i];
	}
	TScrollBar_SetCount_ev(fpic->sbZoom, k);
}

static void mbZoom_minus_OnClick(TMenuButton* self, long KeyState, bool DblClick) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
  int i, x;
	if (!fpic->pxm) return;
	i = 0;
	x = ZoomTab[i];
	while (x && (x >= fpic->sbZoom->Count)) {
	    i++; 
	    x = ZoomTab[i];
	}
	TScrollBar_SetCount_ev(fpic->sbZoom, x);
}


static void mbZoom_xy_OnClick(TMenuButton *self, long KeyState, bool DblClick) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
  double z_k, zoom_k = 0;
  int width, height;

	if (!fpic->pxm) return;

	width = fpic->AzGraf->width;
	height = fpic->AzGraf->height;
	switch (self->tag) {
	case 0:
	    zoom_k = 1;
	    break;
	case 1:
	    zoom_k = (double)width / (double)fpic->pxm->width;
	    break;
	case 2:
	    zoom_k = (double)height / (double)fpic->pxm->height;
	    break;
	case 3:
	    zoom_k = (double)width / (double)fpic->pxm->width;
	    z_k = (double)height / (double)fpic->pxm->height;
	    if (zoom_k > z_k) zoom_k = z_k;
	    break;
	}

	if (zoom_k < 0.005) zoom_k = 0.005;

	fpic->new_zoom_k = zoom_k;
	fpic->new_zoom_kh = zoom_k;
	ALDpic_resize_pxm(fpic);

	fpic->sbZoom->Count = fpic->old_w * 100 / fpic->pxm->width;
	TScrollBar_Refresh(fpic->sbZoom);

	if (!CutOut_Chk_On()) {
	    TScrollBar_SetCount(fpic->AzGraf->HSB, 0);
	    fpic->HSB_Count = 0;
	    TScrollBar_SetCount(fpic->AzGraf->VSB, 0);
	    fpic->VSB_Count = 0;
	}

	Refresh((TWins*)fpic->AzGraf);
}

/* ______________________ Create _____________________________________ */
void MenuButtonZoom_Create(TMainForm *self) {

	self->mbZoom_no = TMenuButton_Create(self->PanelTop, self->mbFile);
	self->mbZoom_no->pic = &self->picZoom_no;
	self->mbZoom_no->dis_pic = &self->picZoom_xy_dis;
	self->mbZoom_no->tag = 0;
	self->mbZoom_no->OnClick = mbZoom_xy_OnClick;
	Set_Parent((TWins*)self->mbZoom_no, self->PanelTop);

	self->mbZoom_w = TMenuButton_Create(self->PanelTop, self->mbFile);
	self->mbZoom_w->pic = &self->picZoom_w;
	self->mbZoom_w->dis_pic = &self->picZoom_w_dis;
	self->mbZoom_w->tag = 1;
	self->mbZoom_w->OnClick = mbZoom_xy_OnClick;
	Set_Parent((TWins*)self->mbZoom_w, self->PanelTop);

	self->mbZoom_h = TMenuButton_Create(self->PanelTop, self->mbFile);
	self->mbZoom_h->pic = &self->picZoom_h;
	self->mbZoom_h->dis_pic = &self->picZoom_h_dis;
	self->mbZoom_h->tag = 2;
	self->mbZoom_h->OnClick = mbZoom_xy_OnClick;
	Set_Parent((TWins*)self->mbZoom_h, self->PanelTop);

	self->mbZoom_wh = TMenuButton_Create(self->PanelTop, self->mbFile);
	self->mbZoom_wh->pic = &self->picZoom_wh;
	self->mbZoom_wh->dis_pic = &self->picZoom_wh_dis;
	self->mbZoom_wh->tag = 3;
	self->mbZoom_wh->OnClick = mbZoom_xy_OnClick;
	Set_Parent((TWins*)self->mbZoom_wh, self->PanelTop);

	self->mbZoom_minus = TMenuButton_Create(self->PanelTop, self->mbFile);
	self->mbZoom_minus->pic = &self->picZoom_minus;
	self->mbZoom_minus->dis_pic = &self->picZoom_minus_dis;
	self->mbZoom_minus->OnClick = mbZoom_minus_OnClick;
	Set_Parent((TWins*)self->mbZoom_minus, self->PanelTop);

	self->mbZoom_plus = TMenuButton_Create(self->PanelTop, self->mbFile);
	self->mbZoom_plus->pic = &self->picZoom_plus;
	self->mbZoom_plus->dis_pic = &self->picZoom_plus_dis;
	self->mbZoom_plus->OnClick = mbZoom_plus_OnClick;
	Set_Parent((TWins*)self->mbZoom_plus, self->PanelTop);

}
