/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include <unistd.h>
#include <fcntl.h>

#define PROCMEMINFO "/proc/meminfo"

int meminfo_scan(TMemInfo *MemInfo, const char *buf, int lg) {
  int resmk = 0;

	while (*buf && (lg > 0) && (resmk != 0x37)) {
	    if (*buf == 'M') {
		if (pcncmp("MemTotal:", buf, 9)) {
		    buf += 9;
		    MemInfo->Total = pctoint(buf);
		    resmk |= 0x01;
		} else if (pcncmp("MemFree:", buf, 8)) {
		    buf += 8;
		    MemInfo->Free = pctoint(buf);
		    resmk |= 0x02;
		}
	    } else if (*buf == 'C') {
		if (pcncmp("Cached:", buf, 7)) {
		    buf += 7;
		    MemInfo->Cached = pctoint(buf);
		    resmk |= 0x04;
		}
	    } else if (*buf == 'S') {
		if (pcncmp("SwapTotal:", buf, 10)) {
		    buf += 10;
		    MemInfo->SwapTotal = pctoint(buf);
		    resmk |= 0x10;
		} else if (pcncmp("SwapFree:", buf, 9)) {
		    buf += 9;
		    MemInfo->SwapFree = pctoint(buf);
		    resmk |= 0x20;
		}
	    }
	    while (*buf && (*buf != '\n')) {buf++; lg--;}
	    if (*buf == '\n') {buf++; lg--;}
	}
	return resmk;
}

int meminfo_get(TMemInfo *MemInfo) {
  int fd, l;
  int resmk = 0;
  char buf[4096];

	fd = open(PROCMEMINFO, O_RDONLY);
	if (fd > 0) {
	    l = read(fd, buf, sizeof(buf)-1);
	    close(fd);
	    if (l > 10) {
		buf[l] = 0;
		resmk = meminfo_scan(MemInfo, buf, l);
	    }
	}
	return resmk;
}
