/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldpic.h"

void SwapPic(TMainForm *self) {
  TPixMap *org_pxm, *rot_pxm;
  dword *line, *pls, *pld;
  byte *pls0, *pld0;
  bool RePaint_pxm;
  bool SwapX, SwapY, Rotat90, Rotat180, Rotat270;

	org_pxm = ALDpic_pxm_get(self, ib_org_pxm);
	if (!org_pxm ||
	    (!(self->miSwapX->fu & miChecked) &&
	     !(self->miSwapY->fu & miChecked) &&
	     !(self->miRotat90->fu & miChecked) &&
	     !(self->miRotat180->fu & miChecked) &&
	     !(self->miRotat270->fu & miChecked))) {
	    if (ALDpic_pxm_get(self, ib_rot_pxm)) {
		ALDpic_pxm_free(self, ib_rszfree_pxm | ib_rot_pxm);
	    }
	    self->SwapX = self->SwapY = False;
	    self->Rotat90 = self->Rotat180 = self->Rotat270 = False;
	    return;
	}

	RePaint_pxm = ALDpic_pxm_get(self, ib_rot_pxm) == NULL;
#ifndef _OS_WIN32
	if (RePaint_pxm) {
	    dword freemem = get_FreeMem(self, self->pxm0_mem);
	    if (!freemem) {
		menuTools_clr_rot_swap(self);
		MsgBox_Error((TWins*)self, "low mem\nDisable rotate and swap");
		return;
	    }
	}
#endif

	if (self->SwapX != ((self->miSwapX->fu & miChecked) != 0)) {
	    self->SwapX  = (self->miSwapX->fu & miChecked) != 0;
	    RePaint_pxm = True;
	}
	if (self->SwapY != ((self->miSwapY->fu & miChecked) != 0)) {
	    self->SwapY  =  (self->miSwapY->fu & miChecked) != 0;
	    RePaint_pxm = True;
	}

	if (self->Rotat90 != ((self->miRotat90->fu & miChecked) != 0)) {
	    self->Rotat90  =  (self->miRotat90->fu & miChecked) != 0;
	    RePaint_pxm = True;
	}
	if (self->Rotat180 != ((self->miRotat180->fu & miChecked) != 0)) {
	    self->Rotat180  =  (self->miRotat180->fu & miChecked) != 0;
	    RePaint_pxm = True;
	}
	if (self->Rotat270 != ((self->miRotat270->fu & miChecked) != 0)) {
	    self->Rotat270  =  (self->miRotat270->fu & miChecked) != 0;
	    RePaint_pxm = True;
	}

	if (!RePaint_pxm) return;
	ALDpic_pxm_free(self, ib_rszfree_pxm | ib_rot_pxm);

	SwapX = self->SwapX;
	SwapY = self->SwapY;
	Rotat90  = self->Rotat90;
	Rotat180 = self->Rotat180;
	Rotat270 = self->Rotat270;

	if (Rotat90 || Rotat270) {
	    rot_pxm = (TPixMap*)TImage_Create_dup_struct((TImage*)org_pxm, 0);
	    self->rot_pxm = rot_pxm;
	    rot_pxm->width  = org_pxm->height;
	    rot_pxm->height = org_pxm->width;
	    rot_pxm->img_malloc((TImage*)rot_pxm);
  int sadd0 = -4;
  int dadd0 = rot_pxm->bytes_per_line;
  int doff = 0;
  int dinc = 1;

	    pld0 = rot_pxm->data;
	    pls0 = org_pxm->data + (4 * (org_pxm->width-1));
	    line = xmalloc(rot_pxm->bytes_per_line);
	    if (Rotat270) {
		if (!SwapY) {doff = rot_pxm->width-1; dinc = -1;}
		if (!SwapX) {pls0 = org_pxm->data; sadd0 = 4;}
	    } else {
		if (SwapY) {doff = rot_pxm->width-1; dinc = -1;}
		if (SwapX) {pls0 = org_pxm->data; sadd0 = 4;}
	    }

	    for (int y=rot_pxm->height;y>0;y--) {
		pls = (dword*)pls0;
		pld = (dword*)line + doff;
		for (int x=org_pxm->height;x>0;x--) {
		    *pld = *pls;
		    pld += dinc; 
		    pls = (dword*)((byte*)pls + org_pxm->bytes_per_line);
		}
		pnmove(pld0, line, rot_pxm->bytes_per_line);
		pld0 += dadd0;
		pls0 += sadd0;
	    }
	    xfree(line);
	    return;
	}

	if (Rotat180) {
	    SwapX = !SwapX;
	    SwapY = !SwapY;
	}

	rot_pxm = NULL;
	if (SwapX || SwapY) {
	    rot_pxm = (TPixMap*)TImage_Create_dup_struct(
				(TImage*)org_pxm, dupfu_init_imgmem);
	}

	if (SwapX) {
	    pld0 = rot_pxm->data + (org_pxm->bytes_per_line * (org_pxm->height-1));
	    pls0 = org_pxm->data;
	    for (int y=org_pxm->height;y>0;y--) {
		pnmove(pld0, pls0, org_pxm->bytes_per_line);
		pld0 -= org_pxm->bytes_per_line;
		pls0 += org_pxm->bytes_per_line;
	    }
	    if (SwapY) {
		line = xmalloc(rot_pxm->bytes_per_line);
		pls0 = rot_pxm->data;
		for (int y=rot_pxm->height;y>0;y--) {
		    pls = (dword*)pls0;
		    pld = line + (rot_pxm->width-1);
		    for (int x=rot_pxm->width;x>0;x--) {
			*pld = *pls;
			pld--; pls++;
		    }
		    pnmove(pls0, line, rot_pxm->bytes_per_line);
		    pls0 += rot_pxm->bytes_per_line;
		}
		xfree(line);
	    }
	    org_pxm = rot_pxm;

	} else if (SwapY) {
	    pld0 = rot_pxm->data;
	    pls0 = org_pxm->data;
	    for (int y=org_pxm->height;y>0;y--) {
		pls = (dword*)pls0;
		pld = (dword*)pld0 + (org_pxm->width-1);
		for (int x=org_pxm->width;x>0;x--) {
		    *pld = *pls;
		    pld--; pls++;
		}
		pls0 += org_pxm->bytes_per_line;
		pld0 += org_pxm->bytes_per_line;
	    }
	    org_pxm = rot_pxm;
	}
	self->rot_pxm = rot_pxm;
}
