/*
 Copyright (C) 2010-2015 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "ElMath.h"
//#include "Form_RLC.h"
#include "ElGraf.h"
#include <math.h>

void Form_L_math(TFormL *fL, float w) {
  float uH;

//	uH = fL->L->dval;
//	if (fL->cbTL->Checked) uH = fL->TL->dval;
	uH = fL->TL->dval;

	SetUp_L(&fL->rlc, w, uH);
	if (fL->cbOptOn->Checked) {
	    if (fL->cbRs->Checked && (fL->Rs->dval > 0))
		RLC_Add_Ser_R(&fL->rlc, w, fL->Rs->dval);
	    if (fL->cbRp->Checked && (fL->Rp->dval > 0))
		RLC_Add_Par_R(&fL->rlc, w, fL->Rp->dval * 1000);
	    if (fL->cbCp->Checked && (fL->Cp->dval > 0))
		RLC_Add_Par_C(&fL->rlc, w, fL->Cp->dval * 0.000001);
	}
	if (fL->cbCs->Checked) {
	    RLC_Add_Ser_C(&fL->rlc, w, fL->dvCs->dval * 0.000001);
	}
}

static void fL_math_loc_Az(TFormL *fL) {
  float w = fL->MHz->dval * M_PI * 2;
	Form_L_math(fL, w);
	fL->Z->nk = 2;
	if (fL->rlc.Z >= 1000) fL->Z->nk = 1;
	if (fL->rlc.Z >= 10000) fL->Z->nk = 0;
	TDVal_Set_Value(fL->Z, fL->rlc.Z);
}

static void fL_Set_Stat_exDVal(TFormL *fL) {
  int Color = 0xffffff;
	if (!fL->exDVal) return;
//	if (fL->cbTL->Checked) {
	    fL->exDVal->ReadOnly = (fL->sbTL->Count != 0);
	    TDVal_Set_Value(fL->exDVal, fL->TL->dval);
//	} else {
//	    fL->exDVal->ReadOnly = False;
//	    TDVal_Set_Value(fL->exDVal, fL->L->dval);
//	}
	if (fL->exDVal->ReadOnly) Color = 0xe0e0e0;
	SetColor((TWins*)fL->exDVal, Color);
}

static void fL_math_loc(TFormL *fL) {
	fL_math_loc_Az(fL);
	fL_Set_Stat_exDVal(fL);
	if (fL->OnChange) fL->OnChange((TFormRLC*)fL);
}

static void fL_SaveDaten(TFormL *fL, TpcIni *ini) {
  TpcIni *pcIni = TpcIni_Create(appDat.inifile_app);
  char *pc;
  int OnOff = 0;
  char buf[512];

	pcIni = ini;
	if (!ini) pcIni = get_appIni();
	if (fL->cbOptOn->Checked) OnOff |= 0x01;
	if (fL->cbRs->Checked) OnOff |= 0x02;
	if (fL->cbRp->Checked) OnOff |= 0x04;
	if (fL->cbCp->Checked) OnOff |= 0x08;
//	if (fL->cbTL->Checked) OnOff |= 0x10;
	if (fL->cbTLsync->Checked) OnOff |= 0x20;
	if (fL->cbCs->Checked) OnOff |= 0x40;

	pc = buf;
	doubletoppc(&pc, fL->MHz->dval, fL->MHz->nk | kSPACE_ADD);
	doubletoppc(&pc, fL->Rs->dval, fL->Rs->nk | kSPACE_ADD);
	doubletoppc(&pc, fL->Rp->dval, fL->Rp->nk | kSPACE_ADD);
	doubletoppc(&pc, fL->Cp->dval, fL->Cp->nk | kSPACE_ADD);
	doubletoppc(&pc, fL->TLmin->dval, fL->TLmin->nk | kSPACE_ADD);
	doubletoppc(&pc, fL->dvCs->dval, fL->dvCs->nk | kSPACE_ADD);
	inttoppc(&pc, OnOff);

	TpcIni_WR(pcIni, fL->Gruppe, fL->sOpt, buf);
	TpcIni_WR_double(pcIni, fL->Gruppe, fL->sC, fL->L->dval, fL->L->nk);
	if (!ini) {
	    TpcIni_Save(pcIni);
	    free_appIni(pcIni);
	}
}

static void fL_cb_OnClick(TChkBox *self, long KeyState, bool DblClick) {
  TFormL *fL = (TFormL*)self->FormStruct;
	if (self == fL->cbCs) RePaint(fL->pnlL);
	fL_math_loc(fL);
	fL_SaveDaten(fL, NULL);
}

static void fL_TL_SetVal(TFormL *fL, int Count) {
  float L = fL->L->dval - (fL->L->dval - fL->TLmin->dval) * 
			    (float)(Count) / (float)(fL->sbTL->MaxCount);
	if (L < 0.001) L = 0.001;
	fL->TL->nk = 2;
	if (L < 1.0) fL->TL->nk = 3;
	if (L < 0.1) fL->TL->nk = 4;
	TDVal_Set_Value(fL->TL, L);
}

static void fL_DVal_OnValChange(TDVal *dv, double val) {
  TFormL *fL = (TFormL*)dv->FormStruct;
	fL_TL_SetVal(fL, TScrollBar_GetCount(fL->sbTL));
	fL_math_loc(fL);
	fL_SaveDaten(fL, NULL);
}

static void fL_sbTL_OnCount(TScrollBar* sb, int Count) {
  TFormL *fL = (TFormL*)sb->FormStruct;
  TPage_XFilter *pg = fL->subClass;

	fL_TL_SetVal(fL, Count);
	fL->val_sync = Count;
//	if (fL->OnSync && fL->cbTLsync->Checked) fL->OnSync((TFormRLC*)fL, Count);
	if (fL->cbTLsync->Checked) {
	    if (pg->f_Ls && (pg->f_Ls != fL)) 
				Form_L_sync((TFormRLC*)fL, pg->f_Ls, Count);
	    if (pg->f_Lx && (pg->f_Lx != fL)) 
				Form_L_sync((TFormRLC*)fL, pg->f_Lx, Count);
	    if (fL->OnSync) fL->OnSync((TFormRLC*)fL, Count);
	}
	fL_math_loc(fL);
}

void Form_L_sync(TFormRLC *fRLC, TFormL *fL, int val) {
	if (fRLC == (TFormRLC*)fL) return;
	fL->val_sync = val;
	if (fL->cbTLsync->Checked) {
	    TScrollBar_SetCount(fL->sbTL, val);
	    fL_TL_SetVal(fL, val);
	    fL_math_loc_Az(fL);
	    fL_Set_Stat_exDVal(fL);
	}
}

static void Form_L_SetFreq(TFormRLC *fRLC, float val) {
	TDVal_Set_Value(((TFormL*)fRLC)->MHz, val);
	fL_math_loc_Az((TFormL*)fRLC);
}

static void fL_pnlL_OnPaint(TWins *self) {
  TFormL *fL = (TFormL*)self->FormStruct;
  int x2;
  int x = 13;
  int y = 24;
  int y2 = y+17;
  int y3 = y2+13;
  bool Cs_On = fL->cbCs->Checked;

	if (Cs_On) x = 8;
	DrawPic(self->WinID, get_Pic_pto(), x, y+2);
	DrawLineRGB(self->WinID, 0, x+7, y+5, x+9, y+5);
	DrawPic(self->WinID, get_Pic_pt(), x+10, y+3);
	DrawLineRGB(self->WinID, 0, x+15, y+5, x+19, y+5);
	DrawPic(self->WinID, get_Pic_Rh(), x+20, y);
	  DrawPic(self->WinID, get_Pic_cRs(), x+25, y+10);
	DrawLineRGB(self->WinID, 0, x+40, y+5, x+49, y+5);
	DrawPic(self->WinID, get_Pic_Lh(), x+50, y);
	  DrawPic(self->WinID, get_Pic_cL(), x+58, y+10);
	DrawLineRGB(self->WinID, 0, x+70, y+5, x+84, y+5);
	DrawPic(self->WinID, get_Pic_pt(), x+75, y+3);
	x2 = x+85;
	if (Cs_On) {
	    DrawPic(self->WinID, get_Pic_Ch(), x2-3, y);
	      DrawPic(self->WinID, get_Pic_cCs(), x2, y+12);
	    x2 += 17;
	}
	DrawPic(self->WinID, get_Pic_pto(), x2, y+2);

	DrawPic(self->WinID, get_Pic_pt(), x+10, y2+3);
	DrawLineRGB(self->WinID, 0, x+12, y+8, x+12, y3+5);
	DrawLineRGB(self->WinID, 0, x+12, y2+5, x+34, y2+5);
	DrawPic(self->WinID, get_Pic_Rh(), x+35, y2);
	  DrawPic(self->WinID, get_Pic_cRp(), x+55, y2+7);
	DrawLineRGB(self->WinID, 0, x+55, y2+5, x+76, y2+5);
	DrawLineRGB(self->WinID, 0, x+77, y+8, x+77, y3+5);
	DrawPic(self->WinID, get_Pic_pt(), x+75, y2+3);

	DrawLineRGB(self->WinID, 0, x+12, y3+5, x+34, y3+5);
	DrawPic(self->WinID, get_Pic_Ch(), x+35, y3);
	  DrawPic(self->WinID, get_Pic_cCp(), x+50, y3+7);
	DrawLineRGB(self->WinID, 0, x+55, y3+5, x+76, y3+5);

/* TDVal L */
	DrawPic(self->WinID, get_Pic_cL(), fL->L->left-11, fL->L->top+7);
	DrawPic(self->WinID, get_Pic_cuH(), fL->L->left+fL->L->width+3, fL->L->top+7);
}


static void fL_pnlOpt_OnPaint(TWins *self) {
  TFormL *fL = (TFormL*)self->FormStruct;

	DrawPic(self->WinID, get_Pic_cRs(), fL->Rs->left-15, fL->Rs->top+5);
	DrawPic(self->WinID, get_Pic_cOhm(), fL->Rs->left+fL->Rs->width+3, fL->Rs->top+5);
	DrawPic(self->WinID, get_Pic_cRp(), fL->Rp->left-15, fL->Rp->top+5);
	DrawPic(self->WinID, get_Pic_ckOhm(), fL->Rp->left+fL->Rp->width+3, fL->Rp->top+5);
	DrawPic(self->WinID, get_Pic_cCp(), fL->Cp->left-15, fL->Cp->top+5);
	DrawPic(self->WinID, get_Pic_cpF(), fL->Cp->left+fL->Cp->width+3, fL->Cp->top+5);
}

static void fL_pnlZ_OnPaint(TWins *self) {
  TFormL *fL = (TFormL*)self->FormStruct;

	DrawPic(self->WinID, get_Pic_cf(), fL->MHz->left-8, fL->MHz->top+5);
	DrawPic(self->WinID, get_Pic_cMHz(), fL->MHz->left+fL->MHz->width+3, fL->MHz->top+5);
	DrawPic(self->WinID, get_Pic_cZ(), fL->Z->left-8, fL->Z->top+5);
	DrawPic(self->WinID, get_Pic_cOhm(), fL->Z->left+fL->Z->width+3, fL->Z->top+5);

	DrawPic(self->WinID, get_Pic_cuH(), fL->TL->left+fL->TL->width+3, fL->TL->top+5);
	DrawPic(self->WinID, get_Pic_cuH(), fL->TLmin->left+fL->TLmin->width+3, fL->TLmin->top+5);

	DrawPic(self->WinID, get_Pic_cpF(), fL->dvCs->left+fL->dvCs->width+3, fL->dvCs->top+5);

}
static void fL_pnlZ_OnResize(TWins *self) {
  TFormL *fL = (TFormL*)self->FormStruct;
	SetTop((TWins*)fL->TLmin, self->height-20);
	SetTop((TWins*)fL->TL, self->height-38);
	SetTop((TWins*)fL->cbTLsync, self->height-55);
}

static void Form_L_OnMove(TFormL *self) {
	TFormRLC_Save((TFormRLC*)self);
}

static void fL_LoadData(TFormL *self, TpcIni *ini) {
  int OnOff;
  const char *sopt;

	TDVal_Set_Value(self->L, TpcIni_RD_float(ini, self->Gruppe, self->sC, self->L->dval));
	sopt = TpcIni_RD_pc(ini, self->Gruppe, self->sOpt, "0 0 0 0 0 100 0x10");
	TDVal_Set_Value(self->MHz, ppctodouble(&sopt));
	TDVal_Set_Value(self->Rs, ppctodouble(&sopt));
	TDVal_Set_Value(self->Rp, ppctodouble(&sopt));
	TDVal_Set_Value(self->Cp, ppctodouble(&sopt));
	TDVal_Set_Value(self->TLmin, ppctodouble(&sopt));
	TDVal_Set_Value(self->dvCs, ppctodouble(&sopt));
//	ppctodouble(&sopt);
	OnOff = ppctoint(&sopt);
	TChkBox_SetChecked(self->cbOptOn, OnOff & 0x01);
	TChkBox_SetChecked(self->cbRs, OnOff & 0x02);
	TChkBox_SetChecked(self->cbRp, OnOff & 0x04);
	TChkBox_SetChecked(self->cbCp, OnOff & 0x08);
//	TChkBox_SetChecked(self->cbTL, OnOff & 0x10);
	TChkBox_SetChecked(self->cbTLsync, OnOff & 0x20);
	TChkBox_SetChecked(self->cbCs, OnOff & 0x40);
}

static void LoadData(TFormL *self, TpcIni *ini) {
	if (!ini) return;
	fL_LoadData(self, ini);
	TScrollBar_SetCount(self->sbTL, 0);
	TDVal_Set_Value(self->TL, self->L->dval);
	fL_Set_Stat_exDVal(self);
}

static void Update(TFormL *self, float val, int ufu) {
// printf("%s(%d): %f\n", FL, val);
	TDVal_Set_Value(self->L, val);
	TScrollBar_SetCount(self->sbTL, 0);
	TDVal_Set_Value(self->TL, self->L->dval);
	fL_Set_Stat_exDVal(self);
	fL_math_loc_Az(self);
}

TFormL *Create_Form_L(TWins *parent, const char *Caption, const char *Gruppe, 
			const char *sC, TDVal *exDVal, float val) {
  TFormL *fL;
  TpcIni *pcIni;
  const char *sopt;

	pcIni = get_appIni();

	fL = TForm_CreatParamAlg(parent, sizeof(TFormL));
	fL->wtyp = wtyp_TFormL;
//	fL->Visible = False;
	fL->FormZStyle = fszTransient;
	fL->FormPosition = poDesigned;
	fL->Gruppe = Gruppe;
	fL->sC = sC;
	fL->sOpt = pcadd(sC, "opt");
	fL->sXY = pcadd(sC, "xy");
	fL->FormSave = TFormRLC_Save;
	fL->SaveData = fL_SaveDaten;
	fL->LoadData = LoadData;
	fL->Update = Update;
	fL->SetFreq = Form_L_SetFreq;

	SetCaption((TWins*)fL, Caption);
	fL->width = 226;
	fL->height = 148;
	fL->min_width = fL->width;
	fL->min_height = fL->height;
	fL->max_width = fL->width;
	fL->max_height = fL->height;
	sopt = TpcIni_RD_pc(pcIni, Gruppe, fL->sXY, "0 0");
	fL->left = ppctoint(&sopt);
	fL->top = ppctoint(&sopt);
	fL->tag = (ppctoint(&sopt) != 0);
	fL->Visible = False; //fL->tag;
//	fL->OnCanClose = Form_L_OnCanClose;
	fL->OnMove = Form_L_OnMove;
//	fL->SetVisible = TForm_L_SetVisible;
	fL->exDVal = exDVal;


	fL->pnl1 = TWins_CreateBA((TWins*)fL, 0, 0, 134, 21, 0, alLeft);
	fL->pnlL = TWins_CreateBA(fL->pnl1, 0, 0, 134, 72, mBorder | mBorderL, alTop);
	fL->pnlOpt = TWins_CreateBA(fL->pnl1, 0, 20, 130, 80, mBorder | mBorderL, alClient);
	fL->pnlZ = TWins_CreateBA((TWins*)fL, 136, 0, 130, 80, mBorder | mBorderL, alClient);

/* Panel C */
	fL->pnlL->OnPaint = fL_pnlL_OnPaint;
	fL->L = TDVal_CreateS((TWins*)fL, 22, 2, 70, 21);
	fL->L->nk = 3;
	fL->L->dv_fu = tdv_fu_LostFocusEnter;
	fL->L->OnValChange = fL_DVal_OnValChange;
	SetFont((TWins*)fL->L, "-*-helvetica-bold-r-*-*-14-*-75-75-*-*-*-*");
	if (fL->exDVal) fL->exDVal->owner = (TWins*)fL->L;

/* Panel Optionen */
	fL->pnlOpt->OnPaint = fL_pnlOpt_OnPaint;
	fL->cbOptOn = TChkBox_CreateS(fL->pnlOpt, 2, 2, 56, 16, "Opt On");
	fL->cbOptOn->OnClick = fL_cb_OnClick;
	fL->cbRs = TChkBox_CreateS(fL->pnlOpt, 2, 20, 16, 16, NULL);
	fL->cbRs->OnClick = fL_cb_OnClick;
	fL->cbRp = TChkBox_CreateS(fL->pnlOpt, 2, 39, 16, 16, NULL);
	fL->cbRp->OnClick = fL_cb_OnClick;
	fL->cbCp = TChkBox_CreateS(fL->pnlOpt, 2, 58, 16, 16, NULL);
	fL->cbCp->OnClick = fL_cb_OnClick;
	fL->Rs = TDVal_CreateS(fL->pnlOpt, 36, 18, 60, 18);
	fL->Rs->nk = 3;
	fL->Rs->dv_fu = tdv_fu_LostFocusEnter;
	fL->Rs->OnValChange = fL_DVal_OnValChange;
	fL->Rp = TDVal_CreateS(fL->pnlOpt, 36, 37, 60, 18);
	fL->Rp->nk = 3;
	fL->Rp->dv_fu = tdv_fu_LostFocusEnter;
	fL->Rp->OnValChange = fL_DVal_OnValChange;
	fL->Cp = TDVal_CreateS(fL->pnlOpt, 36, 56, 60, 18);
	fL->Cp->nk = 2;
	fL->Cp->dv_fu = tdv_fu_LostFocusEnter;
	fL->Cp->OnValChange = fL_DVal_OnValChange;
//	fL->cbTL = TChkBox_CreateS(fL->pnlOpt, 86, 2, 32, 16, "TL");
//	fL->cbTL->OnClick = fL_cb_OnClick;
	fL->sbTL = TScrollBarVert_CreateP(fL->pnlOpt);
	fL->sbTL->Align = alRight;
	fL->sbTL->OnCount = fL_sbTL_OnCount;
	TScrollBar_SetMaxCount(fL->sbTL, 1000);

/* Panel Z */
	fL->pnlZ->OnPaint = fL_pnlZ_OnPaint;
	fL->pnlZ->OnResize = fL_pnlZ_OnResize;
	fL->MHz = TDVal_CreateS(fL->pnlZ, 12, 3, 56, 18);
	fL->MHz->nk = 1;
	fL->MHz->dv_fu = tdv_fu_LostFocusEnter;
	fL->MHz->OnValChange = fL_DVal_OnValChange;

	fL->Z = TDVal_CreateS(fL->pnlZ, 12, 22, 56, 18);
	fL->Z->nk = 2;
	fL->Z->ReadOnly = True;
	fL->Z->KeyFu |= mNoKeyFocus;
	SetColor((TWins*)fL->Z, 0xe8e8e8);

	fL->cbCs = TChkBox_CreateS(fL->pnlZ, 2, 50, 60, 16, "Cs");
	fL->cbCs->OnClick = fL_cb_OnClick;
	fL->dvCs = TDVal_CreateS(fL->pnlZ, 2, 68, 58, 18);
	fL->dvCs->nk = 1;
	TDVal_Set_Min(fL->dvCs, 0.1);
	fL->dvCs->OnValChange = fL_DVal_OnValChange;


	fL->cbTLsync = TChkBox_CreateS(fL->pnlZ, 2, 101, 60, 16, "TLsync");
	fL->cbTLsync->OnClick = fL_cb_OnClick;
	fL->TL = TDVal_CreateS(fL->pnlZ, 2, 121, 58, 18);
	fL->TL->nk = 1;
	fL->TL->ReadOnly = True;
	fL->TL->KeyFu |= mNoKeyFocus;
	SetColor((TWins*)fL->TL, 0xe8e8e8);
	fL->TLmin = TDVal_CreateS(fL->pnlZ, 2, 121, 58, 18);
	fL->TLmin->nk = 3;
	fL->TLmin->dv_fu = tdv_fu_LostFocusEnter;
	fL->TLmin->OnValChange = fL_DVal_OnValChange;
	TDVal_Set_Min(fL->TLmin, 0.001);


	TDVal_Set_Value(fL->L, val);
	fL_LoadData(fL, pcIni);
	free_appIni(pcIni);

	fL_TL_SetVal(fL, TScrollBar_GetCount(fL->sbTL));

	fL_math_loc(fL);

	return fL;
}

