/*
 Copyright (C) 2010-2015 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#ifndef __AH_FORM_LC_H__
#define __AH_FORM_LC_H__    1

#include "appXbase.h"
#include "math_line.h"
#include "RLC.h"
#include "tlineedit.h"

#define wtyp_TFormR		wtyp_USER_Form + 1
#define wtyp_TFormL		wtyp_USER_Form + 2
#define wtyp_TFormC		wtyp_USER_Form + 3
#define wtyp_TFormDigA		wtyp_USER_Form + 4
#define wtyp_TFormDigB		wtyp_USER_Form + 5


#define AlgTFormRLC const char *Gruppe; \
  char *sOpt; \
  char *sXY; \
  void (*OnChange)(struct TFormRLC* self); \
  void (*OnSync)(struct TFormRLC* self, int val); \
  void (*FormSave)(struct TFormRLC* self); \
  void (*SaveData)(struct TCSelf *self, TpcIni *ini); \
  void (*LoadData)(struct TCSelf *self, TpcIni *ini); \
  void (*Update)(struct TCSelf *self, float val, int ufu); \
  void (*SetFreq)(struct TFormRLC* self, float val);

#define TCSelf TFormRLC
typedef struct TFormRLC {
  AlgTForm
  AlgTFormRLC;
} TFormRLC;
#undef TCSelf

#define TCSelf TFormC
typedef struct TFormC {
  AlgTForm
  AlgTFormRLC;
  const char *sC;
  
  TWins *pnl1;
  TWins *pnlC;
  TDVal *C;
  TWins *pnlOpt;
  TDVal *Rs;
  TDVal *Ls;
  TDVal *Rp;
  TWins *pnlZ;
  TDVal *MHz;
  TDVal *Z;
  TChkBox *cbC;
  TChkBox *cbOptOn;
  TChkBox *cbRs;
  TChkBox *cbRp;
  TChkBox *cbLs;
//  TChkBox *cbTC;
  TScrollBar *sbTC;
  TDVal *TCmin;
  TChkBox *cbTCsync;
  int val_sync;
  TDVal *TC;
  TRLC rlc;

  TDVal *exDVal;

} TFormC;
#undef TCSelf

TFormC *Create_Form_C(TWins *parent, const char *Caption, const char *Gruppe, 
			const char *sC, TDVal *exDVal, float val);
void Form_C_math(TFormC *fC, float w);
void Form_C_sync(TFormRLC *fRLC, TFormC *fC, int val);

#define TCSelf TFormL
typedef struct TFormL {
  AlgTForm
  AlgTFormRLC;
  const char *sC;
  TWins *pnl1;
  TWins *pnlL;
  TDVal *L;
  TWins *pnlOpt;
  TDVal *Rs;
  TDVal *Cp;
  TDVal *Rp;
  TWins *pnlZ;
  TDVal *MHz;
  TDVal *Z;
  TChkBox *cbC;
  TChkBox *cbOptOn;
  TChkBox *cbRs;
  TChkBox *cbRp;
  TChkBox *cbCp;
//  TChkBox *cbTL;
  TScrollBar *sbTL;
  TDVal *TLmin;
  TChkBox *cbTLsync;
  int val_sync;
  TDVal *TL;
  TRLC rlc;

  TDVal *exDVal;

  TChkBox *cbCs;
  TDVal *dvCs;

} TFormL;
#undef TCSelf

TFormL *Create_Form_L(TWins *parent, const char *Caption, const char *Gruppe, 
			const char *sC, TDVal *exDVal, float val);
void Form_L_math(TFormL *fL, float w);
void Form_L_sync(TFormRLC *fRLC, TFormL *fL, int val);

#define TCSelf TFormR
typedef struct TFormR {
  AlgTForm
  AlgTFormRLC;
  const char *sR;
  TWins *pnl1;
  TWins *pnlR;
  TDVal *R;
  TWins *pnlOpt;
  TDVal *Ls;
  TDVal *Cp;
  TWins *pnlZ;
  TDVal *MHz;
  TDVal *Z;
  TChkBox *cbC;
  TChkBox *cbOptOn;
  TChkBox *cbLs;
  TChkBox *cbCp;
//  TChkBox *cbTR;
  TScrollBar *sbTR;
  TDVal *TRmin;
  TChkBox *cbTRsync;
  int val_sync;
  TDVal *TR;
  TRLC rlc;

  TDVal *exDVal;

} TFormR;
#undef TCSelf

TFormR *Create_Form_R(TWins *parent, const char *Caption, const char *Gruppe, 
			const char *sR, TDVal *exDVal, float val);
void Form_R_math(TFormR *fR, float w);
void Form_R_sync(TFormRLC *fRLC, TFormR *fR, int val);

void TFormRLC_Save(TFormRLC* fRLC);

#define TCSelf TFormDigA
typedef struct TFormDigA {
  AlgTForm
  AlgTFormRLC;
  const char *sF;

  TWins *pnl1;
  TWins *pnlX;
  TWins *pnlOpt;
  TWins *pnlZ;
//pnlX
  TDVal *dvX;
  TDVal *dvNr;
/* Panel Optionen */
  TLineEdit *le;
//pnlZ
  TChkBox *cbTX;
  TScrollBar *sbTX;
  TDVal *dvTX;
  TDVal *dvTXval;
  TChkBox *cbTXsync;
  int val_sync;
  TMathLineStruct *mls;

  TDVal *exDVal;

} TFormDigA;
#undef TCSelf

TFormDigA *Create_Form_DigA(TWins *parent, const char *Caption, 
		const char *Gruppe, const char *sF, TDVal *exDVal, float val);
void Form_DigA_sync(TFormRLC *fRLC, TFormDigA *mf, int val);

#endif /* __AH_FORM_LC_H__ */
