/*
 Copyright (C) 2010-2015 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "ElMath.h"

static void TFormRLConoff_DoPaint(TFormRLConoff *self) {
	if (self->pic) {
	    DrawPic(self->WinID, self->pic, 
			(self->width - self->pic->width) >> 1, 
			(self->height - self->pic->height) >> 1);
	}
	TWins_DoPaint((TWins*)self);
}

static void TFormRLConoff_DoMouseDown(TFormRLConoff *self, XButtonEvent *ev) {
  TFormRLC *fRLC = (TFormRLC*)self->Form;
	TWins_DoMouseDown((TWins*)self, ev);
	if (fRLC) {
	    fRLC->tag = ((self->BorderFu & mBorderL) == 0);
	    SetVisible((TWins*)fRLC, fRLC->tag != 0);
	    if (fRLC->FormSave) fRLC->FormSave(fRLC);
	}
}

static TFormRLConoff *TFormRLConoff_Create(TWins *Parent) {
  TFormRLConoff *fof;
  TWins_Create_struct wcs;
	TWins_Create_struct_init(&wcs, sizeof(TFormRLConoff), wtyp_Wins);
	wcs.Parent = Parent;
	TWins_DefaultConf(&wcs);
	fof = wcs.wins;
	fof->DoPaint = TFormRLConoff_DoPaint;
	fof->DoMouseDown = TFormRLConoff_DoMouseDown;
	fof->BorderFu = mBorder;
	return fof;
}

TFormRLConoff *TFormRLConoff_CreateU(TWins *Parent, int left, int top, int width, int height, TPic *pic) {
  TFormRLConoff *fof = TFormRLConoff_Create(Parent);
	fof->pic = pic;
	fof->top = top;
	fof->left = left;
	fof->width = width;
	fof->height = height;
	Set_Parent((TWins*)fof, Parent);
	return fof;
}

static void TFormRLConoff_Owner_OnShow(TFormRLC *self) {
  TFormRLConoff *fof = (TFormRLConoff*)self->owner;
	fof->BorderFu |= mBorderL;
	Refresh((TWins*)fof);
}
static void TFormRLConoff_Owner_OnCanClose(TFormRLC *self, int *CanClose) {
  TFormRLConoff *fof = (TFormRLConoff*)self->owner;

	fof->BorderFu &= ~mBorderL;
	if (self->CloseIsWM_DELETE) {
	    self->tag = 0;
	    if (self->FormSave) self->FormSave(self);
	}
	RePaint((TWins*)fof);
}

void TFormRLConoff_SetForm(TFormRLConoff *fof, TForm *Form) {
	Form->owner = (TWins*)fof;
	Form->OnShow = (void*)TFormRLConoff_Owner_OnShow;
	Form->OnCanClose = (void*)TFormRLConoff_Owner_OnCanClose;
	fof->Form = Form;
}

void TFormRLC_Save(TFormRLC* fRLC) {
  TpcIni *pcIni;
  char buf[256];

	pcIni = get_appIni();
	snprintf(buf, sizeof(buf), "%d %d %ld", fRLC->left, fRLC->top, fRLC->tag);
	TpcIni_WR(pcIni, fRLC->Gruppe, fRLC->sXY, buf);
	TpcIni_Save(pcIni);
	free_appIni(pcIni);
}
