/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#ifndef __MICROSTRIP_H__
#define __MICROSTRIP_H__    1

typedef struct {
  float W;
  float G;
  float H;
  float L;
  float T;
  float Er;
  float Er_tan;
  float Freq;

  bool Coplanar;
  bool GroundPlane;
  bool nc2;
  bool nc3;

  float Z;
  float nSm;
  float pFm;
  float uHm;
  float dbm;
  float Ohmm;
  float OhmPm;

  float nS;
  float pF;
  float uH;
  float db;
  float Ohm;
  float OhmP;

  float Eeff;
  float Eeff_W;

} TMicrostripDat;

void Microstrip_math(TMicrostripDat *md);
void Microstrip_math_Freq(TMicrostripDat *md);
void Microstrip_math_L(TMicrostripDat *md);

#endif /* __MICROSTRIP_H__ */

