/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "sysbase.h"

#define RLC_R	0
#define RLC_C	1
#define RLC_L	2

typedef struct TRLC {
  struct TRLC *next_ser;
  struct TRLC *next_par;
  int typ;
  float val;
  float U;
  float I, Iw, Ib;
  float Z, Xw, Xb;
} TRLC;

void REGP3 SetUp_R(TRLC *rlc, float w, float R);
void REGP3 SetUp_C(TRLC *rlc, float w, float C);
void REGP3 SetUp_L(TRLC *rlc, float w, float L);
void REGP3 RLC_Add_Par(TRLC *A, TRLC *B);
void REGP3 RLC_Add_Ser(TRLC *A, TRLC *B);

void REGP3 RLC_Add_Ser_R(TRLC *A, float w, float R);
void REGP3 RLC_Add_Par_R(TRLC *A, float w, float R);
void REGP3 RLC_Add_Ser_C(TRLC *A, float w, float C);
void REGP3 RLC_Add_Par_C(TRLC *A, float w, float C);
void REGP3 RLC_Add_Ser_L(TRLC *A, float w, float L);
void REGP3 RLC_Add_Par_L(TRLC *A, float w, float L);

void REGP3 RLC_Copy(TRLC *dest, TRLC *src);
