/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#ifndef	__MATH_LINE_H__
#define	__MATH_LINE_H__    1

#define ml_Error	-1
#define ml_nop		0
#define ml_konst	1

#define mlst_RunMask		0x0000ffff
#define mlst_print_all_sum	1
#define mlst_print_Error_off	(1<<1)
#define mlst_Error		(1<<16)
#define mlst_hidden		(1<<17)

typedef struct TMathLine {
  struct TMathLine *next;
  int line;
  int t;
  const char *pc;
  char *res_name;
  int name_lg;
  double res;
} TMathLine;

typedef struct TMathLineStruct {
  char *res_name;
  double res;
  int error;
  int err_X;
  int stat;	//b17=hidden res
  int ml_res;
  int line_nr;
  void (*OnResult)(struct TMathLineStruct *ms, int ml_res);
/* private */
  TMathLine *ml;
  TMathLine *akt;
  int err_X_off;
  double tmp_res;
  char *pct;
  int fidx;
  double f[100];
} TMathLineStruct;


int math_line_scan(TMathLineStruct *ms, TMathLine * ml);
bool math_line(TMathLineStruct *ms, const char *pc);
void math_line_clr(TMathLineStruct *ms);
void math_line_free(TMathLineStruct *ms);

#endif /* __MATH_LINE_H__ */
