/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "ElMath.h"
#include "ElGraf.h"
#include <math.h>



static void DIGF_SetCursor_Dat_txt(TPage_DIG_Filter *pg) {
  char buf[64];
  char *pc;
  TScaleXY_Txt *xy_txt;
  TScale_Point *psp;

	xy_txt = pg->xy_ind->txt;
	while (xy_txt) {
	    xfree(xy_txt->s);
	    xy_txt->s = NULL;
	    xy_txt = xy_txt->next;
	}

	pc = buf;
	*pc = 0;
	xy_txt = pg->xy_ind->txt;
	if (pg->pxy1->PaintDat) {
	    TScaleXY_GetCursX_YVal(pg->xy_ind, pg->pxy1, &psp);
	    if (psp) {
		doubletoppc(&pc ,log10(psp->y)*20, 2);
		ppcmove(&pc, "db  ");
	    }
	}
	if (pg->pxy2->PaintDat) {
	    TScaleXY_GetCursX_YVal(pg->xy_ind, pg->pxy2, &psp);
	    if (psp) {
		doubletoppc(&pc ,log10(psp->y)*20, 2);
		ppcmove(&pc, "db  ");
	    }
	}
	if (pg->pxy3->PaintDat) {
	    TScaleXY_GetCursX_YVal(pg->xy_ind, pg->pxy3, &psp);
	    if (psp) {
		doubletoppc(&pc ,log10(psp->y)*20, 2);
		ppcmove(&pc, "db ");
	    }
	}
	ppcchange(&xy_txt->s, buf);

	xy_txt = xy_txt->next;
	if (!pg->pxy4->PaintDat) return;
	pc = buf;
	TScaleXY_GetCursX_YVal(pg->xy_ind, pg->pxy4, &psp);
	if (!psp) return;
	doubletoppc(&pc ,psp->v1, 3);
	ppcmove(&pc, "ms ");
	doubletoppc(&pc ,psp->y, 6);
	ppcchange(&xy_txt->s, buf);
}

static void SetCursor_sbDetail(TPage_DIG_Filter *pg) {
  int nk = 2;
  char buf[64];
  char *pc;
  TScaleXY_Txt *xy_txt = pg->xy_ind->txt;

	while (xy_txt) {
	    xfree(xy_txt->s);
	    xy_txt->s = NULL;
	    xy_txt = xy_txt->next;
	}

	pg->xy_ind->CursorX = pg->sbDetail->Count * pg->ScaleKHz / 
			      pg->sbDetail->MaxCount;
	if (pg->ScaleKHz <= 20) nk = 3;
	pc = buf;
	doubletoppc(&pc ,TScaleXY_GetCursX_ScaleVal(pg->xy_ind), nk);
	*pc = ' '; pc++;
	ppcmove(&pc, "KHz");
	ppcchange(&pg->xy_ind->CursorX_Str, buf);

	DIGF_SetCursor_Dat_txt(pg);
}

static void EML_DIG_Filter_sbDetail_OnCount(TScrollBar* sb, int Count) {
  TPage_DIG_Filter *pg = sb->subClass;
	SetCursor_sbDetail(pg);
	TWins_Refresh((TWins*)pg->xy_ind);
}

static void EML_DIG_Filter_xy_ind_OnResize(TScaleXY *self) {
  TPage_DIG_Filter *pg = self->subClass;
	SetWidth((TWins*)pg->sbDetail, self->width - pg->xy_ind->sx2 + 22);
}

static void EML_DIG_Filter_sbScale_OnCount(TScrollBar* sb, int Count) {
  TPage_DIG_Filter *pg = sb->subClass;
  float off;
  int m = 0;

	if (pg->ScaleKHz < 10) m = 1;
	if (pg->ScaleKHz < 1) m = 2;
	if (pg->ScaleKHz < 0.1) m = 3;
	off = Count * pg->ScaleKHz / 10;
	pg->ScaleKHzoff = off;
	TScaleXY_Set_Dat(pg->xy_ind->dat->dx, "KHz", off, pg->ScaleKHz+off, 2, pg->fuLogX | m);
	SetCursor_sbDetail(pg);
	math_Filter_IIR1(pg->IIR1);
	Refresh((TWins*)pg->xy_ind);
}

static void ELM_DIGF_cbmaxKHZ_OnClick(TMenu *me, long KeyState, TMenuItem *mi) {
  TPage_DIG_Filter *pg = me->subClass;
  int m;
  float off;
	if (pg->cbmaxKHZ->popup == me) {
	    off = pg->ScaleKHz;
	    pg->ScaleKHz = pctodouble(mi->s);
	    m = pg->sbScale->Count;
	    if (m > 0) {
		m = m * off / pg->ScaleKHz;
		TScrollBar_SetCount(pg->sbScale, m);
	    }
	}

	m = 0;
	if (pg->ScaleKHz < 10) m = 1;
	if (pg->ScaleKHz < 1) m = 2;
	if (pg->ScaleKHz < 0.1) m = 3;

	off = pg->sbScale->Count * pg->ScaleKHz / 10;
	pg->ScaleKHzoff = off;
	TScaleXY_Set_Dat(pg->xy_ind->dat->dx, "KHz", off, pg->ScaleKHz+off, 2, pg->fuLogX | m);
	SetCursor_sbDetail(pg);
	math_Filter_IIR1(pg->IIR1);
	Refresh((TWins*)pg->xy_ind);
}

static void ELM_IIR1_SaveDaten(TPage_DIG_Filter *pg) {
  TpcIni *pcIni = TpcIni_Create(appDat.inifile_app);
	TpcIni_WR_float(pcIni, "IIR1", "SampKHZ", pg->dvSampKHZ->dval, pg->dvSampKHZ->nk);
	TpcIni_SaveAndFree(pcIni);
}

/* void ELM_DIGF_cbsampKHZ_OnClick(TMenu *me, long KeyState, TMenuItem *mi) {
  TPage_DIG_Filter *pg = me->subClass;
	math_Filter_IIR1(pg->IIR1);
	Refresh((TWins*)pg->xy_ind);
} */

static void EML_DIG_dv_T_OnValChange(TDVal *dv, double val) {
  TPage_DIG_Filter *pg = dv->subClass;
	math_Filter_IIR1(pg->IIR1);
	Refresh((TWins*)pg->xy_ind);
	ELM_IIR1_SaveDaten(pg);
}

static void ELM_DIGF_cbLog_OnClick(TMenu *me, long KeyState, TMenuItem *mi) {
  TPage_DIG_Filter *pg = me->subClass;
  const char *pc;
	pg->fuLogX = sxysetfu_lin;
	pc = GetCaption_pc((TWins*)pg->cbLog);
	if (!pccasecmpASCII(pc, "log -1")) pg->fuLogX = sxysetfu_log_1; else
	if (!pccasecmpASCII(pc, "log10 -1")) pg->fuLogX = sxysetfu_log10_1;
	if (!pccasecmpASCII(pc, "log20 -1")) pg->fuLogX = sxysetfu_log20_1;
	if (!pccasecmpASCII(pc, "log100-1")) pg->fuLogX = sxysetfu_log100_1;
	TScaleXY_Set_Dat_Log(pg->xy_ind, pg->fuLogX, 0);
}

/* ************************************************ */
void ELM_IIR1_DataChange(TPage_DIG_Filter *pg) {
	DIGF_SetCursor_Dat_txt(pg);
	Refresh((TWins*)pg->xy_ind);
}

static void ELM_IIR1_pnlGrafVal_OnResize(TWins *self) {
  TPage_DIG_Filter *pg = self->subClass;
  int x;
	vds_SetStr(&self->vds, "Freq");
	x = TextWidthColorString(&self->vds) + 4;
	SetLeft((TWins*)pg->cbmaxKHZ, x);
	vds_SetStr(&self->vds, "FSamp");
	x += pg->cbmaxKHZ->width + TextWidthColorString(&self->vds) + 4;
	SetLeft((TWins*)pg->dvSampKHZ, x);
	vds_SetStr(&self->vds, "KHz  T");
	x += pg->dvSampKHZ->width + TextWidthColorString(&self->vds) + 4;
	SetLeft((TWins*)pg->dv_T, x);

	x = self->width - pg->cbLog->width - 2;
	SetLeft((TWins*)pg->cbLog, x);
}

static void str_toGraf(TWins *Wins, const char *s, int x, int y) {
	vds_SetStr(&Wins->vds, s);
	DrawColorString(x, y, &Wins->vds);
}

static void ELM_IIR1_pnlGrafVal_OnPaint(TWins *self) {
  TPage_DIG_Filter *pg = self->subClass;
  int x = 2;
	str_toGraf(self, "Freq", x, 3);
	x =  pg->cbmaxKHZ->left + pg->cbmaxKHZ->width + 2;
	str_toGraf(self, "FSamp", x, 3);
	x =  pg->dvSampKHZ->left + pg->dvSampKHZ->width + 2;
	str_toGraf(self, "KHz  T", x, 3);
}


static TPage *ELM_pageDIG_Filter_Create(TPageControl *Parent) {
	return TPage_CreateParamAlg(Parent, sizeof(TPage_DIG_Filter));
}

/* void pgc_DIG_Filter_OnActivate_pg(TPageControl *pagc, TPage *pag) {
  TPage_DIG_Filter *pg = pagc->subClass;
	Dig_IIR1_SetVisible(pg->IIR1, (pag == (TPage*)pg->IIR1));
} */

static void pgc_OnChangeTab(TPageControl *self, TPage *fromPage, TPage *toPage, int *fu) {
  TPage_DIG_Filter *pg = self->subClass;

	Dig_IIR1_SetVisible(pg->IIR1, (toPage == (TPage*)pg->IIR1));
}

TPage_DIG_Filter *ELM_pageDIG_Filter(TPageControl *pagc, const char *Caption) {
  TPage_DIG_Filter *pg;
  TpcIni *pcIni;

	pcIni = get_appIni();

	pg = (TPage_DIG_Filter*)TPageControl_AddNewUserPage(pagc, Caption, ELM_pageDIG_Filter_Create);
	pg->subClass = pg;

	pg->pnl1 = TWins_CreateBA((TWins*)pg, 0, 0, 346, 21,
				mBorder | mBorderL, alLeft);

	pg->pgc = TPageControl_Create(pg->pnl1);
	pg->pgc->Align = alClient;
	pg->pgc->height = 120;
//	pg->pgc->OnPageActivate = pgc_DIG_Filter_OnActivate_pg;
	pg->pgc->OnChangeTab = pgc_OnChangeTab;

	Set_Parent((TWins*)pg->pgc, pg->pnl1);

	pg->IIR1 = page_Add_Dig_IIR1(pg->pgc, pg);


/* ****************** Graf ****************************************************/
	pg->pnlGraf = TWins_CreateBA((TWins*)pg, 0, 0, 310, 21, 
				mBorder | mBorderL, alClient);
/* Graf Dat */
	pg->pnlGrafVal = TWins_CreateBA(pg->pnlGraf, 0, 0, 310, 21, 
				mBorder, alTop);
	pg->pnlGrafVal->OnPaint = ELM_IIR1_pnlGrafVal_OnPaint;
	pg->pnlGrafVal->OnResize = ELM_IIR1_pnlGrafVal_OnResize;



	pg->cbmaxKHZ = TComboBox_CreateS(pg->pnlGrafVal, 40, 1, 60, 18, "20");
	pg->cbmaxKHZ->ReadOnly = True;
  static const char *cbKHZ_Tab[9] = {"1", "2", "5",
			"10", "20", "30", "50", "100", "200"};
	for (int i=0;i<9;i++)
	    TComboBox_AddItem(pg->cbmaxKHZ, cbKHZ_Tab[i], 0, ELM_DIGF_cbmaxKHZ_OnClick);

	pg->dvSampKHZ = TDVal_CreateSV4(pg->pnlGrafVal, 120, 1, 60, 18, 
		TpcIni_RD_float(pcIni, "IIR1", "SampKHZ", 48), 1, 1000, 3);
	pg->dvSampKHZ->dv_fu = tdv_fu_LostFocusEnter;
	pg->dvSampKHZ->OnValChange = EML_DIG_dv_T_OnValChange;

	pg->dv_T = TDVal_CreateSV4(pg->pnlGrafVal, 220, 1, 40, 18, 20, 20, 9999, 0);
	pg->dv_T->dv_fu = tdv_fu_LostFocusEnter;
	pg->dv_T->OnValChange = EML_DIG_dv_T_OnValChange;
	SetColor((TWins*)pg->dv_T, 0xffffc0);

	pg->cbLog = TComboBox_CreateS(pg->pnlGrafVal, 220, 1, 76, 18, "log10 -1");
	pg->cbLog->ReadOnly = True;
  static const char *cbLog_Tab[5] = {"lin", "log -1", "log10 -1", "log20 -1", "log100-1"};
	for (int i=0;i<5;i++)
	    TComboBox_AddItem(pg->cbLog, cbLog_Tab[i], 0, ELM_DIGF_cbLog_OnClick);


/* Graf Az */
	pg->xy_ind = TScaleXY_Create(pg->pnlGraf);
	pg->xy_ind->Align = alClient;
	pg->xy_ind->OnResize = EML_DIG_Filter_xy_ind_OnResize;
	pg->xy_ind->sx1 = 22;
	pg->xy_ind->sy1 = 18;
	pg->xy_ind->sy2 = 46;
	pg->xy_ind->CursFu = 0x01;
	Set_Parent((TWins*)pg->xy_ind, pg->pnlGraf);

	pg->sbDetail = TScrollBarHorz_CreateP((TWins*)pg->xy_ind);
	pg->sbDetail->OnCount = EML_DIG_Filter_sbDetail_OnCount;
	TScrollBar_SetMaxCount(pg->sbDetail, 2000);
	pg->sbDetail->LargeChange = 50;

	pg->sbScale = TScrollBarHorz_CreateP((TWins*)pg->xy_ind);
	pg->sbScale->BorderFu = mBorder | mBorderL | 
			mBorderNoLeft | mBorderNoRigth | mBorderNoBottom;
	pg->sbScale->Align = alBottom;
	SetHeight((TWins*)pg->sbScale, 16);
	TScrollBar_SetMaxCount(pg->sbScale, 40);
	pg->sbScale->LargeChange = 5;
	pg->sbScale->OnCount = EML_DIG_Filter_sbScale_OnCount;

// Filter 1 AZ 
	TScaleXY_SetDat_mem(&pg->xy_ind->dat, 21, 19, 1001);
  TScale_pxy *pxy = pg->xy_ind->dat->pxy;
	pg->pxy1 = pxy;
	pxy->Color = 0x0000c0;
	pxy->PaintDat = True;
	pxy->AddOff = True;
// Filter 2 AZ 
	pxy->next = xcalloc(sizeof(TScale_pxy) + sizeof(TScale_Point)*1001);
	pxy = pxy->next;
	pg->pxy2 = pxy;
	pxy->count = 1001;
	pxy->Color = 0x00c000;
	pxy->PaintDat = True;
	pxy->AddOff = True;
// Filter 1+2 AZ 
	pxy->next = xcalloc(sizeof(TScale_pxy) + sizeof(TScale_Point)*1001);
	pxy = pxy->next;
	pg->pxy3 = pxy;
	pxy->count = 1001;
	pxy->Color = 0xc00000;
	pxy->PaintDat = True;
	pxy->AddOff = True;
// Filter Time
	pxy->next = xcalloc(sizeof(TScale_pxy) + sizeof(TScale_Point)*1001);
	pxy = pxy->next;
	pg->pxy4 = pxy;
	pxy->count = 1001;
	pxy->Color = 0xc0c000;
	pxy->PaintDat = True;
	pxy->AddOff = True;



  TScaleXY_Txt *xy_txt;
	xy_txt = xcalloc(sizeof(TScaleXY_Txt));
	xy_txt->x = 2;
	xy_txt->y = 20;
	pg->xy_ind->txt = xy_txt;
	xy_txt->next = xcalloc(sizeof(TScaleXY_Txt));
	xy_txt = xy_txt->next;
	xy_txt->x = 2;
	xy_txt->y = 36;

	pg->ScaleKHz = 20;
	pg->fuLogX = sxysetfu_log10_1;
	TScaleXY_Set_Dat(pg->xy_ind->dat->dx, "kHz", 0, 20, 2, pg->fuLogX);
	TScaleXY_Set_Dat(pg->xy_ind->dat->dy, "dB", -70, 20, 2, sxysetfu_dB20);

	free_appIni(pcIni);

	return pg;
}

