/*
 Copyright (C) 2010-2015 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "ElMath.h"
#include "ElGraf.h"
#include <math.h>

static void str_toGraf(TWins *Wins, const char *s, int x, int y) {
	vds_SetStr(&Wins->vds, s);
	DrawColorString(x, y, &Wins->vds);
}

static void DrawBP2(Window WinID, int x, int y, int fu) {
  int xa;
  int x2 = x;
  int y2 = y+30;

	Draw_xP1_Rg(WinID, &x2, &xa, y, y2, fu);

	if ((fu & 0x0300) == 0x000) {
	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC3());
	    DrawTP1_Lv(WinID, &x2, 9, y, get_Pic_cL3());
	}

	if ((fu & 0x0300) == 0x100) {
	  if ((fu & 0x10000) == 0) {
	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC1());
	    DrawTP1_Lh(WinID, &x2, y, get_Pic_cL1());
	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC3());
	    DrawTP1_Lv(WinID, &x2, 9, y, get_Pic_cL3());
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC5());
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL5());
	  } else {
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL5());
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC5());
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL3());
	    DrawTP1_Cv(WinID, &x2, 9, y, get_Pic_cC3());
	    DrawTP1_Lh(WinID, &x2, y, get_Pic_cL1());
	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC1());
	  }
	}

	if ((fu & 0x0300) == 0x200) {
	  if ((fu & 0x10000) == 0) {
	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC1());
	    DrawTP1_Lh(WinID, &x2, y, get_Pic_cL1());
	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC2());
	    DrawTP1_Lh(WinID, &x2, y, get_Pic_cL2());
//	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC3());
//	    DrawTP1_Lv(WinID, &x2, 9, y, get_Pic_cL3());
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC4());
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL4());
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC5());
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL5());
	  } else {
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL5());
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC5());
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL4());
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC4());
	    DrawTP1_Lh(WinID, &x2, y, get_Pic_cL2());
	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC2());
	    DrawTP1_Lh(WinID, &x2, y, get_Pic_cL1());
	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC1());
	  }
	}

	if ((fu & 0x0300) == 0x300) {
	  if ((fu & 0x10000) == 0) {
	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC1());
	    DrawTP1_Lh(WinID, &x2, y, get_Pic_cL1());
	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC2());
	    DrawTP1_Lh(WinID, &x2, y, get_Pic_cL2());
	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC3());

	    DrawTP1_Lh(WinID, &x2, y, get_Pic_cL3());

	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC4());
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL4());
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC5());
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL5());
	  } else {
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL5());
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC5());
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL4());  
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC4());

	    DrawTP1_Lh(WinID, &x2, y, get_Pic_cL3());

	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC3());
	    DrawTP1_Lh(WinID, &x2, y, get_Pic_cL2());
	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC2());
	    DrawTP1_Lh(WinID, &x2, y, get_Pic_cL1());
	    DrawTP1_Cv(WinID, &x2, 0, y, get_Pic_cC1());
	  }
	}

	Draw_xP1_Ra(WinID, x2, xa, y, y2, fu);
}

static float ImpF1(TPage_BP2 *self, float MHz, float *Z) {
  float res, w;
  TRLC btIn;

	w = MHz * M_PI * 2;
	if (!XF_MathOut((TPage_XFilter*)self, w, &btIn, &res)) return res;
	Form_C_math(self->f_C3, w);
	Form_L_math(self->f_L3, w);
	RLC_Add_Par(&btIn, &self->f_C3->rlc);
	RLC_Add_Par(&btIn, &self->f_L3->rlc);
	res *= btIn.Z;

	XF_MathIn((TPage_XFilter*)self, w, &btIn, &res, Z);
	return res;
} 
static float ImpF2(TPage_BP2 *self, float MHz, float *Z) {
  float res, w;
  TRLC btIn;

	w = MHz * M_PI * 2;
	if (!XF_MathOut((TPage_XFilter*)self, w, &btIn, &res)) return res;
	Form_C_math(self->f_C1, w);
	Form_C_math(self->f_C3, w);
	Form_C_math(self->f_C5, w);
	Form_L_math(self->f_L1, w);
	Form_L_math(self->f_L3, w);
	Form_L_math(self->f_L5, w);

	if (self->cbInvOn->Checked) {
	    RLC_Add_Par(&btIn, &self->f_C1->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_L1->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_L3->rlc);
	    RLC_Add_Par(&btIn, &self->f_C3->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_C5->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_L5->rlc);
	    res *= btIn.Z;
	} else {
	    RLC_Add_Par(&btIn, &self->f_L5->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_C5->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_L3->rlc);
	    RLC_Add_Par(&btIn, &self->f_C3->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_L1->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_C1->rlc);
	    res *= btIn.Z;
	}
	XF_MathIn((TPage_XFilter*)self, w, &btIn, &res, Z);
	return res;
}
static float ImpF3(TPage_BP2 *self, float MHz, float *Z) {
  float res, w;
  TRLC btIn;

	w = MHz * M_PI * 2;
	if (!XF_MathOut((TPage_XFilter*)self, w, &btIn, &res)) return res;
	Form_C_math(self->f_C1, w);
	Form_C_math(self->f_C2, w);
//	Form_C_math(self->f_C3, w);
	Form_C_math(self->f_C4, w);
	Form_C_math(self->f_C5, w);
	Form_L_math(self->f_L1, w);
	Form_L_math(self->f_L2, w);
//	Form_L_math(self->f_L3, w);
	Form_L_math(self->f_L4, w);
	Form_L_math(self->f_L5, w);

	if (self->cbInvOn->Checked) {
	    RLC_Add_Par(&btIn, &self->f_C1->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_L1->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_C2->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_C4->rlc);
	    RLC_Add_Ser(&btIn, &self->f_L2->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_L4->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_C5->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_L5->rlc);
	    res *= btIn.Z;
	} else {
	    RLC_Add_Par(&btIn, &self->f_L5->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_C5->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_L4->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_C4->rlc);
//	res /= btIn.Z;
//	RLC_Add_Par(&btIn, &self->f_L3->rlc);
//	RLC_Add_Par(&btIn, &self->f_C3->rlc);
//	res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_L2->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_C2->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_L1->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_C1->rlc);
	    res *= btIn.Z;
	}

	XF_MathIn((TPage_XFilter*)self, w, &btIn, &res, Z);
	return res;
}
static float ImpF4(TPage_BP2 *self, float MHz, float *Z) {
  float res, w;
  TRLC btIn;

	w = MHz * M_PI * 2;
	if (!XF_MathOut((TPage_XFilter*)self, w, &btIn, &res)) return res;
	Form_C_math(self->f_C1, w);
	Form_C_math(self->f_C2, w);
	Form_C_math(self->f_C3, w);
	Form_C_math(self->f_C4, w);
	Form_C_math(self->f_C5, w);
	Form_L_math(self->f_L1, w);
	Form_L_math(self->f_L2, w);
	Form_L_math(self->f_L3, w);
	Form_L_math(self->f_L4, w);
	Form_L_math(self->f_L5, w);

	if (self->cbInvOn->Checked) {
	    RLC_Add_Par(&btIn, &self->f_C1->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_L1->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_C2->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_L2->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_C3->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_L3->rlc);
	    RLC_Add_Ser(&btIn, &self->f_C4->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_L4->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_C5->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_L5->rlc);
	    res *= btIn.Z;
	} else {
	    RLC_Add_Par(&btIn, &self->f_L5->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_C5->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_L4->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_C4->rlc);
	    RLC_Add_Ser(&btIn, &self->f_L3->rlc);
	    res /= btIn.Z;
//	    RLC_Add_Par(&btIn, &self->f_L3->rlc);
	    RLC_Add_Par(&btIn, &self->f_C3->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_L2->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_C2->rlc);
	    res *= btIn.Z;
	    RLC_Add_Ser(&btIn, &self->f_L1->rlc);
	    res /= btIn.Z;
	    RLC_Add_Par(&btIn, &self->f_C1->rlc);
	    res *= btIn.Z;
	}
	XF_MathIn((TPage_XFilter*)self, w, &btIn, &res, Z);
	return res;
}

static void math_Filter(TPage_BP2 *self) {
  TPage_Filter *pgf = self->pgfilt;
  float fcStep, fOff, fStep;
  TScale_pxy *pxy = pgf->xy_ind->dat->pxy;
  TScale_pxy *pxy2;
  TScale_pxy *pxy3 = NULL;
  float fc, Z, K;
  TScale_Point *sSP, *dSP;

	K = 1;
	if (pgf->cbRgRa->Checked)
	    K = (self->f_Rg->rlc.val + self->f_Ra->rlc.val) / self->f_Ra->rlc.val;

	fOff = pgf->ScaleMHzoff;
	fStep = pgf->ScaleMHz;
	fcStep = fStep / (pxy->count-1);
	for (int i=0;i<pxy->count;i++) {
	    fc = i * fcStep + fOff;
	    pxy->xy[i].x = fc;
	    pxy->xy[i].y = K * ImpF1(self, fc, &Z);
	    pxy->xy[i].y2 = Z;
	}
	if (self->cbF1ImpOn->Checked) pxy3 = pxy;

	pxy = pxy->next;
	fcStep = fStep / (pxy->count-1);
	for (int i=0;i<pxy->count;i++) {
	    fc = i * fcStep + fOff;
	    pxy->xy[i].x = fc;
	    pxy->xy[i].y = K * ImpF2(self, fc, &Z);
	    pxy->xy[i].y2 = Z;
	}
	if (self->cbF2ImpOn->Checked) pxy3 = pxy;

	pxy = pxy->next;
	fcStep = fStep / (pxy->count-1);
	for (int i=0;i<pxy->count;i++) {
	    fc = i * fcStep + fOff;
	    pxy->xy[i].x = fc;
	    pxy->xy[i].y = K * ImpF3(self, fc, &Z);
	    pxy->xy[i].y2 = Z;
	}
	if (self->cbF3ImpOn->Checked) pxy3 = pxy;


	pxy = pxy->next;
	fcStep = fStep / (pxy->count-1);
	for (int i=0;i<pxy->count;i++) {
	    fc = i * fcStep + fOff;
	    pxy->xy[i].x = fc;
	    pxy->xy[i].y = K * ImpF4(self, fc, &Z);
	    pxy->xy[i].y2 = Z;
	}
	if (self->cbF4ImpOn->Checked) pxy3 = pxy;

	Z = self->dv_Rg->dval;
	if (pxy3 && (Z > 0)) {
	    pxy2 = pgf->yInZ;
	    pxy2->PaintDat = True;
	    sSP = &pxy3->xy[0];
	    dSP = &pxy2->xy[0];
	    for (int i=0;i<pxy2->count;i++) {
		dSP->x = sSP->x;
		dSP->y = sSP->y2 / Z;
		dSP++; sSP++;
	    }
	} else {
	    pgf->yInZ->PaintDat = False;
	}

	SetCursor_Dat_txt(pgf);
	Refresh((TWins*)pgf->xy_ind);

}

void BP2_SetVisible(TPage_BP2 *self, bool On) {
	SetVisible((TWins*)self->f_C1, self->f_C1->tag && On);
	SetVisible((TWins*)self->f_C2, self->f_C2->tag && On);
	SetVisible((TWins*)self->f_C3, self->f_C3->tag && On);
	SetVisible((TWins*)self->f_C4, self->f_C4->tag && On);
	SetVisible((TWins*)self->f_C5, self->f_C5->tag && On);
	SetVisible((TWins*)self->f_L1, self->f_L1->tag && On);
	SetVisible((TWins*)self->f_L2, self->f_L2->tag && On);
	SetVisible((TWins*)self->f_L3, self->f_L3->tag && On);
	SetVisible((TWins*)self->f_L4, self->f_L4->tag && On);
	SetVisible((TWins*)self->f_L5, self->f_L5->tag && On);

	XF_SetVisible((TPage_XFilter*)self, On);
}

/* ************** BP2 Ext Ev ****************** */
static bool MathImp(TPage_BP2 *self, TMgsMathImp *pImp) {
	if (!pImp) return false;
	if (self->cbF1ImpOn->Checked) {
	    pImp->yVal = ImpF1(self, pImp->MHz, &pImp->Z);
	    return true;
	} else if (self->cbF2ImpOn->Checked) {
	    pImp->yVal = ImpF2(self, pImp->MHz, &pImp->Z);
	    return true;
	} else if (self->cbF3ImpOn->Checked) {
	    pImp->yVal = ImpF3(self, pImp->MHz, &pImp->Z);
	    return true;
	} else if (self->cbF4ImpOn->Checked) {
	    pImp->yVal = ImpF4(self, pImp->MHz, &pImp->Z);
	    return true;
	}
	return false; 
}

static void DVal_Update(TFormRLC *rlc, double val) {
	if (rlc->Update) rlc->Update(rlc, val, 0);
	if (rlc->SaveData) rlc->SaveData(rlc, NULL);
}

static bool self_OnMsg(TPage_BP2 *self, int msg, void *p) {
  TpcIni *pcIni;
  int i;
  float c, l, k0, dv1, dv2, l1, l3, l5;
  TFormSetLC0 *LC0;

	switch (msg & MSG_BEF_MASK) {
	case MSG_MATH_FILTER:
	    math_Filter(self);
	    return true;

	case MSG_MATH_IMP:
	    return MathImp(self, p);

	case MSG_NEW_SCALE_PARAM:
	    pcIni = get_appIni();
	    i = 1;
	    if (self->ScaleMHz >= 1) i = 0;
	    TpcIni_WR_float(pcIni, self->gname, "ScaleMHz", self->ScaleMHz, i);
	    TpcIni_Save(pcIni);
	    free_appIni(pcIni);
	    return true;

	case MSG_SetLC0:
	    if (!p) return false;
	    LC0 = p;
	    switch (LC0->nr) {
	    case 1:
		DVal_Update((TFormRLC*)self->f_C3, LC0->C * 2 * LC0->K);
		DVal_Update((TFormRLC*)self->f_L3, LC0->L / (2 * LC0->K));
		math_Filter(self);
		return true;
	    case 2:
		c = LC0->C / LC0->K;
		l = LC0->L * LC0->K;

		dv1 = ((2 / (LC0->K * LC0->K)) + 1) * LC0->v[0];
		dv2 = ((LC0->K * LC0->K / 2) + 1) * (2 / LC0->v[1]);
		l5 = l /  LC0->v[0];
		l3 = l / dv1;
		l1 = l / dv2;
		k0 = l5 / (l1 + l3);

		DVal_Update((TFormRLC*)self->f_C1, c *  LC0->v[0]);
		DVal_Update((TFormRLC*)self->f_L1, l / dv2 * k0);

		DVal_Update((TFormRLC*)self->f_C3, c * dv1 / k0);
		DVal_Update((TFormRLC*)self->f_L3, l / dv1 * k0);

		DVal_Update((TFormRLC*)self->f_C5, c * dv2 / k0);
		DVal_Update((TFormRLC*)self->f_L5, l5);

		math_Filter(self);
		return true;
	    }
	    return false;
	}
	return false;
}

/* ************** BP2 Ev ****************** */
static void cbXxOn_OnClick(TChkBox *self, long KeyState, bool DblClick) {
  TPage_BP2 *pg = self->subClass;
  TpcIni *pcIni = TpcIni_Create(appDat.inifile_app);
	XF_SaveOnOff((TPage_XFilter*)pg, pcIni);
	TpcIni_SaveAndFree(pcIni);
	RePaint((TWins*)pg->pnl);
	math_Filter(pg);
}
/* static void cbInvOn_OnClick(TChkBox *self, long KeyState, bool DblClick) {
  TPage_BP2 *pg = self->subClass;
	RePaint((TWins*)pg->pnl);
	math_Filter(pg);
} */

static void cbFxOn_OnClick(TChkBox *self, long KeyState, bool DblClick) {
  TPage_BP2 *pg = self->subClass;
//  TPage_Filter *pg = self->subClass;
  TpcIni *pcIni = TpcIni_Create(appDat.inifile_app);
	XF_SaveOnOff((TPage_XFilter*)pg, pcIni);
	TpcIni_SaveAndFree(pcIni);
	((TScale_pxy*)self->tag)->PaintDat = ((TChkBox*)self)->Checked;
	Refresh((TWins*)pg->pgfilt->xy_ind);
}

static void cbFxImpOn_OnClick(TChkBox *self, long KeyState, bool DblClick) {
  TPage_BP2 *pg = self->subClass;
  TpcIni *pcIni = TpcIni_Create(appDat.inifile_app);
	if (pg->cbF1ImpOn != self) TChkBox_SetChecked(pg->cbF1ImpOn, False);
	if (pg->cbF2ImpOn != self) TChkBox_SetChecked(pg->cbF2ImpOn, False);
	if (pg->cbF3ImpOn != self) TChkBox_SetChecked(pg->cbF3ImpOn, False);
	if (pg->cbF4ImpOn != self) TChkBox_SetChecked(pg->cbF4ImpOn, False);
	XF_SaveOnOff((TPage_XFilter*)pg, pcIni);
	TpcIni_SaveAndFree(pcIni);
	math_Filter(pg);
	Refresh((TWins*)pg->pgfilt->xy_ind);
}

static void pnl_OnPaint(TWins *self) {
  TPage_BP2 *pg = self->subClass;
  int fu, x;

	fu = XF_GetPaint_Fu((TPage_XFilter*)pg);
	x = pg->cbF1On->left + pg->cbF1On->width + 2;

	DrawBP2(self->WinID, x, pg->cbF1On->top, fu);
	fu += 0x100;
	DrawBP2(self->WinID, x, pg->cbF2On->top, fu);
	fu += 0x100;
	DrawBP2(self->WinID, x, pg->cbF3On->top, fu);
	fu += 0x100;
	DrawBP2(self->WinID, x, pg->cbF4On->top, fu);

	DrawPic(self->WinID, get_Pic_cOhm(), 
			pg->dv_Ra->left + pg->dv_Ra->width + 2,
			pg->dv_Ra->top + 5);

	str_toGraf(self, "pF", pg->dv_Cx->left + pg->dv_Cx->width + 1,
			       pg->dv_Cx->top + 3);

	str_toGraf(self, "pF", pg->dv_C3->left + pg->dv_C3->width + 1,
			       pg->dv_C3->top + 3);
	str_toGraf(self, "pF", pg->dv_C5->left + pg->dv_C5->width + 1,
			       pg->dv_C5->top + 3);

	str_toGraf(self, "uH", pg->dv_L3->left + pg->dv_L3->width + 1,
			       pg->dv_L3->top + 3);
	str_toGraf(self, "uH", pg->dv_L5->left + pg->dv_L5->width + 1,
			       pg->dv_L5->top + 3);
}

static void DVal_OnValChange(TDVal *dv, double val) {
	if (dv->owner) TDVal_DoValChange((TDVal*)dv->owner, val, tdvfu_ChangeEv);
}

static void fXxx_OnChange(TFormRLC* fRLC) {
	math_Filter((TPage_BP2*)fRLC->subClass);
}
/* static void BP2_OnRSync(TFormRLC* fRLC, int val) {
  TPage_BP2 *pg = fRLC->subClass;
	Form_R_sync(fRLC, pg->f_Rg, val);
	Form_R_sync(fRLC, pg->f_Rs, val);
	Form_R_sync(fRLC, pg->f_Rx, val);
	Form_R_sync(fRLC, pg->f_Ra, val);
} */
static void OnLSync(TFormRLC* fRLC, int val) {
  TPage_BP2 *pg = fRLC->subClass;
	Form_L_sync(fRLC, pg->f_L1, val);
	Form_L_sync(fRLC, pg->f_L2, val);
	Form_L_sync(fRLC, pg->f_L3, val);
	Form_L_sync(fRLC, pg->f_L4, val);
	Form_L_sync(fRLC, pg->f_L5, val);
}
static void OnCSync(TFormRLC* fRLC, int val) {
  TPage_BP2 *pg = fRLC->subClass;
//	Form_C_sync(fRLC, pg->f_Cs, val);
//	Form_C_sync(fRLC, pg->f_Cx, val);
	Form_C_sync(fRLC, pg->f_C1, val);
	Form_C_sync(fRLC, pg->f_C2, val);
	Form_C_sync(fRLC, pg->f_C3, val);
	Form_C_sync(fRLC, pg->f_C4, val);
	Form_C_sync(fRLC, pg->f_C5, val);
}
/* ************** Save Load ****************** */
static void SaveData(TPage_BP2 *self, TpcIni *ini) {
	XF_SaveData((TPage_XFilter*)self, ini);

	self->f_L1->SaveData(self->f_L1, ini);
	self->f_L2->SaveData(self->f_L2, ini);
	self->f_L3->SaveData(self->f_L3, ini);
	self->f_L4->SaveData(self->f_L4, ini);
	self->f_L5->SaveData(self->f_L5, ini);

	self->f_C1->SaveData(self->f_C1, ini);
	self->f_C2->SaveData(self->f_C2, ini);
	self->f_C3->SaveData(self->f_C3, ini);
	self->f_C4->SaveData(self->f_C4, ini);
	self->f_C5->SaveData(self->f_C5, ini);
}

static void LoadData(TPage_BP2 *self, TpcIni *ini) {

	XF_LoadData((TPage_XFilter*)self, ini);

	self->f_L1->LoadData(self->f_L1, ini);
	self->f_L2->LoadData(self->f_L2, ini);
	self->f_L3->LoadData(self->f_L3, ini);
	self->f_L4->LoadData(self->f_L4, ini);

	self->f_C1->LoadData(self->f_C1, ini);
	self->f_C2->LoadData(self->f_C2, ini);
	self->f_C3->LoadData(self->f_C3, ini);

	math_Filter(self);
	Refresh((TWins*)self->pgfilt->xy_ind);
}

/* ************** BP2 Create ****************** */
static void DVal_Create_Xxx(TWins *Parent, TDVal **dv, TFormRLConoff **onoff, int *x, int y, int w, int nk, TPic *pic) {
  int tx = *x;
  TDVal *tdv = TDVal_CreateS(Parent, tx+19, y, w, 19);
	tdv->nk = nk;
	tdv->dv_fu = tdv_fu_LostFocusEnter;
	tdv->OnValChange = DVal_OnValChange;
	*dv = tdv;
	*onoff = TFormRLConoff_CreateU(Parent, tx, y+1, 18, 16, pic);
	*x = tx + w + 21;
}

/*static TFormR *Create_fR(TPage_BP2 *self, const char *Caption,
			const char *s, TDVal *dv, float val) {
  TFormR *fR = Create_Form_R(appDat.obj, Caption, self->gname, s, dv, val);
	fR->subClass = self;
	TDVal_Set_Value(dv, fR->R->dval);
	fR->OnChange = fXxx_OnChange;
	fR->OnSync = BP2_OnRSync;
	return fR;
} */
static TFormL *Create_fL(TPage_BP2 *self, const char *Caption,
			const char *s, TDVal *dv, float val) {
  TFormL *fL = Create_Form_L(appDat.obj, Caption, self->gname, s, dv, val);
	fL->subClass = self;
	TDVal_Set_Value(dv, fL->L->dval);
	fL->OnChange = fXxx_OnChange;
	fL->OnSync = OnLSync;
	return fL;
}
static TFormC *Create_fC(TPage_BP2 *self, const char *Caption,
			const char *s, TDVal *dv, float val) {
  TFormC *fC = Create_Form_C(appDat.obj, Caption, self->gname, s, dv, val);
	fC->subClass = self;
	TDVal_Set_Value(dv, fC->C->dval);
	fC->OnChange = fXxx_OnChange;
	fC->OnSync = OnCSync;
	return fC;
}

TPage_BP2 *page_Add_BP2(TPageControl *pagc, TPage_Filter *pgfilt) {
  TPage_BP2 *self;
  TWins *pnl;
  int x, y;
  TAddXFilter xf;

	xf.pagc = pagc;
	xf.pgfilt = pgfilt;
	xf.gname = "BP2";
	xf.psize = sizeof(TPage_BP2);
	xf.ini = get_appIni();
	xf.TDValOnValChange = DVal_OnValChange;
	xf.fXxx_OnChange = fXxx_OnChange;
	xf.OnRSync = NULL;
	xf.OnLSync = OnLSync;
	xf.OnCSync = OnCSync;
	xf.dvfu = FU_RG|FU_RS|FU_RX|FU_RA|FU_CS|FU_CX|FU_LS|FU_LX;

	xf.cb_OnClick = cbXxOn_OnClick;
	xf.cbfu = FU_RS|FU_RX|FU_CS|FU_CX|FU_LS|FU_LX|FU_INV;
	xf.cbOnOff = 0xffe0;
	xf.cbY = 122;

	xf.cbFxOnClick = cbFxOn_OnClick;
	xf.cbFxImpOnClick = cbFxImpOn_OnClick;
	xf.cbF1Y = 145;
	xf.cbF2Y = 190;
	xf.cbF3Y = 235;
	xf.cbF4Y = 280;
	xf.cbFxfu = FU_F1|FU_F2|FU_F3|FU_F4;

	xf.LC0_Popupfu = FU_F1|FU_F2; //|FU_F3|FU_F4;

	self = (TPage_BP2*)PageAddXFilter(&xf);

	self->pnl->OnPaint = pnl_OnPaint;
	pnl = self->pnl;

/* C1 C2 C3 */
	x = 0;
	y = 42;
	DVal_Create_Xxx(pnl, &self->dv_C1, &self->OnOff_C1, &x, y, 54, 1, get_Pic_cC1());
	DVal_Create_Xxx(pnl, &self->dv_C2, &self->OnOff_C2, &x, y, 54, 1, get_Pic_cC2());
	DVal_Create_Xxx(pnl, &self->dv_C3, &self->OnOff_C3, &x, y, 54, 1, get_Pic_cC3());
/* C4 C5 */
	x = 0;
	y += 20;
	DVal_Create_Xxx(pnl, &self->dv_C4, &self->OnOff_C4, &x, y, 54, 1, get_Pic_cC4());
	DVal_Create_Xxx(pnl, &self->dv_C5, &self->OnOff_C5, &x, y, 54, 1, get_Pic_cC5());
/* L1 L2 L3 */
	x = 0;
	y += 20;
	DVal_Create_Xxx(pnl, &self->dv_L1, &self->OnOff_L1, &x, y, 54, 3, get_Pic_cL1());
	DVal_Create_Xxx(pnl, &self->dv_L2, &self->OnOff_L2, &x, y, 54, 3, get_Pic_cL2());
	DVal_Create_Xxx(pnl, &self->dv_L3, &self->OnOff_L3, &x, y, 54, 3, get_Pic_cL3());
/* L4 L5 */
	x = 0;
	y += 20;
	DVal_Create_Xxx(pnl, &self->dv_L4, &self->OnOff_L4, &x, y, 54, 3, get_Pic_cL4());
	DVal_Create_Xxx(pnl, &self->dv_L5, &self->OnOff_L5, &x, y, 54, 3, get_Pic_cL5());

	self->f_C1 = Create_fC(self, "BP2 C1", "C1", self->dv_C1, 8);
	self->f_C2 = Create_fC(self, "BP2 C2", "C2", self->dv_C2, 16);
	self->f_C3 = Create_fC(self, "BP2 C3", "C3", self->dv_C3, 8);
	self->f_C4 = Create_fC(self, "BP2 C4", "C4", self->dv_C4, 8);
	self->f_C5 = Create_fC(self, "BP2 C5", "C5", self->dv_C5, 8);

	self->f_L1 = Create_fL(self, "BP2 L1", "L1", self->dv_L1, 0.02);
	self->f_L2 = Create_fL(self, "BP2 L2", "L2", self->dv_L2, 0.02);
	self->f_L3 = Create_fL(self, "BP2 L3", "L3", self->dv_L3, 0.02);
	self->f_L4 = Create_fL(self, "BP2 L4", "L4", self->dv_L4, 0.01);
	self->f_L5 = Create_fL(self, "BP2 L5", "L5", self->dv_L5, 0.02);

	TFormRLConoff_SetForm(self->OnOff_C1, (TForm*)self->f_C1);
	TFormRLConoff_SetForm(self->OnOff_C2, (TForm*)self->f_C2);
	TFormRLConoff_SetForm(self->OnOff_C3, (TForm*)self->f_C3);
	TFormRLConoff_SetForm(self->OnOff_C4, (TForm*)self->f_C4);
	TFormRLConoff_SetForm(self->OnOff_C5, (TForm*)self->f_C5);
	TFormRLConoff_SetForm(self->OnOff_L1, (TForm*)self->f_L1);
	TFormRLConoff_SetForm(self->OnOff_L2, (TForm*)self->f_L2);
	TFormRLConoff_SetForm(self->OnOff_L3, (TForm*)self->f_L3);
	TFormRLConoff_SetForm(self->OnOff_L4, (TForm*)self->f_L4);
	TFormRLConoff_SetForm(self->OnOff_L5, (TForm*)self->f_L5);

	self->OnMsg = self_OnMsg;
	self->SaveData = SaveData;
	self->LoadData = LoadData;

	free_appIni(xf.ini);

	return self;
}

