/*
 Copyright (C) 2010-2015 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "ElMath.h"
#include "ElGraf.h"
#include <math.h>

static void str_toGraf(TWins *Wins, const char *s, int x, int y) {
	vds_SetStr(&Wins->vds, s);
	DrawColorString(x, y, &Wins->vds);
}

static void DrawW1(Window WinID, int x, int y, int fu) {
  int xa;
  int x2 = x;
  int x2a;
  int ya = y+45;
  int y2 = y+30;

	if ((fu & 0x0300) == 0x000) {
	    Draw_xP1_Rg(WinID, &x2, &xa, y, y2, fu & 0x01);
	    x2a = x2;
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC1());
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL1());
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC3());
	    Draw_xP1_Ra(WinID, x2, xa, y, y2, 0);

	    xa -= 3;
	    DrawLineRGB(WinID, 0, xa, y2+3, xa, y2+45);

	    DrawPic(WinID, get_Pic_pt(), x2a-4, y-2);
	    DrawLineRGB(WinID, 0, x2a-2, y, x2a-2, y+45);
	    DrawLineRGB(WinID, 0, x2a-2, y+45, x2a, y+45);

	    DrawTP1_Lh(WinID, &x2a, ya, get_Pic_cL3());
	    DrawTP1_Cv(WinID, &x2a, 0, ya, get_Pic_cC4());
	    DrawTP1_Lh(WinID, &x2a, ya, get_Pic_cL5());
	    Draw_xP1_R_Out(WinID, x2a, xa, ya, ya+30, fu & 0x04, get_Pic_cRb());
	}

	if ((fu & 0x0300) == 0x200) {
	    Draw_xP1_Rg(WinID, &x2, &xa, y, y2, fu & 0x01);
	    x2a = x2;
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC1());
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL1());
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC2());
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL2());
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC3());
	    Draw_xP1_Ra(WinID, x2, xa, y, y2, 0);

	    xa -= 3;
	    DrawLineRGB(WinID, 0, xa, y2+3, xa, y2+45);

	    DrawPic(WinID, get_Pic_pt(), x2a-4, y-2);
	    DrawLineRGB(WinID, 0, x2a-2, y, x2a-2, y+45);
	    DrawLineRGB(WinID, 0, x2a-2, y+45, x2a, y+45);

	    DrawTP1_Lh(WinID, &x2a, ya, get_Pic_cL3());
	    DrawTP1_Cv(WinID, &x2a, 0, ya, get_Pic_cC4());
	    DrawTP1_Lh(WinID, &x2a, ya, get_Pic_cL4());
	    DrawTP1_Cv(WinID, &x2a, 0, ya, get_Pic_cC5());
	    DrawTP1_Lh(WinID, &x2a, ya, get_Pic_cL5());
	    Draw_xP1_R_Out(WinID, x2a, xa, ya, ya+30, fu & 0x04, get_Pic_cRb());
	}
}

static void ImpW1_ab_F1(TPage_W1 *self, float MHz, float *Z, float *ZB, float *yVA, float *yVB) {
  TRLC rlcA, rlcB, rlcT;
  float yA, yB;
  float w = MHz * M_PI * 2;
	if (w < 0.000001) {
	    *Z = self->f_Rx->R->dval;
	    *yVA = 0;
	    *yVB = 0;
	    return;
	}
	Form_R_math(self->f_Ra, w);
	Form_R_math(self->f_Rx, w);
	Form_C_math(self->f_C1, w);
	Form_C_math(self->f_C3, w);
	Form_C_math(self->f_C4, w);
	Form_L_math(self->f_L1, w);
	Form_L_math(self->f_L3, w);
	Form_L_math(self->f_L5, w);

	RLC_Copy(&rlcA, &self->f_Ra->rlc);
	yA = rlcA.Z;
	RLC_Add_Ser(&rlcA, &self->f_C3->rlc);
	yA /= rlcA.Z;
	RLC_Add_Par(&rlcA, &self->f_L1->rlc);
	yA *= rlcA.Z;
	RLC_Add_Ser(&rlcA, &self->f_C1->rlc);
	yA /= rlcA.Z;
	RLC_Copy(&rlcT, &rlcA);


	RLC_Copy(&rlcB, &self->f_Rx->rlc);
	yB = rlcB.Z;

	if (self->cbCxOn->Checked) {
		Form_C_math(self->f_Cx, w);
		RLC_Add_Ser(&rlcB, &self->f_Cx->rlc);
	}


	RLC_Add_Ser(&rlcB, &self->f_L5->rlc);
	yB /= rlcB.Z;
	RLC_Add_Par(&rlcB, &self->f_C4->rlc);
	yB *= rlcB.Z;
	RLC_Add_Ser(&rlcB, &self->f_L3->rlc);
	yB /= rlcB.Z;

	RLC_Add_Par(&rlcA, &rlcB);
	yA *= rlcA.Z;
	RLC_Add_Par(&rlcB, &rlcT);
	yB *= rlcB.Z;

	if (self->cbCsOn->Checked) {
	    Form_C_math(self->f_Cs, w);
	    RLC_Add_Ser(&rlcA, &self->f_Cs->rlc);
	    RLC_Add_Ser(&rlcB, &self->f_Cs->rlc);
	}

	*Z = 0;
	*ZB = 0;
	if (self->f_Rg->R->dval > 0) {
	    *Z = rlcA.Z;
	    *ZB = rlcB.Z;
	    Form_R_math(self->f_Rg, w);
	    RLC_Add_Ser(&rlcA, &self->f_Rg->rlc);
	    RLC_Add_Ser(&rlcB, &self->f_Rg->rlc);
	}

	yA /= rlcA.Z;
	yB /= rlcB.Z;
	*yVA = yA;
	*yVB = yB;
}

static void ImpW1_ab_F3(TPage_W1 *self, float MHz, float *Z, float *ZB, float *yVA, float *yVB) {
  TRLC rlcA, rlcB, rlcT;
  float yA, yB;
  float w = MHz * M_PI * 2;
	if (w < 0.000001) {
	    *Z = self->f_Rx->R->dval;
	    *yVA = 0;
	    *yVB = 0;
	    return;
	}
	Form_R_math(self->f_Ra, w);
	Form_R_math(self->f_Rx, w);
	Form_C_math(self->f_C1, w);
	Form_C_math(self->f_C2, w);
	Form_C_math(self->f_C3, w);
	Form_C_math(self->f_C4, w);
	Form_C_math(self->f_C5, w);
	Form_L_math(self->f_L1, w);
	Form_L_math(self->f_L2, w);
	Form_L_math(self->f_L3, w);
	Form_L_math(self->f_L4, w);
	Form_L_math(self->f_L5, w);

	RLC_Copy(&rlcA, &self->f_Ra->rlc);
	yA = rlcA.Z;
	RLC_Add_Ser(&rlcA, &self->f_C3->rlc);
	yA /= rlcA.Z;
	RLC_Add_Par(&rlcA, &self->f_L2->rlc);
	yA *= rlcA.Z;
	RLC_Add_Ser(&rlcA, &self->f_C2->rlc);
	yA /= rlcA.Z;
	RLC_Add_Par(&rlcA, &self->f_L1->rlc);
	yA *= rlcA.Z;
	RLC_Add_Ser(&rlcA, &self->f_C1->rlc);
	yA /= rlcA.Z;
	RLC_Copy(&rlcT, &rlcA);


	RLC_Copy(&rlcB, &self->f_Rx->rlc);
	yB = rlcB.Z;
	if (self->cbCxOn->Checked) {
		Form_C_math(self->f_Cx, w);
		RLC_Add_Ser(&rlcB, &self->f_Cx->rlc);
	}
	RLC_Add_Ser(&rlcB, &self->f_L5->rlc);
	yB /= rlcB.Z;
	RLC_Add_Par(&rlcB, &self->f_C5->rlc);
	yB *= rlcB.Z;
	RLC_Add_Ser(&rlcB, &self->f_L4->rlc);
	yB /= rlcB.Z;
	RLC_Add_Par(&rlcB, &self->f_C4->rlc);
	yB *= rlcB.Z;
	RLC_Add_Ser(&rlcB, &self->f_L3->rlc);
	yB /= rlcB.Z;

	RLC_Add_Par(&rlcA, &rlcB);
	yA *= rlcA.Z;
	RLC_Add_Par(&rlcB, &rlcT);
	yB *= rlcB.Z;

	if (self->cbCsOn->Checked) {
	    Form_C_math(self->f_Cs, w);
	    RLC_Add_Ser(&rlcA, &self->f_Cs->rlc);
	    RLC_Add_Ser(&rlcB, &self->f_Cs->rlc);
	}

	*Z = 0;
	*ZB = 0;
	if (self->f_Rg->R->dval > 0) {
	    *Z = rlcA.Z;
	    *ZB = rlcB.Z;
	    Form_R_math(self->f_Rg, w);
	    RLC_Add_Ser(&rlcA, &self->f_Rg->rlc);
	    RLC_Add_Ser(&rlcB, &self->f_Rg->rlc);
	}

	yA /= rlcA.Z;
	yB /= rlcB.Z;
	*yVA = yA;
	*yVB = yB;
}


static float ImpF1(TPage_W1 *self, float MHz, float *Z) {
  float ZA, ZB;
  float yVA, yVB;
	ImpW1_ab_F1(self, MHz, &ZA, &ZB, &yVA, &yVB);
	*Z = ZA;
	return yVA;
} 
static float ImpF2(TPage_W1 *self, float MHz, float *Z) {
  float ZA, ZB;
  float yVA, yVB;
	ImpW1_ab_F1(self, MHz, &ZA, &ZB, &yVA, &yVB);
	*Z = ZB;
	return yVB;
}


static float ImpF3(TPage_W1 *self, float MHz, float *Z) {
  float ZA, ZB;
  float yVA, yVB;
	ImpW1_ab_F3(self, MHz, &ZA, &ZB, &yVA, &yVB);
	*Z = ZA;
	return yVA;
}

static float ImpF4(TPage_W1 *self, float MHz, float *Z) {
  float ZA, ZB;
  float yVA, yVB;
	ImpW1_ab_F3(self, MHz, &ZA, &ZB, &yVA, &yVB);
	*Z = ZB;
	return yVB;
}

static void math_Filter(TPage_W1 *self) {
  TPage_Filter *pgf = self->pgfilt;
  float fcStep, fOff, fStep;
  TScale_pxy *pxy = pgf->xy_ind->dat->pxy;
  TScale_pxy *pxy2;
  TScale_pxy *pxy3 = NULL;
  float fc, Z, K;
  TScale_Point *sSP, *dSP;

	K = 1;
	if (pgf->cbRgRa->Checked)
	    K = (self->f_Rg->rlc.val + self->f_Ra->rlc.val) / self->f_Ra->rlc.val;

	fOff = pgf->ScaleMHzoff;
	fStep = pgf->ScaleMHz;
	fcStep = fStep / (pxy->count-1);
	for (int i=0;i<pxy->count;i++) {
	    fc = i * fcStep + fOff;
	    pxy->xy[i].x = fc;
	    pxy->xy[i].y = K * ImpF1(self, fc, &Z);
	    pxy->xy[i].y2 = Z;
	}
	if (self->cbF1ImpOn->Checked) pxy3 = pxy;

	pxy = pxy->next;
	fcStep = fStep / (pxy->count-1);
	for (int i=0;i<pxy->count;i++) {
	    fc = i * fcStep + fOff;
	    pxy->xy[i].x = fc;
	    pxy->xy[i].y = K * ImpF2(self, fc, &Z);
	    pxy->xy[i].y2 = Z;
	}
	if (self->cbF2ImpOn->Checked) pxy3 = pxy;

	pxy = pxy->next;
	fcStep = fStep / (pxy->count-1);
	for (int i=0;i<pxy->count;i++) {
	    fc = i * fcStep + fOff;
	    pxy->xy[i].x = fc;
	    pxy->xy[i].y = K * ImpF3(self, fc, &Z);
	    pxy->xy[i].y2 = Z;
	}
	if (self->cbF3ImpOn->Checked) pxy3 = pxy;


	pxy = pxy->next;
	fcStep = fStep / (pxy->count-1);
	for (int i=0;i<pxy->count;i++) {
	    fc = i * fcStep + fOff;
	    pxy->xy[i].x = fc;
	    pxy->xy[i].y = K * ImpF4(self, fc, &Z);
	    pxy->xy[i].y2 = Z;
	}
	if (self->cbF4ImpOn->Checked) pxy3 = pxy;

	Z = self->dv_Rg->dval;
	if (pxy3 && (Z > 0)) {
	    pxy2 = pgf->yInZ;
	    pxy2->PaintDat = True;
	    sSP = &pxy3->xy[0];
	    dSP = &pxy2->xy[0];
	    for (int i=0;i<pxy2->count;i++) {
		dSP->x = sSP->x;
		dSP->y = sSP->y2 / Z;
		dSP++; sSP++;
	    }
	} else {
	    pgf->yInZ->PaintDat = False;
	}

	SetCursor_Dat_txt(pgf);
	Refresh((TWins*)pgf->xy_ind);

}

static void SaveW1OnOff(TPage_W1 *self, TpcIni *pcIni) {
  int OnOff = 0;

	if (self->cbCsOn->Checked) OnOff |= 0x01;
//	if (self->cbRsOn->Checked) OnOff |= 0x02;
	if (self->cbCxOn->Checked) OnOff |= 0x04;
//	if (self->cbRxOn->Checked) OnOff |= 0x08;

	if (self->cbF1On->Checked) OnOff |= 0x010;
	if (self->cbF2On->Checked) OnOff |= 0x020;
	if (self->cbF3On->Checked) OnOff |= 0x040;
	if (self->cbF4On->Checked) OnOff |= 0x080;

	if (self->cbF1ImpOn->Checked) OnOff |= 0x100;
	if (self->cbF2ImpOn->Checked) OnOff |= 0x200;
	if (self->cbF3ImpOn->Checked) OnOff |= 0x300;
	if (self->cbF4ImpOn->Checked) OnOff |= 0x400;

	TpcIni_WR_int(pcIni, self->gname, "OnOff", OnOff);
}

void W1_SetVisible(TPage_W1 *self, bool On) {
	SetVisible((TWins*)self->f_Rg, self->f_Rg->tag && On);
//	SetVisible((TWins*)self->f_Rs, self->f_Rs->tag && On);
	SetVisible((TWins*)self->f_Rx, self->f_Rx->tag && On);
	SetVisible((TWins*)self->f_Ra, self->f_Ra->tag && On);
	SetVisible((TWins*)self->f_Cs, self->f_Cs->tag && On);
	SetVisible((TWins*)self->f_Cx, self->f_Cx->tag && On);
	SetVisible((TWins*)self->f_C1, self->f_C1->tag && On);
	SetVisible((TWins*)self->f_C2, self->f_C2->tag && On);
	SetVisible((TWins*)self->f_C3, self->f_C3->tag && On);
	SetVisible((TWins*)self->f_C4, self->f_C4->tag && On);
	SetVisible((TWins*)self->f_C5, self->f_C5->tag && On);
	SetVisible((TWins*)self->f_L1, self->f_L1->tag && On);
	SetVisible((TWins*)self->f_L2, self->f_L2->tag && On);
	SetVisible((TWins*)self->f_L3, self->f_L3->tag && On);
	SetVisible((TWins*)self->f_L4, self->f_L4->tag && On);
	SetVisible((TWins*)self->f_L5, self->f_L5->tag && On);
  TScale_pxy *pxy;
	if (On) {
	    pxy = self->pgfilt->xy_ind->dat->pxy;
	    while (pxy) {
		pxy->PaintDat = False;
		pxy = pxy->next;
	    }
	    math_Filter(self);
	    ((TScale_pxy*)self->cbF1On->tag)->PaintDat = self->cbF1On->Checked;
	    ((TScale_pxy*)self->cbF2On->tag)->PaintDat = self->cbF2On->Checked;
	    ((TScale_pxy*)self->cbF3On->tag)->PaintDat = self->cbF3On->Checked;
	    ((TScale_pxy*)self->cbF4On->tag)->PaintDat = self->cbF4On->Checked;
	}
}

/* ************** W1 Ext Ev ****************** */
/*bool ImpW1_Fx(TPage_W1 *self, float MHz, float *yVal, float *Z) {
	if (self->cbF1ImpOn->Checked) {
		*yVal = ImpW1_F1(self, MHz, Z);
	} else if (self->cbF2ImpOn->Checked) {
		*yVal = ImpW1_F2(self, MHz, Z);
	} else if (self->cbF3ImpOn->Checked) {
		*yVal = ImpW1_F3(self, MHz, Z);
	} else if (self->cbF4ImpOn->Checked) {
		*yVal = ImpW1_F4(self, MHz, Z);
	} else return False;
	return True;
} */

static bool MathImp(TPage_W1 *self, TMgsMathImp *pImp) {
	if (!pImp) return false;
	if (self->cbF1ImpOn->Checked) {
	    pImp->yVal = ImpF1(self, pImp->MHz, &pImp->Z);
	    return true;
	} else if (self->cbF2ImpOn->Checked) {
	    pImp->yVal = ImpF2(self, pImp->MHz, &pImp->Z);
	    return true;
	} else if (self->cbF3ImpOn->Checked) {
	    pImp->yVal = ImpF3(self, pImp->MHz, &pImp->Z);
	    return true;
	} else if (self->cbF4ImpOn->Checked) {
	    pImp->yVal = ImpF4(self, pImp->MHz, &pImp->Z);
	    return true;
	}
	return false; 
}

static void DVal_Update(TFormRLC *rlc, double val) {
	if (rlc->Update) rlc->Update(rlc, val, 0);
	if (rlc->SaveData) rlc->SaveData(rlc, NULL);
}

static bool self_OnMsg(TPage_W1 *self, int msg, void *p) {
  TpcIni *pcIni;
  int i;
  TFormSetLC0 *LC0;

	switch (msg & MSG_BEF_MASK) {
	case MSG_MATH_FILTER:
	    math_Filter(self);
	    return true;

	case MSG_MATH_IMP:
	    return MathImp(self, p);

	case MSG_NEW_SCALE_PARAM:
	    pcIni = get_appIni();
	    i = 1;
	    if (self->ScaleMHz >= 1) i = 0;
	    TpcIni_WR_float(pcIni, self->gname, "ScaleMHz", self->ScaleMHz, i);
	    TpcIni_Save(pcIni);
	    free_appIni(pcIni);
	    return true;

	case MSG_SetLC0:
	    if (!p) return false;
	    LC0 = p;
	    switch (LC0->nr) {
	    case 1:
		DVal_Update((TFormRLC*)self->f_C1, LC0->C / LC0->v[0]);
		DVal_Update((TFormRLC*)self->f_L1, LC0->L / LC0->v[1]);
		DVal_Update((TFormRLC*)self->f_C3, LC0->C / LC0->v[2]);
		math_Filter(self);
		return true;
	    case 2:
		DVal_Update((TFormRLC*)self->f_L3, LC0->L * LC0->v[0]);
		DVal_Update((TFormRLC*)self->f_C4, LC0->C * LC0->v[1]);
		DVal_Update((TFormRLC*)self->f_L5, LC0->L * LC0->v[2]);
		math_Filter(self);
		return true;
	    case 3:
		DVal_Update((TFormRLC*)self->f_C1, LC0->C / LC0->v[0]);
		DVal_Update((TFormRLC*)self->f_L1, LC0->L / LC0->v[1]);
		DVal_Update((TFormRLC*)self->f_C2, LC0->C / LC0->v[2]);
		DVal_Update((TFormRLC*)self->f_L2, LC0->L / LC0->v[3]);
		DVal_Update((TFormRLC*)self->f_C3, LC0->C / LC0->v[4]);
		math_Filter(self);
		return true;
	    case 4:
		DVal_Update((TFormRLC*)self->f_L3, LC0->L * LC0->v[0]);
		DVal_Update((TFormRLC*)self->f_C4, LC0->C * LC0->v[1]);
		DVal_Update((TFormRLC*)self->f_L4, LC0->L * LC0->v[2]);
		DVal_Update((TFormRLC*)self->f_C5, LC0->C * LC0->v[3]);
		DVal_Update((TFormRLC*)self->f_L5, LC0->L * LC0->v[4]);
		math_Filter(self);
		return true;
	    }
	    return false;
	}
	return false;
}

/* ************** W1 Ev ****************** */
static void cbXxOn_OnClick(TChkBox *self, long KeyState, bool DblClick) {
  TPage_W1 *pg = self->subClass;
  TpcIni *pcIni = TpcIni_Create(appDat.inifile_app);
	SaveW1OnOff(pg, pcIni);
	TpcIni_SaveAndFree(pcIni);
	RePaint((TWins*)pg->pnl);
	math_Filter(pg);
}

static void cbFxOn_OnClick(TChkBox *self, long KeyState, bool DblClick) {
  TPage_W1 *pg = self->subClass;
//  TPage_Filter *pg = self->subClass;
  TpcIni *pcIni = TpcIni_Create(appDat.inifile_app);
	SaveW1OnOff(pg, pcIni);
	TpcIni_SaveAndFree(pcIni);
	((TScale_pxy*)self->tag)->PaintDat = ((TChkBox*)self)->Checked;
	Refresh((TWins*)pg->pgfilt->xy_ind);
}

static void cbFxImpOn_OnClick(TChkBox *self, long KeyState, bool DblClick) {
  TPage_W1 *pg = self->subClass;
  TpcIni *pcIni = TpcIni_Create(appDat.inifile_app);
	if (pg->cbF1ImpOn != self) TChkBox_SetChecked(pg->cbF1ImpOn, False);
	if (pg->cbF2ImpOn != self) TChkBox_SetChecked(pg->cbF2ImpOn, False);
	if (pg->cbF3ImpOn != self) TChkBox_SetChecked(pg->cbF3ImpOn, False);
	if (pg->cbF4ImpOn != self) TChkBox_SetChecked(pg->cbF4ImpOn, False);
	SaveW1OnOff(pg, pcIni);
	TpcIni_SaveAndFree(pcIni);
	math_Filter(pg);
	Refresh((TWins*)pg->pgfilt->xy_ind);
}

static void pnl_OnPaint(TWins *self) {
  TPage_W1 *pg = self->subClass;
  int fu = 0;
  int x = pg->cbF1On->left + pg->cbF1On->width + 2;

	if (pg->cbCsOn->Checked) fu |= 0x01;
//	if (pg->cbRsOn->Checked) fu |= 0x02;
	if (pg->cbCxOn->Checked) fu |= 0x04;
//	if (pg->cbRxOn->Checked) fu |= 0x08;

	DrawW1(self->WinID, x, pg->cbF1On->top, fu);
	fu += 0x100;
	DrawW1(self->WinID, x, pg->cbF2On->top, fu);
	fu += 0x100;
	DrawW1(self->WinID, x, pg->cbF3On->top, fu);
	fu += 0x100;
	DrawW1(self->WinID, x, pg->cbF4On->top, fu);

	DrawPic(self->WinID, get_Pic_cOhm(), 
			pg->dv_Rx->left + pg->dv_Rx->width + 2,
			pg->dv_Rx->top + 5);

	str_toGraf(self, "pF", pg->dv_Cx->left + pg->dv_Cx->width + 1,
			       pg->dv_Cx->top + 3);

	str_toGraf(self, "pF", pg->dv_C3->left + pg->dv_C3->width + 1,
			       pg->dv_C3->top + 3);
	str_toGraf(self, "pF", pg->dv_C5->left + pg->dv_C5->width + 1,
			       pg->dv_C5->top + 3);

	str_toGraf(self, "uH", pg->dv_L2->left + pg->dv_L2->width + 1,
			       pg->dv_L2->top + 3);
	str_toGraf(self, "uH", pg->dv_L5->left + pg->dv_L5->width + 1,
			       pg->dv_L5->top + 3);
}

static void DVal_OnValChange(TDVal *dv, double val) {
	if (dv->owner) TDVal_DoValChange((TDVal*)dv->owner, val, tdvfu_ChangeEv);
}

static void fXxx_OnChange(TFormRLC* fRLC) {
	math_Filter((TPage_W1*)fRLC->subClass);
}
static void OnRSync(TFormRLC* fRLC, int val) {
  TPage_W1 *pg = fRLC->subClass;
	Form_R_sync(fRLC, pg->f_Rg, val);
//	Form_R_sync(fRLC, pg->f_Rs, val);
	Form_R_sync(fRLC, pg->f_Rx, val);
	Form_R_sync(fRLC, pg->f_Ra, val);
}
static void OnLSync(TFormRLC* fRLC, int val) {
  TPage_W1 *pg = fRLC->subClass;
	Form_L_sync(fRLC, pg->f_L1, val);
	Form_L_sync(fRLC, pg->f_L2, val);
	Form_L_sync(fRLC, pg->f_L3, val);
	Form_L_sync(fRLC, pg->f_L4, val);
	Form_L_sync(fRLC, pg->f_L5, val);
}
static void OnCSync(TFormRLC* fRLC, int val) {
  TPage_W1 *pg = fRLC->subClass;
	Form_C_sync(fRLC, pg->f_Cs, val);
	Form_C_sync(fRLC, pg->f_Cx, val);
	Form_C_sync(fRLC, pg->f_C1, val);
	Form_C_sync(fRLC, pg->f_C2, val);
	Form_C_sync(fRLC, pg->f_C3, val);
	Form_C_sync(fRLC, pg->f_C4, val);
	Form_C_sync(fRLC, pg->f_C5, val);
}
/* ************** Save Load ****************** */
static void SaveData(TPage_W1 *self, TpcIni *ini) {
	self->f_Rg->SaveData(self->f_Rg, ini);
//	self->f_Rs->SaveData(self->f_Rs, ini);
	self->f_Rx->SaveData(self->f_Rx, ini);
	self->f_Ra->SaveData(self->f_Ra, ini);

	self->f_L1->SaveData(self->f_L1, ini);
	self->f_L2->SaveData(self->f_L2, ini);
	self->f_L3->SaveData(self->f_L3, ini);
	self->f_L4->SaveData(self->f_L4, ini);
	self->f_L5->SaveData(self->f_L5, ini);

	self->f_Cs->SaveData(self->f_Cs, ini);
	self->f_Cx->SaveData(self->f_Cx, ini);
	self->f_C1->SaveData(self->f_C1, ini);
	self->f_C2->SaveData(self->f_C2, ini);
	self->f_C3->SaveData(self->f_C3, ini);
	self->f_C4->SaveData(self->f_C4, ini);
	self->f_C5->SaveData(self->f_C5, ini);
}

static void LoadData(TPage_W1 *self, TpcIni *ini) {

	self->f_Rg->LoadData(self->f_Rg, ini);
//	self->f_Rs->LoadData(self->f_Rs, ini);
	self->f_Rx->LoadData(self->f_Rx, ini);
	self->f_Ra->LoadData(self->f_Ra, ini);

	self->f_L1->LoadData(self->f_L1, ini);
	self->f_L2->LoadData(self->f_L2, ini);
	self->f_L3->LoadData(self->f_L3, ini);
	self->f_L4->LoadData(self->f_L4, ini);
	self->f_L5->LoadData(self->f_L5, ini);

	self->f_Cs->LoadData(self->f_Cs, ini);
	self->f_Cx->LoadData(self->f_Cx, ini);
	self->f_C1->LoadData(self->f_C1, ini);
	self->f_C2->LoadData(self->f_C2, ini);
	self->f_C3->LoadData(self->f_C3, ini);
	self->f_C4->LoadData(self->f_C4, ini);
	self->f_C5->LoadData(self->f_C5, ini);

	math_Filter(self);
	Refresh((TWins*)self->pgfilt->xy_ind);
}

/* ************** W1 Create ****************** */
static void DVal_Create_Xxx(TWins *Parent, TDVal **dv, TFormRLConoff **onoff, int *x, int y, int w, int nk, TPic *pic) {
  int tx = *x;
  TDVal *tdv = TDVal_CreateS(Parent, tx+19, y, w, 19);
	tdv->nk = nk;
	tdv->dv_fu = tdv_fu_LostFocusEnter;
	tdv->OnValChange = DVal_OnValChange;
	*dv = tdv;
	*onoff = TFormRLConoff_CreateU(Parent, tx, y+1, 18, 16, pic);
	*x = tx + w + 21;
}

/* static TFormR *Create_fR(TPage_W1 *self, const char *Caption,
			const char *s, TDVal *dv, float val) {
  TFormR *fR = Create_Form_R(appDat.obj, Caption, self->gname, s, dv, val);
	fR->subClass = self;
	TDVal_Set_Value(dv, fR->R->dval);
	fR->OnChange = fXxx_OnChange;
	fR->OnSync = OnRSync;
	return fR;
} */
static TFormL *Create_fL(TPage_W1 *self, const char *Caption,
			const char *s, TDVal *dv, float val) {
  TFormL *fL = Create_Form_L(appDat.obj, Caption, self->gname, s, dv, val);
	fL->subClass = self;
	TDVal_Set_Value(dv, fL->L->dval);
	fL->OnChange = fXxx_OnChange;
	fL->OnSync = OnLSync;
	return fL;
}
static TFormC *Create_fC(TPage_W1 *self, const char *Caption,
			const char *s, TDVal *dv, float val) {
  TFormC *fC = Create_Form_C(appDat.obj, Caption, self->gname, s, dv, val);
	fC->subClass = self;
	TDVal_Set_Value(dv, fC->C->dval);
	fC->OnChange = fXxx_OnChange;
	fC->OnSync = OnCSync;
	return fC;
}

/*static TPage *page_Add_W1_Create(TPageControl *Parent) {
	return TPage_CreateParamAlg(Parent, sizeof(TPage_W1));
} */

TPage_W1 *page_Add_W1(TPageControl *pagc, TPage_Filter *pgfilt) {
  TPage_W1 *self;
  TWins *pnl;
//  TpcIni *pcIni;
  int x, y;
  TAddXFilter xf;

	xf.pagc = pagc;
	xf.pgfilt = pgfilt;
	xf.gname = "W1";
	xf.psize = sizeof(TPage_W1);
	xf.ini = get_appIni();
	xf.TDValOnValChange = DVal_OnValChange;
	xf.fXxx_OnChange = fXxx_OnChange;
	xf.OnRSync = OnRSync;
	xf.OnLSync = OnLSync;
	xf.OnCSync = OnCSync;
	xf.dvfu = FU_RG|FU_RX|FU_RA|FU_CS|FU_CX;

	xf.cb_OnClick = cbXxOn_OnClick;
	xf.cbfu = FU_CS|FU_CX;
	xf.cbOnOff = 0xffe0;
	xf.cbY = 124;

	xf.cbFxOnClick = cbFxOn_OnClick;
	xf.cbFxImpOnClick = cbFxImpOn_OnClick;
	xf.cbF1Y = 149;
	xf.cbF2Y = 194;
	xf.cbF3Y = 239;
	xf.cbF4Y = 284;
	xf.cbFxfu = FU_F1|FU_F2|FU_F3|FU_F4;

	xf.LC0_Popupfu = FU_F1|FU_F2|FU_F3|FU_F4;

	self = (TPage_W1*)PageAddXFilter(&xf);

	SetLeft((TWins*)self->dv_Rx, self->dv_Ra->left + 75);
	SetLeft((TWins*)self->OnOff_Rx, self->OnOff_Ra->left + 75);
	self->OnOff_Rx->pic = get_Pic_cRb();
	SetCaption((TWins*)self->f_Rx, "W1 Rb");

//	pcIni = get_appIni();

//	self = (TPage_W1*) TPageControl_AddNewUserPage(pagc, "W1", page_Add_W1_Create);
//	self->art = PAGE_ART_FILTER;
//	self->subClass = self;
//	self->pgfilt = pgfilt;
//	self->gname = "W1";

//	pnl = TWins_CreateBA((TWins*)self, 0, 0, 318, 21, 0, alLeft);
//	self->pnl = pnl;
	self->pnl->OnPaint = pnl_OnPaint;
	pnl = self->pnl;
/* Rg Rs Rx Ra */
//	x = 0;
//	y = 2;
//	DVal_Create_Xxx(pnl, &self->dv_Rg, &self->OnOff_Rg, &x, y, 54, 1, get_Pic_cRg());
////	DVal_Create_Xxx(pnl, &self->dv_Rs, &self->OnOff_Rs, &x, y, 54, 1, get_Pic_cRs());
//	x += 75;
//	DVal_Create_Xxx(pnl, &self->dv_Ra, &self->OnOff_Ra, &x, y, 54, 1, get_Pic_cRa());
//	DVal_Create_Xxx(pnl, &self->dv_Rx, &self->OnOff_Rx, &x, y, 54, 1, get_Pic_cRb());
/* Cs Ca */
//	x = 0;
//	y += 20;
//	DVal_Create_Xxx(pnl, &self->dv_Cs, &self->OnOff_Cs, &x, y, 54, 1, get_Pic_cCs());
//	DVal_Create_Xxx(pnl, &self->dv_Cx, &self->OnOff_Cx, &x, y, 54, 1, get_Pic_cCx());
/* C1 C2 C3 */
	x = 0;
	y = 42;
	DVal_Create_Xxx(pnl, &self->dv_C1, &self->OnOff_C1, &x, y, 54, 1, get_Pic_cC1());
	DVal_Create_Xxx(pnl, &self->dv_C2, &self->OnOff_C2, &x, y, 54, 1, get_Pic_cC2());
	DVal_Create_Xxx(pnl, &self->dv_C3, &self->OnOff_C3, &x, y, 54, 1, get_Pic_cC3());
/* L1 L2 */
	x = 0;
	y += 20;
	DVal_Create_Xxx(pnl, &self->dv_L1, &self->OnOff_L1, &x, y, 54, 3, get_Pic_cL1());
	DVal_Create_Xxx(pnl, &self->dv_L2, &self->OnOff_L2, &x, y, 54, 3, get_Pic_cL2());
/* C4 C5 */
	x = 0;
	y += 20;
	DVal_Create_Xxx(pnl, &self->dv_C4, &self->OnOff_C4, &x, y, 54, 1, get_Pic_cC4());
	DVal_Create_Xxx(pnl, &self->dv_C5, &self->OnOff_C5, &x, y, 54, 1, get_Pic_cC5());
/* L3 L4 L5*/
	x = 0;
	y += 20;
	DVal_Create_Xxx(pnl, &self->dv_L3, &self->OnOff_L3, &x, y, 54, 3, get_Pic_cL3());
	DVal_Create_Xxx(pnl, &self->dv_L4, &self->OnOff_L4, &x, y, 54, 3, get_Pic_cL4());
	DVal_Create_Xxx(pnl, &self->dv_L5, &self->OnOff_L5, &x, y, 54, 3, get_Pic_cL5());
/*
	m = TpcIni_RD_int(pcIni, self->gname, "OnOff", 0xffe0);

	y += 20;
	self->cbCsOn = TChkBox_CreateS(pnl, 2, y, 60, 16, "Cs on");
//	self->cbRsOn = TChkBox_CreateS(pnl, 72, y, 60, 16, "Rs on");
	self->cbCxOn = TChkBox_CreateS(pnl, 142, y, 60, 16, "Cx on");
//	self->cbRxOn = TChkBox_CreateS(pnl, 212, y, 60, 16, "Rx on");
	self->cbCsOn->OnClick = cbW1XxOn_OnClick;
//	self->cbRsOn->OnClick = cbW1XxOn_OnClick;
	self->cbCxOn->OnClick = cbW1XxOn_OnClick;
//	self->cbRxOn->OnClick = cbW1XxOn_OnClick;
	self->cbCsOn->Checked = ((m & 0x01) != 0);
//	self->cbRsOn->Checked = ((m & 0x02) != 0);
	self->cbCxOn->Checked = ((m & 0x04) != 0);
//	self->cbRxOn->Checked = ((m & 0x08) != 0);
*/
/* Filter On/Off */
//	y = 105;
/*	y += 20;
	self->cbF1On = TChkBox_CreateS(pnl, 2, y, 38, 17, "F1");
	self->cbF1ImpOn = TChkBox_CreateS(pnl, 2, y+17, 38, 17, "Imp");
	SetColor((TWins*)self->cbF1On, 0xa0a0ff);
	SetColor((TWins*)self->cbF1ImpOn, 0xe0e080);
	y += 45;
	self->cbF2On = TChkBox_CreateS(pnl, 2, y, 38, 17, "F2");
	self->cbF2ImpOn = TChkBox_CreateS(pnl, 2, y+17, 38, 17, "Imp");
	SetColor((TWins*)self->cbF2On, 0xa0ffa0);
	SetColor((TWins*)self->cbF2ImpOn, 0xe0e080);
	y += 45;
	self->cbF3On = TChkBox_CreateS(pnl, 2, y, 38, 17, "F3");
	self->cbF3ImpOn = TChkBox_CreateS(pnl, 2, y+17, 38, 17, "Imp");
	SetColor((TWins*)self->cbF3On, 0xff8080);
	SetColor((TWins*)self->cbF3ImpOn, 0xe0e080);
	y += 45;
	self->cbF4On = TChkBox_CreateS(pnl, 2, y, 38, 17, "F4");
	self->cbF4ImpOn = TChkBox_CreateS(pnl, 2, y+17, 38, 17, "Imp");
	SetColor((TWins*)self->cbF4On, 0xff80ff);
	SetColor((TWins*)self->cbF4ImpOn, 0xe0e080);

	self->cbF1On->OnClick = cbW1FxOn_OnClick;
	self->cbF2On->OnClick = cbW1FxOn_OnClick;
	self->cbF3On->OnClick = cbW1FxOn_OnClick;
	self->cbF4On->OnClick = cbW1FxOn_OnClick;
	self->cbF1On->Checked = ((m & 0x010) != 0);
	self->cbF2On->Checked = ((m & 0x020) != 0);
	self->cbF3On->Checked = ((m & 0x040) != 0);
	self->cbF4On->Checked = ((m & 0x080) != 0);

	self->cbF1ImpOn->OnClick = cbW1FxImpOn_OnClick;
	self->cbF2ImpOn->OnClick = cbW1FxImpOn_OnClick;
	self->cbF3ImpOn->OnClick = cbW1FxImpOn_OnClick;
	self->cbF4ImpOn->OnClick = cbW1FxImpOn_OnClick;
	self->cbF1ImpOn->Checked = ((m & 0x700) == 0x100);
	self->cbF2ImpOn->Checked = ((m & 0x700) == 0x200);
	self->cbF3ImpOn->Checked = ((m & 0x700) == 0x300);
	self->cbF4ImpOn->Checked = ((m & 0x700) == 0x400);

	self->f_Rg = Create_fR(self, "W1 Rg", "Rg", self->dv_Rg, 60);
//	self->f_Rs = Create_fR(self, "W1 Rs", "Rs", self->dv_Rs, 50);
	self->f_Rx = Create_fR(self, "W1 Rb", "Rb", self->dv_Rx, 60);
	self->f_Ra = Create_fR(self, "W1 Ra", "Ra", self->dv_Ra, 60);

	self->f_Cs = Create_fC(self, "W1 Cs", "Cs", self->dv_Cs, 100);
	self->f_Cx = Create_fC(self, "W1 Cx", "Cx", self->dv_Cx, 100);
*/
	self->f_C1 = Create_fC(self, "W1 C1", "C1", self->dv_C1, 3.3);
	self->f_C2 = Create_fC(self, "W1 C2", "C2", self->dv_C2, 2.7);
	self->f_C3 = Create_fC(self, "W1 C3", "C3", self->dv_C3, 4.7);
	self->f_C4 = Create_fC(self, "W1 C4", "C4", self->dv_C4, 12);
	self->f_C5 = Create_fC(self, "W1 C5", "C5", self->dv_C5, 12);

	self->f_L1 = Create_fL(self, "W1 L1", "L1", self->dv_L1, 0.016);
	self->f_L2 = Create_fL(self, "W1 L2", "L2", self->dv_L2, 0.016);
	self->f_L3 = Create_fL(self, "W1 L3", "L3", self->dv_L3, 0.068);
	self->f_L4 = Create_fL(self, "W1 L4", "L4", self->dv_L4, 0.100);
	self->f_L5 = Create_fL(self, "W1 L5", "L5", self->dv_L5, 0.056);

/*	TFormRLConoff_SetForm(self->OnOff_Rg, (TForm*)self->f_Rg);
//	TFormRLConoff_SetForm(self->OnOff_Rs, (TForm*)self->f_Rs);
	TFormRLConoff_SetForm(self->OnOff_Rx, (TForm*)self->f_Rx);
	TFormRLConoff_SetForm(self->OnOff_Ra, (TForm*)self->f_Ra);
	TFormRLConoff_SetForm(self->OnOff_Cs, (TForm*)self->f_Cs);
	TFormRLConoff_SetForm(self->OnOff_Cx, (TForm*)self->f_Cx); */
	TFormRLConoff_SetForm(self->OnOff_C1, (TForm*)self->f_C1);
	TFormRLConoff_SetForm(self->OnOff_C2, (TForm*)self->f_C2);
	TFormRLConoff_SetForm(self->OnOff_C3, (TForm*)self->f_C3);
	TFormRLConoff_SetForm(self->OnOff_C4, (TForm*)self->f_C4);
	TFormRLConoff_SetForm(self->OnOff_C5, (TForm*)self->f_C5);
	TFormRLConoff_SetForm(self->OnOff_L1, (TForm*)self->f_L1);
	TFormRLConoff_SetForm(self->OnOff_L2, (TForm*)self->f_L2);
	TFormRLConoff_SetForm(self->OnOff_L3, (TForm*)self->f_L3);
	TFormRLConoff_SetForm(self->OnOff_L4, (TForm*)self->f_L4);
	TFormRLConoff_SetForm(self->OnOff_L5, (TForm*)self->f_L5);

//	self->ScaleMHz = TpcIni_RD_float(pcIni, self->gname, "ScaleMHz", 1000);
	self->OnMsg = self_OnMsg;

	self->SaveData = SaveData;
	self->LoadData = LoadData;

	free_appIni(xf.ini);

	return self;
}
