/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "ElMath.h"
#include "ElGraf.h"
#include <math.h>

static void EML_Microstrip_sbDetail_OnCount(TScrollBar* sb, int Count) {
}

static void EML_Microstrip_xy_ind_OnResize(TScaleXY *self) {
  TPage_Microstrip *pg = self->subClass;
	SetWidth((TWins*)pg->sbDetail, self->width - pg->xy_ind->sx2 + 22);
}

static void SetUpMM_MIL(TWins *wins, double korr, int nk, int OnOff) {
	while (wins) {
	    if (wins->next_child) SetUpMM_MIL(wins->next_child, korr, nk, OnOff);
	    if (wins->wtyp == wtyp_TDVal) {
		switch (wins->tag) {
		case 1: 
		    TDVal_SetUpKorr((TDVal*)wins, korr, nk, OnOff);
		    break;
		case 2: 
		    TDVal_KorrOnOff((TDVal*)wins, OnOff);
		    break;
		}
	    }
	    wins = wins->next;
	}
}

void pageMicrostrip_SetUp(TPage_Microstrip *pg, int fu, int iVal) {
  bool MkPaint = False;
	switch (fu) {
	    case 1: 
		pg->mm_mil = iVal;
		switch (iVal) {
		    case 0: 
			SetUpMM_MIL(pg->next_child, 0.0254, 0, False);
			break;
		    case 1: 
			SetUpMM_MIL(pg->next_child, 0.0254, 0, True);
			break;

		}
		MkPaint = True;
		break;
	} 
	if (MkPaint && TestWinIsVisible((TWins*)pg) && pg->pgc->AktPage) {
	    if (pg->pgc->AktPage == (TPage*)pg->MS1) RePaint(pg->MS1->pnl);
	}
}


static TPage *ELM_pageMicrostrip_Create(TPageControl *Parent) {
	return TPage_CreateParamAlg(Parent, sizeof(TPage_Microstrip));
}

TPage_Microstrip *ELM_pageMicrostripAdd(TPageControl *pagc, const char *Caption) {
  TPage_Microstrip *pg;
  TpcIni *pcIni;

	pcIni = get_appIni();

	pg = (TPage_Microstrip*) TPageControl_AddNewUserPage(pagc, Caption, ELM_pageMicrostrip_Create);
	pg->subClass = pg;

	pg->pnl1 = TWins_CreateBA((TWins*)pg, 0, 0, 322, 21,
				mBorder | mBorderL, alLeft);

	pg->pgc = TPageControl_Create(pg->pnl1);
	pg->pgc->Align = alClient;
	pg->pgc->height = 120;
//	pg->pgc->OnChange = pgc_Filter_OnChange;
	Set_Parent((TWins*)pg->pgc, pg->pnl1);

	pg->MS1 = page_Add_MS1(pg->pgc, pg);

/* ****************** Graf ****************************************************/
	pg->pnlGraf = TWins_CreateBA((TWins*)pg, 0, 0, 310, 21, 
				mBorder | mBorderL, alClient);
/* Graf Dat */
	pg->pnlGrafVal = TWins_CreateBA(pg->pnlGraf, 0, 0, 310, 21, 
				mBorder, alTop);

/* Graf Az */
	pg->xy_ind = TScaleXY_Create(pg->pnlGraf);
	pg->xy_ind->Align = alClient;
	pg->xy_ind->OnResize = EML_Microstrip_xy_ind_OnResize;
	pg->xy_ind->sx1 = 22;
	pg->xy_ind->sy1 = 18;
	pg->xy_ind->CursFu = 0x01;
	Set_Parent((TWins*)pg->xy_ind, pg->pnlGraf);

	pg->sbDetail = TScrollBarHorz_CreateP((TWins*)pg->xy_ind);
	pg->sbDetail->OnCount = EML_Microstrip_sbDetail_OnCount;
//	SetLeft((TWins*)pg->sbDetail, 1);
	TScrollBar_SetMaxCount(pg->sbDetail, 20000);
	pg->sbDetail->LargeChange = 50;

	TScaleXY_SetDat_mem(&pg->xy_ind->dat, 21, 19, 1001);

	free_appIni(pcIni);

	return pg;
}
