/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "TeCache.h"

TFormTeCache_Dat cd_Buf[max_cbXM];

TFormTeCache_Dat dat_CPUX_ref[max_cbXM];

#ifdef use_PAGES
TFormTeCache_Dat cdm_Buf[max_cbXM];	//memmove
TFormTeCache_Dat cdm_rd_Buf[max_cbXM];
#endif

#ifdef use_exec_Xns
TScaleXnsRaster exec_xr[8];
TScaleXnsRaster exec_rd_xr[8];
#endif

TScaleXnsRaster dat_xr[8];
TScaleXnsRaster dat_rd_xr[8];

static void TTeCache_buStart_OnClick(TButton *self, long KeyState, bool DblClick) {
  TFormTeCache *form = (TFormTeCache*)self->FormStruct;
#ifdef use_PAGES
	if (form->PageControl->AktPage == form->pgExec) {
	    TTeCache_memExec_Start(form);
	} else if (form->PageControl->AktPage == form->pgMemMove) {
	    TTeCache_MemMove_Start(form);
#ifdef use_FEATURE
	} else if (form->PageControl->AktPage == form->pgImageZoom) {
	    TTeCache_ImageZoom_Start(form);
#endif
	}
#else
	TTeCache_memExec_Start(form);
#endif
}


static void TTeCache_buStop_OnClick(TButton *self, long KeyState, bool DblClick) {
	((TFormTeCache*)self->FormStruct)->Stop = True;
}

static void TTeCache_pnlBottom_OnResize(TWins *self) {
  TFormTeCache *form = (TFormTeCache*)self->FormStruct;
	form->buClose->left = self->width - form->buClose->width - 1;
}

#if defined (__i386__) || defined (__x86_64__)
static void TTeCache_mTSC_ON(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormTeCache *form = (TFormTeCache*)self->FormStruct;
	smi->fu ^= miChecked;
	form->TSC_on = (smi->fu & miChecked) != 0;
}
#endif

static void TTeCache_mStart_250ms(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormTeCache *form = (TFormTeCache*)self->FormStruct;
	smi->fu ^= miChecked;
	form->Start250ms = (smi->fu & miChecked) != 0;
}

static void OnChangeTab(TPageControl *self, TPage *fromPage, TPage *toPage, int *fu) {
  TFormTeCache *form = (TFormTeCache*)self->FormStruct;
	RePaint(form->pnlSelAz);
	if (toPage == form->pgExec) {
	    SetVisible(form->pnlAlign, False);
	    form->xns_mov->OnPaint = NULL;
	} else if (toPage == form->pgMemMove) {
	    SetVisible(form->pnlAlign, True);
	    form->xns_mov->OnPaint = MemMove_ScaleXns_OnPaint;
	}
}

static void TTeCache_mView_X(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormTeCache *form = (TFormTeCache*)self->FormStruct;
  TMenuItem *mi = form->menuView->MenuItem;
  TFormTeCache_Dat *cdv;

	while (mi) {
	    if (mi->tag &0x100) mi->fu &= ~miChecked;
	    mi = mi->next;
	}
	smi->fu |= miChecked;

	if (smi->tag &0x100) {
	    form->cd_default_arr = NULL;
	    form->cd_default_view = NULL;
#ifdef use_PAGES
	    for (int idx=0; idx<8; idx++) {
		Fill0(&cdm_rd_Buf[idx], sizeof(TFormTeCache_Dat));
		dat_rd_xr[idx].fu = 0;
		if (cdm_Buf[idx].max_ps > 0) {
		    dat_xr[idx].PHmax_ns = (float)cdm_Buf[idx].max_ps / 1000;
		    TTeCache_Set_Max_ns_Scale(&dat_xr[idx]);
		}
	    }
#endif
	    switch(smi->tag & 0xff) {
	    case 1: 
		TeCache_ld_PII200(form);
		form->cd_default_arr = dat_CPUX_ref; 
		break;
	    case 2: 
		TeCache_ld_PIII700(form);
		form->cd_default_arr = dat_CPUX_ref; 
		break;
	    case 3: 
		TeCache_ld_M1870(form);
		form->cd_default_arr = dat_CPUX_ref; 
		break;
	    case 4: 
		TeCache_ld_C2D_2400(form);
		form->cd_default_arr = dat_CPUX_ref; 
		break;
	    case 5: 
		TeCache_ld_I7_870(form);
		form->cd_default_arr = dat_CPUX_ref; 
		break;
	    case 0x10:
		TTeCache_Load_User(form, 1);
		form->cd_default_arr = dat_CPUX_ref; 
		break;
	    case 0x11: 
		TTeCache_Load_User(form, 2);
		form->cd_default_arr = dat_CPUX_ref; 
		break;
	    case 0x12: 
		TTeCache_Load_User(form, 3);
		form->cd_default_arr = dat_CPUX_ref; 
		break;
	    }
	    if (form->cd_default_arr) {
		cdv = &form->cd_default_arr[form->akt_MX];
		if (!cdv) {
		    cdv = NULL;
		} 
		form->cd_default_view = cdv;
	    }
	}
	TTeCache_pnlExec_OnPaint(form->pnlExec);
}

static void TTeCache_mFile_Exit(TMenu *self, long KeyState, TMenuItem *smi) {
	Close();
}

static void TTeCache_buClose_OnClick(TButton *self, long KeyState, bool DblClick) {
	Close();
}

static void TTeCache_OnAppStart() {
  TFormTeCache *form = (TFormTeCache*)appDat.obj;
  int ms;
	ms = GetTime_ms() + 200;

	TTeCache_InitProc(form, 0x400);
	TTeCache_get_MHz(form);
	TTeCache_pnlExec_OnPaint(form->pnlExec);
	
	while ((!cpTime(ms, GetTime_ms())) && AppProcessMessages());

	TTeCache_get_MHz(form);
	TTeCache_FreeExecMem(form);
	TTeCache_pnlExec_OnPaint(form->pnlExec);
}

#ifndef _OS_WIN32
static const char zico16TeCache[] = {
 0x06,0x07,0x10,0x00,0x10,0x00,0x00,0x00,0x76,0x00,0x00,0x00,0x46,0x29,0x8E,0x7B,
 0x14,0xB5,0x1C,0xE7,0x00,0xF8,0xDF,0xFF,0x89,0x48,0x52,0x91,0xB0,0x08,0x6D,0x09,
 0x5A,0x8C,0x38,0xE1,0x46,0xE3,0x12,0x3C,0xE2,0xD6,0xEF,0xE5,0x38,0x04,0xF5,0x6C,
 0x3A,0xBB,0xCF,0x15,0x03,0x51,0x65,0xFB,0xD3,0x1D,0x07,0x71,0x6F,0x57,0xB2,0xEF,
 0x28,0x11,0xD7,0xF3,0x8E,0xE7,0x38,0x4A,0x5C,0x3E,0x3A,0x3C,0x4D,0x47,0x89,0x2A,
 0xF1,0xB3,0xF2,0x38,0x7F,0x00,0x8E,0x67,0xD9,0xBD,0xA2,0x00,0x71,0xFC,0x77,0x96,
 0x5C,0xE2,0x66,0xD4,0xCA,0x4E,0xA3,0x14,0x32,0x32,0x27,0x9C,0x58,0x44,0x94,0x0B,
 0xA5,0x05,0x44,0x15,0x49,0x02};
#endif

const int build_v = ALD_BUILD_V;
const char *build_date = __DATE__;

const char *Help_Msg = {
  "\n"
  "Usage: TeCache [options]\n"
  "\n"
  "  -h, --help           Prints out this screen\n\n"
  "  ALDccp: TeCache version "ALD_VERSION"  (build %d  %s)\n"
};

int main (int argc, char **argv) {
  TFormTeCache *self;
  int i; //, x, y;
  char *val;
  bool help = False;
  bool err = False;

	i = 1;
	while (!err && !help && (i<argc)) {
	    val = argv[i];
	    if (*val == '-') {
		val++;
		switch (*val) {
		case 'h':
		    help = True;
		    break;
		case '-':
		    val++;
		    if (pcncmp(val, "help", 4)) {
			help = True;
#ifdef Test_Root_WinId
		    } else if (pcncmp(val, "TestRootWinID", 13)) {
			i++;
			val = argv[i];
			if (val && (*val != '-')) {
			    TestRootWinId = pctoint(val);
			} else err = True;
#endif
		    } else err = True;
		    break;
		default: 
		    err = True;
		}
	    } else {
		err = True;
	    }
	    i++;
	}

	if (help || err) {
	    printf(Help_Msg, build_v, build_date);
	    exit(err);
	}


	initXapp(0, argc, argv);
	self = TForm_CreatParamAlg(NULL, sizeof(TFormTeCache));
	appDat.obj = self;

#ifdef USE_DECOR
	appXDat.DefaultButtonDecor = TDecor_button_w3b3_Create();
#endif
#ifdef _OS_WIN32
	appDat.inifile_app = pcadd(appDat.ALDini_dir, "\\TeCache.ini");
#else
	appDat.inifile_app = pcadd(appDat.ALDini_dir, "/TeCache.ini");

	self->Icon = GetZIcon(zico16TeCache);
#endif

#if defined (__i386__) || defined (__x86_64__)
	i = Get_CPUID(&self->cpuid);
	self->has_TSC = (i && (self->cpuid.FeatureFlags1 & TSC_FLAG));
	self->Start250ms = True;

	if (i && self->cpuid.ProcessorName[0]) {
	    char *pc = self->cpuid.ProcessorName;
	    while (*pc == 0x20) pc++;
	    pc = pcadd("ALD Cache Test       ", pc);
	    SetCaption((TWins*)self, pc);
	    xfree(pc);
	} else {
	    SetCaption((TWins*)self, "ALD Cache Test");
	}
#else
	self->Start250ms = True;
	SetCaption((TWins*)self, "ALD Cache Test");
#endif

	self->IconName = APPNAME;
	self->width = 560;
	self->height = 324;
	self->min_width = 480;
	self->min_height = 240;
	self->max_width = 1024;
	self->max_height = 560;
	self->FormPosition = poDesigned;

	self->pnlTop = TWins_CreateBA((TWins*)self, 0, 0, 200, 22, mBorder, alTop);
	self->pnlMiddle = TWins_CreateBA((TWins*)self, 0, 0, 200, 42, mBorder | mBorderL, alClient);
	self->pnlBottom = TWins_CreateBA((TWins*)self, 0, 0, 200, 23, 0, alBottom);
	self->pnlBottom->OnResize = TTeCache_pnlBottom_OnResize;

// ******* Menu File *******
	self->mbFile = TMenuButton_CreateS(self->pnlTop, (TMenuButton*)self, "File");

	self->menuFile = TMenu_Create((TWins*)self);
	((TMenuButton*)self->mbFile)->menu = self->menuFile;
#ifdef use_SAVE_UserDat
	TMenu_AddItem(self->menuFile, "Save Dat User 1", 0, TTeCache_mFile_SaveU1)->tag = 1;
	TMenu_AddItem(self->menuFile, "Save Dat User 2", 0, TTeCache_mFile_SaveU1)->tag = 2;
	TMenu_AddItem(self->menuFile, "Save Dat User 3", 0, TTeCache_mFile_SaveU1)->tag = 3;
	TMenu_AddItem(self->menuFile, "-", 0, NULL);
#endif
	TMenu_AddItem(self->menuFile, "Exit", 0, TTeCache_mFile_Exit);

// ******* Menu Settings *******
	self->mbSettings = TMenuButton_CreateS(self->pnlTop, self->mbFile, "Settings");

	self->menuSettings = TMenu_Create((TWins*)self);
	self->mbSettings->menu = self->menuSettings;
#if defined (__i386__) || defined (__x86_64__)
	i = miNotEnabled | miCanCheck;
	if (self->has_TSC) i = miCanCheck; // | miChecked;
	TMenu_AddItem(self->menuSettings, "TSC ON", i, TTeCache_mTSC_ON);
#endif
	TMenu_AddItem(self->menuSettings, "Start 250ms", miCanCheck | miChecked, TTeCache_mStart_250ms);

// ******* Menu View *******
	self->mbView = TMenuButton_CreateS(self->pnlTop, self->mbFile, "View");

	self->menuView = TMenu_Create((TWins*)self);
	self->mbView->menu = self->menuView;
	TMenu_AddItem(self->menuView, "none", miCanCheck | miChecked, TTeCache_mView_X)->tag = 0x100;
	TMenu_AddItem(self->menuView, "PII 200MHz", miCanCheck , TTeCache_mView_X)->tag = 0x101;
	TMenu_AddItem(self->menuView, "PIII 700MHz", miCanCheck , TTeCache_mView_X)->tag = 0x102;
	TMenu_AddItem(self->menuView, "M 1870MHz", miCanCheck , TTeCache_mView_X)->tag = 0x103;
	TMenu_AddItem(self->menuView, "Core 2 Duo 2,4GHz", miCanCheck , TTeCache_mView_X)->tag = 0x104;
	TMenu_AddItem(self->menuView, "i7-870 3,0Ghz", miCanCheck , TTeCache_mView_X)->tag = 0x105;
	TMenu_AddItem(self->menuView, "-", 0, NULL);
	TMenu_AddItem(self->menuView, "User 1", miCanCheck , TTeCache_mView_X)->tag = 0x110;
	TMenu_AddItem(self->menuView, "User 2", miCanCheck , TTeCache_mView_X)->tag = 0x111;
	TMenu_AddItem(self->menuView, "User 3", miCanCheck , TTeCache_mView_X)->tag = 0x112;

	MenuHelp_Create(self);

#ifdef use_PAGES
	self->PageControl = TPageControl_Create(self->pnlMiddle);
	self->PageControl->Align = alClient;
	self->PageControl->OnChangeTab = OnChangeTab;
	Set_Parent((TWins*)self->PageControl, self->pnlMiddle);

	self->pgExec = (TPage*)TPageControl_AddNewPage(self->PageControl, "Mem-exec");
	self->pgMemMove = (TPage*)TPageControl_AddNewPage(self->PageControl, "Mem-move");
	self->pnlExec = TWins_CreateBA((TWins*)self->pgExec, 0, 0, 70, 42,
				mBorder | mBorderL, alClient);

#ifdef use_exec_Xns
	self->ns_exec = TScaleXns_Create((TWins*)self->pgExec);
	self->ns_exec->width = 340;
	self->ns_exec->height = 250;
//	self->ns_exec->Align = alClient;
	self->ns_exec->BorderFu = mBorder | mBorderL;
	TeCache_exec_init(self);
	Set_Parent((TWins*)self->ns_exec, (TWins*)self->pgExec);
#endif

	self->xns_mov = TScaleXns_Create((TWins*)self->pgMemMove);
	self->xns_mov->Align = alClient;
	self->xns_mov->BorderFu = mBorder | mBorderL;
	TeCache_memmove_init(self);
	Set_Parent((TWins*)self->xns_mov, (TWins*)self->pgMemMove);
#ifdef use_FEATURE
	self->pgImageZoom = (TPage*)TPageControl_AddNewPage(self->PageControl, "Image Zoom");
#endif

#else
	self->pnlExec = TWins_CreateBA(self->pnlMiddle, 0, 0, 70, 42, 0, alClient);
#endif
	self->pnlExec->OnPaint = TTeCache_pnlExec_OnPaint;
	self->pnlExec->OnResize = TTeCache_pnlExec_OnResize;
	pnlSelAz_Create(self);


	self->buStart = TButton_CreateS(self->pnlBottom, 1, 1, 60, 22, "Start");
	self->buStop = TButton_CreateS(self->pnlBottom, 63, 1, 60, 22, "Stop");
	self->buClose = TButton_CreateS(self->pnlBottom, 1, 1, 60, 22, "Close");

	self->buStart->OnClick = TTeCache_buStart_OnClick;
	self->buStop->OnClick = TTeCache_buStop_OnClick;
	self->buClose->OnClick = TTeCache_buClose_OnClick;

	SetEnabled((TWins*)self->buStop, False);


	self->gr_x = 3;
	self->gr_y = 3;
	self->color_ps = 0xc00000;
	self->color_ps_d = 0x804080;
//	TTeCache_SetMem(self, 0x40000);	//1MB

	self->cd_view = &cd_Buf[4];

	appXDat.OnAppStart = TTeCache_OnAppStart;

	AppRun();
	return 0;
}
