/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "TeCache.h"

void TeCache_ld_Head( TFormTeCache_Dat *cd, const char *s0) {
  const char *s = s0;
	cd->MHz = ppctoint(&s);
	cd->sampz = ppctoint(&s);
	cd->maxmem_ps = ppctoint(&s);
	cd->min_ps = ppctoint(&s);
	cd->max_ps = ppctoint(&s);
	cd->ges_time = ppctoint(&s);
}

void TeCache_ld_t( TFormTeCache_Dat *cd, const char *s0) {
  const char *s = s0;
	for (int i=0; i<cd->sampz; i++) {
	    cd->sampt[i] = ppctohex(&s);
	}
}

void TeCache_ld_m( TFormTeCache_Dat *cd, const char *s0) {
  const char *s = s0;
	for (int i=0; i<cd->sampz; i++) {
	    cd->sampmem[i] = ppctohex(&s) << 8;
	}
}

#ifdef use_PAGES

void TeCache_mov_cd(TFormTeCache_Dat *cdd, TFormTeCache_Dat *cds) {
	pnmove(cdd, cds, sizeof(TFormTeCache_Dat));
}

void TeCache_add_mem(dword *mem, int shift) {
	*mem += 0x100 << shift;
	if (*mem > 0x1000) *mem += 0x100 << shift;
	if (*mem > 0x2000) *mem += 0x200 << shift;
	if (*mem > 0x4000) *mem += 0x400 << shift;
	if (*mem > 0x8000) *mem += 0x800 << shift;
	if (*mem > 0x10000) *mem += 0x1000 << shift;
	if (*mem > 0x20000) *mem += 0x2000 << shift;
	if (*mem > 0x40000) *mem += 0x4000 << shift;
	if (*mem > 0x80000) *mem += 0x8000 << shift;
	if (*mem > 0x100000) *mem += 0x10000 << shift;
	if (*mem > 0x200000) *mem += 0x20000 << shift;	//2..4M
	if (*mem > 0x400000) *mem += 0x40000 << shift;	//4..8M
	if (*mem > 0x800000) *mem += 0x80000 << shift;	//8..16M
	if (*mem > 0x1000000) *mem += 0x100000 << shift;//16..32M
//	if (*mem > 0x2000000) *mem += 0x200000 << shift;//32..64M
}
#endif
