/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version. 

 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details. 

 You should have received a copy of the GNU General Public
 License along with this program; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA

 ----------------------------------------------------------------
 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appXbase.h"

#define TCSelf TFormMain
typedef struct TFormMain {
  AlgTForm
  TEdit *ed1;
  TEdit *ed2;
  TEdit *ed3;
  TButton *buStartStop;
  TChkBox *cbFilePR;
  TButton *buStartStopPath;
  TChkBox *cbPathPR;
  char *fname;
  char *pname;
} TFormMain;
#undef TCSelf

static void mf_OnResize(TFormMain *self) {

	self->ed1->width = self->width - 2;
}

void mf_buStartStop(TWins *self, long KeyState, bool DblClick) {
  TFormMain *mf = (TFormMain*)self->ParentForm;

	if (!self->tag) {
	    self->tag = 1;
	    SetCaption(self, "Stop");
	} else {
	    self->tag = 0;
	    SetCaption(self, "Start File");
	    SetCaption((TWins*)mf->ed2, NULL);
	}
}

void mf_buStartStopPath(TWins *self, long KeyState, bool DblClick) {
  TFormMain *mf = (TFormMain*)self->ParentForm;

	if (!self->tag) {
	    self->tag = 1;
	    SetCaption(self, "Stop");
	} else {
	    self->tag = 0;
	    SetCaption(self, "Start Path");
	    SetCaption((TWins*)mf->ed3, NULL);
	}
}


void mf_On_appEv(TEv_Array *appEv) {
  TFormMain *mf = appEv->obj;
	if (mf->fname) {
	    if (!file_unlink(mf->fname, NULL)) {
		mf->buStartStop->tag = 0;
		SetCaption((TWins*)mf->buStartStop, "Start File");
		SetCaption((TWins*)mf->ed2, NULL);
	    }
	    ppcfree(&mf->fname);
	}
	if (mf->buStartStop->tag) {
	    dword dw = GetTime_us();
	    char *pc = base32_dec((char*)&dw, 4);
	    ppcchange_add_n(&pc, 2, "testtemp_", pc);
	    mf->fname = path_add(GetCaption_pc((TWins*)mf->ed1), pc);
	    SetCaption((TWins*)mf->ed2, pc);
	    xfree(pc);
// printf("%s(%d): %s\n", FL, mf->fname);
	    FileHandle fd;
	    if (FileOpen_wr(mf->fname, &fd, 0)) {
		fd_write_va(fd, "124saas111111111111\nadaff\n");
		FileClose(fd);
	    } else {
		mf->buStartStop->tag = 0;
		SetCaption((TWins*)mf->buStartStop, "Start File");
		SetCaption((TWins*)mf->ed2, NULL);
	    }
	}
	if (mf->fname && mf->cbFilePR->Checked) {
	    if (!file_unlink(mf->fname, NULL)) {
		mf->buStartStop->tag = 0;
		SetCaption((TWins*)mf->buStartStop, "Start File");
		SetCaption((TWins*)mf->ed2, NULL);
	    }
	    ppcfree(&mf->fname);
	}

	if (mf->pname) {
	    if (!file_rmdir(mf->pname, NULL)) {
		mf->buStartStopPath->tag = 0;
		SetCaption((TWins*)mf->buStartStopPath, "Start File");
		SetCaption((TWins*)mf->ed3, NULL);
	    }
	    ppcfree(&mf->pname);
	}
	if (mf->buStartStopPath->tag) {
	    dword dw = GetTime_us();
	    char *pc = base32_dec((char*)&dw, 4);
	    ppcchange_add_n(&pc, 2, "pathtemp_", pc);
	    mf->pname = path_add(GetCaption_pc((TWins*)mf->ed1), pc);
	    SetCaption((TWins*)mf->ed3, pc);
	    xfree(pc);
// printf("%s(%d): %s\n", FL, mf->pname);
	    if (!file_mkdir(mf->pname, NULL, 0)) {
		mf->buStartStopPath->tag = 0;
		SetCaption((TWins*)mf->buStartStopPath, "Start File");
		SetCaption((TWins*)mf->ed3, NULL);
	    }
	}
	if (mf->pname && mf->cbPathPR->Checked) {
	    if (!file_rmdir(mf->pname, NULL)) {
		mf->buStartStopPath->tag = 0;
		SetCaption((TWins*)mf->buStartStopPath, "Start File");
		SetCaption((TWins*)mf->ed3, NULL);
	    }
	    ppcfree(&mf->pname);
	}
}

char *Help_Msg = {
  "\n"
  "Usage: edit\n"
  "\n"
  "  -h, --help           Prints out this screen\n\n"
  "  ALDccp: edit version "VERSION"  (build %d  %s)\n"
};

int build_v = ALD_BUILD_V;
char *build_date = __DATE__;

int main (int argc, char **argv) {
  int i;
  char *val;
//  char *InFile;
  TFormMain *self;
  bool help = False;
  bool err = False;


//	InFile = NULL;
	i = 1;
	while (!err && (i<argc)) {
	    val = argv[i];
	    if (*val == '-') {
		val++;
		switch (*val) {
		case 'h':
		    help = True;
		    break;
		case '-':
		    val++;
		    if (pcncmp(val, "help", 4)) {
			help = True;
		    } else err = True;
		    break;
		default: 
		    err = True;
		}
	    } else {
//		InFile = val;
		err = True;
	    }
	    i++;
	}

//	err = err || !InFile;
	if (help || err) {
	    printf(Help_Msg, build_v, build_date);
	    exit(err);
	}

	initXapp(0, argc, argv);
	self = TForm_CreatParamAlg(NULL, sizeof(TFormMain));
	IappDat.obj = self;
	self->OnResize = mf_OnResize;

	self->ed1 = TEdit_CreateS((TWins*)self, 1, 1, 200, 18, 
						"/tmp/testdir");

	self->buStartStop = (TButton*)TButton_CreateS((TWins*)self, 1, 22, 84, 24, "Start File");
	self->buStartStop->OnClick = mf_buStartStop;
	self->ed2 = TEdit_CreateS((TWins*)self, 88, 24, 140, 18, NULL);
	self->cbFilePR = TChkBox_CreateS((TWins*)self, 230, 24, 40, 18, "PR");

	self->buStartStopPath = (TButton*)TButton_CreateS((TWins*)self, 1, 50, 84, 24, "Start Path");
	self->buStartStopPath->OnClick = mf_buStartStopPath;
	self->ed3 = TEdit_CreateS((TWins*)self, 88, 52, 140, 18, NULL);
	self->cbPathPR = TChkBox_CreateS((TWins*)self, 230, 52, 40, 18, "PR");

	IappDat.t_io_us = 3333;
	Add_appEv(mf_On_appEv)->obj = self;
	AppRun();
	return 0;
}
