/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version. 

 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details. 

 You should have received a copy of the GNU General Public
 License along with this program; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA

 ----------------------------------------------------------------
 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "buildin_et.h"

typedef struct {
  const char *s;
  TBuildin_app *bi_app;
} Tbi_AHapp;

Tbi_AHapp bi_Tab[] = {
#ifndef _OS_WIN32
  {"daemonexec", bi_daemonexec_main},
  {"findsharprocs", bi_findsharprocs_main},
#endif
  {"inidata", bi_inidata_main},
  {"shdata", bi_shdata_main},
  {NULL, NULL}
};

TBuildin_app *Get_Buildin_pc(char *pc) {
  Tbi_AHapp *bi = bi_Tab;

	while (bi->s) {
		if (pccmp(bi->s, pc)) {
			return bi->bi_app;
		}
		bi++;
	}
	return NULL;
}

void BuildinHelp() {
  int x, l;
  char *pc;
  char line[128];
  Tbi_AHapp *bi = bi_Tab;

	printf("Usage: embtool function [arguments]...\n\n");
	printf("embtool Currently defined functions:\n");
	line[0] = 0x09;
	x = 8;
	pc = &line[1];
	while (bi->s) {
		l = pclen(bi->s);
		if ((x + l) > 76) {
			printf("%s\n", line);
			x = 8;
			pc = &line[1];
		}
		ppcmove(&pc, bi->s);
		x += l;
		bi++;
		if (bi->s) ppcmove(&pc, ", ");
	}
	if (x > 8) printf("%s\n", line); 
	printf("\n  ALDccp: embtool version "VERSION"  (build %d  %s)\n",
						build_v, build_date);
}
