/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version. 

 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details. 

 You should have received a copy of the GNU General Public
 License along with this program; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA

 ----------------------------------------------------------------
 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appXbase.h"

TForm *FormMain;
TEdit *Edit1;
TEdit *Edit2;
TEdit *Edit3;

static void Edit1_OnKeyDown(TEdit *self, TKeyEvent *KeyEv) {
  int m;
  char *s, *s2;
  KeySym keysymA;
  char line[256];

	XLookupString(appXDat.Tmp_XKeyEv, (char*)&m, 4, &keysymA, NULL);

	s =  XKeysymToString(keysymA);
	s2 = XKeysymToString(KeyEv->keysym);
	snprintf(line, 256, "%s -> %s", s, s2); 

	SetCaption((TWins*)Edit2, line);


	snprintf(line, 256, "key=%d(0x%x) st=0x%x c=0x%x -> 0x%x", 
		KeyEv->keycode, KeyEv->keycode, 
		(int)KeyEv->state, (int)keysymA, (int)KeyEv->keysym);
	SetCaption((TWins*)Edit3, line);
}

static void FormMain_OnResize(TForm *self) {
	Edit1->width = self->width;
	Edit2->width = self->width - Edit2->left;
	Edit3->width = self->width - Edit3->left;
//	Edit3->width = self->width - Edit3->left;
}

static const char *Help_Msg = {
  "\n"
  "Usage: keytest [options]\n"
  "\n"
  "  -h, --help           Prints out this screen\n\n"
  "  ALDccp: keytest version "ALD_VERSION"  (build %d  %s)\n"
};

int build_v = ALD_BUILD_V;
static const char *build_date = __DATE__;

int main (int argc, char **argv) {
  int i;
  char *val;
  bool help = False;
  bool err = False;

	i = 1;
	while (!err && (i<argc)) {
	    val = argv[i];
	    if (*val == '-') {
		val++;
		switch (*val) {
		case 'h':
		    help = True;
		    break;
		case '-':
		    val++;
		    if (pcncmp(val, "help", 4)) {
			help = True;
#ifdef Test_Root_WinId
		    } else if (pcncmp(val, "TestRootWinID", 13)) {
			i++;
			val = argv[i];
			if (val && *val != '-') {
				TestRootWinId = pctoint(val);
			} else err = True;
#endif
		    } else err = True;
		    break;
		default: 
			err = True;
		}
	    } else err = True;
	    i++;
	}

	if (help || err) {
	    printf(Help_Msg, build_v, build_date);
	    exit(err);
	}

	initXapp(0, argc, argv);

	FormMain =  TForm_Create(NULL);
	FormMain->vds.UTF8on = True;
	SetCaption((TWins*)FormMain, "keytest");
	FormMain->left = 10;
	FormMain->top = 30;
	FormMain->width = 300;
	FormMain->height = 60;
	FormMain->min_width = 300;
	FormMain->min_height = 60;
//	FormMain->max_height = 41;
//	((TForm*)FormMain)->FormPosition = poDesigned;
	FormMain->FormZStyle = fszNoResize;
	FormMain->OnResize = FormMain_OnResize;

	Edit1 = TEdit_CreateS((TWins*)FormMain, 0, 2, 200, 18, NULL);
	Edit1->KeyFu = mCanFocus;
	Edit1->OnKeyDown = Edit1_OnKeyDown;

	Edit2 = TEdit_CreateS((TWins*)FormMain, 10, 22, 200, 18, NULL);
	Edit2->ReadOnly = True;
	Edit3 = TEdit_CreateS((TWins*)FormMain, 10, 42, 215, 18, NULL);
	Edit3->ReadOnly = True;

	FormMain->FocusWin = (TWins*)Edit1;

	AppRun();
	return 0;
}
